(*<*)
theory ListProgs = RSD_TYPING:
(*>*)

subsection{*Heap-allocated data structures*}

subsubsection{*Program representations*}

text{*We first define the program for copying lists from Section 1,
Figure 2.*}

consts LIST::Class
       NIL::Class
       CONS::Class
       HD::Field
       TL::Field

consts x::Var
       y::Var
       h::Var
       t::Var
       z::Var
       Copy::Method
       OptCopy::Method
       CrossCopy::Method
       AllocFirstCopy::Method


constdefs NilCopy::Mbody
"NilCopy \<equiv> ([],emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn],0)"

constdefs NilClass::Classdef
"NilClass \<equiv> emp[Copy \<mapsto> NilCopy]"

text{*The bytecode is defined as in Figure 25.*}

constdefs ConsCopy::Mbody
"ConsCopy \<equiv> ([],upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd(upd (upd (upd (upd(upd(upd(upd emp 
                  0 (load this)) 
                  1 (getfield CONS HD))
                  2 (store h))
                  3 (load this))
                  4 (getfield CONS TL))
                  5 (store t))
                  6 (load t))
                  7 (invokeV LIST Copy))
                  8 (store t))
                  9 (new CONS))
                  10 (store z))
                  11 (load z))
                  12 (load h))
                  13 (putfield CONS HD))
                  14 (load z))
                  15 (load t))
                  16 (putfield CONS TL))
                  17 (load z))
                  18 vreturn
              ,0)"

constdefs ConsClass::Classdef
"ConsClass \<equiv> emp[Copy \<mapsto> ConsCopy]"

constdefs ListCopy::Mbody
"ListCopy \<equiv> ([],emp,0)"

constdefs ListClass::Classdef
"ListClass \<equiv> emp[Copy \<mapsto> ListCopy]"

constdefs COPY::Prog
"COPY \<equiv> emp[LIST \<mapsto> ListClass][NIL \<mapsto> NilClass][CONS \<mapsto> ConsClass]"

(*<*)
lemma InstrNIL0:
"get_ins NilCopy 0 = Some (new NIL)"
    apply (simp add: NilCopy_def get_ins_def)
      apply (rule AL_update4)
      apply (rule AL_update1a) apply (simp, simp)
done
lemma InstrNIL1:
"get_ins NilCopy (Suc 0) = Some vreturn"
apply (simp add: NilCopy_def get_ins_def)
      apply (rule AL_update1) 
done
lemma InstrCONS0:
"get_ins ConsCopy 0 = Some (load this)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp) apply (simp, simp,simp)
          apply (simp, simp, simp) apply (simp, simp, simp) apply (simp, simp) 
done
lemma InstrCONS1:
"get_ins ConsCopy (Suc 0) = Some (getfield CONS HD)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp) apply (simp, simp,simp)
          apply (simp, simp, simp) apply (simp, simp, simp) apply simp 
done
lemma InstrCONS2:
"get_ins ConsCopy (Suc(Suc 0)) = Some (store h)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp) apply (simp, simp,simp)
          apply (simp, simp, simp) apply (simp, simp, simp)
done
lemma InstrCONS3:
"get_ins ConsCopy (Suc(Suc(Suc 0))) = Some (load this)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp)
          apply (simp, simp, simp) apply (simp, simp, simp) apply (simp, simp) 
done
lemma InstrCONS4:
"get_ins ConsCopy (Suc(Suc(Suc(Suc 0)))) = Some (getfield CONS TL)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp)
          apply (simp, simp, simp) apply (simp, simp, simp) apply simp 
done
lemma InstrCONS5:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc 0))))) = Some (store t)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp)
          apply (simp, simp, simp) apply (simp, simp, simp)
done
lemma InstrCONS6:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc 0)))))) = Some (load t)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp)
          apply (simp, simp, simp) apply (simp, simp)
done
lemma InstrCONS7:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))) = Some  (invokeV LIST Copy)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) apply (simp, simp, simp)
          apply (simp, simp, simp) apply simp 
done
lemma InstrCONS8:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))) = Some (store t)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp, simp) 
done
lemma InstrCONS9:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))) = Some (new CONS)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp) 
done
lemma InstrCONS10:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))) = Some (store z)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply simp
done
lemma InstrCONS11:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))))) = Some  (load z)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp)
done
lemma InstrCONS12:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))))) = Some (load h)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) 
          apply (simp, simp)
done
lemma InstrCONS13:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))))))) = Some (putfield CONS HD)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) 
          apply simp
done
lemma InstrCONS14:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))))))) = Some (load z)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp,simp) 
done
lemma InstrCONS15:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))))))))) = Some  (load t)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply (simp, simp)
done
lemma InstrCONS16:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))))))))) = Some (putfield CONS TL)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4, rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp) apply simp
done
lemma InstrCONS17:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))))))))))) = Some (load z)"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update4)
        apply (rule AL_update1a) apply (simp, simp)
done
lemma InstrCONS18:
"get_ins ConsCopy (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))))))))))) = Some vreturn"
      apply (simp add: ConsCopy_def get_ins_def)
        apply (rule AL_update1a) apply simp
done
(*>*)

text{*Next, the optimised program from Section 5.3, Figure 28.*}

constdefs ConsOpt::Mbody
"ConsOpt \<equiv> ([],upd(upd(upd(upd(upd(upd(upd(upd(upd (upd (upd (upd(upd(upd(upd emp 
                  0 (load this)) 
                  1 (getfield CONS HD))
                  2 (store h))
                  3 (load this))
                  4 (getfield CONS TL))
                  5 (invokeV LIST OptCopy))
                  6 (store t))
                  7 (new CONS))
                  8 dup)
                  9 (load h))
                  10 (putfield CONS HD))
                  11 dup)
                  12 (load t))
                  13 (putfield CONS TL))
                  14 vreturn
              ,0)"

(*<*)
lemma InstrOPT0: "get_ins ConsOpt 0 = Some (load this)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp,simp)
          apply (simp, simp, simp) 
done

lemma InstrOPT1: "get_ins ConsOpt (Suc 0) = Some (getfield CONS HD)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp,simp)
          apply (simp, simp) 
done
lemma InstrOPT2: "get_ins ConsOpt (Suc(Suc 0)) = Some (store h)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp,simp)
          apply (simp) 
done
lemma InstrOPT3: "get_ins ConsOpt (Suc(Suc(Suc 0))) = Some (load this)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp,simp)
done
lemma InstrOPT4: "get_ins ConsOpt (Suc(Suc(Suc(Suc 0)))) = Some (getfield CONS TL)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp)
done
lemma InstrOPT5: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc 0))))) = Some (invokeV LIST OptCopy)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply simp
done
lemma InstrOPT6: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc 0)))))) = Some (store t)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) 
done
lemma InstrOPT7: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))) = Some (new CONS)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp)
done
lemma InstrOPT8: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))) = Some (dup)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply simp
done
lemma InstrOPT9: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))) = Some (load h)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
done
lemma InstrOPT10: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))) = Some (putfield CONS HD)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp)
done
lemma InstrOPT11: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))))) = Some (dup)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply simp
done
lemma InstrOPT12: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))))) = Some (load t)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) 
done
lemma InstrOPT13: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))))))) = Some (putfield CONS TL)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp)
done
lemma InstrOPT14: "get_ins ConsOpt (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))))))) = Some (vreturn)"
      apply (simp add: ConsOpt_def get_ins_def)
        apply (rule AL_update1a) apply simp
done
(*>*)

constdefs OptListClass::Classdef
"OptListClass \<equiv> emp[Copy \<mapsto> ListCopy][OptCopy \<mapsto> ListCopy]"

constdefs OptNilClass::Classdef
"OptNilClass \<equiv> emp[Copy \<mapsto> NilCopy][OptCopy \<mapsto> NilCopy]"

constdefs OptConsClass::Classdef
"OptConsClass \<equiv> emp[Copy \<mapsto> ConsCopy][OptCopy \<mapsto> ConsOpt]"

constdefs OPT::Prog
"OPT \<equiv> emp[LIST \<mapsto> OptListClass][NIL \<mapsto> OptNilClass][CONS \<mapsto> OptConsClass]"

text{*Now the program that moves allocation first (Figure 29).*}

constdefs Cross::Mbody
"Cross \<equiv> ([],upd(upd(upd(upd(upd (upd (upd (upd(upd(upd(upd emp 
                  0 (new CONS)) 
                  1 dup)
                  2 dup)
                  3 (load this))
                  4 (getfield CONS HD))
                  5 (putfield CONS HD))
                  6 (load this))
                  7 (getfield CONS TL))
                  8 (invokeV LIST CrossCopy))
                  9 (putfield CONS TL))
                  10 vreturn
              ,0)"

(*<*)
lemma InstrCROSS0: "get_ins Cross 0 = Some (new CONS)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp)
done

lemma InstrCROSS1: "get_ins Cross (Suc 0) = Some dup"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply simp
done
lemma InstrCROSS2: "get_ins Cross (Suc(Suc 0)) = Some dup"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) 
done
lemma InstrCROSS3: "get_ins Cross (Suc(Suc(Suc 0))) = Some (load this)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp)
done
lemma InstrCROSS4: "get_ins Cross (Suc(Suc(Suc(Suc 0)))) = Some (getfield CONS HD)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply simp
done
lemma InstrCROSS5: "get_ins Cross (Suc(Suc(Suc(Suc(Suc 0))))) = Some (putfield CONS HD)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
done
lemma InstrCROSS6: "get_ins Cross (Suc(Suc(Suc(Suc(Suc(Suc 0)))))) = Some (load this)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp)
done
lemma InstrCROSS7: "get_ins Cross (Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))) = Some (getfield CONS TL)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply simp
done
lemma InstrCROSS8: "get_ins Cross (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))) = Some (invokeV LIST CrossCopy)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) 
done
lemma InstrCROSS9: "get_ins Cross (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))) = Some (putfield CONS TL)"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp)
done
lemma InstrCROSS10: "get_ins Cross (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))) = Some vreturn"
      apply (simp add: Cross_def get_ins_def)
        apply (rule AL_update1a) apply simp
done
(*>*)

constdefs CrossListClass::Classdef
"CrossListClass \<equiv> emp[Copy \<mapsto> ListCopy][OptCopy \<mapsto> ListCopy][CrossCopy \<mapsto> ListCopy]"

constdefs CrossNilClass::Classdef
"CrossNilClass \<equiv> emp[Copy \<mapsto> NilCopy][OptCopy \<mapsto> NilCopy][CrossCopy \<mapsto> NilCopy]"

constdefs CrossConsClass::Classdef
"CrossConsClass \<equiv> emp[Copy \<mapsto> ConsCopy][OptCopy \<mapsto> ConsOpt][CrossCopy \<mapsto> Cross]"

constdefs CROSS::Prog
"CROSS \<equiv> emp[LIST \<mapsto> CrossListClass][NIL \<mapsto> CrossNilClass][CONS \<mapsto> CrossConsClass]"

text{*Finally, yet another alternative. Like CROSS, allocation
precedes the method invocation. Aditionally, the order of field
updates is swapped: the copying of the tail, and the assignment of
this copy to the tail field precede the assignment to the
head-field.*}

constdefs AllocFirst::Mbody
"AllocFirst \<equiv> ([],upd(upd(upd(upd(upd (upd (upd (upd(upd(upd(upd emp 
                  0 (new CONS)) 
                  1 dup)
                  2 dup)
                  3 (load this))
                  4 (getfield CONS TL))
                  5 (invokeV LIST AllocFirstCopy))
                  6 (putfield CONS TL))
                  7 (load this))
                  8 (getfield CONS HD))
                  9 (putfield CONS HD))
                  10 vreturn
              ,0)"

(*<*)
lemma InstrALLOCFIRST0: "get_ins AllocFirst 0 = Some (new CONS)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply (simp, simp)
done

lemma InstrALLOCFIRST1: "get_ins AllocFirst (Suc 0) = Some dup"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) apply simp
done
lemma InstrALLOCFIRST2: "get_ins AllocFirst (Suc(Suc 0)) = Some dup"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp, simp) 
done
lemma InstrALLOCFIRST3: "get_ins AllocFirst (Suc(Suc(Suc 0))) = Some (load this)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply (simp, simp)
done
lemma InstrALLOCFIRST4: "get_ins AllocFirst (Suc(Suc(Suc(Suc 0)))) = Some (getfield CONS TL)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
          apply simp
done
lemma InstrALLOCFIRST5: "get_ins AllocFirst (Suc(Suc(Suc(Suc(Suc 0))))) = Some (invokeV LIST AllocFirstCopy)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp,simp) 
done
lemma InstrALLOCFIRST6: "get_ins AllocFirst (Suc(Suc(Suc(Suc(Suc(Suc 0)))))) = Some (putfield CONS TL)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) apply (simp, simp)
done
lemma InstrALLOCFIRST7: "get_ins AllocFirst (Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))) = Some (load this)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1a)
          apply (simp, simp, simp) apply simp
done
lemma InstrALLOCFIRST8: "get_ins AllocFirst (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))) = Some (getfield CONS HD)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update4, rule AL_update1a)
          apply (simp, simp, simp) 
done
lemma InstrALLOCFIRST9: "get_ins AllocFirst (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0))))))))) = Some (putfield CONS HD)"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update4, rule AL_update1a)
          apply (simp, simp)
done
lemma InstrALLOCFIRST10: "get_ins AllocFirst (Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc(Suc 0)))))))))) = Some vreturn"
      apply (simp add: AllocFirst_def get_ins_def)
        apply (rule AL_update1a) apply simp
done
(*>*)

constdefs AllocFirstListClass::Classdef
"AllocFirstListClass \<equiv> emp[Copy \<mapsto> ListCopy][OptCopy \<mapsto> ListCopy][AllocFirstCopy \<mapsto> ListCopy]"

constdefs AllocFirstNilClass::Classdef
"AllocFirstNilClass \<equiv> emp[Copy \<mapsto> NilCopy][OptCopy \<mapsto> NilCopy][AllocFirstCopy \<mapsto> NilCopy]"

constdefs AllocFirstConsClass::Classdef
"AllocFirstConsClass \<equiv> emp[Copy \<mapsto> ConsCopy][OptCopy \<mapsto> ConsOpt][AllocFirstCopy \<mapsto> AllocFirst]"

constdefs ALLOCFIRST::Prog
"ALLOCFIRST \<equiv> emp[LIST \<mapsto> AllocFirstListClass][NIL \<mapsto> AllocFirstNilClass][CONS \<mapsto> AllocFirstConsClass]"

(*<*) 
end
(*>*)