(*<*)
theory ListSL_NIArbVerif = ListProgs +  ExampleBase:
(*>*)

datatype ContLevel = low Colour | high Colour Colour

consts NPred :: "(TP \<times> Colour \<times> ((ContLevel \<times> Colour) list) \<times> MP
                     \<times> Colour \<times> ((ContLevel \<times> Colour) list) \<times> MP) set"

inductive NPred intros
NPred_Nil: "\<lbrakk>N=emp[\<omega>\<mapsto>(classTP NIL)]; star N (emp[\<alpha>\<mapsto>(classTP NIL)]) M\<rbrakk> \<Longrightarrow> (tp,\<omega>,[],N,\<alpha>,[],M):NPred"
NPred_Low:"\<lbrakk>(tp, \<delta>, \<Lambda>, N, \<epsilon>, \<Omega>, M) : NPred;
              star N (emp[\<omega>\<mapsto>(classTP CONS)]) N'; star N' (emp[\<gamma>\<mapsto>tp]) NN; 
              star M (emp[\<omega>\<mapsto>(classTP CONS)]) M'; star M' (emp[\<gamma>\<mapsto>tp]) M''; star M'' (emp[\<alpha>\<mapsto>(classTP CONS)]) MM\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, (low \<gamma>,\<delta>)#\<Lambda>, NN, \<alpha>, (low \<gamma>,\<epsilon>)#\<Omega>, MM):NPred"
NPred_High:"\<lbrakk>(tp, \<delta>, \<Lambda>, N, \<epsilon>, \<Omega>, M) : NPred;
               star N (emp[\<omega>\<mapsto>(classTP CONS)]) N'; 
               star N' (emp[\<gamma>\<mapsto>tp]) N''; star N'' (emp[\<gamma>'\<mapsto>tp]) NN; 
               star M (emp[\<omega>\<mapsto>(classTP CONS)]) M'; star M' (emp[\<gamma>\<mapsto>tp]) M'';
               star M'' (emp[\<gamma>'\<mapsto>tp]) M'''; star M''' (emp[\<alpha>\<mapsto>(classTP CONS)]) MM\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, (high \<gamma> \<gamma>',\<delta>)#\<Lambda>, NN, \<alpha>, (high \<gamma> \<gamma>',\<epsilon>)#\<Omega>, MM):NPred"

lemma NPred_length: "(tp, \<omega>, \<Omega>, N, \<alpha>, \<Lambda>, M) \<in> NPred \<Longrightarrow> length \<Omega> = length \<Lambda>"
(*<*)
apply (erule NPred.induct)
  apply simp
  apply simp
  apply simp
done
(*>*)

lemma NPred_preMP_AL: "(tp, \<omega>, \<Omega>, N, \<alpha>, \<Lambda>, M) \<in> NPred \<Longrightarrow> N:AL"
(*<*)
apply (erule NPred.induct)
  apply simp apply (rule AL_UPD, rule AL_EMP)
  apply (simp add: star_def)
  apply (simp add: star_def)
done
(*>*)

lemma NPred_postMP_AL: "(tp, \<omega>, \<Omega>, N, \<alpha>, \<Lambda>, M) \<in> NPred \<Longrightarrow> M:AL"
(*<*)
apply (erule NPred.induct)
  apply (simp add: star_def)
  apply (simp add: star_def)
  apply (simp add: star_def)
done
(*>*)

lemma NPred_MP_contained: "(tp, \<omega>, \<Omega>, N, \<alpha>, \<Lambda>, M) \<in> NPred \<Longrightarrow> contained N M"
(*<*)
apply (erule NPred.induct)
  apply (simp add: star_def AL_sum_def)
  apply (simp add: star_def contained_def, clarsimp)
    apply (erule AL_sum3)
    apply (drule AL_sum_split, assumption)
    apply (erule disjE)
      apply (erule AL_sum3) 
      apply (drule AL_sum_split, assumption)
      apply (erule disjE) apply (erule AL_sum3) apply fast
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
      apply (simp add: AL_emp1)
    apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
      apply (simp add: AL_emp1)
  apply (simp add: star_def contained_def, clarsimp)
    apply (erule AL_sum3)
    apply (drule AL_sum_split, assumption)
    apply (erule disjE)
      apply (erule AL_sum3) 
      apply (drule AL_sum_split, assumption)
      apply (erule disjE) apply (erule AL_sum3) 
        apply (drule AL_sum_split, assumption)
        apply (erule disjE) apply (erule AL_sum3) apply fast
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
        apply (simp add: AL_emp1)
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
      apply (simp add: AL_emp1)
    apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
      apply (simp add: AL_emp1)
done
(*>*)

lemma NPred_lowHighShape:
  "(tp, \<omega>, \<Omega> , N, \<alpha>, \<Upsilon>, M) \<in> NPred \<Longrightarrow> 
     \<forall> y \<delta> \<Lambda> x \<epsilon> \<Theta> . \<Omega>=(y, \<delta>) # \<Lambda> \<longrightarrow> 
                      \<Upsilon> = (x, \<epsilon>) # \<Theta> \<longrightarrow> x = y"
(*<*)
apply (erule NPred.elims)
apply clarsimp
apply clarsimp
apply clarsimp
done
(*>*)

consts Z_NHigh :: "(TP \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP
                       \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP) set"
       Z_NLow ::  "(TP \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP
                       \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP) set"

inductive Z_NHigh Z_NLow intros
Z_NHigh_Nil:"\<lbrakk>N=emp[\<omega>\<mapsto>(classTP NIL)]; star N (emp[\<alpha>\<mapsto>(classTP NIL)]) M\<rbrakk> \<Longrightarrow> (tp,\<omega>,[],[],N,\<alpha>,[],[],M):Z_NHigh"
Z_NHigh_Cons:"\<lbrakk>xx=(\<gamma>,\<delta>); xx'=(\<gamma>',\<delta>); yy=(\<gamma>,\<epsilon>); yy'=(\<gamma>',\<epsilon>);
               (tp, \<delta>, \<Lambda>, \<Lambda>', N, \<epsilon>, \<Omega>, \<Omega>', M) : Z_NLow; 
               star N (emp[\<omega>\<mapsto>(classTP CONS)]) N'; 
               star N' (emp[\<gamma>\<mapsto>tp]) N''; star N'' (emp[\<gamma>'\<mapsto>tp]) NN;
               star M (emp[\<omega>\<mapsto>(classTP CONS)]) M';
               star M' (emp[\<gamma>\<mapsto>tp]) M''; star M'' (emp[\<gamma>'\<mapsto>tp]) M'''; star M''' (emp[\<alpha>\<mapsto>(classTP CONS)]) MM\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, xx#\<Lambda>, xx'#\<Lambda>', NN, \<alpha>, yy#\<Omega>, yy'#\<Omega>', MM):Z_NHigh"
Z_NLow_Nil:"\<lbrakk>N=emp[\<omega>\<mapsto>(classTP NIL)]; star N (emp[\<alpha>\<mapsto>(classTP NIL)]) M\<rbrakk> \<Longrightarrow> (tp,\<omega>,[],[],N,\<alpha>,[],[],M):Z_NLow"
Z_NLow_Cons:"\<lbrakk>xx=(\<gamma>,\<delta>); yy=(\<gamma>,\<epsilon>); (tp, \<delta>, \<Lambda>, \<Lambda>', N, \<epsilon>, \<Omega>, \<Omega>', M) : Z_NHigh; 
              star N (emp[\<omega>\<mapsto>(classTP CONS)]) N'; star N' (emp[\<gamma>\<mapsto>tp]) NN; 
              star M (emp[\<omega>\<mapsto>(classTP CONS)]) M'; star M' (emp[\<gamma>\<mapsto>tp]) M''; star M'' (emp[\<alpha>\<mapsto>(classTP CONS)]) MM\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, xx#\<Lambda>, xx#\<Lambda>', NN, \<alpha>, yy#\<Omega>, yy#\<Omega>', MM):Z_NLow"

consts Z_convert::"((Colour \<times> Colour) list) \<Rightarrow> ((Colour \<times> Colour) list) \<Rightarrow> ((ContLevel \<times> Colour) list) option"
primrec
"Z_convert [] L = (case L of [] \<Rightarrow> Some [] | (\<gamma>'#Cols') \<Rightarrow> None)"
"Z_convert (xy#Cols) L = 
   (case L of [] \<Rightarrow> None 
       | (xy'#Cols') \<Rightarrow> (case Z_convert Cols Cols' of
                           None \<Rightarrow> None
                       | Some M \<Rightarrow> (case xy of (\<gamma>,\<delta>) \<Rightarrow>
                                    case xy' of (\<gamma>',\<delta>') \<Rightarrow> 
                                    (if \<delta> = \<delta>'
                                      then Some (((if \<gamma>=\<gamma>' then (low \<gamma>) else (high \<gamma> \<gamma>')),\<delta>)#M)
                                      else None))))"

lemma "((tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Omega>,\<Omega>',M):Z_NHigh \<longrightarrow> (\<exists> X Y . Z_convert \<Lambda> \<Lambda>' = Some X \<and> Z_convert \<Omega> \<Omega>' = Some Y \<and> 
                                                     (tp,\<omega>,X,N,\<alpha>,Y,M):NPred)) \<and> 
       ((tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Omega>,\<Omega>',M):Z_NLow \<longrightarrow> (\<exists> X Y . Z_convert \<Lambda> \<Lambda>' = Some X \<and> Z_convert \<Omega> \<Omega>' = Some Y \<and> 
                                                     (tp,\<omega>,X,N,\<alpha>,Y,M):NPred))"
(*<*)
apply (rule Z_NHigh_Z_NLow.induct)
apply clarsimp apply (rule NPred_Nil) apply simp apply assumption 
apply clarsimp
  apply rule apply clarsimp apply (simp add: star_def AL_sum_def AL_dom_upd1 AL_dom_emp)
  apply clarsimp apply (erule NPred_High) apply assumption+
apply clarsimp apply (rule NPred_Nil) apply simp apply assumption
apply clarsimp
  apply (erule NPred_Low) apply assumption+
done
(*>*)

consts Hleft::"Colour \<Rightarrow> ((ContLevel \<times> Colour) list) \<Rightarrow> HP option"
primrec
"Hleft \<omega> [] = Some(emp[\<omega>\<mapsto>(NIL,emp)])"
"Hleft \<omega> (ht # \<Lambda>) = 
     (case ht of (cont,\<delta>) \<Rightarrow>
        (case Hleft \<delta> \<Lambda> of
           None \<Rightarrow> None
         | Some H \<Rightarrow> (if \<omega> \<in> AL_dom H 
                   then None 
                   else case cont of low \<gamma> \<Rightarrow> Some(H[\<omega>\<mapsto>(CONS,emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])])
                                   | high \<gamma> \<gamma>' \<Rightarrow> Some(H[\<omega>\<mapsto>(CONS,emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]))))"

consts Hright::"Colour \<Rightarrow> ((ContLevel \<times> Colour) list) \<Rightarrow> HP option"
primrec
"Hright \<omega> [] = Some(emp[\<omega>\<mapsto>(NIL,emp)])"
"Hright \<omega> (ht # \<Lambda>) = 
     (case ht of (cont,\<delta>) \<Rightarrow>
        (case Hright \<delta> \<Lambda> of
           None \<Rightarrow> None
         | Some H \<Rightarrow> (if \<omega> \<in> AL_dom H 
                   then None 
                   else case cont of low \<gamma> \<Rightarrow> Some(H[\<omega>\<mapsto>(CONS,emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])])
                                   | high \<gamma> \<gamma>' \<Rightarrow> Some(H[\<omega>\<mapsto>(CONS,emp[HD\<mapsto>\<gamma>'][TL\<mapsto>\<delta>])]))))"

(*<*)
lemma Hleft_AL[rule_format]: "\<forall> \<omega> H . Hleft \<omega> \<Lambda> = Some H \<longrightarrow> H:AL"
apply (induct \<Lambda>)
apply clarsimp apply (rule AL_UPD, rule AL_EMP)
apply clarsimp 
  apply (case_tac "Hleft b \<Lambda>", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom aa", clarsimp, clarsimp)
  apply (erule_tac x=b in allE, erule_tac x=aa in allE, clarsimp)
  apply (case_tac a, clarsimp) apply (erule AL_UPD)
  apply clarsimp  apply (erule AL_UPD)
done

lemma Hright_AL[rule_format]: "\<forall> \<omega> H . Hright \<omega> \<Lambda> = Some H \<longrightarrow> H:AL"
apply (induct \<Lambda>)
apply clarsimp apply (rule AL_UPD, rule AL_EMP)
apply clarsimp 
  apply (case_tac "Hright b \<Lambda>", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom aa", clarsimp, clarsimp)
  apply (erule_tac x=b in allE, erule_tac x=aa in allE, clarsimp)
  apply (case_tac a, clarsimp) apply (erule AL_UPD)
  apply clarsimp  apply (erule AL_UPD)
done
(*>*)

constdefs mkRSD::"Colour \<Rightarrow> MP \<Rightarrow> HP \<Rightarrow> HP \<Rightarrow> RSD"
"mkRSD \<omega> N H K \<equiv> (([],emp[this\<mapsto>\<omega>],H),N,([],emp[this\<mapsto>\<omega>],K))"

text{*Next, the definition of specification sets.*}

constdefs NISp::"TP \<Rightarrow> nat \<Rightarrow> (RSD \<times> RSD) set"
"NISp tp n \<equiv> { (\<phi>,\<psi>) . \<exists> \<omega> \<Omega> \<alpha> \<Lambda> H K H' K' HK H'K' M N. 
                       Hleft \<omega> \<Omega> = Some H \<and> Hright \<omega> \<Omega> = Some H' \<and> 
                       \<phi> = mkRSD \<omega> N H H' \<and>
                       Hleft \<alpha> \<Lambda> = Some K \<and> Hright \<alpha> \<Lambda> = Some K' \<and> 
                       star H K HK \<and> star H' K' H'K' \<and>
                       \<psi>= (([\<alpha>],emp,HK),M,([\<alpha>],emp,H'K')) \<and> 
                       (tp, \<omega>, \<Omega>, N, \<alpha>, \<Lambda>, M):NPred \<and>
                       length \<Lambda> = n}"

text{*The proof context.*}

constdefs G::"TP \<Rightarrow> Ctxt"
"G tp \<equiv> {(ppts,S) . ppts = ((NilCopy,0),(NilCopy,0)) \<and> S \<in> NISp tp 0} \<union>
         {(ppts,S) . \<exists> n . n>0 \<and> ppts=((ConsCopy,0),(ConsCopy,0)) \<and> S \<in> NISp tp n}"

text{*The main verification of the method.*}

lemma G_verified:
   "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];
        \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
      mbody_is LIST Copy ListCopy; mbody_is NIL Copy NilCopy; mbody_is CONS Copy ConsCopy\<rbrakk> 
    \<Longrightarrow> CtxtVerified (G tp)"
(*<*)
apply (simp add: G_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp)
  apply (simp add: NISp_def mkRSD_def) apply (rotate_tac -3, erule thin_rl, erule thin_rl)  
  apply clarsimp
  apply (erule NPred.elims) prefer 2 apply clarsimp prefer 2 apply clarsimp apply clarsimp
  apply (rename_tac HK H'K' M \<alpha> \<omega>)
  apply (subgoal_tac "contained emp[\<omega>\<mapsto>(classTP NIL)] M \<and>
                      AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<subseteq> AL_dom HK \<and>
                      AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<subseteq> AL_dom H'K'")
  prefer 2 apply (simp add: star_def contained_def, clarsimp)
           apply (rule, clarsimp) apply (drule AL_upd_split)
                                  apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
                                  apply (simp add: AL_emp1)
           apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)           
  apply rule  apply (simp add: preserved_def) 
  apply (subgoal_tac "(G tp,(([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)]), 
                              emp[\<omega>\<mapsto>(classTP NIL)], 
                             ([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])), 
                            NilCopy, 0, NilCopy, 0, False, 
                            ([\<alpha>], emp, HK), M, ([\<alpha>], emp, H'K')) \<in> Typing") apply (simp add: G_def NISp_def mkRSD_def)
  apply (rule_tac c=\<alpha> and C=NIL in TypingNewNew)
    apply (rule InstrNIL0)
    apply (rule InstrNIL0)
    apply fastsimp
    apply (simp add: star_def AL_dom_upd1 AL_dom_emp)
    apply (simp add: subclass_of_refl)
    apply (simp add: subclass_of_refl)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply fastsimp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def star_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def AL_emp1)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
        apply (rule, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule_tac disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3, rule AL_update1) 
            apply (simp add: AL_emp1)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
        apply (rule, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule_tac disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3, rule AL_update1) 
            apply (simp add: AL_emp1)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
        apply (rule, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule_tac disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3, rule AL_update1) 
            apply (simp add: AL_emp1)
(*n>0*)
apply clarsimp
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (simp add: NISp_def, clarsimp)
  apply (subgoal_tac "preserved (mkRSD \<omega> N H H') (([\<alpha>], emp, bd), ak, [\<alpha>], emp, be)", simp add: preserved_def) 
  prefer 2 apply (simp add: preserved_def mkRSD_def, clarsimp) 
           apply (rename_tac HK M H'K' \<omega> \<Omega> \<alpha> \<Lambda> H K H' K' N)
           apply rule apply (erule NPred_MP_contained)
           apply (simp add: star_def AL_sum_def) apply fast
  apply (subgoal_tac "(G tp,mkRSD \<omega> N H H', ConsCopy, 0, ConsCopy, 0, False, ([\<alpha>], emp, bd), ak, [\<alpha>], emp, be)
          \<in> Typing", simp add: G_def NISp_def)
  apply (simp add: mkRSD_def) apply clarsimp
  apply (rename_tac HK M H'K' \<omega> \<Omega> \<alpha> \<Lambda> H K H' K' N)
  apply (frule NPred_length)
  apply (case_tac \<Lambda>, clarsimp) apply clarsimp 
  apply (case_tac \<Omega>, clarsimp) apply clarsimp 
  apply (case_tac "Hleft ba lista", clarsimp,clarsimp)
  apply (case_tac "Hright ba lista", clarsimp,clarsimp) 
  apply (case_tac "Hleft b list", clarsimp,clarsimp) 
  apply (case_tac "Hright b list", clarsimp,clarsimp) 
  apply (case_tac "\<omega> \<in> AL_dom ab", clarsimp,clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ad", clarsimp,clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ae", clarsimp,clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom ac", clarsimp,clarsimp)
  apply (rename_tac x \<epsilon> \<Theta> y \<delta> \<Lambda> H0 H0' K0 K0')
  apply (frule NPred_lowHighShape) apply clarsimp
apply (erule NPred.elims, clarsimp)
(*Case NPredLow*)
  apply clarsimp
  apply (rename_tac HK H'K' H0 H0' K0 K0' M M' M'' MM N N' NN \<Lambda> \<Theta> \<alpha> \<delta> \<epsilon> \<gamma> \<omega>) 
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (simp add: star_def, (erule conjE)+)
  apply (subgoal_tac "AL_dom H0[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])] \<inter> AL_dom K0 = {}")
  prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
  apply (frule_tac M=K0 in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
  apply (subgoal_tac "AL_dom H0'[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])] \<inter> AL_dom K0' = {}")
  prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
  apply (frule_tac M=K0' in AL_sum_exists_AL) apply (erule exE, rename_tac HH', erule conjE)

  apply (subgoal_tac "(G tp, (([\<epsilon>], emp[this\<mapsto>\<omega>][h\<mapsto>\<gamma>][t\<mapsto>\<delta>], HH), 
                                 delete MM \<alpha>,
                                 [\<epsilon>], emp[this\<mapsto>\<omega>][h\<mapsto>\<gamma>][t\<mapsto>\<delta>],HH'),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), False,
           ([\<alpha>], emp, HK), MM, [\<alpha>], emp, H'K')
          \<in> Typing")
  prefer 2
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS8)
        apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS8)
        apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=\<alpha> and C=CONS in TypingNewNew)
        apply (rule InstrCONS9)
        apply (rule InstrCONS9)
        apply fastsimp
        apply (simp add: AL_dom_delete)
        apply (simp add: subclass_of_refl)
        apply (simp add: subclass_of_refl)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS10)
       apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS10)
        apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS11)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS11)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS12)
        apply fastsimp    
         apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
         apply simp
         apply simp
         apply simp
         apply (rule UniCtxtVerified_emp)
         (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS12)
        apply fastsimp    
        apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniPut)
        apply (rule InstrCONS13)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniPut)
        apply (rule InstrCONS13)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS14)
        apply fastsimp    
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS14)
        apply fastsimp    
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS15)
        apply fastsimp    
        apply (rule AL_update4, rule AL_update1) apply clarsimp
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrCONS18)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply rule apply (rule AL_UPD) apply (erule AL_DEL) 
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1)
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply assumption
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply assumption
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp) apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) 
              apply (erule AL_sum4) apply(rule AL_update1)
            apply clarsimp apply (drule AL_delete6) apply clarsimp 
              apply (simp add: AL_emp1) 
  apply (case_tac \<Lambda>, clarsimp)
  (*case NIL*)
  apply (erule NPred.elims) prefer 2 apply clarsimp prefer 2 apply clarsimp apply clarsimp 
  apply (rename_tac \<epsilon> \<delta>)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (subgoal_tac "AL_dom emp[\<delta>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<epsilon>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<delta>\<mapsto>(NIL, emp)]" and M="emp[\<epsilon>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<delta>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<epsilon>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<delta>\<mapsto>(classTP NIL)]" and M="emp[\<epsilon>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<delta>],emp[\<delta>\<mapsto>(NIL, emp)]),emp[\<delta>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<delta>],emp[\<delta>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]" 
                     and K="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]" in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) 
                       apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def contained_def)
                   apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) 
                       apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)   
        apply (rotate_tac -9) apply (erule thin_rl)
          apply (rule TypingAx) apply (simp add: G_def) apply (rule disjI1)
                              apply (simp add: NISp_def mkRSD_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<delta> in exI, rule_tac x="[]" in exI, simp)
                              apply (rule_tac x=\<epsilon> in exI, rule_tac x="[]" in exI, simp)
                              apply (simp add: star_def)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, assumption)
                              apply simp                               
                              apply (rule, rule, simp)
                              apply (rule NPred_Nil) apply simp apply (simp add: star_def) 
        apply (simp add: RSD_sum_def star_def) 
           apply (rule, erule AL_DEL) 
           apply (simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (rotate_tac -1, erule disjE) 
                       apply (drule AL_upd_split)
                       apply (rotate_tac -1, erule disjE, clarsimp) 
                         apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule, clarsimp)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (rotate_tac -1, erule disjE) 
                       apply (drule AL_upd_split)
                       apply (rotate_tac -1, erule disjE, clarsimp) 
                         apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule,clarsimp)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
                 apply (rule, simp  add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp) 
                    apply (rule, clarsimp)
                      apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                      apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
                    apply (rule, clarsimp)
                      apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                      apply (erule AL_sum3) 
                      apply (drule AL_upd_split) 
                      apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                      apply (erule AL_sum3) apply (erule AL_sum4) apply assumption  
                    apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)   
  (*Case \<Lambda> non-empty*)
  apply clarsimp
  apply (erule NPred.elims) apply clarsimp
  (*NPredLow*)
  apply clarsimp
  apply (rename_tac \<alpha> \<delta> \<epsilon> \<gamma> \<omega>)
  apply (case_tac "Hleft \<delta> \<Lambda>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<delta> \<Lambda>", clarsimp, clarsimp)
  apply (case_tac "Hleft \<epsilon> \<Omega>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<epsilon> \<Omega>", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom a", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom aa", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ab", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ac", clarsimp, clarsimp)
  apply (rename_tac \<upsilon> \<gamma> \<omega> HH HH' M M\<delta> M\<delta>\<mu> M\<delta>\<mu>\<epsilon> N N\<delta> N\<delta>\<mu> \<Lambda> \<Omega> \<epsilon> \<beta> \<alpha> \<mu> \<delta> H0 H0' K0 K0')
  apply (subgoal_tac "AL_dom H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])] \<inter> AL_dom K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])]" and M="K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])] \<inter> AL_dom K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])] = {}") 
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])]" and M="K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac H="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]"
                     and K="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]"
                     and \<gamma>="(([],emp[this\<mapsto>\<delta>],upd H0 \<delta> (CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])),
                              N\<delta>\<mu>,
                             ([],emp[this\<mapsto>\<delta>],upd H0' \<delta> (CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def star_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hleft_AL)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hright_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: star_def AL_sum_def AL_dom_delete AL_dom_upd1 AL_dom_emp) 
            apply (simp add: contained_def, rule, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
              apply clarsimp apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1) 
                                apply (simp add: AL_emp1) 
            apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length \<Lambda>)" in exI, simp)
          apply (rule, simp add: ConsCopy_def)
          apply (simp add: NISp_def mkRSD_def)
          apply (rule_tac x=\<delta> in exI, rule_tac x="(low \<mu>, \<beta>) # \<Lambda>" in exI, simp add: star_def)
          apply (rule_tac x=\<epsilon> in exI, rule_tac x="(low \<mu>, \<alpha>) # \<Omega>" in exI, simp)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule) apply simp
          apply (erule NPred_Low) apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption)
                                  apply (simp add: star_def)
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
        apply (simp add: RSD_sum_def star_def, (erule conjE)+)
          apply rule apply (erule AL_DEL) 
          apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp) 
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (erule AL_sum3) apply (erule conjE)
                                    apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (simp add: AL_emp1)
             apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
  (*NPredHigh*)
  apply clarsimp
  apply (rename_tac \<alpha> \<delta> \<epsilon> \<gamma> \<gamma>' \<omega>)
  apply (case_tac "Hleft \<delta> \<Lambda>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<delta> \<Lambda>", clarsimp, clarsimp)
  apply (case_tac "Hleft \<epsilon> \<Omega>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<epsilon> \<Omega>", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom a", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom aa", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ab", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ac", clarsimp, clarsimp)
  apply (rename_tac \<upsilon> \<gamma> \<omega> HH HH' M M\<delta> M\<delta>\<mu> M\<delta>\<mu>\<mu>' M\<delta>\<mu>\<mu>'\<epsilon> N N\<delta> N\<delta>\<mu> N\<delta>\<mu>\<mu>' \<Lambda> \<Omega> \<epsilon> \<beta> \<alpha> \<mu> \<mu>' \<delta> H0 H0' K0 K0')
  apply (subgoal_tac "AL_dom H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])] \<inter> AL_dom K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])]" and M="K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])] \<inter> AL_dom K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<alpha>])] = {}") 
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])]" and M="K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac H="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]"
                     and K="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]"
                     and \<gamma>="(([],emp[this\<mapsto>\<delta>],upd H0 \<delta> (CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])),
                              N\<delta>\<mu>\<mu>',
                             ([],emp[this\<mapsto>\<delta>],upd H0' \<delta> (CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def star_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hleft_AL)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hright_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: star_def AL_sum_def AL_dom_delete AL_dom_upd1 AL_dom_emp) 
            apply (simp add: contained_def, rule, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
              apply clarsimp apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1) 
                                apply (simp add: AL_emp1) 
            apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length \<Lambda>)" in exI, simp)
          apply (rule, simp add: ConsCopy_def)
          apply (simp add: NISp_def mkRSD_def)
          apply (rule_tac x=\<delta> in exI, rule_tac x="(high \<mu> \<mu>', \<beta>) # \<Lambda>" in exI, simp add: star_def)
          apply (rule_tac x=\<epsilon> in exI, rule_tac x="(high \<mu> \<mu>', \<alpha>) # \<Omega>" in exI, simp)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule) apply simp
          apply (erule NPred_High) apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption)
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) 
                                  apply (simp add: star_def) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
        apply (simp add: RSD_sum_def star_def, (erule conjE)+)
          apply rule apply (erule AL_DEL) 
          apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp) 
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (erule AL_sum3) apply (erule conjE)
                                    apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (simp add: AL_emp1)
             apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
(*Case NPredHigh*)
  apply clarsimp
  apply (rename_tac HK H'K' H0 H0' K0 K0' M M' M'' M''' MM N N' N'' NN \<Lambda> \<Theta> \<alpha> \<delta> \<epsilon> \<gamma> \<gamma>' \<omega>) 
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (simp add: star_def, (erule conjE)+)
  apply (subgoal_tac "AL_dom H0[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])] \<inter> AL_dom K0 = {}")
  prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
  apply (frule_tac M=K0 in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
  apply (subgoal_tac "AL_dom H0'[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>'][TL\<mapsto>\<delta>])] \<inter> AL_dom K0' = {}")
  prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
  apply (frule_tac M=K0' in AL_sum_exists_AL) apply (erule exE, rename_tac HH', erule conjE)

  apply (subgoal_tac "(G tp, (([\<epsilon>], emp[this\<mapsto>\<omega>][h\<mapsto>\<gamma>][t\<mapsto>\<delta>], HH), 
                                 delete MM \<alpha>,
                                 [\<epsilon>], emp[this\<mapsto>\<omega>][h\<mapsto>\<gamma>'][t\<mapsto>\<delta>],HH'),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), False,
           ([\<alpha>], emp, HK), MM, [\<alpha>], emp, H'K')
          \<in> Typing")
  prefer 2
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS8)
        apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS8)
        apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule_tac c=\<alpha> and C=CONS in TypingNewNew)
        apply (rule InstrCONS9)
        apply (rule InstrCONS9)
        apply fastsimp
        apply (simp add: AL_dom_delete)
        apply (simp add: subclass_of_refl)
        apply (simp add: subclass_of_refl)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS10)
       apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniStore)
        apply (rule InstrCONS10)
        apply fastsimp    
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS11)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS11)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS12)
        apply fastsimp    
         apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
         apply simp
         apply simp
         apply simp
         apply (rule UniCtxtVerified_emp)
         (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS12)
        apply fastsimp    
        apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniPut)
        apply (rule InstrCONS13)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniPut)
        apply (rule InstrCONS13)
        apply fastsimp    
        apply (rule AL_update1)
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS14)
        apply fastsimp    
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectR)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS14)
        apply fastsimp    
        apply (rule AL_update1) 
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
      apply (rule TypingInj)
      apply (rule UniInjectL)
      prefer 3 apply fastsimp
      apply (rule UniLoad)
        apply (rule InstrCONS15)
        apply fastsimp    
        apply (rule AL_update4, rule AL_update1) apply clarsimp
        apply simp
        apply simp
        apply simp
        apply (rule UniCtxtVerified_emp)
        (* apply fast *)
      apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrCONS18)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply rule apply (rule AL_UPD) apply (erule AL_DEL) 
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1)
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply assumption
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply assumption
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp) apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) 
              apply (erule AL_sum4) apply(rule AL_update1)
            apply clarsimp apply (drule AL_delete6) apply clarsimp 
              apply (simp add: AL_emp1) 
  (*Now that we've verified the tail of the method body, let's verify the invocation.
   Unfortunately, this means we've got to unfold NPred once more, to do the case distinction 
   regarding the object type*)
  apply (case_tac \<Lambda>, clarsimp)
  (*case NIL*)
  apply (erule NPred.elims) prefer 2 apply clarsimp prefer 2 apply clarsimp apply clarsimp 
  apply (rename_tac M \<epsilon> \<delta>)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (subgoal_tac "AL_dom emp[\<delta>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<epsilon>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<delta>\<mapsto>(NIL, emp)]" and M="emp[\<epsilon>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<delta>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<epsilon>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<delta>\<mapsto>(classTP NIL)]" and M="emp[\<epsilon>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<delta>],emp[\<delta>\<mapsto>(NIL, emp)]),emp[\<delta>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<delta>],emp[\<delta>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp]" 
                     and K="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>'][TL\<mapsto>\<delta>])]" in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) 
                       apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def contained_def)
                   apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                   apply (rule, clarsimp) 
                     apply (rule AL_update4) apply assumption apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def contained_def)
                   apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3)  apply (erule AL_sum3) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)   
        apply (rotate_tac -9) apply (erule thin_rl)
          apply (rule TypingAx) apply (simp add: G_def) apply (rule disjI1)
                              apply (simp add: NISp_def mkRSD_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<delta> in exI, rule_tac x="[]" in exI, simp)
                              apply (rule_tac x=\<epsilon> in exI, rule_tac x="[]" in exI, simp)
                              apply (simp add: star_def)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, assumption)
                              apply simp                               
                              apply (rule, rule, simp)
                              apply (rule NPred_Nil) apply simp apply (simp add: star_def) 
        apply (simp add: RSD_sum_def star_def) 
           apply (rule, erule AL_DEL) 
           apply (simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (rotate_tac -1, erule disjE) 
                       apply (drule AL_upd_split)
                       apply (rotate_tac -1, erule disjE, clarsimp) 
                         apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule, clarsimp)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (rotate_tac -1, erule disjE) 
                       apply (drule AL_upd_split)
                       apply (rotate_tac -1, erule disjE, clarsimp) 
                         apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule,clarsimp)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
                 apply (rule, simp  add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp) 
                    apply (rule, clarsimp)
                      apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                      apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
                    apply (rule, clarsimp)
                      apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                      apply (erule AL_sum3) 
                      apply (drule AL_upd_split) 
                      apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                      apply (erule AL_sum3) 
                      apply (drule AL_upd_split) 
                      apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                      apply (erule AL_sum3) apply (erule AL_sum4) apply assumption  
                    apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)   
  (*Case \<Lambda> non-empty*)
  apply clarsimp
  apply (erule NPred.elims) apply clarsimp
  (*NPredLow*)
  apply clarsimp
  apply (rename_tac \<alpha> \<delta> \<epsilon> \<gamma> \<omega>)
  apply (case_tac "Hleft \<delta> \<Lambda>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<delta> \<Lambda>", clarsimp, clarsimp)
  apply (case_tac "Hleft \<epsilon> \<Omega>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<epsilon> \<Omega>", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom a", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom aa", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ab", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ac", clarsimp, clarsimp)
  apply (rename_tac M\<delta>\<mu>\<epsilon>\<omega> M\<delta>\<mu>\<epsilon>\<omega>\<gamma> M\<delta>\<mu>\<epsilon>\<omega>\<gamma>\<gamma>' MM N\<delta>\<mu>\<omega> N\<delta>\<mu>\<omega>\<gamma> NN \<upsilon> \<gamma> \<gamma>' \<omega> HH HH' M M\<delta> M\<delta>\<mu> M\<delta>\<mu>\<epsilon> N N\<delta> N\<delta>\<mu> \<Lambda> \<Omega> \<epsilon> \<beta> \<alpha> \<mu> \<delta>  H0 H0' K0 K0')
  apply (subgoal_tac "AL_dom H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])] \<inter> AL_dom K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])]" and M="K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])] \<inter> AL_dom K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])] = {}") 
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])]" and M="K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac H="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]"
                     and K="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>'][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp]"
                     and \<gamma>="(([],emp[this\<mapsto>\<delta>],upd H0 \<delta> (CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])),
                              N\<delta>\<mu>,
                             ([],emp[this\<mapsto>\<delta>],upd H0' \<delta> (CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def star_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hleft_AL)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hright_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: star_def AL_sum_def AL_dom_delete AL_dom_upd1 AL_dom_emp) 
            apply (simp add: contained_def, rule, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
              apply clarsimp apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                             apply (erule AL_sum3)
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                             apply (erule AL_sum3) 
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) 
                                apply (simp add: AL_emp1) 
            apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length \<Lambda>)" in exI, simp)
          apply (rule, simp add: ConsCopy_def)
          apply (simp add: NISp_def mkRSD_def)
          apply (rule_tac x=\<delta> in exI, rule_tac x="(low \<mu>, \<beta>) # \<Lambda>" in exI, simp add: star_def)
          apply (rule_tac x=\<epsilon> in exI, rule_tac x="(low \<mu>, \<alpha>) # \<Omega>" in exI, simp)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule) apply simp
          apply (erule NPred_Low) apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption)
                                  apply (simp add: star_def)
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
        apply (simp add: RSD_sum_def star_def, (erule conjE)+)
          apply rule apply (erule AL_DEL) 
          apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp) 
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (erule AL_sum3) apply (erule conjE)
                                    apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (erule AL_sum3) apply (erule conjE)
                                    apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (simp add: AL_emp1)
             apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
  (*NPredHigh*)
  apply clarsimp
  apply (rename_tac \<alpha> \<delta> \<epsilon> \<gamma> \<gamma>' \<omega>)
  apply (case_tac "Hleft \<delta> \<Lambda>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<delta> \<Lambda>", clarsimp, clarsimp)
  apply (case_tac "Hleft \<epsilon> \<Omega>", clarsimp, clarsimp)  
  apply (case_tac "Hright \<epsilon> \<Omega>", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom a", clarsimp, clarsimp)
  apply (case_tac "\<omega> \<in> AL_dom aa", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ab", clarsimp, clarsimp)
  apply (case_tac "\<alpha> \<in> AL_dom ac", clarsimp, clarsimp)
  apply (rename_tac M\<delta>\<mu>\<mu>'\<epsilon>\<omega> M\<delta>\<mu>\<mu>'\<epsilon>\<omega>\<gamma> M\<delta>\<mu>\<mu>'\<epsilon>\<omega>\<gamma>' MM N\<delta>\<mu>\<mu>'\<omega> N\<delta>\<mu>\<mu>'\<omega>\<gamma> NN \<upsilon> \<gamma> \<gamma>' \<omega> HH HH' 
                    M M\<delta> M\<delta>\<mu> M\<delta>\<mu>\<mu>' M\<delta>\<mu>\<mu>'\<epsilon> N N\<delta> N\<delta>\<mu> N\<delta>\<mu>\<mu>' \<Lambda> \<Omega> \<epsilon> \<beta> \<alpha> \<mu> \<mu>' \<delta> H0 H0' K0 K0')
  apply (subgoal_tac "AL_dom H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])] \<inter> AL_dom K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])]" and M="K0[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])] \<inter> AL_dom K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<alpha>])] = {}") 
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H0'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])]" and M="K0'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac H="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>][TL\<mapsto>\<delta>])]"
                     and K="emp[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<gamma>'][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp]"
                     and \<gamma>="(([],emp[this\<mapsto>\<delta>],upd H0 \<delta> (CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])),
                              N\<delta>\<mu>\<mu>',
                             ([],emp[this\<mapsto>\<delta>],upd H0' \<delta> (CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def star_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hleft_AL)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule Hright_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: star_def AL_sum_def AL_dom_delete AL_dom_upd1 AL_dom_emp) 
            apply (simp add: contained_def, rule, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
              apply clarsimp apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                             apply (erule AL_sum3) 
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                             apply (erule AL_sum3) 
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) 
                                apply (simp add: AL_emp1) 
            apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length \<Lambda>)" in exI, simp)
          apply (rule, simp add: ConsCopy_def)
          apply (simp add: NISp_def mkRSD_def)
          apply (rule_tac x=\<delta> in exI, rule_tac x="(high \<mu> \<mu>', \<beta>) # \<Lambda>" in exI, simp add: star_def)
          apply (rule_tac x=\<epsilon> in exI, rule_tac x="(high \<mu> \<mu>', \<alpha>) # \<Omega>" in exI, simp)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule, assumption)
          apply (rule, assumption)
          apply (rule, rule) apply simp
          apply (erule NPred_High) apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption)
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) 
                                  apply (simp add: star_def) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
                                  apply (simp add: star_def, (erule conjE)+) apply (rule, assumption, assumption) 
        apply (simp add: RSD_sum_def star_def, (erule conjE)+)
          apply rule apply (erule AL_DEL) 
          apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_dom_delete AL_sum_def AL_dom_upd1 AL_dom_emp) 
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
            apply (rule, clarsimp) apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
              apply (erule AL_sum3) apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (erule AL_sum3) apply (erule conjE)
                                    apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (erule AL_sum3) apply (erule conjE)
                                    apply (drule AL_upd_split) 
                                    apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
                                    apply (simp add: AL_emp1)
             apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
done
(*>*)

text{*In particular, the result holds for program $COPY$.*}

lemma G_verified_COPY:
   "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];P=COPY; distinct [NIL,CONS,LIST];
        \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS\<rbrakk> 
    \<Longrightarrow> CtxtVerified (G tp)"
(*<*)
apply (erule G_verified, assumption+)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=ListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>LIST = Some ListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: ListClass_def) apply (rule AL_update1)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=NilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>NIL = Some NilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: NilClass_def) apply (rule AL_update1)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=ConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>CONS = Some ConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: ConsClass_def) apply (rule AL_update1)
done
(*>*)

(*<*)
end
(*>*)