(*<*)
theory ListSL_NIVerif = ListSLRep:
(*>*)

subsubsection{*Verification of the non-interference property from
Section 5.4*}

text{*We first define a version of the predicates that do not employ
the $\ast$ operator but explicit distinctness conditions.*}

consts Y_NHigh :: "(TP \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP
                       \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP) set"
       Y_NLow ::  "(TP \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP
                       \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP) set"

inductive Y_NHigh Y_NLow intros
Y_NHigh_Nil:"\<lbrakk>\<omega>\<noteq>\<alpha>; N=emp[\<omega>\<mapsto>(classTP NIL)]; M=N[\<alpha>\<mapsto>(classTP NIL)]\<rbrakk> \<Longrightarrow> (tp,\<omega>,[],[],N,\<alpha>,[],[],M):Y_NHigh"
Y_NHigh_Cons:"\<lbrakk>xx=(\<gamma>,\<delta>); xx'=(\<gamma>',\<delta>); yy=(\<gamma>,\<epsilon>); yy'=(\<gamma>',\<epsilon>);
               (tp, \<delta>, \<Lambda>, \<Lambda>', N, \<epsilon>, \<Omega>, \<Omega>', M) : Y_NLow; 
               distinct [\<gamma>,\<gamma>',\<omega>,\<alpha>]; {\<gamma>,\<gamma>',\<omega>,\<alpha>} \<inter> AL_dom M ={}; 
               NN=N[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp];
               MM=M[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp][\<alpha>\<mapsto>(classTP CONS)]\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, xx#\<Lambda>, xx'#\<Lambda>', NN, \<alpha>, yy#\<Omega>, yy'#\<Omega>', MM):Y_NHigh"
Y_NLow_Nil:"\<lbrakk>\<omega>\<noteq>\<alpha>; N=emp[\<omega>\<mapsto>(classTP NIL)]; M=N[\<alpha>\<mapsto>(classTP NIL)]\<rbrakk> \<Longrightarrow> (tp,\<omega>,[],[],N,\<alpha>,[],[],M):Y_NLow"
Y_NLow_Cons:"\<lbrakk>xx=(\<gamma>,\<delta>); yy=(\<gamma>,\<epsilon>); (tp, \<delta>, \<Lambda>, \<Lambda>', N, \<epsilon>, \<Omega>, \<Omega>', M) : Y_NHigh; 
              distinct [\<gamma>,\<omega>,\<alpha>]; {\<gamma>,\<omega>,\<alpha>} \<inter> AL_dom M ={}; 
              NN=N[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]; 
              MM=M[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<alpha>\<mapsto>(classTP CONS)]\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, xx#\<Lambda>, xx#\<Lambda>', NN, \<alpha>, yy#\<Omega>, yy#\<Omega>', MM):Y_NLow"

(*<*)
lemma Y_NHigh_Y_NLow_D:
 "((tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NHigh \<longrightarrow>
         ((\<Lambda> = [] \<and> \<Lambda>'= [] \<and> \<Upsilon>=[] \<and> \<Upsilon>'=[] \<and> \<omega>\<noteq>\<alpha> \<and> N=emp[\<omega>\<mapsto>(classTP NIL)] \<and> M=N[\<alpha>\<mapsto>(classTP NIL)]) \<or>
           (\<exists> \<gamma> \<delta> \<Theta> \<gamma>' \<Theta>' \<epsilon> \<Omega> \<Omega>' NN MM . 
                \<Lambda> = (\<gamma>,\<delta>)#\<Theta> \<and> \<Lambda>'= (\<gamma>',\<delta>)#\<Theta>' \<and> \<Upsilon>=(\<gamma>,\<epsilon>)#\<Omega> \<and> \<Upsilon>'=(\<gamma>',\<epsilon>)#\<Omega>' \<and> 
               (tp, \<delta>, \<Theta>, \<Theta>', NN, \<epsilon>, \<Omega>, \<Omega>', MM) : Y_NLow \<and>
               distinct [\<gamma>,\<gamma>',\<omega>,\<alpha>] \<and> {\<gamma>,\<gamma>',\<omega>,\<alpha>} \<inter> AL_dom MM ={} \<and>
               N=upd(upd(upd NN \<omega> (classTP CONS)) \<gamma> tp) \<gamma>' tp \<and>
               M=upd(upd(upd(upd MM \<omega> (classTP CONS)) \<gamma> tp) \<gamma>' tp) \<alpha> (classTP CONS)))) \<and>
  ((tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NLow \<longrightarrow>
         ((\<Lambda> = [] \<and> \<Lambda>'= [] \<and> \<Upsilon>=[] \<and> \<Upsilon>'=[] \<and> \<omega>\<noteq>\<alpha> \<and> N=emp[\<omega>\<mapsto>(classTP NIL)] \<and> M=N[\<alpha>\<mapsto>(classTP NIL)]) \<or>
           (\<exists> \<gamma> \<delta> \<Theta> \<Theta>' \<epsilon> \<Omega> \<Omega>' NN MM . 
                \<Lambda> = (\<gamma>,\<delta>)#\<Theta> \<and> \<Lambda>'= (\<gamma>,\<delta>)#\<Theta>' \<and> \<Upsilon>=(\<gamma>,\<epsilon>)#\<Omega> \<and> \<Upsilon>'=(\<gamma>,\<epsilon>)#\<Omega>' \<and> 
               (tp, \<delta>, \<Theta>, \<Theta>', NN, \<epsilon>, \<Omega>, \<Omega>', MM) : Y_NHigh \<and>
               distinct [\<gamma>,\<omega>,\<alpha>] \<and> {\<gamma>,\<omega>,\<alpha>} \<inter> AL_dom MM ={} \<and>
               N=upd(upd NN \<omega> (classTP CONS)) \<gamma> tp \<and>
               M=upd(upd(upd MM \<omega> (classTP CONS)) \<gamma> tp) \<alpha> (classTP CONS))))"
apply (rule Y_NHigh_Y_NLow.induct)
apply simp
apply clarsimp apply fast
apply simp
apply clarsimp apply fast
done

lemma Y_NHigh_D:
 "(tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NHigh \<Longrightarrow>
         (\<Lambda> = [] \<and> \<Lambda>'= [] \<and> \<Upsilon>=[] \<and> \<Upsilon>'=[] \<and> \<omega>\<noteq>\<alpha> \<and> N=emp[\<omega>\<mapsto>(classTP NIL)] \<and> M=N[\<alpha>\<mapsto>(classTP NIL)]) \<or>
         (\<exists> \<gamma> \<delta> \<Theta> \<gamma>' \<Theta>' \<epsilon> \<Omega> \<Omega>' NN MM . 
                \<Lambda> = (\<gamma>,\<delta>)#\<Theta> \<and> \<Lambda>'= (\<gamma>',\<delta>)#\<Theta>' \<and> \<Upsilon>=(\<gamma>,\<epsilon>)#\<Omega> \<and> \<Upsilon>'=(\<gamma>',\<epsilon>)#\<Omega>' \<and> 
               (tp, \<delta>, \<Theta>, \<Theta>', NN, \<epsilon>, \<Omega>, \<Omega>', MM) : Y_NLow \<and>
               distinct [\<gamma>,\<gamma>',\<omega>,\<alpha>] \<and> {\<gamma>,\<gamma>',\<omega>,\<alpha>} \<inter> AL_dom MM ={} \<and>
               N=upd(upd(upd NN \<omega> (classTP CONS)) \<gamma> tp) \<gamma>' tp \<and>
               M=upd(upd(upd(upd MM \<omega> (classTP CONS)) \<gamma> tp) \<gamma>' tp) \<alpha> (classTP CONS))"
apply (insert Y_NHigh_Y_NLow_D) apply simp done

lemma Y_NLow_D:
  "(tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NLow \<Longrightarrow>
         (\<Lambda> = [] \<and> \<Lambda>'= [] \<and> \<Upsilon>=[] \<and> \<Upsilon>'=[] \<and> \<omega>\<noteq>\<alpha> \<and> N=emp[\<omega>\<mapsto>(classTP NIL)] \<and> M=N[\<alpha>\<mapsto>(classTP NIL)]) \<or>
         (\<exists> \<gamma> \<delta> \<Theta> \<Theta>' \<epsilon> \<Omega> \<Omega>' NN MM . 
               \<Lambda> = (\<gamma>,\<delta>)#\<Theta> \<and> \<Lambda>'= (\<gamma>,\<delta>)#\<Theta>' \<and> \<Upsilon>=(\<gamma>,\<epsilon>)#\<Omega> \<and> \<Upsilon>'=(\<gamma>,\<epsilon>)#\<Omega>' \<and> 
               (tp, \<delta>, \<Theta>, \<Theta>', NN, \<epsilon>, \<Omega>, \<Omega>', MM) : Y_NHigh \<and>
               distinct [\<gamma>,\<omega>,\<alpha>] \<and> {\<gamma>,\<omega>,\<alpha>} \<inter> AL_dom MM ={} \<and>
               N=upd(upd NN \<omega> (classTP CONS)) \<gamma> tp \<and>
               M=upd(upd(upd MM \<omega> (classTP CONS)) \<gamma> tp) \<alpha> (classTP CONS))"
apply (insert Y_NHigh_Y_NLow_D) apply simp done

lemma Y_NHigh_Y_NLow_contained_length:
  "((tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NHigh \<longrightarrow> (contained N M \<and> length \<Lambda> = length \<Lambda>' \<and> 
                                          length \<Lambda> = length \<Upsilon> \<and> length \<Lambda> = length \<Upsilon>' \<and>
                                          map fst \<Lambda> = map fst \<Upsilon> \<and> map fst \<Lambda>' = map fst \<Upsilon>' \<and>
                                          map snd \<Lambda> = map snd \<Lambda>' \<and> map snd \<Upsilon> = map snd \<Upsilon>' \<and> 
                                          AL_dom N = {\<omega>} \<union> (set(map fst \<Lambda>)) \<union> (set(map snd \<Lambda>)) \<union> (set(map fst \<Lambda>')) \<and> 
                                          AL_dom M = AL_dom N \<union> {\<alpha>} \<union> (set(map snd \<Upsilon>)) \<and> 
                                          AL_dom N \<inter> ({\<alpha>} \<union> (set(map snd \<Upsilon>))) = {} \<and>
                                          N:AL \<and> M:AL)) \<and> 
    ((tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NLow \<longrightarrow> (contained N M \<and> length \<Lambda> = length \<Lambda>' \<and> 
                                          length \<Lambda> = length \<Upsilon> \<and> length \<Lambda> = length \<Upsilon>' \<and>
                                          map fst \<Lambda> = map fst \<Upsilon> \<and> map fst \<Lambda>' = map fst \<Upsilon>' \<and>
                                          map snd \<Lambda> = map snd \<Lambda>' \<and> map snd \<Upsilon> = map snd \<Upsilon>' \<and>
                                          AL_dom N = {\<omega>} \<union> (set(map fst \<Lambda>)) \<union>  (set(map snd \<Lambda>)) \<union> (set(map fst \<Lambda>')) \<and> 
                                          AL_dom M = AL_dom N \<union> {\<alpha>} \<union>  (set(map snd \<Upsilon>)) \<and>
                                          AL_dom N \<inter> ({\<alpha>} \<union> (set(map snd \<Upsilon>))) = {} \<and>
                                          N:AL \<and> M:AL))"
apply (rule Y_NHigh_Y_NLow.induct)
apply clarsimp 
  apply rule apply (rule contained_upd) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
  apply (simp add: AL_dom_upd1 AL_dom_emp)
  apply rule apply fast
  apply (rule, rule AL_UPD, rule AL_EMP) 
  apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
apply clarify
  apply rule apply (rotate_tac -5, erule thin_rl, erule thin_rl) apply (simp (no_asm) add: contained_def, clarsimp)
    apply (rule AL_update4)
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (rule AL_update1)
      apply clarsimp
      apply (rule AL_update4)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (rule AL_update1)
        apply clarsimp
        apply (rule AL_update4)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update1)
          apply clarsimp
          apply (rule AL_update4)
            apply (erule contained3) apply assumption
          apply assumption
        apply assumption
      apply assumption
    apply (drule AL_domI) apply (simp add: AL_dom_upd1)
      apply (erule disjE, clarsimp) apply (erule disjE, clarsimp) apply (erule disjE, clarsimp)
      apply (drule contained6) apply assumption apply fast  
  apply (simp add: AL_dom_upd1) 
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply (rule AL_UPD, rule AL_UPD, erule AL_UPD) 
    apply (erule conjE)+ apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, erule AL_UPD)     
apply clarsimp 
  apply rule apply (rule contained_upd) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
  apply (simp add: AL_dom_upd1 AL_dom_emp)
  apply rule apply fast
  apply (rule, rule AL_UPD, rule AL_EMP) 
  apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
apply clarify
  apply rule apply (rotate_tac -5, erule thin_rl, erule thin_rl) apply (simp (no_asm) add: contained_def, clarsimp)
    apply (rule AL_update4)
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (rule AL_update1)
      apply clarsimp
      apply (rule AL_update4)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (rule AL_update1)
        apply clarsimp
        apply (rule AL_update4)
          apply (erule contained3) apply assumption
        apply assumption
      apply assumption
    apply (drule AL_domI) apply (simp add: AL_dom_upd1)
      apply (erule disjE, clarsimp) apply (erule disjE, clarsimp) apply (drule contained6, assumption) apply fast 
  apply (simp add: AL_dom_upd1) 
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply fast
    apply rule apply (erule conjE)+ apply (rule AL_UPD, erule AL_UPD) 
    apply (erule conjE)+ apply (rule AL_UPD, rule AL_UPD, erule AL_UPD)     
done

lemma Y_NHigh_contained_length:
  "(tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NHigh \<Longrightarrow> 
   contained N M \<and> length \<Lambda> = length \<Lambda>' \<and> 
   length \<Lambda> = length \<Upsilon> \<and> length \<Lambda> = length \<Upsilon>' \<and>
   map fst \<Lambda> = map fst \<Upsilon> \<and> map fst \<Lambda>' = map fst \<Upsilon>' \<and>
   map snd \<Lambda> = map snd \<Lambda>' \<and> map snd \<Upsilon> = map snd \<Upsilon>' \<and> 
   AL_dom N = {\<omega>} \<union> (set(map fst \<Lambda>)) \<union> (set(map snd \<Lambda>)) \<union> (set(map fst \<Lambda>')) \<and> 
   AL_dom M = AL_dom N \<union> {\<alpha>} \<union> (set(map snd \<Upsilon>)) \<and> 
   AL_dom N \<inter> ({\<alpha>} \<union> (set(map snd \<Upsilon>))) = {} \<and> N:AL \<and> M:AL"
apply (insert Y_NHigh_Y_NLow_contained_length) apply fast done

lemma Y_NLow_contained_length:
  "(tp,\<omega>,\<Lambda>,\<Lambda>',N,\<alpha>,\<Upsilon>,\<Upsilon>',M):Y_NLow \<Longrightarrow>
   contained N M \<and> length \<Lambda> = length \<Lambda>' \<and> 
   length \<Lambda> = length \<Upsilon> \<and> length \<Lambda> = length \<Upsilon>' \<and>
   map fst \<Lambda> = map fst \<Upsilon> \<and> map fst \<Lambda>' = map fst \<Upsilon>' \<and>
   map snd \<Lambda> = map snd \<Lambda>' \<and> map snd \<Upsilon> = map snd \<Upsilon>' \<and> 
   AL_dom N = {\<omega>} \<union> (set(map fst \<Lambda>)) \<union> (set(map snd \<Lambda>)) \<union> (set(map fst \<Lambda>')) \<and> 
   AL_dom M = AL_dom N \<union> {\<alpha>} \<union> (set(map snd \<Upsilon>)) \<and> 
   AL_dom N \<inter> ({\<alpha>} \<union> (set(map snd \<Upsilon>))) = {} \<and> N:AL \<and> M:AL"
apply (insert Y_NHigh_Y_NLow_contained_length) apply fast done
(*>*)

text{*The following definition uses the star operator and is thus
closer to what we write in the paper. The two lemmas showing the
(apart from ALsum X emp X) equivalence between the Y-predicates and
the Z-predicates follow.*}

consts Z_NHigh :: "(TP \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP
                       \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP) set"
       Z_NLow ::  "(TP \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP
                       \<times> Colour \<times> ((Colour \<times> Colour) list) \<times> ((Colour \<times> Colour) list) \<times> MP) set"

inductive Z_NHigh Z_NLow intros
Z_NHigh_Nil:"\<lbrakk>N=emp[\<omega>\<mapsto>(classTP NIL)]; star N (emp[\<alpha>\<mapsto>(classTP NIL)]) M\<rbrakk> \<Longrightarrow> (tp,\<omega>,[],[],N,\<alpha>,[],[],M):Z_NHigh"
Z_NHigh_Cons:"\<lbrakk>xx=(\<gamma>,\<delta>); xx'=(\<gamma>',\<delta>); yy=(\<gamma>,\<epsilon>); yy'=(\<gamma>',\<epsilon>);
               (tp, \<delta>, \<Lambda>, \<Lambda>', N, \<epsilon>, \<Omega>, \<Omega>', M) : Z_NLow; 
               star N (emp[\<omega>\<mapsto>(classTP CONS)]) N'; 
               star N' (emp[\<gamma>\<mapsto>tp]) N''; star N'' (emp[\<gamma>'\<mapsto>tp]) NN;
               star M (emp[\<omega>\<mapsto>(classTP CONS)]) M';
               star M' (emp[\<gamma>\<mapsto>tp]) M''; star M'' (emp[\<gamma>'\<mapsto>tp]) M'''; star M''' (emp[\<alpha>\<mapsto>(classTP CONS)]) MM\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, xx#\<Lambda>, xx'#\<Lambda>', NN, \<alpha>, yy#\<Omega>, yy'#\<Omega>', MM):Z_NHigh"
Z_NLow_Nil:"\<lbrakk>N=emp[\<omega>\<mapsto>(classTP NIL)]; star N (emp[\<alpha>\<mapsto>(classTP NIL)]) M\<rbrakk> \<Longrightarrow> (tp,\<omega>,[],[],N,\<alpha>,[],[],M):Z_NLow"
Z_NLow_Cons:"\<lbrakk>xx=(\<gamma>,\<delta>); yy=(\<gamma>,\<epsilon>); (tp, \<delta>, \<Lambda>, \<Lambda>', N, \<epsilon>, \<Omega>, \<Omega>', M) : Z_NHigh; 
              star N (emp[\<omega>\<mapsto>(classTP CONS)]) N'; star N' (emp[\<gamma>\<mapsto>tp]) NN; 
              star M (emp[\<omega>\<mapsto>(classTP CONS)]) M'; star M' (emp[\<gamma>\<mapsto>tp]) M''; star M'' (emp[\<alpha>\<mapsto>(classTP CONS)]) MM\<rbrakk>
           \<Longrightarrow> (tp, \<omega>, xx#\<Lambda>, xx#\<Lambda>', NN, \<alpha>, yy#\<Omega>, yy#\<Omega>', MM):Z_NLow"

lemma Z_AL:
  "((tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NHigh \<longrightarrow> N:AL \<and> M:AL) \<and>
   ((tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NLow \<longrightarrow> N:AL \<and> M:AL)"
apply (rule Z_NHigh_Z_NLow.induct)
  apply (simp add: star_def) apply (rule AL_UPD, rule AL_EMP)
  apply (simp add: star_def)
  apply (simp add: star_def) apply (rule AL_UPD, rule AL_EMP)
  apply (simp add: star_def)
done

lemma Z_NHigh_AL:
  "(tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NHigh \<Longrightarrow> N:AL \<and> M:AL"
apply (simp add: Z_AL)
done

lemma Z_NLow_AL:
  "(tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NLow \<Longrightarrow> N:AL \<and> M:AL"
apply (simp add: Z_AL)
done

lemma ZY:
  "((tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NHigh \<longrightarrow> 
        (\<exists> NN MM . (tp, \<omega>, \<Lambda>, \<Lambda>', NN, \<alpha>, \<Omega>, \<Omega>', MM):Y_NHigh \<and> 
                   AL_sum N emp NN \<and> AL_sum M emp MM)) \<and>
   ((tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NLow \<longrightarrow>
        (\<exists> NN MM . (tp, \<omega>, \<Lambda>, \<Lambda>', NN, \<alpha>, \<Omega>, \<Omega>', MM):Y_NLow \<and> 
                   AL_sum N emp NN \<and> AL_sum M emp MM))"
(*<*)
apply (rule Z_NHigh_Z_NLow.induct)
apply (rule_tac x=N in exI, rule_tac x="N[\<alpha>\<mapsto>(classTP NIL)]" in exI)
  apply (rule, rule Y_NHigh_Nil) 
    apply (simp add: star_def AL_dom_upd1 AL_dom_emp) apply fast
    apply assumption
    apply simp 
    apply (rule, rule AL_sum_emp2)
    apply (simp add: star_def, clarsimp) 
      apply (simp (no_asm) add: AL_sum_def contained_def) 
       apply (rule, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) 
       apply (rule, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE, drule AL_upd_split)
           apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
           apply (simp add: AL_emp1)
         apply (drule AL_upd_split)
           apply (erule disjE, clarsimp) apply (rule AL_update1) 
           apply (simp add: AL_emp1)
       apply (simp add: AL_emp1)
apply clarsimp
  apply (rule_tac x="NNa[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp]" in exI,
         rule_tac x="MMa[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp][\<alpha>\<mapsto>(classTP CONS)]" in exI)
  apply (rule, rule Y_NHigh_Cons) apply fastsimp apply fastsimp apply fastsimp apply fastsimp apply assumption
    apply (simp add: star_def AL_sum_def, clarsimp)
      apply (drule contained5)+
      apply (simp add:  AL_dom_upd1 AL_dom_emp, clarsimp) apply fastsimp 
    apply (simp add: star_def AL_sum_def, clarsimp)
      apply (drule contained5)+
      apply (simp add:  AL_dom_upd1 AL_dom_emp) 
    apply simp
    apply simp 
    apply (simp (no_asm) add: AL_sum_def contained_def)
      apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp star_def) 
      apply (rule, simp add: star_def, clarsimp) 
        apply (drule AL_sum_split, assumption) 
        apply (erule disjE, rule AL_update4)
          apply (drule AL_sum_split, assumption) 
          apply (erule disjE, rule AL_update4)
            apply (drule AL_sum_split, assumption) 
            apply (erule disjE, rule AL_update4) apply (erule AL_sum3, assumption)
              apply (drule_tac H=N in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
            apply (drule AL_upd_split) 
            apply (erule disjE, clarsimp) apply (rule AL_update1) 
            apply (simp add: AL_emp1)
            apply (drule_tac H=N' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
         apply (drule AL_upd_split) 
         apply (erule disjE, clarsimp) apply (rule AL_update1) 
           apply (simp add: AL_emp1)
       apply (drule_tac H=N'' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
     apply (drule AL_upd_split) 
     apply (erule disjE, clarsimp) apply (rule AL_update1) 
       apply (simp add: AL_emp1)
  apply (simp add: AL_emp1)
      apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp star_def) 
      apply (simp add: star_def, clarsimp) 
        apply (drule AL_sum_split, assumption) 
        apply (erule disjE, rule AL_update4)
          apply (drule AL_sum_split, assumption) 
          apply (erule disjE, rule AL_update4)
            apply (drule AL_sum_split, assumption) 
            apply (erule disjE, rule AL_update4)
              apply (drule AL_sum_split, assumption) 
              apply (erule disjE, rule AL_update4) apply (erule AL_sum3, assumption)
                apply (drule_tac H=M in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
              apply (drule AL_upd_split) 
              apply (erule disjE, clarsimp) apply (rule AL_update1) 
              apply (simp add: AL_emp1)
            apply (drule_tac H=M' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
          apply (drule AL_upd_split) 
          apply (erule disjE, clarsimp) apply (rule AL_update1) 
            apply (simp add: AL_emp1)
        apply (drule_tac H=M'' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
      apply (drule AL_upd_split) 
      apply (erule disjE, clarsimp) apply (rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (drule_tac H=M''' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
      apply (drule AL_upd_split) 
      apply (erule disjE, clarsimp) apply (rule AL_update1) 
        apply (simp add: AL_emp1)
apply (rule_tac x=N in exI, rule_tac x="N[\<alpha>\<mapsto>(classTP NIL)]" in exI)
  apply (rule, rule Y_NLow_Nil) 
    apply (simp add: star_def AL_dom_upd1 AL_dom_emp) apply fast
    apply assumption
    apply simp 
    apply (rule, rule AL_sum_emp2)
    apply (simp add: star_def, clarsimp) 
      apply (simp (no_asm) add: AL_sum_def contained_def) 
       apply (rule, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) 
       apply (rule, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE, drule AL_upd_split)
           apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
           apply (simp add: AL_emp1)
         apply (drule AL_upd_split)
           apply (erule disjE, clarsimp) apply (rule AL_update1) 
           apply (simp add: AL_emp1)
       apply (simp add: AL_emp1)
apply clarsimp
  apply (rule_tac x="NNa[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]" in exI,
         rule_tac x="MMa[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<alpha>\<mapsto>(classTP CONS)]" in exI)
  apply (rule, rule Y_NLow_Cons) apply fastsimp apply fastsimp apply assumption
    apply (simp add: star_def AL_sum_def, clarsimp)
      apply (drule contained5)+
      apply (simp add:  AL_dom_upd1 AL_dom_emp, clarsimp) apply fastsimp 
    apply (simp add: star_def AL_sum_def, clarsimp)
      apply (drule contained5)+
      apply (simp add:  AL_dom_upd1 AL_dom_emp) 
    apply simp
    apply simp 
    apply (simp (no_asm) add: AL_sum_def contained_def)
      apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp star_def) 
      apply (rule, simp add: star_def, clarsimp) 
        apply (drule AL_sum_split, assumption) 
        apply (erule disjE, rule AL_update4)
          apply (drule AL_sum_split, assumption) 
          apply (erule disjE, rule AL_update4) apply (erule AL_sum3, assumption)
              apply (drule_tac H=N in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
            apply (drule AL_upd_split) 
            apply (erule disjE, clarsimp) apply (rule AL_update1) 
            apply (simp add: AL_emp1)
            apply (drule_tac H=N' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
         apply (drule AL_upd_split) 
         apply (erule disjE, clarsimp) apply (rule AL_update1) 
           apply (simp add: AL_emp1)
  apply (simp add: AL_emp1)
      apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp star_def) 
      apply (simp add: star_def, clarsimp) 
        apply (drule AL_sum_split, assumption) 
        apply (erule disjE, rule AL_update4)
          apply (drule AL_sum_split, assumption) 
          apply (erule disjE, rule AL_update4)
            apply (drule AL_sum_split, assumption) 
            apply (erule disjE, rule AL_update4) apply (erule AL_sum3, assumption)
                apply (drule_tac H=M in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
              apply (drule AL_upd_split) 
              apply (erule disjE, clarsimp) apply (rule AL_update1) 
              apply (simp add: AL_emp1)
            apply (drule_tac H=M' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
          apply (drule AL_upd_split) 
          apply (erule disjE, clarsimp) apply (rule AL_update1) 
            apply (simp add: AL_emp1)
        apply (drule_tac H=M'' in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
      apply (drule AL_upd_split) 
      apply (erule disjE, clarsimp) apply (rule AL_update1) 
        apply (simp add: AL_emp1)
done
(*>*)

lemma YZ:
  "((tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Y_NHigh
         \<longrightarrow> (tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NHigh) \<and>
   ((tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Y_NLow
         \<longrightarrow> (tp, \<omega>, \<Lambda>, \<Lambda>', N, \<alpha>, \<Omega>, \<Omega>', M):Z_NLow)"
(*<*)
apply (rule Y_NHigh_Y_NLow.induct)
apply (rule Z_NHigh_Nil)  
  apply assumption 
  apply (simp add: star_def AL_sum_def AL_dom_upd1 AL_dom_emp)
  apply rule apply (rule contained_upd) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
  apply rule apply (simp add: contained_def, clarsimp)
             apply (drule AL_upd_split)
             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
  apply (rule, fast)
  apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
apply (subgoal_tac "contained N M", drule contained5)
  prefer 2 apply (drule Y_NLow_contained_length) apply simp
  apply (rule_tac N'="N[\<omega>\<mapsto>(classTP CONS)]" and N''="N[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]" and
                  M'="M[\<omega>\<mapsto>(classTP CONS)]" and M''="M[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]" and
                  M'''="M[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp][\<gamma>'\<mapsto>tp]" in Z_NHigh_Cons) 
    apply fastsimp apply fastsimp apply fastsimp apply assumption apply assumption
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply fast
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule, fast)
                             apply (rule AL_UPD) apply (drule Z_NLow_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule, fast)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (drule Z_NLow_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule, fast)
                             apply (rule, fast)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_UPD) apply (drule Z_NLow_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule AL_UPD) apply (drule Z_NLow_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (drule Z_NLow_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule, fast)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_UPD) apply (drule Z_NLow_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule, fast)
                             apply (rule, fast)
                             apply (rule, fast)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_UPD) 
                                apply (drule Z_NLow_AL) apply simp
apply (rule Z_NLow_Nil)  
  apply assumption 
  apply (simp add: star_def AL_sum_def AL_dom_upd1 AL_dom_emp)
  apply rule apply (rule contained_upd) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
  apply rule apply (simp add: contained_def, clarsimp)
             apply (drule AL_upd_split)
             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
  apply (rule,fast)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_EMP)
apply (subgoal_tac "contained N M", drule contained5)
  prefer 2 apply (drule Y_NHigh_contained_length) apply simp
  apply (rule_tac N'="N[\<omega>\<mapsto>(classTP CONS)]" and M'="M[\<omega>\<mapsto>(classTP CONS)]" and
                  M''="M[\<omega>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>tp]" in Z_NLow_Cons) 
    apply fastsimp apply fastsimp apply assumption 
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply fast
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule, fast)
                             apply (rule AL_UPD) apply (drule Z_NHigh_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule, fast)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (drule Z_NHigh_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule AL_UPD) apply (drule Z_NHigh_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                             apply (rule AL_UPD) apply (rule AL_UPD) apply (drule Z_NHigh_AL) apply simp
    apply (simp add: star_def AL_sum_def contained_def, clarsimp)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule, clarsimp) apply (rule AL_update4, assumption) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
      apply (rule, clarsimp) apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
      apply (rule, fast)
      apply (rule, fast) 
      apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_UPD) apply (drule Z_NHigh_AL) apply simp
done
(*>*)

text{*Next, the definition of specification sets.*}

constdefs NISp::"TP \<Rightarrow> nat \<Rightarrow> (RSD \<times> RSD) set"
"NISp tp n \<equiv> { (\<phi>,\<psi>) . \<exists> \<gamma> \<Lambda> \<Lambda>' \<upsilon> \<Upsilon> \<Upsilon>' H H' \<Sigma> \<Pi> \<Sigma>' \<Pi>' N M. 
                       \<phi>=(\<Sigma>,N,\<Sigma>') \<and> preS \<gamma> \<Lambda> = Some \<Sigma> \<and> preS \<gamma> \<Lambda>' = Some \<Sigma>' \<and> 

                       \<psi>=(\<Pi>,M,\<Pi>') \<and> \<Pi> = ([\<upsilon>],emp,H) \<and> \<Pi>' = ([\<upsilon>],emp,H') \<and> 
                       starOpt (ListHP \<gamma> \<Lambda>) (ListHP \<upsilon> \<Upsilon>) H \<and> 
                       starOpt (ListHP \<gamma> \<Lambda>') (ListHP \<upsilon> \<Upsilon>') H' \<and> 
                       ((tp, \<gamma>, \<Lambda>, \<Lambda>', N, \<upsilon>,\<Upsilon>,\<Upsilon>',M) : Y_NHigh \<or>
                        (tp, \<gamma>, \<Lambda>, \<Lambda>', N, \<upsilon>,\<Upsilon>,\<Upsilon>',M) : Y_NLow) \<and>
                       length \<Lambda> = n}"

text{*The proof context.*}

constdefs G::"TP \<Rightarrow> Ctxt"
"G tp \<equiv> {(ppts,S) . ppts = ((NilCopy,0),(NilCopy,0)) \<and> S \<in> NISp tp 0} \<union>
         {(ppts,S) . \<exists> n . n>0 \<and> ppts=((ConsCopy,0),(ConsCopy,0)) \<and> S \<in> NISp tp n}"

text{*The main verification of the method.*}

lemma G_verified:
   "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];
        \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
      mbody_is LIST Copy ListCopy; mbody_is NIL Copy NilCopy; mbody_is CONS Copy ConsCopy\<rbrakk> 
    \<Longrightarrow> CtxtVerified (G tp)"
(*<*)
apply (simp add: G_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp)
  apply (simp add: NISp_def) apply (rotate_tac -3, erule thin_rl, erule thin_rl)  
  apply clarsimp
  apply (subgoal_tac "contained af ak \<and>
        length [] = length \<Lambda>' \<and>
        length [] = length \<Upsilon> \<and>
        length [] = length \<Upsilon>' \<and>
        map fst [] = map fst \<Upsilon> \<and>
        map fst \<Lambda>' = map fst \<Upsilon>' \<and>
        map snd [] = map snd \<Lambda>' \<and>
        map snd \<Upsilon> = map snd \<Upsilon>' \<and>
        AL_dom af = {\<gamma>} \<union> set (map fst []) \<union> set (map snd []) \<union> set (map fst \<Lambda>') \<and>
        AL_dom ak = AL_dom af \<union> {\<upsilon>} \<union> set (map snd \<Upsilon>) \<and> AL_dom af \<inter> ({\<upsilon>} \<union> set (map snd \<Upsilon>)) = {} \<and> af \<in> AL \<and> ak \<in> AL")
  prefer 2 apply (erule disjE) apply (erule Y_NHigh_contained_length) apply (erule Y_NLow_contained_length)
  apply (rule, simp add: preserved_def starOptDEF, clarsimp)
    apply (simp add: AL_sum_def preS_def, clarsimp)
  apply (subgoal_tac "(G tp,((ad, ae, bb), af, ag, ah, bc), NilCopy, 0, NilCopy, 0, False, ([\<upsilon>], emp, bd), ak, [\<upsilon>], emp, be)
          \<in> Typing", simp add: G_def NISp_def)
  apply (simp add: preS_def, clarsimp)
  apply (rename_tac N K M K' \<gamma> \<upsilon>)
  apply (rule_tac c=\<upsilon> and C=NIL in TypingNewNew)
    apply (rule InstrNIL0)
    apply (rule InstrNIL0)
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp)
    apply (simp add: subclass_of_refl)
    apply (simp add: subclass_of_refl)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply fastsimp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, erule AL_UPD)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def starOptDEF, clarsimp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule_tac disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp  apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp  apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp 
              apply (erule disjE) apply (drule Y_NHigh_D) apply clarsimp apply (rule AL_update1)
                                  apply (drule Y_NLow_D) apply clarsimp apply (rule AL_update1) 
            apply clarsimp apply (erule contained3, assumption) 
          apply (rule contained_emp)
        apply (simp add: AL_dom_emp)
(*n>0*)
apply clarsimp
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (simp add: NISp_def, clarsimp)
  apply (subgoal_tac "contained af ak \<and>
        length \<Lambda> = length \<Lambda>' \<and>
        length \<Lambda> = length \<Upsilon> \<and>
        length \<Lambda> = length \<Upsilon>' \<and>
        map fst \<Lambda> = map fst \<Upsilon> \<and>
        map fst \<Lambda>' = map fst \<Upsilon>' \<and>
        map snd \<Lambda> = map snd \<Lambda>' \<and>
        map snd \<Upsilon> = map snd \<Upsilon>' \<and>
        AL_dom af = {\<gamma>} \<union> set (map fst \<Lambda>) \<union> set (map snd \<Lambda>) \<union> set (map fst \<Lambda>') \<and>
        AL_dom ak = AL_dom af \<union> {\<upsilon>} \<union> set (map snd \<Upsilon>) \<and> AL_dom af \<inter> ({\<upsilon>} \<union> set (map snd \<Upsilon>)) = {} \<and> af \<in> AL \<and> ak \<in> AL")
     prefer 2 apply (erule disjE) apply (erule Y_NHigh_contained_length) apply (erule Y_NLow_contained_length)
  apply (rule, simp add: preserved_def preS_def starOptDEF AL_sum_def, clarsimp)
     apply rule apply fast apply fast
  apply (subgoal_tac "(G tp,((ad, ae, bb), af, ag, ah, bc), ConsCopy, 0, ConsCopy, 0, False, ([\<upsilon>], emp, bd), ak, [\<upsilon>], emp, be)
          \<in> Typing", simp add: G_def NISp_def)
  apply (case_tac \<Lambda>, clarsimp)  apply clarsimp 
  apply (simp add: NISp_def preS_def starOptDEF)
  apply (case_tac "ListHP b list", clarsimp,clarsimp)
  apply (case_tac "ListHP b zsa", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zsc", clarsimp,clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac N H\<gamma>K\<omega> M H'\<gamma>K'\<omega> \<gamma> \<omega> \<nu> \<delta> \<Lambda> \<epsilon> \<Upsilon> \<Lambda>' \<mu>' \<Upsilon>' H H' K K')
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp   
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
apply (rename_tac \<nu>' \<Upsilon>' H H' K K')
apply (subgoal_tac "AL_dom H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<nu>][TL\<mapsto>\<delta>])] \<inter> AL_dom K = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
apply (subgoal_tac "AL_dom H'[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<nu>'][TL\<mapsto>\<delta>])] \<inter> AL_dom K' = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K' in AL_sum_exists_AL) apply (erule exE, rename_tac HH', erule conjE)

apply (subgoal_tac "(G tp, (([\<epsilon>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<nu>][t\<mapsto>\<delta>], HH), 
                                 delete M \<omega>,
                                 [\<epsilon>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<nu>'][t\<mapsto>\<delta>],HH'),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), 
           False, ([\<omega>], emp, H\<gamma>K\<omega>), M, [\<omega>], emp, H'\<gamma>K'\<omega>) \<in> Typing")
prefer 2
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac c=\<omega> and C=CONS in TypingNewNew)
      apply (rule InstrCONS9)
      apply (rule InstrCONS9)
      apply fastsimp
      apply (simp add: AL_dom_delete)
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrCONS18)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD) apply (rule AL_DEL)
          apply (erule disjE) apply (drule Y_NHigh_contained_length) apply simp
                              apply (drule Y_NLow_contained_length) apply simp
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (rotate_tac -1, erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply assumption
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp)
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (rotate_tac -1, erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply assumption
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_dom_delete) 
          apply (rule, clarsimp) apply (drule AL_upd_split)
            apply (rotate_tac -1, erule disjE, clarsimp) 
              apply (erule disjE) apply (drule Y_NHigh_D, clarsimp) apply (rule AL_update1)
              apply (drule Y_NLow_D, clarsimp) apply (rule AL_update1)
            apply clarsimp apply (drule AL_delete6) apply simp
          apply (rule, simp add: AL_emp1)
apply (case_tac \<Lambda>, clarsimp)
(*case \<Lambda>=[]*)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (subgoal_tac "AL_dom emp[\<delta>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<epsilon>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<delta>\<mapsto>(NIL, emp)]" and M="emp[\<epsilon>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<delta>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<epsilon>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<delta>\<mapsto>(classTP NIL)]" and M="emp[\<epsilon>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<delta>],emp[\<delta>\<mapsto>(NIL, emp)]),emp[\<delta>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<delta>],emp[\<delta>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<nu>][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp]" 
                     and K="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<nu>'][TL\<mapsto>\<delta>])]" in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) 
                       apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) 
                       apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1)
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, erule disjE, drule Y_NHigh_D, clarsimp) apply (drule Y_NLow_D, clarsimp) 
                       apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                       apply (simp add: contained_def)
                       apply (rule, clarsimp) 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update4, rule AL_update4) 
                           apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
                            apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp)
                         apply (simp add: AL_emp1)
                       apply clarsimp 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                       apply clarsimp 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply fast
                       apply clarsimp 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update4) 
                           apply (rule AL_update1) apply assumption apply assumption 
                         apply (simp add: AL_emp1)
                   apply (drule Y_NLow_D, clarsimp) apply (drule Y_NHigh_D, clarsimp) 
                       apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                       apply (simp add: contained_def)
                       apply (rule, clarsimp) 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update4, rule AL_update1) 
                            apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp)
                         apply (simp add: AL_emp1)
                       apply clarsimp 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                       apply clarsimp 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) 
                       apply clarsimp 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) 
                           apply assumption 
                         apply (simp add: AL_emp1)
                  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)   
                    apply (erule disjE) apply (drule Y_NHigh_D, clarsimp) apply (drule Y_NLow_D, clarsimp) apply (simp add: AL_dom_upd1)
                    apply (drule Y_NLow_D, clarsimp) apply (drule Y_NHigh_D, clarsimp) apply (simp add: AL_dom_upd1)
        apply (rotate_tac -8) apply (erule thin_rl)
          apply (rule TypingAx) apply (simp add: G_def) apply (rule disjI1)
                              apply (simp add: NISp_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<delta> in exI, rule_tac x="[]" in exI)
                              apply (simp add: preS_def) apply (rule_tac x="[]" in exI, clarsimp)
                              apply (rule_tac x=\<epsilon> in exI, rule_tac x="[]" in exI, rule_tac x="[]" in exI)
                              apply (simp add: starOpt_def star_def)
                              apply (rule,rule,rule, rule) prefer 2 apply (rule, assumption) apply (rule, assumption)
                                apply (rule, assumption) apply (rule, assumption) apply (rule, assumption) apply (rule, assumption)
                              apply (erule disjE) apply (rule disjI2)
                                apply (drule Y_NHigh_D, clarsimp) apply (drule Y_NLow_D, clarsimp) apply (erule Y_NLow_Nil) apply simp
                                apply simp
                              apply (rule disjI1)
                                apply (drule Y_NLow_D, clarsimp) apply (drule Y_NHigh_D, clarsimp) apply (erule Y_NHigh_Nil) apply simp
                                apply simp
                            apply simp
        apply (simp add: RSD_sum_def) 
           (*apply (frule Y_NLow_contained_length) apply (drule Y_NLow_D, clarsimp)*)
           apply (rule, rule AL_DEL)  apply (erule disjE, drule Y_NHigh_contained_length, simp)
              apply (drule Y_NLow_contained_length, simp)
           apply (simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (rotate_tac -1, erule disjE) 
                       apply (drule AL_upd_split)
                       apply (rotate_tac -1, erule disjE, clarsimp) 
                         apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule, clarsimp)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (rotate_tac -1, erule disjE) 
                       apply (drule AL_upd_split)
                       apply (rotate_tac -1, erule disjE, clarsimp) 
                         apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply (rule,clarsimp)
                     apply (drule AL_upd_split)
                     apply (rotate_tac -1, erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                   apply (erule disjE, drule Y_NHigh_contained_length) apply clarsimp
                      apply (simp add: AL_dom_delete AL_dom_upd1 AL_dom_emp) apply fast
                   apply (drule Y_NLow_contained_length) apply clarsimp
                      apply (simp add: AL_dom_delete AL_dom_upd1 AL_dom_emp) apply fast
                    apply (rule, clarsimp)
                      apply (erule disjE,drule Y_NHigh_D,clarsimp) apply (drule Y_NLow_D, clarsimp)
                        apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update4, assumption)
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                      apply (drule Y_NLow_D,clarsimp) apply (drule Y_NHigh_D, clarsimp)
                        apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (rule AL_update4, rule AL_update4, rule AL_update4, assumption)
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                    apply (rule, clarsimp)
                      apply (erule disjE,drule Y_NHigh_D,clarsimp) apply (drule Y_NLow_D, clarsimp)
                        apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (rule AL_update4)
                          apply (drule AL_upd_split)
                          apply (erule disjE, clarsimp) apply (rule AL_update1)
                          apply (rule AL_update4) apply clarsimp
                            apply (drule AL_upd_split)
                            apply (erule disjE, clarsimp) apply (rule AL_update1)
                            apply (rule AL_update4) apply clarsimp
                              apply (drule AL_upd_split)
                              apply (erule disjE, clarsimp) apply (rule AL_update1)
                              apply (simp add: AL_emp1)
                            apply simp
                          apply simp
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                      apply (drule Y_NLow_D,clarsimp) apply (drule Y_NHigh_D, clarsimp)
                        apply (rule AL_delete5) apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (rule AL_update4)
                          apply (drule AL_upd_split)
                          apply (erule disjE, clarsimp) apply (rule AL_update1)
                            apply clarsimp
                            apply (drule AL_upd_split)
                            apply (erule disjE, clarsimp) 
                            apply (rule AL_update4) apply clarsimp
                              apply (drule AL_upd_split)
                              apply (erule disjE, clarsimp) apply (rule AL_update1)
                              apply (simp add: AL_emp1)
                            apply simp
                        apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp) apply clarsimp
                      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                        apply (rule, clarsimp) apply (rule, clarsimp)
                        apply (erule disjE,drule Y_NHigh_D,clarsimp) apply (drule Y_NLow_D, clarsimp)
                          apply (simp add: AL_dom_upd1 AL_dom_emp) 
                        apply (drule Y_NLow_D,clarsimp) apply (drule Y_NHigh_D, clarsimp)
                          apply (simp add: AL_dom_upd1 AL_dom_emp) 
(*Case last non-empty*)
apply clarsimp
  apply (case_tac "ListHP b list", clarsimp, clarsimp)  
  apply (case_tac "ListHP b zsa", clarsimp, clarsimp)
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP ba zsc", clarsimp, clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<mu> \<beta> \<Lambda> \<alpha> \<Upsilon> \<Lambda>' \<mu>' \<Upsilon>' H H' K K')
  apply (subgoal_tac "AL_dom H[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])] \<inter> AL_dom K[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])]" and M="K[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])] \<inter> AL_dom K'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<alpha>])] = {}") 
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H'[\<delta>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])]" and M="K'[\<epsilon>\<mapsto>(CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<alpha>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def)
        apply (rule_tac H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<nu>][TL\<mapsto>\<delta>])]"
                     and K="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<nu>'][TL\<mapsto>\<delta>])]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp]"
                     and \<gamma>="(([],emp[this\<mapsto>\<delta>],upd H \<delta> (CONS, emp[HD\<mapsto>\<mu>][TL\<mapsto>\<beta>])),
                              delete (delete (delete N \<nu>') \<nu>) \<gamma>,
                             ([],emp[this\<mapsto>\<delta>],upd H' \<delta> (CONS, emp[HD\<mapsto>\<mu>'][TL\<mapsto>\<beta>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (rotate_tac -1, erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (rotate_tac -1, erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_delete AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def, rule, clarsimp)
                       apply (drule AL_delete6) apply (erule conjE)
                       apply (drule AL_delete6) apply (erule conjE)
                       apply (drule AL_delete6) apply (erule conjE, assumption)
             apply clarsimp
                       apply (erule disjE, drule Y_NHigh_D, clarsimp)                         
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp, rule AL_update1) apply clarsimp
                         apply (rule AL_update4)
                           apply (drule AL_upd_split)
                           apply (erule disjE, clarsimp, rule AL_update1) apply clarsimp
                           apply (rule AL_update4)
                             apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp, rule AL_update1) apply (simp add: AL_emp1)
                           apply assumption
                         apply assumption 
                       apply (drule Y_NLow_D, clarsimp)
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp, rule AL_update1) apply clarsimp
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply clarsimp
                         apply (rule AL_update4)
                           apply (drule AL_upd_split)
                             apply (erule disjE, clarsimp, rule AL_update1) apply (simp add: AL_emp1)
                         apply assumption
            apply (simp add: AL_dom_upd1 AL_dom_emp AL_dom_delete)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length \<Upsilon>)" in exI, simp)
          apply (rule, simp add: ConsCopy_def)
          apply (simp add: NISp_def preS_def)
          apply (rule_tac x=\<delta> in exI, rule_tac x="(\<mu>, \<beta>) # \<Lambda>" in exI, clarsimp)
          apply (rule_tac x="(\<mu>', \<beta>) # \<Lambda>'" in exI, clarsimp)
          apply (rule_tac x=\<epsilon> in exI, rule_tac x="(\<mu>, \<alpha>) # \<Upsilon>" in exI)
          apply (rule_tac x="(\<mu>', \<alpha>) # \<Upsilon>'" in exI) apply clarsimp
          apply (simp add: starOpt_def star_def)
          apply (rule_tac x=KK in exI, simp) apply (rule_tac x=KK' in exI, simp)
          apply (rule_tac x="delete(delete (delete (delete M \<gamma>) \<nu>) \<nu>') \<omega>" in exI)
          apply (rule, simp)
          apply (erule disjE) apply (rule disjI2) apply (drule Y_NHigh_D, clarsimp)
            apply (subgoal_tac "delete (delete (delete NN[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp] \<nu>') \<nu>) \<gamma> = NN", clarsimp)
              apply (subgoal_tac "delete( delete (delete (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma>) \<nu>) \<nu>') \<omega> = MM", clarsimp)
                apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma> = 
                                    (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp] \<gamma>)[\<omega>\<mapsto>(classTP CONS)]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff)
                apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp] \<gamma> = (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<gamma>)[\<nu>'\<mapsto>tp]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff2) 
                apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<gamma> = (delete MM[\<gamma>\<mapsto>(classTP CONS)] \<gamma>)[\<nu>\<mapsto>tp]", clarsimp) 
                prefer 2 apply (erule AL_delete_upd_diff2)
                apply (simp add: AL_delete7) 
                apply (subgoal_tac "delete MM \<gamma> = MM", clarsimp) prefer 2 apply (rule AL_delete3) apply (erule AL_notdomD)
                apply (subgoal_tac "delete MM[\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<nu> = (delete MM[\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp] \<nu>)[\<omega>\<mapsto>(classTP CONS)]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff)
                apply (subgoal_tac "delete MM[\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp] \<nu> = (delete MM[\<nu>\<mapsto>tp] \<nu>)[\<nu>'\<mapsto>tp]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff)
                apply (simp add: AL_delete7) 
                apply (subgoal_tac "delete MM \<nu> = MM", clarsimp) prefer 2 apply (rule AL_delete3) apply (erule AL_notdomD)
                apply (subgoal_tac "delete MM[\<nu>'\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<nu>' = (delete MM[\<nu>'\<mapsto>tp] \<nu>')[\<omega>\<mapsto>(classTP CONS)]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff)
                apply (simp add: AL_delete7) 
                apply (subgoal_tac "delete MM \<nu>' = MM", clarsimp) prefer 2 apply (rule AL_delete3) apply (erule AL_notdomD)
                apply (rule AL_delete3) apply (erule AL_notdomD)
              apply (simp add: AL_delete_upd_same)
                apply (subgoal_tac "delete NN[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<nu>' = (delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu>')[\<nu>\<mapsto>tp]", simp add: AL_delete_upd_same)
                prefer 2 apply (erule AL_delete_upd_diff2)
                apply (subgoal_tac "delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu>' = (delete NN \<nu>')[\<gamma>\<mapsto>(classTP CONS)]", clarsimp)
                apply (subgoal_tac "delete NN \<nu>' = NN", clarsimp) 
                prefer 2 apply (rule AL_delete3) apply (rule AL_notdomD) apply (drule Y_NLow_contained_length, clarsimp) 
                apply (subgoal_tac "delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu> = (delete NN \<nu>)[\<gamma>\<mapsto>(classTP CONS)]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff)
                apply (subgoal_tac "delete NN \<nu> = NN", clarsimp) 
                prefer 2 apply (rule AL_delete3) apply (rule AL_notdomD) apply (drule Y_NLow_contained_length, clarsimp) 
                apply (simp add: AL_delete_upd_same) apply (rule AL_delete3) apply (rule AL_notdomD) apply (drule Y_NLow_contained_length, clarsimp) 
                apply (erule AL_delete_upd_diff) 
            apply (rule disjI1) apply (drule Y_NLow_D, clarsimp)
            apply (subgoal_tac "delete (delete (delete NN[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<nu>) \<nu>) \<gamma> = NN", clarsimp)
              apply (subgoal_tac "delete (delete (delete (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma>) \<nu>) \<nu>) \<omega> = MM", clarsimp)
                apply (subgoal_tac "delete (delete (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma>) \<nu>) \<nu> =
                                    delete (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma>) \<nu>", clarsimp)
                prefer 2 apply (subgoal_tac "delete (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma>) \<nu> =
                                  delete (delete (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma>) \<nu>) \<nu>", clarsimp) 
                         apply (rule AL_delete_idempotent)
                apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<gamma> = 
                                    (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<gamma>)[\<omega>\<mapsto>(classTP CONS)]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff)
                apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<gamma> = (delete MM[\<gamma>\<mapsto>(classTP CONS)] \<gamma>)[\<nu>\<mapsto>tp]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff2) 
                apply (simp add: AL_delete7) 
                apply (subgoal_tac "delete MM \<gamma> = MM", clarsimp) prefer 2 apply (rule AL_delete3) apply (erule AL_notdomD)
                apply (subgoal_tac "delete MM[\<nu>\<mapsto>tp][\<omega>\<mapsto>(classTP CONS)] \<nu> = (delete MM[\<nu>\<mapsto>tp] \<nu>)[\<omega>\<mapsto>(classTP CONS)]", clarsimp)
                prefer 2 apply (erule AL_delete_upd_diff)
                apply (simp add: AL_delete7) 
                apply (subgoal_tac "delete MM \<nu> = MM", clarsimp) prefer 2 apply (rule AL_delete3) apply (erule AL_notdomD)
                apply (rule AL_delete3) apply (erule AL_notdomD)
              apply (simp add: AL_delete_upd_same)
                apply (subgoal_tac "delete (delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu>) \<nu> = delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu>", clarsimp)
                prefer 2 apply (subgoal_tac "delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu> = delete (delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu>) \<nu>", clarsimp)
                         apply (rule AL_delete_idempotent)
                apply (subgoal_tac "delete NN[\<gamma>\<mapsto>(classTP CONS)] \<nu> = (delete NN \<nu>)[\<gamma>\<mapsto>(classTP CONS)]", clarsimp)
                apply (subgoal_tac "delete NN \<nu> = NN", clarsimp) 
                prefer 2 apply (rule AL_delete3) apply (rule AL_notdomD) apply (drule Y_NHigh_contained_length, clarsimp)
                apply (simp add: AL_delete_upd_same) apply (rule AL_delete3) apply (rule AL_notdomD) apply (drule Y_NHigh_contained_length, clarsimp) 
                apply (erule AL_delete_upd_diff)
        apply (simp add: RSD_sum_def)
          apply rule apply (rule AL_DEL) apply (erule disjE) apply (drule Y_NHigh_contained_length, clarsimp)
                     apply (drule Y_NLow_contained_length, clarsimp)
          apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (rotate_tac -1, erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (rotate_tac -1, erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (rotate_tac -1, erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply (rule, clarsimp)
              apply (drule AL_upd_split)
              apply (rotate_tac -1, erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp add: AL_dom_delete AL_dom_upd1 AL_dom_emp) apply fast
            apply (rule, clarsimp) apply (drule AL_delete6, erule conjE) apply (drule AL_delete6, erule conjE)
               apply (drule AL_delete6, erule conjE) apply (drule AL_delete6, erule conjE) apply (erule AL_delete5b) apply assumption
            apply (rule, clarsimp)
              apply (erule disjE, drule Y_NHigh_D, clarsimp)
                apply (simp add: AL_delete_upd_same)
                apply (subgoal_tac "(delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp][\<nu>'\<mapsto>tp] \<omega>) = (delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<omega>)[\<nu>'\<mapsto>tp]", clarsimp)
                  apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<omega> = (delete MM[\<gamma>\<mapsto>(classTP CONS)] \<omega>)[\<nu>\<mapsto>tp]", clarsimp) 
                    apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)] \<omega> = (delete MM \<omega>)[\<gamma>\<mapsto>(classTP CONS)]", clarsimp)
                      apply (drule AL_upd_split)
                      apply (erule disjE) apply clarsimp apply (rule AL_update1) 
                        apply (rule AL_update4, clarsimp)
                        apply (drule AL_upd_split)
                        apply (erule disjE) apply clarsimp apply (rule AL_update1)
                          apply (rule AL_update4, clarsimp)
                          apply (drule AL_upd_split)
                          apply (erule disjE) apply clarsimp apply (rule AL_update1)
                          apply (simp add: AL_emp1)
                        apply simp
                      apply simp
                    apply (erule AL_delete_upd_diff)
                  apply (erule AL_delete_upd_diff)
                apply (erule AL_delete_upd_diff)
              apply (drule Y_NLow_D, clarsimp)
                apply (simp add: AL_delete_upd_same)
                apply (subgoal_tac "(delete MM[\<gamma>\<mapsto>(classTP CONS)][\<nu>\<mapsto>tp] \<omega>) = (delete MM[\<gamma>\<mapsto>(classTP CONS)] \<omega>)[\<nu>\<mapsto>tp]", clarsimp)
                    apply (subgoal_tac "delete MM[\<gamma>\<mapsto>(classTP CONS)] \<omega> = (delete MM \<omega>)[\<gamma>\<mapsto>(classTP CONS)]", clarsimp)
                    apply (drule AL_upd_split)
                    apply (erule disjE) apply clarsimp apply (rule AL_update1) 
                      apply (rule AL_update4, clarsimp)
                      apply (drule AL_upd_split)
                      apply (erule disjE) apply clarsimp apply clarsimp
                      apply (drule AL_upd_split)
                      apply (erule disjE) apply clarsimp apply (rule AL_update1)
                      apply (simp add: AL_emp1)
                    apply simp
                  apply (erule AL_delete_upd_diff)
                apply (erule AL_delete_upd_diff)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_dom_delete AL_sum_def) apply fast 
done
(*>*)

text{*In particular, the result holds for program $COPY$.*}

lemma G_verified_COPY:
   "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];P=COPY; distinct [NIL,CONS,LIST];
        \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS\<rbrakk> 
    \<Longrightarrow> CtxtVerified (G tp)"
(*<*)
apply (erule G_verified, assumption+)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=ListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>LIST = Some ListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: ListClass_def) apply (rule AL_update1)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=NilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>NIL = Some NilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: NilClass_def) apply (rule AL_update1)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=ConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>CONS = Some ConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: ConsClass_def) apply (rule AL_update1)
done
(*>*)

(*<*)
end
(*>*)