(*<*)
theory ListSL_RelVerif1 = ListSLRep:
(*>*)

subsubsection{*Verification of $G_1$ from Section 5.3*}

text{*First, a proof that does not share the subproofs for the
instructions following the invocations.*}

lemma G_verified_nonshared:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
        \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
        mbody_is LIST Copy ListCopy; mbody_is LIST OptCopy ListCopy; mbody_is NIL Copy NilCopy;
        mbody_is NIL OptCopy NilCopy; mbody_is CONS Copy ConsCopy; mbody_is CONS OptCopy ConsOpt\<rbrakk> 
    \<Longrightarrow> CtxtVerified G1"
(*<*)
apply (simp add: G1_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp)
  apply (simp add: RelSp1_def) apply (erule thin_rl, erule thin_rl)  
  apply (rule, simp add: preserved_def starOptDEF, clarsimp)
    apply (rule, simp add: AL_sum_def)
    apply (simp add: preS_def AL_sum_def, clarsimp)
  apply clarsimp
  apply (subgoal_tac "(G1,((ad, ae, bb), emp[\<gamma>\<mapsto>(classTP NIL)], ad, ae, bb), 
                       NilCopy, 0, NilCopy, 0, False, 
                      ([\<gamma>'], emp, bd), ak, ([\<gamma>'], emp, bd)) \<in> Typing", simp add: G1_def RelSp1_def)
  apply (simp add: preS_def, clarsimp)
  apply (rename_tac K M \<gamma> \<gamma>')
apply (rule_tac c=\<gamma>' and C=NIL in TypingNewNew)
    apply (rule InstrNIL0)
    apply (rule InstrNIL0)
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp)
    apply (simp add: subclass_of_refl)
    apply (simp add: subclass_of_refl)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply fastsimp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def starOptDEF, clarsimp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp  apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp  apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (simp add: AL_dom_emp)
(*n>0*)
apply (rule, clarsimp)
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (rule, simp add: preserved_def RelSp1_def preS_def starOptDEF, clarsimp)
    apply (simp add: AL_sum_def)  apply fast
  apply (subgoal_tac "(G1,((ad, ae, bb), af, ag, ah, bc), ConsCopy, 0, ConsOpt, 0, False, (ai, aj, bd), ak, al, am, be)
          \<in> Typing", simp add: G1_def)
  apply (simp add: RelSp1_def preS_def, clarsimp)
  apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp)
  apply (simp add: starOptDEF, clarsimp)
  apply (rename_tac H N HK NM \<gamma> \<Lambda> \<gamma>' \<Upsilon> K M)
  apply (case_tac \<Lambda>, clarsimp,clarsimp) 
  apply (case_tac "ListN b list", clarsimp,clarsimp) 
  apply (case_tac "ListHP b list", clarsimp,clarsimp) 
  apply (case_tac "ListN ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp,clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<gamma> \<gamma>' \<epsilon> \<theta> \<Theta> \<omega> \<Omega> N H M K)
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule InstrOPT0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp   
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT1)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
apply (case_tac \<Omega>, clarsimp)
(*case \<Omega>=[]*)
  apply (rule_tac HH="emp[\<theta>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>])][\<omega>\<mapsto>(NIL, emp)]"
              and NN="emp[\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)][\<omega>\<mapsto>(classTP NIL)]"
              and KK="emp[\<theta>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>])][\<omega>\<mapsto>(NIL, emp)]" in TypingInvVInvV3)
      apply (rule InstrCONS7)
      apply (simp add: ListCopy_def)
      apply (rule InstrOPT5)
      apply (simp add: ListCopy_def) 
      apply fastsimp    
      apply (rule absFrameNil) apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      prefer 2 apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
      prefer 2 apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
      prefer 2 apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (subgoal_tac "AL_dom emp[\<theta>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<omega>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<theta>\<mapsto>(NIL, emp)]" and M="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<theta>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<omega>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<theta>\<mapsto>(classTP NIL)]" and M="emp[\<omega>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<theta>],emp[\<theta>\<mapsto>(NIL, emp)]),emp[\<theta>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<theta>],emp[\<theta>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>])]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)]" 
                     and K="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>])]" in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp add: G1_def) apply (rule disjI1)
                              apply (simp add: RelSp1_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<theta> in exI, rule_tac x="[]" in exI)
                              apply (simp add: preS_def)
                              apply (rule_tac x=\<omega> in exI, rule_tac x="[]" in exI) apply (simp add: star_def starOpt_def)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp)
          apply (rule, simp)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (rule AL_update4, rule AL_update4, assumption)
                         apply (drule_tac H="emp[\<theta>\<mapsto>(NIL, emp)]" in AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                         apply (drule_tac H="emp[\<theta>\<mapsto>(NIL, emp)]" in AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (rule AL_update4, rule AL_update4, assumption)
                         apply (drule_tac H="emp[\<theta>\<mapsto>(classTP NIL)]" in AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                         apply (drule_tac H="emp[\<theta>\<mapsto>(classTP NIL)]" in AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
                     apply (simp add: AL_emp1)
                 apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT6)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac c=\<gamma>' and C=CONS in TypingNewNew)
      apply (rule InstrCONS9)
      apply (rule InstrOPT7)
      apply fastsimp    
      apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT9)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT10)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT11)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT12)
      apply fastsimp    
      apply (rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrOPT14)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply clarsimp
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply clarsimp
            apply (simp add: AL_emp1)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply clarsimp
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply assumption 
          apply (simp add: AL_emp1)
          apply (simp add: AL_emp1)    
(*Case last non-empty*)
apply clarsimp
  apply (case_tac "ListN ba zs", clarsimp, clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP b list", clarsimp, clarsimp) 
  apply (case_tac "ListN b list", clarsimp, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<delta> \<theta> \<Theta> \<omega> \<Omega> N H K M)
  apply (subgoal_tac "AL_dom H[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>'])] \<inter> AL_dom K[\<omega>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<theta>])]={}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (drule_tac M="K[\<omega>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<theta>])]" in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
  apply (subgoal_tac "AL_dom N[\<theta>'\<mapsto>(classTP CONS)][\<gamma>\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<omega>'\<mapsto>(classTP CONS)]={}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (drule_tac M="M[\<omega>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
  apply (subgoal_tac "AL_dom H[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])] \<inter> AL_dom K[\<omega>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<theta>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])]" and M="K[\<omega>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<theta>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom N[\<theta>'\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<omega>'\<mapsto>(classTP CONS)]={}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="N[\<theta>'\<mapsto>(classTP CONS)]" and M="M[\<omega>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM, erule conjE)  
  apply (rule_tac HH=HH and NN=NN and KK=HH in  TypingInvVInvV3)
      apply (rule InstrCONS7)
      apply (simp add: ListCopy_def) 
      apply (rule InstrOPT5)
      apply (simp add: ListCopy_def) 
      apply fastsimp    
      apply (rule absFrameNil) apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      prefer 2 apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
      prefer 2 apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
      prefer 2 apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsOpt)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsOpt_def) 
        apply (rule_tac H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>'])]"
                     and K="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>'])]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)]" 
                     and \<gamma>="(([],emp[this\<mapsto>\<theta>'],upd H \<theta>' (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])),
                              N[\<theta>'\<mapsto>(classTP CONS)],
                             ([],emp[this\<mapsto>\<theta>'],upd H \<theta>' (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL) 
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListN_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1) 
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp add: G1_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length \<Omega>)" in exI, simp add: ConsCopy_def ConsOpt_def RelSp1_def preS_def)
          apply (rule_tac x=\<theta>' in exI, rule_tac x="(\<delta>,\<omega>)#\<Omega>" in exI, clarsimp)
          apply (rule_tac x=\<omega>' in exI, rule_tac x="(\<delta>,\<theta>)#\<Theta>" in exI, clarsimp)
            apply (simp add: starOpt_def star_def)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp)
          apply (rule, simp)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT6)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac c=\<gamma>' and C=CONS in TypingNewNew)
      apply (rule InstrCONS9)
      apply (rule InstrOPT7)
      apply fastsimp    
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT9)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT10)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT11)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT12)
      apply fastsimp    
      apply (rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrOPT14)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, erule AL_UPD)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
done
(*>*)

text{*Next, a proof of the same result, with a shared proof tree for the
instructions following the invocations.*}

lemma G1_verified_shared:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
        \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
        mbody_is LIST Copy ListCopy; mbody_is LIST OptCopy ListCopy; mbody_is NIL Copy NilCopy;
        mbody_is NIL OptCopy NilCopy; mbody_is CONS Copy ConsCopy; mbody_is CONS OptCopy ConsOpt\<rbrakk> 
    \<Longrightarrow> CtxtVerified G1"
(*<*)
apply (simp add: G1_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp)
  apply (simp add: RelSp1_def) apply (erule thin_rl, erule thin_rl)  
  apply (rule, simp add: preserved_def starOptDEF, clarsimp)
    apply (rule, simp add: AL_sum_def)
    apply (simp add: preS_def AL_sum_def, clarsimp)
  apply clarsimp
  apply (subgoal_tac "(G1,((ad, ae, bb), emp[\<gamma>\<mapsto>(classTP NIL)], ad, ae, bb), 
                       NilCopy, 0, NilCopy, 0, False, 
                      ([\<gamma>'], emp, bd), ak, ([\<gamma>'], emp, bd)) \<in> Typing", simp add: G1_def RelSp1_def)
  apply (simp add: preS_def, clarsimp)
  apply (rename_tac K M \<gamma> \<gamma>')
apply (rule_tac c=\<gamma>' and C=NIL in TypingNewNew)
    apply (rule InstrNIL0)
    apply (rule InstrNIL0)
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp)
    apply (simp add: subclass_of_refl)
    apply (simp add: subclass_of_refl)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply fastsimp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def starOptDEF, clarsimp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp  apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp  apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (simp add: AL_dom_emp)
(*n>0*)
apply (rule, clarsimp)
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (rule, simp add: preserved_def RelSp1_def preS_def starOptDEF, clarsimp)
    apply (simp add: AL_sum_def)  apply fast
  apply (subgoal_tac "(G1,((ad, ae, bb), af, ag, ah, bc), ConsCopy, 0, ConsOpt, 0, False, (ai, aj, bd), ak, al, am, be)
          \<in> Typing", simp add: G1_def)
  apply (simp add: RelSp1_def preS_def, clarsimp)
  apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp)
  apply (simp add: starOptDEF, clarsimp)
  apply (rename_tac H N HK NM \<gamma> \<Lambda> \<gamma>' \<Upsilon> K M)
  apply (case_tac \<Lambda>, clarsimp,clarsimp) 
  apply (case_tac "ListN b list", clarsimp,clarsimp) 
  apply (case_tac "ListHP b list", clarsimp,clarsimp) 
  apply (case_tac "ListN ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp,clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<gamma> \<gamma>' \<epsilon> \<theta> \<Theta> \<omega> \<Omega> N H M K)
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule InstrOPT0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp   
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT1)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
apply (subgoal_tac "AL_dom H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>])] \<inter> AL_dom K = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
apply (subgoal_tac "AL_dom N[\<gamma>\<mapsto>(classTP CONS)] \<inter> AL_dom M = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=M in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
apply (subgoal_tac "(G1, (([\<omega>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>][t\<mapsto>\<theta>], HH), NN, [\<omega>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>],HH),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), ConsOpt, Suc(Suc (Suc (Suc (Suc (Suc 0))))), False, ([\<gamma>'], emp, HK), NM, [\<gamma>'], emp,
           HK)
          \<in> Typing")
prefer 2
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT6)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac c=\<gamma>' and C=CONS in TypingNewNew)
      apply (rule InstrCONS9)
      apply (rule InstrOPT7)
      apply fastsimp    
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply (simp add: subclass_of_refl)
      apply (simp add: subclass_of_refl)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT9)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT10)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT11)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT12)
      apply fastsimp    
      apply (rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrOPT14)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, erule AL_UPD)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
apply (case_tac \<Omega>, clarsimp)
(*case \<Omega>=[]*)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrOPT5)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def)
        apply (subgoal_tac "AL_dom emp[\<theta>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<omega>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<theta>\<mapsto>(NIL, emp)]" and M="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<theta>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<omega>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac N="emp[\<theta>\<mapsto>(classTP NIL)]" and M="emp[\<omega>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<theta>],emp[\<theta>\<mapsto>(NIL, emp)]),emp[\<theta>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<theta>],emp[\<theta>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>])]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)]" 
                     and K="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>])]" in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp add: G1_def) apply (rule disjI1)
                              apply (simp add: RelSp1_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<theta> in exI, rule_tac x="[]" in exI)
                              apply (simp add: preS_def)
                              apply (rule_tac x=\<omega> in exI, rule_tac x="[]" in exI) apply (simp add: star_def starOpt_def)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp 
(*Case last non-empty*)
apply clarsimp
  apply (case_tac "ListN ba zs", clarsimp, clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP b list", clarsimp, clarsimp) 
  apply (case_tac "ListN b list", clarsimp, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<delta> \<theta> \<Theta> \<omega> \<Omega> N H K M)
  apply (subgoal_tac "AL_dom H[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])] \<inter> AL_dom K[\<omega>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<theta>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])]" and M="K[\<omega>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<theta>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom N[\<theta>'\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<omega>'\<mapsto>(classTP CONS)]={}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="N[\<theta>'\<mapsto>(classTP CONS)]" and M="M[\<omega>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM, erule conjE)  
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrOPT5)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsOpt)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsOpt_def) 
        apply (rule_tac H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>'])]"
                     and K="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<theta>'])]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)]" 
                     and \<gamma>="(([],emp[this\<mapsto>\<theta>'],upd H \<theta>' (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])),
                              N[\<theta>'\<mapsto>(classTP CONS)],
                             ([],emp[this\<mapsto>\<theta>'],upd H \<theta>' (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListN_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1) 
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G1_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length \<Omega>)" in exI, simp add: ConsCopy_def ConsOpt_def  RelSp1_def preS_def)
          apply (rule_tac x=\<theta>' in exI, rule_tac x="(\<delta>,\<omega>)#\<Omega>" in exI, clarsimp)
          apply (rule_tac x=\<omega>' in exI, rule_tac x="(\<delta>,\<theta>)#\<Theta>" in exI, clarsimp)
            apply (simp add: starOpt_def star_def)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply simp
        apply (simp add: RSD_sum_def)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
done
(*>*)

text{*Thus, $G_1$ is in particular verified for the program $OPT$.*}

lemma G1_verified_OPT:
  "\<lbrakk>TL \<noteq> HD; P=OPT; distinct [h, t, z, this];distinct [NIL,CONS,LIST];OptCopy \<noteq> Copy;
        \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS\<rbrakk> 
    \<Longrightarrow> CtxtVerified G1"
(*<*)
apply (erule G1_verified_shared, assumption+)
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>LIST = Some OptListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: OptListClass_def) apply (rule AL_update4) apply (rule AL_update1) apply assumption
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>LIST = Some OptListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: OptListClass_def) apply (rule AL_update1) 
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptNilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>NIL = Some OptNilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: OptNilClass_def) apply (rule AL_update4, rule AL_update1) apply assumption
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptNilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>NIL = Some OptNilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: OptNilClass_def) apply (rule AL_update1) 
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>CONS = Some OptConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: OptConsClass_def) apply (rule AL_update4, rule AL_update1) apply assumption
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>CONS = Some OptConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: OptConsClass_def) apply (rule AL_update1) 
done
(*>*)

(*<*)
end
(*>*)