(*<*)
theory ListSL_RelVerif2 = ListSL_UnaryVerif: 
(*>*)

(*We build on ListSL\_UnaryVerif in order to enable the
proof that employs two high applications of the unary invocation
rule*)

subsubsection{*Verification of $G_2$ from Section 5.3*}

text{*First, the proof that does not correlate the invocations.*}

lemma G2_verified_NonCorrelated:
  "\<lbrakk> TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
     mbody_is LIST Copy ListCopy; mbody_is NIL Copy NilCopy; mbody_is CONS Copy ConsCopy;
     mbody_is LIST OptCopy ListCopy; mbody_is NIL OptCopy NilCopy; mbody_is CONS OptCopy ConsOpt\<rbrakk> 
    \<Longrightarrow> CtxtVerified G2"
(*<*)
apply (simp add: G2_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp) apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (simp add: RelSp2_def) 
  apply (rule, simp add: preserved_def starOptDEF, clarsimp)
    apply (rule, simp add: AL_sum_def, clarsimp) apply (erule contained_transitive, assumption)
    apply (simp add: preS_def AL_sum_def, clarsimp) apply (rule, fast) apply fast
  apply clarsimp
  apply (subgoal_tac "(G2,((a, aa, b), emp[\<gamma>\<mapsto>(classTP NIL)], a, aa, b), NilCopy, 0, NilCopy, 0, False, ([\<upsilon>], emp, H), ak, [\<upsilon>'], emp, K)
          \<in> Typing", simp add: G2_def RelSp2_def)
  apply (simp add: preS_def, clarsimp)
  apply (rename_tac N)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  apply (rule_tac cl=\<upsilon>' and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp AL_sum_def) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply simp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def starOptDEF, clarsimp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (simp add: AL_dom_emp)
(*n>0*)
apply (rule, clarsimp)
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (rule, simp add: preserved_def RelSp2_def preS_def starOptDEF, clarsimp)
    apply (simp add: AL_sum_def, clarsimp)  
      apply (rule, erule contained_transitive, assumption) 
      apply fast
  apply (subgoal_tac "(G2,((ad, ae, bb), af, ag, ah, bc),
           ConsCopy, 0, ConsOpt, 0, False, (ai, aj, bd), ak, al, am, be)
          \<in> Typing", simp add: G2_def)
  apply (simp add: RelSp2_def preS_def, clarsimp)
  apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp)
  apply (simp add: starOptDEF, clarsimp)
  apply (rename_tac NMM' \<gamma> \<Lambda> \<upsilon> \<Upsilon> \<upsilon>' \<Upsilon>' HK HK' H N NM K K' M M')
  apply (case_tac \<Lambda>, clarsimp,clarsimp) 
  apply (case_tac "ListN b list", clarsimp,clarsimp) 
  apply (case_tac "ListHP b list", clarsimp,clarsimp) 
  apply (case_tac "ListN ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListN bb zsa", clarsimp,clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp,clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<epsilon> \<omega> \<Omega> \<theta> \<Theta> \<theta>' \<Theta>' N H M K M' K')
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule InstrOPT0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp   
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT1)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K' = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K' in AL_sum_exists_AL) apply (erule exE, rename_tac HH', erule conjE)
apply (subgoal_tac "AL_dom N[\<gamma>\<mapsto>(classTP CONS)] \<inter> AL_dom M = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=M in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom M' = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=M' in AL_sum_exists_AL) apply (erule exE, rename_tac NNN', erule conjE)
apply (subgoal_tac "(G2, (([\<theta>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>][t\<mapsto>\<omega>], HH), NNN', [\<theta>'], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>],HH'),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), ConsOpt, Suc(Suc (Suc (Suc (Suc (Suc 0))))),
             False, ([\<upsilon>], emp, HK), NMM', [\<upsilon>'], emp,
           HK')
          \<in> Typing")
prefer 2
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT6)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and C=CONS and D=CONS in UniNew)
      apply (rule InstrCONS9)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  apply (rule_tac cl=\<upsilon>' and C=CONS and D=CONS in UniNew)
      apply (rule InstrOPT7)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT9)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT10)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT11)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT12)
      apply fastsimp    
      apply (rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrOPT14)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_sum_split, assumption)
            apply (erule disjE) 
              apply (drule AL_sum_split, assumption)
              apply (erule disjE) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
              apply (erule AL_sum3) apply (erule AL_sum4) apply (erule AL_update4) apply assumption
            apply (erule AL_sum4) apply (erule AL_update4, assumption) 
          apply (simp add: AL_emp1)
apply (case_tac \<Omega>, clarsimp)
(*case \<Omega>=[]*)
apply (rule_tac U="W ConsCopy" and L="{Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))))}" in UniInjectL)
  prefer 2 apply (erule W_ConsCopy_verified) apply simp apply simp apply assumption+
  prefer 2 apply fastsimp
  (*prefer 2 apply simp*)
  apply (rule_tac c=\<theta> and
                  HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in UniInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def)
    apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    prefer 2 apply clarsimp apply (erule_tac x=E in allE, erule impE, assumption) apply clarsimp
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def)
        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" and 
                       N="emp[\<gamma>\<mapsto>(classTP CONS)]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>\<mapsto>(NIL, emp)]" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>\<mapsto>(classTP NIL)]" in UniBSFrame)
         apply (rule UniAx) apply (simp add: W_def) apply (rule disjI1)
            apply (rule, simp add: NilCopy_def)
            apply (simp add: Sp_def) apply (rule_tac x=\<omega> in exI, simp add: preS_def starOpt_def star_def)
                                     apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def)
                                     apply (rule, simp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                apply (subgoal_tac "AL_sum emp[\<omega>\<mapsto>(classTP NIL)][\<theta>\<mapsto>(classTP NIL)] emp[\<gamma>\<mapsto>(classTP CONS)] 
                                           (emp[\<omega>\<mapsto>(classTP NIL)][\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)])", assumption)
                  apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
apply clarsimp
apply (rule TypingInj)
apply (rule_tac U="W ConsOpt" and L="{Suc (Suc (Suc (Suc (Suc (Suc 0)))))}" in UniInjectR)
  prefer 2 apply (erule W_ConsOpt_verified) apply simp apply simp apply assumption+
  prefer 2 apply fastsimp
(*  prefer 2 apply simp *)
  apply (rule_tac c=\<theta>' and
                  HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in UniInvV3)
    apply (rule InstrOPT5)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    prefer 2 apply clarsimp apply (erule_tac x=E in allE, erule impE, assumption) apply clarsimp
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def)  
        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], emp[\<omega>\<mapsto>(NIL, emp)])" and
                       H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" and
                       N="emp[\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)]" and
                       HH="emp[\<omega>\<mapsto>(NIL, emp)][\<theta>'\<mapsto>(NIL, emp)]" and
                       NN="emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)]" in UniBSFrame)
         apply (rule UniAx) apply (simp add: W_def) apply (rule disjI1)
            apply (rule, simp add: NilCopy_def)
            apply (simp add: Sp_def) apply (rule_tac x=\<omega> in exI, simp add: preS_def starOpt_def star_def)
                                     apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def)
                                     apply (rule, simp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                     apply rule  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                apply (simp (no_asm) add: SD_sum_def AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                     apply (rule, clarsimp)
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply (simp add: AL_emp1)
                                      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, assumption) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                         apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4) 
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                                         apply (simp add: AL_emp1)
                                       apply assumption
                apply (subgoal_tac "AL_sum emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)] emp[\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)] 
                                           (emp[\<omega>\<mapsto>(classTP NIL)][\<theta>'\<mapsto>(classTP NIL)][\<theta>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)])", assumption)
                  apply (simp (no_asm) add: AL_sum_def contained_def AL_dom_upd1 AL_dom_emp)
                                     apply (rule, clarsimp)
                                       apply (rule AL_update4, rule AL_update4, assumption) 
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                       apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                                     apply clarsimp
                                       apply (drule AL_upd_split)
                                       apply (erule disjE, clarsimp) apply (rule AL_update1)
                                       apply clarsimp
                                       apply (rule AL_update4)
                                         apply (drule AL_upd_split)
                                         apply (erule disjE, clarsimp) apply (rule AL_update1)
                                         apply (simp add: AL_emp1)
                                       apply assumption
                apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply (rule, clarsimp) apply clarsimp
                apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
    apply clarsimp apply (rule_tac H=emp and N=emp and K=emp in TypingFrame) apply (erule TypingInj)
    apply (simp add: RSD_sum_def) 
              apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
              apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
              apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
              apply (simp(no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def AL_emp1)
              apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp)
                apply (drule AL_sum_split, assumption)
                apply (erule disjE) 
                  apply (drule AL_upd_split)
                  apply (erule disjE, clarsimp) apply (rule AL_update1)
                  apply clarsimp
                  apply (rule AL_update4)
                    apply (rule AL_update4, assumption)
                    apply (drule_tac d=a and H="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp)
                  apply (drule_tac d=a and H="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp)
                apply (rule AL_update4)
                  apply (drule AL_upd_split)
                  apply (erule disjE, clarsimp) apply (rule AL_update1)
                  apply (simp add: AL_emp1)
                apply (drule_tac d=a and H="emp[\<theta>\<mapsto>(NIL, emp)]" in AL_domI)
                  apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp)
                apply (drule AL_sum_split, assumption)
                apply (erule disjE) 
                  apply (drule AL_upd_split)
                  apply (erule disjE, clarsimp) apply (rule AL_update1)
                  apply clarsimp
                  apply (rule AL_update4)
                    apply (rule AL_update4, assumption)
                    apply (drule_tac d=a and H="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp)
                  apply (drule_tac d=a and H="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp)
                apply (rule AL_update4)
                  apply (drule AL_upd_split)
                  apply (erule disjE, clarsimp) apply (rule AL_update1)
                  apply (simp add: AL_emp1)
                apply (drule_tac d=a and H="emp[\<theta>'\<mapsto>(NIL, emp)]" in AL_domI)
                  apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp)
                apply (drule AL_sum_split, assumption)
                apply (erule disjE) 
                  apply (drule AL_sum_split, assumption)
                  apply (erule disjE) 
                    apply (drule AL_upd_split)
                    apply (erule disjE, clarsimp) apply (rule AL_update1)
                    apply clarsimp
                    apply (rule AL_update4)
                      apply (rule AL_update4)
                        apply (rule AL_update4, assumption)
                        apply (drule_tac d=a and H="emp[\<omega>\<mapsto>(classTP NIL)]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp)
                    apply (drule_tac d=a and H="emp[\<omega>\<mapsto>(classTP NIL)]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp)
                  apply assumption
                apply (rule AL_update4)
                  apply (drule AL_upd_split)
                  apply (erule disjE, clarsimp) apply (rule AL_update1)
                  apply (simp add: AL_emp1)
                apply (drule_tac d=a and H="emp[\<theta>\<mapsto>(classTP NIL)]" in AL_domI)
                  apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply (rule AL_update4) 
                apply (rule AL_update4) 
                  apply (drule AL_upd_split)
                  apply (erule disjE, clarsimp) apply (rule AL_update1)
                  apply (simp add: AL_emp1)
                apply (drule_tac d=a and H="emp[\<theta>'\<mapsto>(classTP NIL)]" in AL_domI)
                  apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply (drule_tac d=a and H="emp[\<theta>'\<mapsto>(classTP NIL)]" in AL_domI)
                apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
    apply (simp add: RSD_sum_def) apply (simp add: AL_sum_emp2 AL_dom_emp) 
(*Case last non-empty*)
apply clarsimp
  apply (case_tac "ListN ba zs", clarsimp, clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP b list", clarsimp, clarsimp) 
  apply (case_tac "ListN b list", clarsimp, clarsimp)
  apply (case_tac "ListN bb zsa", clarsimp, clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<delta> \<alpha> A \<beta> B \<beta>' B' M K H N M' K')
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (subgoal_tac "AL_dom N[\<omega>\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<theta>\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="N[\<omega>\<mapsto>(classTP CONS)]" and M="M[\<theta>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM, erule conjE) 
  apply (subgoal_tac "AL_dom N[\<omega>\<mapsto>(classTP CONS)] \<inter> AL_dom M'[\<theta>'\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_sum_def AL_dom_upd1) apply clarsimp apply (rule_tac Y="AL_dom N \<union> AL_dom M" in SetTriv103) apply fast apply assumption
  apply (frule_tac N="N[\<omega>\<mapsto>(classTP CONS)]" and M="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM', erule conjE) 
  apply (subgoal_tac "AL_dom MM' \<inter> AL_dom M[\<theta>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1 AL_sum_def) apply (rule, clarsimp) apply (rule, clarsimp) apply clarsimp 
            apply (subgoal_tac "\<forall> A  B C . A \<inter> C = {} \<longrightarrow> B \<inter> C = {} \<longrightarrow> (A \<union> B) \<inter> C = {}")
              apply (erule_tac x="AL_dom N" in allE, erule_tac x="AL_dom M'" in allE, erule_tac x="AL_dom M" in allE)
                apply (erule impE, assumption) apply (erule mp) apply (rule SetTriv108) 
                apply (rule_tac Y="AL_dom N \<union> AL_dom M" in SetTriv103) apply fast apply assumption 
            apply (erule thin_rl)+ apply fast
  apply (rule_tac U="W ConsCopy" and L="{Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0)))))))}" in UniInjectL)
    prefer 2 apply (erule W_ConsCopy_verified) apply simp apply simp apply assumption+ 
    prefer 2 apply fastsimp
(*    prefer 2 apply simp *)
    apply (rule_tac c=\<theta> and HH=HH in UniInvV3)
      apply (rule InstrCONS7)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply simp 
      apply simp 
      prefer 2 apply (rule, rule) apply (erule_tac x=E in allE, erule impE, assumption, clarsimp)
        apply (rule_tac x="fst(snd ConsCopy)" in exI, rule_tac x="snd(snd ConsCopy)" in exI)
        apply (rule, simp add: ConsCopy_def)
        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])])"
                     and H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)]" 
                     and NNN="N[\<omega>\<mapsto>(classTP CONS)]" 
                     and HH=KK and NN=MM in UniBSFrame)
          apply (rule UniAx) apply (simp add: W_def)
            apply (rule disjI2) 
            apply (rule_tac x="Suc (length A)" in exI, simp add: Sp_def ConsCopy_def)
              apply (rule_tac x=\<omega> in exI, rule_tac x="(\<delta>,\<alpha>)#A" in exI, simp add: preS_def)
              apply (rule_tac x="(\<delta>,\<beta>)#B" in exI, simp add: starOpt_def star_def)
          apply (simp add: SD_sum_def)
            apply (rule, simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
              apply (rule, clarsimp)
                apply (rule AL_update4, assumption)
                apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (rule AL_update1)
                apply (simp add: AL_emp1)
            apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (simp add: SD_sum_def)
            apply (rule, simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp)
                apply (drule AL_sum_split, assumption)
                apply (erule disjE)
                  apply (erule AL_sum3, rule AL_update4, assumption)
                  apply (drule_tac d=a and H="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" in AL_domI) apply fast
                apply (erule AL_sum4, assumption)
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
                apply (simp add: AL_emp1)
            apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
          apply (simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
              apply (rule, clarsimp) apply (rule AL_update4, assumption)
                apply (drule_tac d=a in AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (rule AL_update1)
                apply (simp add: AL_emp1)
          apply (subgoal_tac "AL_sum MM emp[\<gamma>\<mapsto>(classTP CONS)] NN", assumption)
            apply (simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp) 
                apply (drule AL_sum_split, assumption)
                apply (erule disjE)
                  apply (erule AL_sum3, rule AL_update4, assumption)
                apply (drule_tac d=a and H="N[\<omega>\<mapsto>(classTP CONS)]" in AL_domI) 
                  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                  apply (erule AL_sum4, assumption)
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1)
                apply (simp add: AL_emp1)
            apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
    apply assumption
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac U="W ConsOpt" and L="{Suc(Suc (Suc (Suc (Suc (Suc 0)))))}" in UniInjectR)
    prefer 2 apply (erule W_ConsOpt_verified) apply simp apply simp apply assumption+ 
    prefer 2 apply fastsimp
(*    prefer 2 apply simp *)
    apply (rule_tac c=\<theta>' and HH=HH' in UniInvV3)
      apply (rule InstrOPT5)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply simp 
      apply simp 
      prefer 2 apply (rule, rule) apply (erule_tac x=E in allE, erule impE, assumption, clarsimp)
        apply (rule_tac x="fst(snd ConsOpt)" in exI, rule_tac x="snd(snd ConsOpt)" in exI)
        apply (rule, simp add: ConsOpt_def)
        apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<omega>], H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])])"
                     and H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and N="M[\<theta>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>(classTP CONS)]"
                     and NNN="N[\<omega>\<mapsto>(classTP CONS)]"
                     and HH=KK' and NN=MM' in UniBSFrame)
          apply (rule UniAx) apply (simp add: W_def)
            apply (rule disjI2) 
            apply (rule_tac x="Suc (length A)" in exI, rule) apply simp apply(simp add: Sp_def ConsOpt_def)
              apply (rule_tac x=\<omega> in exI, rule_tac x="(\<delta>,\<alpha>)#A" in exI, simp add: preS_def)
              apply (rule_tac x="(\<delta>,\<beta>')#B'" in exI, simp add: starOpt_def star_def)
          apply (simp add: SD_sum_def)
            apply (rule, simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
              apply (rule, clarsimp)
                apply (rule AL_update4, assumption)
                apply (drule_tac d=a in AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (rule AL_update1)
                apply (simp add: AL_emp1)
            apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (simp add: SD_sum_def)
            apply (rule, simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp)
                apply (drule AL_sum_split, assumption)
                apply (erule disjE)
                  apply (erule AL_sum3, rule AL_update4, assumption)
                  apply (drule_tac d=a and H="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" in AL_domI) apply fast
                apply (erule AL_sum4, assumption)
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
                apply (simp add: AL_emp1)
            apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp) 
                apply (erule AL_sum3) apply (rule AL_update4, assumption)
                apply (drule_tac d=a in AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
                apply (erule AL_sum4) apply simp
          apply (subgoal_tac "AL_sum MM' M[\<theta>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>(classTP CONS)] NNN'", assumption)
            apply (simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
              apply (rule, clarsimp)
                apply (drule AL_sum_split, assumption)
                apply (erule disjE)
                  apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update4, assumption)
                    apply (drule_tac d=a and H="N[\<omega>\<mapsto>(classTP CONS)]" in AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                apply (erule AL_sum4, assumption)
              apply clarsimp
                apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update1)
                apply (erule AL_sum3) apply (erule AL_sum4) apply simp
          apply assumption
      apply assumption
  apply clarsimp apply (erule TypingInj)
done
(*>*)

text{*Next, the proof where the invocations are correlated.*}

lemma G2_verified_Correlated:
  "\<lbrakk> TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];
     \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
     mbody_is LIST Copy ListCopy; mbody_is NIL Copy NilCopy; mbody_is CONS Copy ConsCopy;
     mbody_is LIST OptCopy ListCopy; mbody_is NIL OptCopy NilCopy; mbody_is CONS OptCopy ConsOpt\<rbrakk> 
    \<Longrightarrow> CtxtVerified G2"
(*<*)
apply (simp add: G2_def CtxtVerified_def, clarsimp)
apply (rule, clarsimp) apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (simp add: RelSp2_def) 
  apply (rule, simp add: preserved_def starOptDEF, clarsimp)
    apply (rule, simp add: AL_sum_def, clarsimp) apply (erule contained_transitive, assumption)
    apply (simp add: preS_def AL_sum_def, clarsimp) apply (rule, fast) apply fast
  apply clarsimp
  apply (subgoal_tac "(G2,((a, aa, b), emp[\<gamma>\<mapsto>(classTP NIL)], a, aa, b), NilCopy, 0, NilCopy, 0, False, ([\<upsilon>], emp, H), ak, [\<upsilon>'], emp, K)
          \<in> Typing", simp add: G2_def RelSp2_def)
  apply (simp add: preS_def, clarsimp)
  apply (rename_tac N)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  apply (rule_tac cl=\<upsilon>' and D=NIL and C=NIL in UniNew)
    apply (rule InstrNIL0)
    prefer 8 apply fastsimp
    apply fastsimp
    apply (simp add: starOptDEF AL_dom_upd1 AL_dom_emp AL_sum_def) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    apply (rule UniCtxtVerified_emp)
    (* apply fast *)
    apply clarsimp
    apply (rule TypingInj)
    apply (rule_tac H=emp and K=emp and N=emp in TypingFrame)
    apply (rule TypingRetRet)
      apply (rule InstrNIL1)
      apply (rule InstrNIL1)
      apply simp
      apply simp
      apply (simp add: RSD_sum_def) apply (rule, simp) apply (rule, simp) apply (rule, simp)
        apply (rule, simp) apply (rule, simp) apply (rule, simp) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP) 
        apply (rule, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD) apply (rule AL_EMP)  
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
      apply (simp add: RSD_sum_def starOptDEF, clarsimp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_sum_def AL_dom_emp AL_dom_upd1) 
          apply (rule, simp (no_asm) add: contained_def, clarsimp) 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, rule AL_update1) 
            apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule contained3, erule contained3, rule AL_update1) 
            apply (simp add: AL_emp1)
          apply (rule contained_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (rule, simp add: AL_dom_emp)
        apply (simp add: AL_dom_emp)
(*n>0*)
apply (rule, clarsimp)
  apply (rotate_tac -3, erule thin_rl, erule thin_rl)
  apply (rule, simp add: preserved_def RelSp2_def preS_def starOptDEF, clarsimp)
    apply (simp add: AL_sum_def, clarsimp)  
      apply (rule, erule contained_transitive, assumption) 
      apply fast
  apply (subgoal_tac "(G2,((ad, ae, bb), af, ag, ah, bc),
           ConsCopy, 0, ConsOpt, 0, False, (ai, aj, bd), ak, al, am, be)
          \<in> Typing", simp add: G2_def)
  apply (simp add: RelSp2_def preS_def, clarsimp)
  apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp)
  apply (simp add: starOptDEF, clarsimp)
  apply (rename_tac NMM' \<gamma> \<Lambda> \<upsilon> \<Upsilon> \<upsilon>' \<Upsilon>' HK HK' H N NM K K' M M')
  apply (case_tac \<Lambda>, clarsimp,clarsimp) 
  apply (case_tac "ListN b list", clarsimp,clarsimp) 
  apply (case_tac "ListHP b list", clarsimp,clarsimp) 
  apply (case_tac "ListN ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp,clarsimp) 
  apply (case_tac "ListN bb zsa", clarsimp,clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp,clarsimp) 
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<epsilon> \<omega> \<Omega> \<theta> \<Theta> \<theta>' \<Theta>' N H M K M' K')
  apply (rule UniInjectL)
    apply (rule UniLoad)
      apply (rule InstrCONS0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
    apply (rule UniLoad)
      apply (rule InstrOPT0)
      prefer 7 apply fastsimp
      apply fastsimp
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS1)
      apply fastsimp   
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT1)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update4) apply (rule AL_update1) apply assumption
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT2)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT3)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply fastsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrCONS4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniGet)
      apply (rule InstrOPT4)
      apply fastsimp    
      apply (rule AL_update1)
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS5)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS6)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
apply (subgoal_tac "AL_dom (H[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) \<inter> AL_dom K' = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=K' in AL_sum_exists_AL) apply (erule exE, rename_tac HH', erule conjE)
apply (subgoal_tac "AL_dom N[\<gamma>\<mapsto>(classTP CONS)] \<inter> AL_dom M = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=M in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom M' = {}")
prefer 2 apply (simp add: AL_sum_def AL_dom_upd1)
apply (frule_tac M=M' in AL_sum_exists_AL) apply (erule exE, rename_tac NNN', erule conjE)
apply (subgoal_tac "(G2, (([\<theta>], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>][t\<mapsto>\<omega>], HH), NNN', [\<theta>'], emp[this\<mapsto>\<gamma>][h\<mapsto>\<epsilon>],HH'),
           ConsCopy, Suc(Suc (Suc (Suc (Suc (Suc (Suc (Suc 0))))))), ConsOpt, Suc(Suc (Suc (Suc (Suc (Suc 0))))), False, ([\<upsilon>], emp, HK), NMM', [\<upsilon>'], emp,
           HK')
          \<in> Typing")
prefer 2
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrOPT6)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  apply (rule_tac cl=\<upsilon> and C=CONS and D=CONS in UniNew)
      apply (rule InstrCONS9)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniStore)
      apply (rule InstrCONS10)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS11)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS12)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply clarsimp apply clarsimp apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS14)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS15)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrCONS16)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectL)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrCONS17)
      apply fastsimp    
      apply (rule AL_update1) 
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  apply (rule_tac cl=\<upsilon>' and C=CONS and D=CONS in UniNew)
      apply (rule InstrOPT7)
      prefer 8 apply fastsimp    
      apply fastsimp
      apply (simp add: AL_sum_def AL_dom_upd1) 
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT8)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT9)
      apply fastsimp    
      apply (rule AL_update4, rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT10)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniDup)
      apply (rule InstrOPT11)
      apply fastsimp    
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniLoad)
      apply (rule InstrOPT12)
      apply fastsimp    
      apply (rule AL_update1) apply clarsimp
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule UniInjectR)
  prefer 3 apply fastsimp
  apply (rule UniPut)
      apply (rule InstrOPT13)
      apply fastsimp    
      apply (rule AL_update1)
      apply simp
      apply simp
      apply simp
      apply (rule UniCtxtVerified_emp)
      (* apply fast *)
  apply clarsimp
  apply (rule TypingInj)
  apply (rule_tac H=emp and N=emp and K=emp in TypingFrame)
  apply (rule TypingRetRet)
      apply (rule InstrCONS18)
      apply (rule InstrOPT14)
      apply simp 
      apply simp
      apply (simp add: RSD_sum_def)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, simp)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_UPD, erule AL_UPD)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (rule, rule AL_sum_emp2)
        apply (simp add: AL_dom_emp AL_dom_upd1) 
      apply (simp add: RSD_sum_def)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
          apply (simp add: contained_def, rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp 
            apply clarsimp
            apply (frule AL_sum_split, assumption)
            apply (erule disjE) apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (rule AL_update4, assumption) apply (drule AL_domI, simp add: AL_dom_upd1 AL_sum_def)
          apply (rule, simp add: AL_emp1)
          apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
          apply (rule, clarsimp, drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_upd_split)
            apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (erule AL_sum4) apply (rule AL_update1)
            apply clarsimp
            apply (drule AL_sum_split, assumption)
            apply (erule disjE) 
              apply (drule AL_sum_split, assumption)
              apply (erule disjE) apply (erule AL_sum3) apply (erule AL_sum3) apply assumption
              apply (erule AL_sum3) apply (erule AL_sum4) apply (erule AL_update4) apply assumption
            apply (erule AL_sum4) apply (erule AL_update4, assumption) 
          apply (simp add: AL_emp1)
apply (case_tac \<Omega>, clarsimp)
(*case \<Omega>=[]*)
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrOPT5)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=NIL", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=NIL", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: NilCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add:NilCopy_def) 
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<theta>\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>\<mapsto>(NIL, emp)]" and N="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK, erule conjE)
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(NIL, emp)] \<inter> AL_dom emp[\<theta>'\<mapsto>(NIL, emp)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>'\<mapsto>(NIL, emp)]" and N="emp[\<omega>\<mapsto>(NIL, emp)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac HHKK', erule conjE)
        apply (subgoal_tac "AL_dom emp[\<omega>\<mapsto>(classTP NIL)] \<inter> AL_dom emp[\<theta>\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (frule_tac M="emp[\<theta>\<mapsto>(classTP NIL)]" and N="emp[\<omega>\<mapsto>(classTP NIL)]" in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM, erule conjE)
        apply (subgoal_tac "AL_dom NNMM \<inter> AL_dom emp[\<theta>'\<mapsto>(classTP NIL)] = {}")
        prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def)
        apply (frule_tac M="emp[\<theta>'\<mapsto>(classTP NIL)]" and N=NNMM in AL_sum_exists_AL)
        apply (erule exE) apply (rename_tac NNMM', erule conjE)
        apply (rule_tac \<gamma>="(([],emp[this\<mapsto>\<omega>],emp[\<omega>\<mapsto>(NIL, emp)]),emp[\<omega>\<mapsto>(classTP NIL)],([],emp[this\<mapsto>\<omega>],emp[\<omega>\<mapsto>(NIL, emp)]))"
                     and H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)]" 
                     and K="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (simp add: AL_dom_upd1 AL_dom_emp contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update4) apply (rule AL_update1) apply assumption
                     apply (simp add: AL_emp1)
                   apply clarsimp 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp add: G2_def) apply (rule disjI1)
                              apply (simp add: RelSp2_def)
                              apply (rule, simp add: NilCopy_def)
                              apply (rule_tac x=\<omega> in exI, rule_tac x="[]" in exI)
                              apply (simp add: preS_def)
                              apply (rule_tac x=\<theta> in exI, rule_tac x="[]" in exI) apply (simp add: star_def starOpt_def)
                              apply (rule_tac x=\<theta>' in exI, rule_tac x="[]" in exI)
                              apply (rule, rule, assumption)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply (rule, rule, rule_tac x="emp[\<theta>'\<mapsto>(NIL,emp)]" in exI) apply (rule, simp)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply simp
                         apply (rule, rule, rule, assumption)
                         apply (rule, assumption) 
                         apply (rule, rule_tac x="emp[\<theta>'\<mapsto>(classTP NIL)]" in exI) apply (rule, simp)
                              apply (rule, assumption)
                              apply (rule, assumption)
                              apply assumption
                         apply simp
        apply (simp add: RSD_sum_def)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (frule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                         apply (simp add: AL_dom_upd1)
                       apply (simp add: AL_emp1)
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (rule, simp (no_asm) add: AL_sum_def)
                   apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                   apply (simp add: contained_def)
                   apply (rule, clarsimp) 
                     apply (drule AL_sum_split, assumption) 
                     apply (erule disjE) 
                       apply (frule AL_sum_split, assumption)
                       apply (erule disjE) 
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (erule AL_sum3, rule AL_update4) apply (rule AL_update1) 
                           apply (simp add: AL_dom_upd1)
                         apply (simp add: AL_emp1)
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (erule AL_sum3) apply(erule AL_sum4, rule AL_update1) 
                       apply (simp add: AL_emp1)
                     apply (erule AL_sum4)apply assumption
                   apply clarsimp
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply(erule AL_sum3, rule AL_update1) 
                     apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply (rule, clarsimp) apply (rule, clarsimp) apply (rule, clarsimp) apply clarsimp 
(*Case last non-empty*)
apply clarsimp
  apply (case_tac "ListN ba zs", clarsimp, clarsimp) 
  apply (case_tac "ListHP ba zs", clarsimp, clarsimp)
  apply (case_tac "ListHP b list", clarsimp, clarsimp) 
  apply (case_tac "ListN b list", clarsimp, clarsimp)
  apply (case_tac "ListN bb zsa", clarsimp, clarsimp) 
  apply (case_tac "ListHP bb zsa", clarsimp, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (drule if_split, clarsimp)
  apply (rename_tac \<delta> \<alpha> A \<beta> B \<beta>' B' M K H N M' K')
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K[\<theta>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK, erule conjE)
  apply (subgoal_tac "AL_dom H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])] \<inter> AL_dom K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="H[\<omega>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])]" and M="K'[\<theta>'\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<beta>'])]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac KK', erule conjE)
  apply (subgoal_tac "AL_dom N[\<omega>\<mapsto>(classTP CONS)] \<inter> AL_dom M[\<theta>\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1)
  apply (frule_tac N="N[\<omega>\<mapsto>(classTP CONS)]" and M="M[\<theta>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MM, erule conjE) 
  apply (subgoal_tac "AL_dom MM \<inter> AL_dom M'[\<theta>'\<mapsto>(classTP CONS)] = {}")
  prefer 2 apply (simp add: AL_dom_upd1 AL_sum_def)
  apply (frule_tac N=MM and M="M'[\<theta>'\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
          apply (erule exE, rename_tac MMM', erule conjE) 
  apply (rule TypingInvVInvV3)
    apply (rule InstrCONS7)
    apply (simp add: ListCopy_def) 
    apply (rule InstrOPT5)
    apply (simp add: ListCopy_def) 
    apply fastsimp    
    apply (rule absFrameNil) apply fastsimp
    apply (rule absFrameNil) apply fastsimp
    apply clarsimp apply (erule TypingInj)
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4) apply (rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply clarsimp
        apply (subgoal_tac "D1'=CONS", clarsimp) prefer 2 apply (erule_tac x=D1' in allE, erule mp, assumption)
        apply (subgoal_tac "D2'=CONS", clarsimp) prefer 2 apply (erule_tac x=D2' in allE, erule mp, assumption)
        apply (rule_tac x="fst(snd ConsCopy)" in exI)
        apply (rule_tac x="fst(snd ConsOpt)" in exI)
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsCopy_def) 
        apply (rule_tac x=0 in exI)
        apply (rule, simp add: ConsOpt_def)
        apply (rule_tac H="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]"
                     and K="emp[\<gamma>\<mapsto>(CONS, upd(upd emp HD \<epsilon>) TL \<omega>)]" 
                     and N="emp[\<gamma>\<mapsto>(classTP CONS)]"
                     and \<gamma>="(([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])),
                              N[\<omega>\<mapsto>(classTP CONS)],
                             ([],emp[this\<mapsto>\<omega>],upd H \<omega> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<alpha>])))"in TypingFrame)
        prefer 2 apply (simp add: RSD_sum_def)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListHP_AL)
          apply (rule, rule AL_UPD, rule AL_UPD) apply (erule ListN_AL)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (rule AL_update4, assumption)
              apply (drule_tac d=a in AL_domI, simp add: AL_dom_upd1) apply clarsimp
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule TypingAx) apply (simp (no_asm_simp) add: G2_def)
          apply (rule disjI2)
          apply (rule_tac x="Suc(length A)" in exI, simp add: ConsCopy_def ConsOpt_def  RelSp2_def preS_def)
          apply (rule_tac x=\<omega> in exI, rule_tac x="(\<delta>,\<alpha>)#A" in exI, clarsimp)
          apply (rule_tac x=\<theta> in exI, rule_tac x="(\<delta>,\<beta>)#B" in exI, clarsimp)
          apply (rule_tac x=\<theta>' in exI, rule_tac x="(\<delta>,\<beta>')#B'" in exI, clarsimp)
            apply (simp add: starOpt_def star_def)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, rule, rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply (rule, assumption)
            apply simp
        apply (simp add: RSD_sum_def)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (frule AL_sum_split, assumption)
              apply (erule disjE)
                apply (erule AL_sum3) apply (erule AL_update4) apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply rule apply (simp (no_asm) add: AL_sum_def)
            apply rule apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
            apply (simp add: contained_def)
            apply (rule, clarsimp)
              apply (drule AL_sum_split, assumption)
              apply (erule disjE)
                apply (frule AL_sum_split, assumption)
                apply (erule disjE) apply (erule AL_sum3) apply (erule AL_sum3) apply (erule AL_update4) 
                  apply (drule_tac H=MM in AL_domI, simp add: AL_sum_def AL_dom_upd1) apply clarsimp 
                apply (erule AL_sum3) apply (erule AL_sum4) apply assumption
              apply (erule AL_sum4) apply assumption
            apply clarsimp
              apply (drule AL_upd_split)
              apply (erule disjE) apply clarsimp apply (erule AL_sum3) apply (erule AL_sum3) apply (rule AL_update1)
              apply (simp add: AL_emp1)
          apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp apply (rule, clarsimp) apply (rule, clarsimp)
            apply (rule, clarsimp) apply clarsimp
done
(*>*)

text{*Thus, $G_2$ is in particular verified for the program $OPT$.*}

lemma G2_verified_OPT:
  "\<lbrakk> TL \<noteq> HD; P=OPT; distinct [h, t, z, this]; distinct [NIL,CONS,LIST];OptCopy \<noteq> Copy;
     \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS\<rbrakk> 
    \<Longrightarrow> CtxtVerified G2"
(*<*)
apply (erule G2_verified_Correlated, assumption+)
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>LIST = Some OptListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: OptListClass_def) apply (rule AL_update4) apply (rule AL_update1) apply assumption
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptNilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>NIL = Some OptNilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: OptNilClass_def) apply (rule AL_update4, rule AL_update1) apply assumption
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>CONS = Some OptConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: OptConsClass_def) apply (rule AL_update4, rule AL_update1) apply assumption
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>LIST = Some OptListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: OptListClass_def) apply (rule AL_update1) 
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptNilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>NIL = Some OptNilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: OptNilClass_def) apply (rule AL_update1) 
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>CONS = Some OptConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: OptConsClass_def) apply (rule AL_update1) 
done
(*>*)

(*<*)
end
(*>*)