(*<*)
theory ListSL_UnaryVerif = ListSLRep:
(*>*)

subsubsection{*Unary verification from Section 5.2*}
(*<*)
lemma UniBS_ContextSame:"\<lbrakk>(CtxtU, \<Sigma>, N, M, l, b, H, c, NN) \<in> UniBS; CtxtU = CtxtW \<rbrakk> \<Longrightarrow> (CtxtW, \<Sigma>, N, M, l, b, H, c, NN) \<in> UniBS"
apply simp
done
(*>*)

lemma U_CrossCopy_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST CrossCopy ListCopy; mbody_is NIL CrossCopy NilCopy; mbody_is CONS CrossCopy Cross\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (U Cross)"
(*<*)
apply (simp add: UniCtxtVerified_def U_def, clarsimp)
apply rule
(*n=0*)
apply clarsimp
apply rule apply (simp add: preS_def starOptDEF) apply (erule conjE)+
  apply (erule AL_sum3b)
apply rule apply (simp add: starOptDEF AL_sum_def)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=NIL in UniNew)
    apply (rule InstrNIL0) 
      apply fastsimp
      apply (simp add: starOptDEF) apply (simp add: AL_dom_upd1 AL_emp1 AL_dom_emp)  
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
(*      apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrNIL1)
    prefer 3 apply (rule SD_sum_emp1)
    apply fastsimp 
    apply simp 
      apply (simp add: SD_sum_def preS_def starOptDEF) apply clarsimp 
      apply (simp add: AL_sum_def)
      apply rule apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def) 
      apply (rule, clarsimp) 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (rule, clarsimp) apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd AL_dom_emp)
    apply (rule AL_sum_emp2)
    apply (simp add: starOptDEF AL_sum_def)
      apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def)
      apply (rule, clarsimp)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (simp add: AL_emp1)
    apply (simp add: AL_dom_emp)
(*n>0*)
apply clarsimp
apply (case_tac n, clarsimp,clarsimp)
apply rule apply (simp add: preS_def starOptDEF  AL_sum_def) apply clarsimp
apply rule apply (simp add: starOptDEF AL_sum_def) apply clarsimp
apply (simp add: preS_def) apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp) 
apply (case_tac nat, clarsimp)
(*n=1: extra case*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rename_tac \<delta> \<epsilon> \<omega>)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrCROSS0)
    apply fastsimp
    apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrCROSS1)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrCROSS2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCROSS3)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCROSS4)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_update4, rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCROSS5)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCROSS6)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp 
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCROSS7)
    apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule_tac N'=N' in UniRun)
(*    apply (rule_tac HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CROSS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])]" 
                and NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CROSS)]" in UniInvV3)*)
    apply (rule_tac HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])][c\<mapsto>(CONS, emp[HD\<mapsto>\<delta>])]" in UniInvV3)
    apply (rule InstrCROSS8)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1) 
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply assumption
    apply clarsimp
    apply (erule_tac x=E in allE, clarsimp)
    apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI, rule_tac x=0 in exI)
    apply rule apply (simp add:NilCopy_def)
      apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<epsilon>], emp[\<epsilon>\<mapsto>(NIL, emp)])" and
                      H="upd(upd emp \<gamma> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])) c (CONS, emp[HD\<mapsto>\<delta>])" and
                      NNN="emp[\<epsilon>\<mapsto>(classTP NIL)]" and 
                      c=\<omega>  and
                      HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)]" and
                      NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)]" and
                      N="upd(upd emp \<gamma> (classTP CONS)) c (classTP CONS)" in UniBSFrame)
        apply (rule UniAx) apply clarsimp 
          apply (rule, simp add: NilCopy_def)
          apply (rule_tac x=\<epsilon> in exI, simp) 
          apply (rule, simp (no_asm) add: AL_sum_def contained_def) 
            apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp) apply (rule AL_update4) apply assumption 
              apply (drule AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp)
            apply clarsimp apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (rule, rule AL_UPD, rule AL_UPD,rule AL_EMP)
            apply (rule, simp (no_asm) add: AL_sum_def contained_def)
              apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
              apply(rule, clarsimp) apply (rule AL_update4, assumption) 
                apply (drule AL_domI, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
              apply clarsimp apply (drule AL_upd_split)
                apply (erule disjE, clarsimp) apply (rule AL_update1)
                apply (simp add: AL_emp1)
             apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
             apply (rule AL_UPD,rule AL_UPD, rule AL_EMP)
      apply (simp add: SD_sum_def) 
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (rule AL_update4, rule AL_update4, rule AL_update4,assumption)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply clarsimp
                     apply (rule AL_update4)
                       apply (rule AL_update4)
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update1) 
                         apply (simp add: AL_emp1)
                       apply assumption
                     apply assumption
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp add: SD_sum_def) 
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (rule AL_update4, rule AL_update4, assumption)
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply clarsimp
                   apply (rule AL_update4, drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                 apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
               apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (rule AL_update4, rule AL_update4, assumption)
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply clarsimp
                   apply (rule AL_update4, drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
               apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update4) apply (rule AL_update1)
                     apply (simp add: AL_dom_upd1 AL_dom_emp)
                   apply clarsimp
                   apply (erule AL_sum3)
                   apply (rule AL_update4, drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
               apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (erule AL_sum4) apply (rule AL_update1) 
                   apply clarsimp
                   apply (erule AL_sum3)
                   apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)  apply clarsimp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCROSS9)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrCROSS10) apply simp apply simp 
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast 
        apply (simp add: contained_def) 
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) 
            apply (erule AL_sum3) apply (rule AL_update1)
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
      apply (rule AL_sum_emp2)
      apply (rule AL_sum_emp2)
      apply (simp (no_asm) add: AL_dom_emp)
(*n>1*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (case_tac "ListN ba list", clarsimp) apply clarsimp
apply (case_tac "ListHP ba list", clarsimp) apply clarsimp
apply (case_tac "ListN bb zs", clarsimp) apply clarsimp
apply (case_tac "ListHP bb zs", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (case_tac zs, clarsimp, clarsimp)
apply (case_tac "ListN bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListHP bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListN bc lista", clarsimp) apply clarsimp
apply (case_tac "ListHP bc lista", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rule_tac CtxtU="U Cross" in UniBS_ContextSame) prefer 2 apply (simp add: U_def preS_def starOpt_def star_def)  
apply (rename_tac This ThisH ThisT \<nu> \<epsilon> \<omega> \<Omega> \<delta> \<Lambda> M K N H)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrCROSS0)
    apply fastsimp
    apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrCROSS1)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrCROSS2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCROSS3)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCROSS4)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_update4, rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCROSS5)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCROSS6)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp 
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCROSS7)
    apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (subgoal_tac "AL_dom (K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])][This\<mapsto>(CONS, emp[HD\<mapsto>ThisH][TL\<mapsto>ThisT])]) \<inter> 
                    AL_dom (H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) = {}")
prefer 2 apply (rule SetTriv108) apply (rule_tac Y="AL_dom (H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])][c\<mapsto>(CONS, emp[HD\<mapsto>ThisH][TL\<mapsto>\<nu>])])" in SetTriv103) 
            apply (simp add: AL_dom_upd1) apply fast
         apply (erule SetTriv108)
apply (frule_tac M="H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in AL_sum_exists_AL,erule exE, rename_tac HH, erule conjE)
apply (rule_tac N'=N' in UniRun)
(*    apply (rule_tac HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CROSS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])]" 
                and NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CROSS)]" in UniInvV3)*)
    apply (rule_tac c=\<nu> and HH="HH[c\<mapsto>(CONS, emp[HD\<mapsto>ThisH])]" in UniInvV3)
    apply (rule InstrCROSS8)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4, rule AL_update4, rule AL_update4)
        apply (rule AL_update1) 
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply assumption
prefer 2
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCROSS9)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrCROSS10) apply simp apply simp 
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add: contained_def) 
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_sum_split, assumption)
          apply (erule disjE) 
            apply (erule AL_sum3) apply assumption 
          apply (erule AL_sum4)
            apply (rule AL_update4) apply assumption apply assumption
        apply (rule contained_emp)
        apply (rule AL_sum_emp2)
        apply (rule AL_sum_emp2)
        apply (simp add: AL_dom_emp)
apply clarsimp
    apply (erule_tac x=E in allE, clarsimp)
    apply (rule_tac x="fst(snd Cross)" in exI, rule_tac x="snd(snd Cross)" in exI)
    apply rule apply (simp add:Cross_def)
    apply (subgoal_tac "(AL_dom  K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]) \<inter> (AL_dom H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)  
    apply (frule_tac N="K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]" and M="H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in AL_sum_exists_AL) 
      apply (erule exE, rename_tac KH,erule conjE)
    apply (subgoal_tac "(AL_dom  M[ThisT\<mapsto>(classTP CONS)]) \<inter> (AL_dom N[\<nu>\<mapsto>(classTP CONS)]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)  
    apply (frule_tac N="M[ThisT\<mapsto>(classTP CONS)]" and M="N[\<nu>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
      apply (erule exE, rename_tac NM,erule conjE)
    apply (rule_tac \<Sigma>="([],emp[this\<mapsto>ThisT],K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])])" and
                    H="emp[This\<mapsto>(CONS, emp[HD\<mapsto>ThisH][TL\<mapsto>ThisT])][c\<mapsto>(CONS, emp[HD\<mapsto>ThisH])]" and 
                    NNN="M[ThisT\<mapsto>(classTP CONS)]" and N="emp[This\<mapsto>(classTP CONS)][c\<mapsto>(classTP CONS)]" and
                    HH=KH and NN=NM in UniBSFrame)
    apply (rule UniAx) apply (simp add: U_def) apply (rule disjI2) 
         apply (rule_tac x="Suc(length \<Lambda>)" in exI) apply (rule, simp) apply (rule, simp add: Cross_def) apply (rule, simp add: Cross_def) 
         apply simp apply (rule_tac x=ThisT in exI) apply (rule_tac x="(\<epsilon>,\<delta>) # \<Lambda>" in exI)
          apply (rule, simp add: preS_def) 
          apply (rule,simp) 
          apply (rule_tac x="(\<epsilon>,\<omega>) # \<Omega>" in exI)
          apply (rule,simp add: starOpt_def star_def)
          apply (rule,simp add: starOpt_def star_def)
          apply simp
        prefer 2 apply (simp add: SD_sum_def)
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply fast
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (rule AL_update4) 
                     apply (drule AL_sum_split, assumption) 
                     apply (erule disjE) apply (erule AL_sum3) apply (rule AL_update4) apply assumption
                       apply (drule_tac H="K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) 
                          apply clarsimp
                     apply (erule AL_sum4) apply assumption
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp) apply (rule AL_update1) apply clarsimp
                   apply (rule AL_update4) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1) apply (simp add: AL_emp1)
                   apply assumption 
               apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
        apply (simp add: SD_sum_def)
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                 apply (simp add: contained_def)
                 apply (rule, clarsimp) apply (rule AL_update4) apply (rule AL_update4) apply (rule AL_update4) apply assumption
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE) apply clarsimp apply (rule AL_update1) apply clarsimp
                   apply (rule AL_update4) apply (rule AL_update4)
                     apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                   apply assumption apply assumption
                 apply (simp add:AL_sum_def AL_dom_upd1 AL_dom_emp)
               apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                 apply (simp add: contained_def)
                 apply (rule, clarsimp) apply (rule AL_update4) apply (rule AL_update4) apply assumption
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE) apply clarsimp apply (rule AL_update1) apply clarsimp
                   apply (rule AL_update4) 
                     apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                   apply assumption 
        apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_sum_split,assumption)
                   apply (erule disjE)
                     apply (erule AL_sum3)
                     apply (rule AL_update4)
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (rule AL_update1) apply clarsimp
                       apply (rule AL_update4) apply assumption apply assumption
                     apply (drule_tac H="M[ThisT\<mapsto>(classTP CONS)]" in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                 apply (erule AL_sum4)
                   apply (rule AL_update4) apply assumption
                     apply (drule_tac H="N[\<nu>\<mapsto>(classTP CONS)]" in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
               apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                   apply (erule AL_sum3) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
           apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
done
(*>*)

lemma W_CrossCopy_verified:
        "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL, CONS, LIST]; subclass_of NIL LIST; \<forall>D. subclass_of D NIL \<longrightarrow> D = NIL;
         \<forall>D. subclass_of D CONS \<longrightarrow> D = CONS; mbody_is LIST CrossCopy ListCopy; mbody_is NIL CrossCopy NilCopy;
         mbody_is CONS CrossCopy Cross\<rbrakk>
        \<Longrightarrow> UniCtxtVerified (W Cross)"
(*<*)
apply (subgoal_tac "UniCtxtVerified (U Cross)", simp add: UW)
apply (erule U_CrossCopy_verified, assumption+)
done
(*>*)

lemma U_ConsCopy_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST Copy ListCopy; mbody_is NIL Copy NilCopy; mbody_is CONS Copy ConsCopy\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (U ConsCopy)"
(*<*)
apply (simp add: UniCtxtVerified_def U_def, clarsimp)
apply rule
(*n=0*)
apply clarsimp
apply rule apply (simp add: preS_def starOptDEF) apply (erule conjE)+
  apply (erule AL_sum3b)
apply rule apply (simp add: starOptDEF AL_sum_def)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=NIL in UniNew)
    apply (rule InstrNIL0) 
      apply fastsimp
      apply (simp add: starOptDEF) apply (simp add: AL_dom_upd1 AL_emp1 AL_dom_emp)  
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
(*      apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrNIL1)
    prefer 3 apply (rule SD_sum_emp1)
    apply fastsimp 
    apply simp 
      apply (simp add: SD_sum_def preS_def starOptDEF) apply clarsimp 
      apply (simp add: AL_sum_def)
      apply rule apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def) 
      apply (rule, clarsimp) 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (rule, clarsimp) apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd AL_dom_emp)
    apply (rule AL_sum_emp2)
    apply (simp add: starOptDEF AL_sum_def)
      apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def)
      apply (rule, clarsimp)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (simp add: AL_emp1)
    apply (simp add: AL_dom_emp)
(*n>0*)
apply clarsimp
apply (case_tac n, clarsimp,clarsimp)
apply rule apply (simp add: preS_def starOptDEF  AL_sum_def) apply clarsimp
apply rule apply (simp add: starOptDEF AL_sum_def) apply clarsimp
apply (simp add: preS_def) apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp) 
apply (case_tac nat, clarsimp)
(*n=1: extra case*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rename_tac \<delta> \<epsilon> \<omega>)
apply (rule UniRun) 
  apply (rule UniLoad)
    apply (rule InstrCONS0)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCONS1)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS3)
    apply fastsimp
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCONS4)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS5)
    apply fastsimp
    apply simp
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS6)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
    apply (rule_tac HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])]" 
                and NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)]" in UniInvV3)
    apply (rule InstrCONS7)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4)
        apply (rule AL_update1) 
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_EMP)
    apply clarsimp
    apply (erule_tac x=E in allE, clarsimp)
    apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI, rule_tac x=0 in exI)
    apply rule apply (simp add:NilCopy_def) 
      apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<epsilon>], emp[\<epsilon>\<mapsto>(NIL, emp)])" and
                      H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])]" and
                      N="emp[\<gamma>\<mapsto>(classTP CONS)]" and
                      HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)]" and
                      NNN="emp[\<epsilon>\<mapsto>(classTP NIL)]" and
                      NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)]" and 
                      c=\<omega> in UniBSFrame) 
      prefer 2 apply (simp add: SD_sum_def) 
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
      prefer 2 apply (simp add: SD_sum_def) 
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
                   apply (clarsimp, drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update4, rule AL_update1)
                       apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp) 
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
      prefer 2 apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
      prefer 2 apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
                   apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update4, rule AL_update1) 
                       apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp) 
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
      prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
      apply (rule UniAx) apply clarsimp
        apply (rule, simp add: NilCopy_def)
        apply (rule_tac x=\<epsilon> in exI, simp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update1) 
          apply (simp add: AL_emp1)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update1) 
          apply (simp add: AL_emp1)
        apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
    (* apply fast *)  
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS8)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrCONS9)
    apply fastsimp
    apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS10)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS11)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS12)
    apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply fastsimp apply fastsimp apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCONS13)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS14)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp 
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS15)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCONS16)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS17)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrCONS18) apply simp apply simp
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast 
        apply (simp add: contained_def) 
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update1)
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
      apply (rule AL_sum_emp2)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
        apply (simp add: contained_def, rule)
        apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update1)
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
(*n>1*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (case_tac "ListN ba list", clarsimp) apply clarsimp
apply (case_tac "ListHP ba list", clarsimp) apply clarsimp
apply (case_tac "ListN bb zs", clarsimp) apply clarsimp
apply (case_tac "ListHP bb zs", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (case_tac zs, clarsimp, clarsimp)
apply (case_tac "ListN bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListHP bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListN bc lista", clarsimp) apply clarsimp
apply (case_tac "ListHP bc lista", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rename_tac \<alpha> \<mu> \<nu> \<epsilon> \<omega> \<Omega> \<delta> \<Lambda> M K N H)
apply (rule UniRun) 
  apply (rule UniLoad)
    apply (rule InstrCONS0)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCONS1)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS3)
    apply fastsimp
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrCONS4)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS5)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS6)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
    apply(subgoal_tac "AL_dom (K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<alpha>][TL\<mapsto>\<mu>])]) \<inter> AL_dom (H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (frule_tac M="H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
    apply (subgoal_tac "AL_dom (M[\<mu>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>(classTP CONS)]) \<inter> AL_dom (N[\<nu>\<mapsto>(classTP CONS)]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (frule_tac M="N[\<nu>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
apply (rule UniRun)
    apply (rule_tac HH=HH and c=\<nu> and NN=NN in UniInvV3)
    apply (rule InstrCONS7)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4)
        apply (rule AL_update1) 
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply assumption
    apply clarsimp
    apply (erule_tac x=E in allE, erule impE, assumption, clarsimp)
    apply (rule_tac x="fst(snd ConsCopy)" in exI, rule_tac x=0 in exI)
    apply rule apply (simp add: ConsCopy_def)
    apply (subgoal_tac "AL_dom (K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]) \<inter> AL_dom(H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (drule_tac N="K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]" in AL_sum_exists_AL) apply (erule exE, rename_tac KK, erule conjE)
    apply (subgoal_tac "AL_dom M[\<mu>\<mapsto>(classTP CONS)] \<inter> AL_dom N[\<nu>\<mapsto>(classTP CONS)] = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (drule_tac N="M[\<mu>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) apply (erule exE, rename_tac MM, erule conjE)
      apply (rule_tac \<Sigma> ="([], emp[this\<mapsto>\<mu>],K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])])" and 
                      H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<alpha>][TL\<mapsto>\<mu>])]" and
                      HH=KK and
                      NNN="M[\<mu>\<mapsto>(classTP CONS)]" and
                      N="emp[\<gamma>\<mapsto>(classTP CONS)]" and
                      NN=MM in UniBSFrame) apply (rule UniAx)
 
  apply (subgoal_tac "((ConsCopy,
            0::nat),
           ([], emp[this\<mapsto>\<mu>], K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]), M[\<mu>\<mapsto>(classTP CONS)], KK, \<nu>, MM)
          \<in> {(ppt, S).
             (\<exists>n>0. ppt = (ConsCopy, 0) \<and> S \<in> Spec n)}") apply (simp add: ConsCopy_def)
       (* apply (erule impE) apply (simp add: ConsCopy_def) apply (erule_tac x=n in allE, simp)*)
  apply clarsimp apply (rule_tac x="Suc(length \<Lambda>)" in exI, clarsimp)
    apply (rule_tac x=\<mu> in exI) apply (rule_tac x="(\<epsilon>,\<delta>) # \<Lambda>" in exI) 
    apply (simp add: preS_def)
    apply (rule_tac x="(\<epsilon>,\<omega>) # \<Omega>" in exI, simp) 
    apply (simp add: starOpt_def star_def AL_dom_upd1)
  apply (simp add: SD_sum_def)
         apply (simp add: AL_dom_upd1 AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
           apply (simp add: contained_def, rule)
           apply clarsimp apply (rule AL_update4) apply assumption
             apply (drule_tac d=ab in AL_domI) apply (simp add: AL_dom_upd1) apply (erule disjE, clarsimp) apply fast 
          apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1)
            apply (simp add: AL_emp1)
  apply (simp add: SD_sum_def)
         apply (simp add: AL_dom_upd1 AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
           apply (simp add: contained_def, rule)
           apply clarsimp 
             apply (frule AL_sum_split, assumption)
             apply (erule disjE) apply (erule AL_sum3) apply (rule AL_update4) apply assumption
               apply (drule_tac d=ab in AL_domI) 
                  apply (simp add: AL_dom_upd1 AL_sum_def) apply (erule disjE, clarsimp)  apply (erule disjE, clarsimp) 
                  apply (erule disjE, clarsimp) apply fast 
             apply (erule AL_sum4) apply assumption
          apply (rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
            apply (simp add: AL_emp1)
          apply (simp add: AL_sum_def AL_dom_upd1) apply fast
  apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
           apply (simp add: contained_def, rule)
           apply clarsimp 
             apply (rule AL_update4, assumption) 
               apply (drule_tac d=ab in AL_domI) apply (simp add: AL_dom_upd1 AL_sum_def) apply (erule disjE, clarsimp)  apply fast 
           apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1)
            apply (simp add: AL_emp1)
  apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
           apply (simp add: contained_def, rule)
           apply clarsimp 
             apply (frule AL_sum_split, assumption)
             apply (erule disjE)
               apply (erule AL_sum3) apply (rule AL_update4, assumption) 
                 apply (drule_tac d=ab in AL_domI) apply (simp add: AL_dom_upd1 AL_sum_def) 
                 apply (erule disjE, clarsimp) apply (erule disjE, clarsimp)  apply (erule disjE, clarsimp) apply fast
               apply (erule AL_sum4) apply assumption
           apply clarsimp
             apply (drule AL_upd_split)
             apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
             apply (simp add: AL_emp1)
  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast 
  (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS8)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrCONS9)
    apply fastsimp
    apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrCONS10)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS11)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS12)
    apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update4, rule AL_update1) apply fastsimp apply fastsimp apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCONS13)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS14)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp 
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS15)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrCONS16)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrCONS17)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrCONS18) apply simp apply simp
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (simp add: contained_def) 
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_sum_split, assumption)
          apply (erule disjE)
            apply (erule AL_sum3) apply assumption
            apply (erule AL_sum4) apply (erule AL_update4) apply assumption
          apply (simp add: AL_emp1)
      apply (rule AL_sum_emp2)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (simp add: contained_def, rule)
        apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_sum_split, assumption)
          apply (erule disjE)
            apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (erule AL_update4) apply assumption  
          apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
done
(*>*)

lemma W_ConsCopy_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST Copy ListCopy; mbody_is NIL Copy NilCopy; mbody_is CONS Copy ConsCopy\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (W ConsCopy)"
(*<*)
apply (subgoal_tac "UniCtxtVerified (U ConsCopy)", simp add: UW)
apply (erule U_ConsCopy_verified, assumption+)
done
(*>*)

lemma V_ConsCopy_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST Copy ListCopy; mbody_is NIL Copy NilCopy; mbody_is CONS Copy ConsCopy\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (V ConsCopy)"
(*<*)
by (simp add: W_ConsCopy_verified VW)
(*>*)

lemma COPY_U_ConsCopy_verified:
  "\<lbrakk>TL \<noteq> HD; P=COPY; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (U ConsCopy)"
(*<*)
apply (erule U_ConsCopy_verified, assumption+)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=ListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>LIST = Some ListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: ListClass_def) apply (rule AL_update1)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=NilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>NIL = Some NilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: NilClass_def) apply (rule AL_update1)
apply (simp add: COPY_def mbody_is_def, clarsimp)
  apply (rule_tac x=ConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>ListClass][NIL\<mapsto>NilClass][CONS\<mapsto>ConsClass]\<down>CONS = Some ConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: ConsClass_def) apply (rule AL_update1)
done
(*>*)
    
lemma U_ConsOpt_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST OptCopy ListCopy; mbody_is NIL OptCopy NilCopy; mbody_is CONS OptCopy ConsOpt\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (U ConsOpt)"
(*<*)
apply (simp add: UniCtxtVerified_def U_def, clarsimp)
apply rule
(*n=0*)
apply clarsimp
apply rule apply (simp add: preS_def starOptDEF) apply (erule conjE)+
  apply (erule AL_sum3b)
apply rule apply (simp add: starOptDEF AL_sum_def)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=NIL in UniNew)
    apply (rule InstrNIL0) 
      apply fastsimp
      apply (simp add: starOptDEF) apply (simp add: AL_dom_upd1 AL_emp1 AL_dom_emp)  
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
      (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrNIL1)
    prefer 3 apply (rule SD_sum_emp1)
    apply fastsimp 
    apply simp 
      apply (simp add: SD_sum_def preS_def starOptDEF) apply clarsimp 
      apply (simp add: AL_sum_def)
      apply rule apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def) 
      apply (rule, clarsimp) 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (rule, clarsimp) apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd AL_dom_emp)
    apply (rule AL_sum_emp2)
    apply (simp add: starOptDEF AL_sum_def)
      apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def)
      apply (rule, clarsimp)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (simp add: AL_emp1)
    apply (simp add: AL_dom_emp)
(*n>0*)
apply clarsimp
apply (case_tac n, clarsimp,clarsimp)
apply rule apply (simp add: preS_def starOptDEF  AL_sum_def) apply clarsimp
apply rule apply (simp add: starOptDEF AL_sum_def) apply clarsimp
apply (simp add: preS_def) apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp) 
apply (case_tac nat, clarsimp)
(*n=1: extra case*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rename_tac \<delta> \<epsilon> \<omega>)
apply (rule UniRun) 
  apply (rule UniLoad)
    apply (rule InstrOPT0)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrOPT1)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrOPT2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrOPT3)
    apply fastsimp
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrOPT4)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
    apply (rule_tac HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])]" 
                and NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)][\<gamma>\<mapsto>(classTP CONS)]" in UniInvV3)
    apply (rule InstrOPT5)
      apply (simp add: ListCopy_def)
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4)
        apply (rule AL_update1) 
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_EMP)
    apply clarsimp
    apply (erule_tac x=E in allE, clarsimp)
    apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI, rule_tac x=0 in exI)
    apply rule apply (simp add:NilCopy_def) 
      apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<epsilon>], emp[\<epsilon>\<mapsto>(NIL, emp)])" and
                      H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])]" and
                      N="emp[\<gamma>\<mapsto>(classTP CONS)]" and
                      HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)]" and
                      NNN="emp[\<epsilon>\<mapsto>(classTP NIL)]" and
                      NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)]" and 
                      c=\<omega> in UniBSFrame) 
      prefer 2 apply (simp add: SD_sum_def) 
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp)
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
      prefer 2 apply (simp add: SD_sum_def) 
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
                   apply (clarsimp, drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update4, rule AL_update1)
                       apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp) 
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
                 apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
      prefer 2 apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) 
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
      prefer 2 apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update1) apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
                   apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update4, rule AL_update4, rule AL_update1) 
                       apply (simp add: AL_dom_upd1 AL_dom_emp) apply (simp add: AL_dom_upd1 AL_dom_emp) 
                   apply (simp add: AL_emp1)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply (simp add: AL_emp1)
      prefer 2 apply (simp add: AL_dom_upd1 AL_dom_emp) apply fast
      apply (rule UniAx) apply clarsimp
        apply (rule, simp add: NilCopy_def)
        apply (rule_tac x=\<epsilon> in exI, simp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp contained_def)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update1) 
          apply (simp add: AL_emp1)
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule AL_update1) 
          apply (simp add: AL_emp1)
        apply (rule AL_UPD, rule AL_UPD, rule AL_EMP)
    (* apply fast *)  
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrOPT6)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrOPT7)
    apply fastsimp
    apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrOPT8)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrOPT9)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrOPT10)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrOPT11)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrOPT12)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrOPT13)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrOPT14) apply simp apply simp
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast 
        apply (simp add: contained_def) 
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update1)
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
      apply (rule AL_sum_emp2)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
        apply (simp add: contained_def, rule)
        apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update1)
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
(*n>1*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (case_tac "ListN ba list", clarsimp) apply clarsimp
apply (case_tac "ListHP ba list", clarsimp) apply clarsimp
apply (case_tac "ListN bb zs", clarsimp) apply clarsimp
apply (case_tac "ListHP bb zs", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (case_tac zs, clarsimp, clarsimp)
apply (case_tac "ListN bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListHP bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListN bc lista", clarsimp) apply clarsimp
apply (case_tac "ListHP bc lista", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rename_tac \<alpha> \<mu> \<nu> \<epsilon> \<omega> \<Omega> \<delta> \<Lambda> M K N H)
apply (rule UniRun) 
  apply (rule UniLoad)
    apply (rule InstrOPT0)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrOPT1)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrOPT2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrOPT3)
    apply fastsimp
    apply (rule AL_update4) apply (rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrOPT4)
    apply fastsimp
    apply (rule AL_update1)
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
    apply(subgoal_tac "AL_dom (K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<alpha>][TL\<mapsto>\<mu>])]) \<inter> AL_dom (H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (frule_tac M="H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in AL_sum_exists_AL) apply (erule exE, rename_tac HH, erule conjE)
    apply (subgoal_tac "AL_dom (M[\<mu>\<mapsto>(classTP CONS)][\<gamma>\<mapsto>(classTP CONS)]) \<inter> AL_dom (N[\<nu>\<mapsto>(classTP CONS)]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (frule_tac M="N[\<nu>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) apply (erule exE, rename_tac NN, erule conjE)
apply (rule UniRun)
    apply (rule_tac HH=HH and c=\<nu> and NN=NN in UniInvV3)
    apply (rule InstrOPT5)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4)
        apply (rule AL_update1) 
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply assumption
    apply clarsimp
    apply (erule_tac x=E in allE, erule impE, assumption, clarsimp)
    apply (rule_tac x="fst(snd ConsOpt)" in exI, rule_tac x=0 in exI)
    apply rule apply (simp add: ConsOpt_def)
    apply (subgoal_tac "AL_dom (K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]) \<inter> AL_dom(H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (drule_tac N="K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]" in AL_sum_exists_AL) apply (erule exE, rename_tac KK, erule conjE)
    apply (subgoal_tac "AL_dom M[\<mu>\<mapsto>(classTP CONS)] \<inter> AL_dom N[\<nu>\<mapsto>(classTP CONS)] = {}")
    prefer 2 apply (simp add: AL_dom_upd1)
    apply (drule_tac N="M[\<mu>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) apply (erule exE, rename_tac MM, erule conjE)
      apply (rule_tac \<Sigma> ="([], emp[this\<mapsto>\<mu>],K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])])" and 
                      H="emp[\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<alpha>][TL\<mapsto>\<mu>])]" and
                      HH=KK and
                      NNN="M[\<mu>\<mapsto>(classTP CONS)]" and
                      N="emp[\<gamma>\<mapsto>(classTP CONS)]" and
                      NN=MM in UniBSFrame) apply (rule UniAx)
 
  apply (subgoal_tac "((ConsOpt,
            0::nat),
           ([], emp[this\<mapsto>\<mu>], K[\<mu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]), M[\<mu>\<mapsto>(classTP CONS)], KK, \<nu>, MM)
          \<in> {(ppt, S).
             (\<exists>n>0. ppt = (ConsOpt, 0) \<and> S \<in> Spec n)}") apply (simp add: ConsOpt_def)
       (* apply (erule impE) apply (simp add: ConsCopy_def) apply (erule_tac x=n in allE, simp)*)
  apply clarsimp apply (rule_tac x="Suc(length \<Lambda>)" in exI, clarsimp)
    apply (rule_tac x=\<mu> in exI) apply (rule_tac x="(\<epsilon>,\<delta>) # \<Lambda>" in exI) 
    apply (simp add: preS_def)
    apply (rule_tac x="(\<epsilon>,\<omega>) # \<Omega>" in exI, simp) 
    apply (simp add: starOpt_def star_def AL_dom_upd1)
  apply (simp add: SD_sum_def)
         apply (simp add: AL_dom_upd1 AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
           apply (simp add: contained_def, rule)
           apply clarsimp apply (rule AL_update4) apply assumption
             apply (drule_tac d=ab in AL_domI) apply (simp add: AL_dom_upd1) apply (erule disjE, clarsimp) apply fast 
          apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1)
            apply (simp add: AL_emp1)
  apply (simp add: SD_sum_def)
         apply (simp add: AL_dom_upd1 AL_dom_emp)
         apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
           apply (simp add: contained_def, rule)
           apply clarsimp 
             apply (frule AL_sum_split, assumption)
             apply (erule disjE) apply (erule AL_sum3) apply (rule AL_update4) apply assumption
               apply (drule_tac d=ab in AL_domI) 
                  apply (simp add: AL_dom_upd1 AL_sum_def) apply (erule disjE, clarsimp)  apply (erule disjE, clarsimp) 
                  apply (erule disjE, clarsimp) apply fast 
             apply (erule AL_sum4) apply assumption
          apply (rule, clarsimp)
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
            apply (simp add: AL_emp1)
          apply (simp add: AL_sum_def AL_dom_upd1) apply fast
  apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
           apply (simp add: contained_def, rule)
           apply clarsimp 
             apply (rule AL_update4, assumption) 
               apply (drule_tac d=ab in AL_domI) apply (simp add: AL_dom_upd1 AL_sum_def) apply (erule disjE, clarsimp)  apply fast 
           apply clarsimp 
            apply (drule AL_upd_split)
            apply (erule disjE, clarsimp) apply (rule AL_update1)
            apply (simp add: AL_emp1)
  apply (simp (no_asm) add: AL_sum_def)
           apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
           apply (simp add: contained_def, rule)
           apply clarsimp 
             apply (frule AL_sum_split, assumption)
             apply (erule disjE)
               apply (erule AL_sum3) apply (rule AL_update4, assumption) 
                 apply (drule_tac d=ab in AL_domI) apply (simp add: AL_dom_upd1 AL_sum_def) 
                 apply (erule disjE, clarsimp) apply (erule disjE, clarsimp)  apply (erule disjE, clarsimp) apply fast
               apply (erule AL_sum4) apply assumption
           apply clarsimp
             apply (drule AL_upd_split)
             apply (erule disjE, clarsimp) apply (erule AL_sum3) apply (rule AL_update1)
             apply (simp add: AL_emp1)
  apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast 
  (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniStore)
    apply (rule InstrOPT6)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrOPT7)
    apply fastsimp
    apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrOPT8)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrOPT9)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrOPT10)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrOPT11)
    apply fastsimp
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrOPT12)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrOPT13)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
    (* apply fast *)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrOPT14) apply simp apply simp
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (simp add: contained_def) 
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_sum_split, assumption)
          apply (erule disjE)
            apply (erule AL_sum3) apply assumption
            apply (erule AL_sum4) apply (erule AL_update4) apply assumption
          apply (simp add: AL_emp1)
      apply (rule AL_sum_emp2)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp)
        apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (simp add: contained_def, rule)
        apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update1)
          apply clarsimp
          apply (drule AL_sum_split, assumption)
          apply (erule disjE)
            apply (erule AL_sum3) apply assumption 
            apply (erule AL_sum4) apply (erule AL_update4) apply assumption  
          apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd1 AL_dom_emp)
done
(*>*)

lemma W_ConsOpt_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST OptCopy ListCopy; mbody_is NIL OptCopy NilCopy; mbody_is CONS OptCopy ConsOpt\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (W ConsOpt)"
(*<*)
apply (subgoal_tac "UniCtxtVerified (U ConsOpt)", simp add: UW)
apply (erule U_ConsOpt_verified) apply assumption+
done
(*>*)

lemma V_ConsOpt_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS;
    mbody_is LIST OptCopy ListCopy; mbody_is NIL OptCopy NilCopy; mbody_is CONS OptCopy ConsOpt\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (V ConsOpt)"
(*<*)
apply (simp add:W_ConsOpt_verified VW)
done
(*>*)

lemma OPT_U_ConsOpt_verified:
  "\<lbrakk>TL \<noteq> HD; P=OPT; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (U ConsOpt)"
(*<*)
apply (erule U_ConsOpt_verified, assumption+)
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptListClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>LIST = Some OptListClass", simp)
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply simp apply simp
  apply (simp add: OptListClass_def) apply (rule AL_update1)
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptNilClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>NIL = Some OptNilClass", simp)
    apply (rule AL_update4, rule AL_update1) apply fastsimp 
  apply (simp add: OptNilClass_def) apply (rule AL_update1)
apply (simp add: OPT_def mbody_is_def, clarsimp)
  apply (rule_tac x=OptConsClass in exI)
  apply rule
    apply (subgoal_tac "emp[LIST\<mapsto>OptListClass][NIL\<mapsto>OptNilClass][CONS\<mapsto>OptConsClass]\<down>CONS = Some OptConsClass", simp)
    apply (rule AL_update1) 
  apply (simp add: OptConsClass_def) apply (rule AL_update1)
done
(*>*)

text{*We can also verify the implementation AllocFirst. However, as
our association lists are not fully extensional we have to use the
additional assumption that the order of field updates to the
(distinct) names HD and TL does not matter. *}

constdefs HDTLAx::bool
"HDTLAx \<equiv> (\<forall> (col1::Colour) col2 . upd(upd emp HD col1) TL col2 = upd(upd emp TL col2) HD col1)"

lemma U_AllocFirstCopy_verified:
  "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this];distinct [NIL,CONS,LIST];
     subclass_of NIL LIST; \<forall> D . subclass_of D  NIL \<longrightarrow> D = NIL; \<forall> D . subclass_of D CONS \<longrightarrow> D = CONS; HDTLAx;
    mbody_is LIST AllocFirstCopy ListCopy; mbody_is NIL AllocFirstCopy NilCopy; mbody_is CONS AllocFirstCopy AllocFirst\<rbrakk>
   \<Longrightarrow> UniCtxtVerified (U AllocFirst)"
(*<*)
apply (simp add: UniCtxtVerified_def U_def, clarsimp)
apply rule
(*n=0*)
apply clarsimp
apply rule apply (simp add: preS_def starOptDEF) apply (erule conjE)+
  apply (erule AL_sum3b)
apply rule apply (simp add: starOptDEF AL_sum_def)
apply (rule_tac CtxtU="U AllocFirst" in UniBS_ContextSame) prefer 2 apply (simp add: U_def)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=NIL in UniNew)
    apply (rule InstrNIL0) 
      apply fastsimp
      apply (simp add: starOptDEF) apply (simp add: AL_dom_upd1 AL_emp1 AL_dom_emp)  
      apply simp
      apply (simp add: subclass_of_refl)
      apply simp
      apply simp
(*      apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrNIL1)
    prefer 3 apply (rule SD_sum_emp1)
    apply fastsimp 
    apply simp 
      apply (simp add: SD_sum_def preS_def starOptDEF) apply clarsimp 
      apply (simp add: AL_sum_def)
      apply rule apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def) 
      apply (rule, clarsimp) 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (rule, clarsimp) apply (simp add: AL_emp1)
      apply (simp add: AL_dom_upd AL_dom_emp)
    apply (rule AL_sum_emp2)
    apply (simp add: starOptDEF AL_sum_def)
      apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp (no_asm) add: contained_def)
      apply (rule, clarsimp)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply clarsimp 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (erule contained3, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (simp add: AL_emp1)
    apply (simp add: AL_dom_emp)
(*n>0*)
apply clarsimp
apply (case_tac n, clarsimp,clarsimp)
apply rule apply (simp add: preS_def starOptDEF  AL_sum_def) apply clarsimp
apply rule apply (simp add: starOptDEF AL_sum_def) apply clarsimp
apply (simp add: preS_def) apply (case_tac "ListHP \<gamma> \<Lambda>", clarsimp,clarsimp) 
apply (rule_tac CtxtU="U AllocFirst" in UniBS_ContextSame) prefer 2 apply (simp add: preS_def U_def) 
apply (case_tac nat, clarsimp)
(*n=1: extra case*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rename_tac \<delta> \<epsilon> \<omega>)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrALLOCFIRST0)
    apply fastsimp
    apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
(*    apply fast*)
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrALLOCFIRST1)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrALLOCFIRST2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrALLOCFIRST3)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrALLOCFIRST4)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule_tac N'=N' and L="{Suc( Suc (Suc (Suc (Suc (Suc 0)))))}" in UniRun)
  apply (rule_tac HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])][c\<mapsto>(CONS, emp)]" in UniInvV3)
    apply (rule InstrALLOCFIRST5)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4, rule AL_update4, rule AL_update1)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply assumption
    apply clarsimp
    apply (erule_tac x=E in allE, clarsimp)
    apply (rule_tac x="emp[0 \<mapsto> (new NIL)][1 \<mapsto> vreturn]" in exI, rule_tac x=0 in exI)
    apply rule apply (simp add:NilCopy_def)
      apply (rule_tac \<Sigma>="([], emp[this\<mapsto>\<epsilon>], emp[\<epsilon>\<mapsto>(NIL, emp)])" and
                      H="upd(upd emp \<gamma> (CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])) c (CONS, emp)" and
                      NNN="emp[\<epsilon>\<mapsto>(classTP NIL)]" and 
                      c=\<omega>  and
                      HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)]" and
                      NN="emp[\<epsilon>\<mapsto>(classTP NIL)][\<omega>\<mapsto>(classTP NIL)]" and
                      N="upd(upd emp \<gamma> (classTP CONS)) c (classTP CONS)" in UniBSFrame)
        apply (rule UniAx) apply (simp add: U_def) apply clarsimp 
          apply (rule, simp add: NilCopy_def)
          apply (rule_tac x=\<epsilon> in exI, simp add: preS_def) 
          apply (simp (no_asm) add: starOpt_def star_def AL_sum_def contained_def) 
            apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp) apply (rule AL_update4) apply assumption 
              apply (drule AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp) apply (drule AL_upd_split)
              apply (erule disjE, clarsimp) apply (rule AL_update1)
              apply (simp add: AL_emp1)
            apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (rule, rule AL_UPD, rule AL_UPD,rule AL_EMP)
            apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
            apply (rule, clarsimp)
              apply (drule AL_upd_split) 
              apply (erule disjE, clarsimp) apply (rule AL_update4, rule AL_update1) 
                apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
              apply (simp add: AL_emp1)
           apply (rule, clarsimp)
             apply (drule AL_upd_split)
             apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
           apply (rule, simp add: AL_dom_emp AL_dom_upd1 AL_sum_def)
           apply (rule AL_UPD,rule AL_UPD, rule AL_EMP)
      apply (simp add: SD_sum_def) 
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (rule AL_update4, rule AL_update4, assumption)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply clarsimp
                     apply (rule AL_update4)
                         apply (drule AL_upd_split)
                         apply (erule disjE, clarsimp)
                           apply (rule AL_update1) 
                         apply (simp add: AL_emp1)
                       apply assumption
                 apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (simp add: SD_sum_def)
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (rule AL_update4, rule AL_update4, assumption)
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply clarsimp
                   apply (rule AL_update4, drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply assumption
                 apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp 
               apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp)
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (rule AL_update4, rule AL_update4, assumption)
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                     apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (rule AL_update1) 
                   apply clarsimp
                   apply (rule AL_update4, drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply assumption
               apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def  AL_dom_upd1 AL_dom_emp) apply fast
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp) apply (erule AL_sum4, rule AL_update4) apply (rule AL_update1)
                     apply (simp add: AL_dom_upd1 AL_dom_emp)
                   apply clarsimp
                   apply (erule AL_sum3)
                   apply (rule AL_update4, drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
               apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp)
                     apply (erule AL_sum4) apply (rule AL_update1) 
                   apply clarsimp
                   apply (erule AL_sum3)
                   apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp)
                       apply (rule AL_update1)
                     apply (simp add: AL_emp1)
                   apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)  apply clarsimp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrALLOCFIRST6)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrALLOCFIRST7)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp 
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrALLOCFIRST8)
    apply fastsimp
    apply (rule AL_update4, rule AL_update4, rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_update4, rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrALLOCFIRST9)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrALLOCFIRST10) apply simp apply simp 
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast 
        apply (simp add: contained_def) 
        apply (rule, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (subgoal_tac "emp[HD\<mapsto>\<delta>][TL\<mapsto>\<omega>]=emp[TL\<mapsto>\<omega>][HD\<mapsto>\<delta>]") apply clarsimp apply (rule AL_update1) 
              apply (simp add: HDTLAx_def) 
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp) 
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) 
            apply (erule AL_sum3) apply (rule AL_update1)
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum4) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (clarsimp, drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (erule AL_sum3) apply (rule AL_update4, rule AL_update1) apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
      apply (rule AL_sum_emp2)
      apply (rule AL_sum_emp2)
      apply (simp (no_asm) add: AL_dom_emp)
(*n>1*)
apply (case_tac \<Lambda>, clarsimp, clarsimp)
apply (simp add: starOptDEF) apply clarsimp
apply (case_tac "ListN ba list", clarsimp) apply clarsimp
apply (case_tac "ListHP ba list", clarsimp) apply clarsimp
apply (case_tac "ListN bb zs", clarsimp) apply clarsimp
apply (case_tac "ListHP bb zs", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (case_tac zs, clarsimp, clarsimp)
apply (case_tac "ListN bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListHP bd zsa", clarsimp) apply clarsimp
apply (case_tac "ListN bc lista", clarsimp) apply clarsimp
apply (case_tac "ListHP bc lista", clarsimp) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (drule if_split) apply clarsimp
apply (rule_tac CtxtU="U AllocFirst" in UniBS_ContextSame) prefer 2 apply (simp add: U_def preS_def starOpt_def star_def)  
apply (rename_tac This ThisH ThisT \<nu> \<epsilon> \<omega> \<Omega> \<delta> \<Lambda> M K N H)
apply (rule UniRun) 
  apply (rule_tac cl=c and D=CONS in UniNew)
    apply (rule InstrALLOCFIRST0)
    apply fastsimp
    apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply simp
    apply (simp add: subclass_of_refl)
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrALLOCFIRST1)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniDup)
    apply (rule InstrALLOCFIRST2)
    apply fastsimp
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrALLOCFIRST3)
    apply fastsimp
    apply (rule AL_update1) 
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrALLOCFIRST4)
    apply fastsimp
    apply (rule AL_update4, rule AL_update1) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule_tac N'=N' and L="{Suc( Suc (Suc (Suc (Suc (Suc 0)))))}" in UniRun)
    apply (rule_tac c=\<nu> and HH="upd (delete H' c) c (CONS, emp)" in UniInvV3)
(*  apply (rule_tac HH="emp[\<epsilon>\<mapsto>(NIL, emp)][\<omega>\<mapsto>(NIL, emp)][\<gamma>\<mapsto>(CONS, emp[HD\<mapsto>\<delta>][TL\<mapsto>\<epsilon>])][c\<mapsto>(CONS, emp)]" in UniInvV3)*)
    apply (rule InstrALLOCFIRST5)
      apply (simp add: ListCopy_def) 
      apply fastsimp
      apply (rule absFrameNil) apply fastsimp
      apply (rule AL_update4, rule AL_update4, rule AL_update1)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
        apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply simp
    apply simp
    apply assumption
prefer 2 apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrALLOCFIRST6)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniLoad)
    apply (rule InstrALLOCFIRST7)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp 
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniGet)
    apply (rule InstrALLOCFIRST8)
    apply fastsimp
    apply (rule AL_update4, rule AL_update4) 
      apply (rule AL_delete5) apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
      apply (erule AL_sum3, rule AL_update1) 
      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
      apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
    apply (rule AL_update4, rule AL_update1) apply assumption
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule UniRun)
  apply (rule UniPut)
    apply (rule InstrALLOCFIRST9)
    apply fastsimp
    apply (rule AL_update1)
    apply simp
    apply simp
    apply simp
apply clarsimp
apply (rule UniInj)
apply (rule_tac H=emp and N=emp in UniBSFrame)
apply (rule UniVret)
    apply (rule InstrALLOCFIRST10) apply simp apply simp 
    apply (simp add: SD_sum_def)
      apply (rule,simp) apply (rule, simp) apply (rule, rule AL_sum_emp2) apply (simp add: AL_dom_emp)
    apply (simp add: SD_sum_def)
      apply (simp (no_asm) add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
        apply (rule, simp add:  AL_sum_def AL_dom_upd1 AL_dom_emp AL_dom_delete) 
        apply (rule, simp add: contained_def, clarsimp) 
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (erule AL_sum4)
              apply (subgoal_tac "emp[HD\<mapsto>ThisH][TL\<mapsto>\<nu>]=emp[TL\<mapsto>\<nu>][HD\<mapsto>ThisH]") apply clarsimp apply (rule AL_update1) 
              apply (simp add: HDTLAx_def)  
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp)
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp, clarsimp) 
          apply (drule AL_delete6, clarsimp)
        apply (rule contained_emp)
      apply (rule AL_sum_emp2)
      apply (rule AL_sum_emp2)
      apply (simp (no_asm) add: AL_dom_emp)
apply clarsimp
    apply (erule_tac x=E in allE, clarsimp)
    apply (rule_tac x="fst(snd AllocFirst)" in exI, rule_tac x="snd(snd AllocFirst)" in exI)
    apply rule apply (simp add:AllocFirst_def)
    apply (subgoal_tac "(AL_dom  K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]) \<inter> (AL_dom H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)  
    apply (frule_tac N="K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]" and M="H[\<nu>\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<omega>])]" in AL_sum_exists_AL) 
      apply (erule exE, rename_tac KH,erule conjE)
    apply (subgoal_tac "(AL_dom  M[ThisT\<mapsto>(classTP CONS)]) \<inter> (AL_dom N[\<nu>\<mapsto>(classTP CONS)]) = {}")
    prefer 2 apply (simp add: AL_dom_upd1)  
    apply (frule_tac N="M[ThisT\<mapsto>(classTP CONS)]" and M="N[\<nu>\<mapsto>(classTP CONS)]" in AL_sum_exists_AL) 
      apply (erule exE, rename_tac NM,erule conjE)
    apply (rule_tac \<Sigma>="([],emp[this\<mapsto>ThisT],K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])])" and
                    H="emp[This\<mapsto>(CONS, emp[HD\<mapsto>ThisH][TL\<mapsto>ThisT])][c\<mapsto>(CONS, emp)]" and 
                    NNN="M[ThisT\<mapsto>(classTP CONS)]" and N="emp[This\<mapsto>(classTP CONS)][c\<mapsto>(classTP CONS)]" and
                    HH=KH and NN=NM in UniBSFrame)
    apply (rule UniAx) apply (simp add: U_def) apply (rule disjI2) 
         apply (rule_tac x="Suc(length \<Lambda>)" in exI) apply (rule, simp) apply (rule, simp add: AllocFirst_def) apply (rule, simp add: AllocFirst_def) 
         apply simp apply (rule_tac x=ThisT in exI) apply (rule_tac x="(\<epsilon>,\<delta>) # \<Lambda>" in exI)
          apply (rule, simp add: preS_def) 
          apply (rule,simp) 
          apply (rule_tac x="(\<epsilon>,\<omega>) # \<Omega>" in exI)
          apply (rule,simp add: starOpt_def star_def)
          apply (rule,simp add: starOpt_def star_def)
          apply simp
        prefer 2 apply (simp add: SD_sum_def)
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def AL_dom_delete) apply fast
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (subgoal_tac "c\<noteq> ab") 
                   prefer 2 apply (drule AL_domI) apply (simp add: AL_sum_def AL_dom_upd1) apply clarsimp
                   apply (rule AL_update4)
                     apply (rule AL_delete5b) apply assumption
                     apply (drule AL_sum_split, assumption) 
                     apply (erule disjE) apply (erule AL_sum3) apply (rule AL_update4) apply assumption
                       apply (drule_tac H="K[ThisT\<mapsto>(CONS, emp[HD\<mapsto>\<epsilon>][TL\<mapsto>\<delta>])]" in AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) 
                          apply clarsimp
                     apply (erule AL_sum4) apply (rule AL_update4) apply assumption
                   apply assumption
                   apply assumption
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp) apply (rule AL_update1) apply clarsimp
                   apply (rule AL_update4) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_delete5b) apply assumption 
                       apply (erule AL_sum3) apply (rule AL_update1) 
                     apply (simp add: AL_emp1)
                   apply assumption 
               apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
        apply (simp add: SD_sum_def)
               apply (rule, simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                 apply (simp add: contained_def)
                 apply (rule, clarsimp) apply (rule AL_update4) apply (rule AL_update4) apply assumption
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE) apply clarsimp apply (rule AL_update1) apply clarsimp
                   apply (rule AL_update4) 
                     apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                   apply assumption 
                 apply (simp add:AL_sum_def AL_dom_upd1 AL_dom_emp)
               apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) 
                 apply (simp add: contained_def)
                 apply (rule, clarsimp) apply (rule AL_update4) apply (rule AL_update4) apply assumption
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                   apply (drule AL_domI, simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                 apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE) apply clarsimp apply (rule AL_update1) apply clarsimp
                   apply (rule AL_update4) 
                     apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
                   apply assumption 
        apply (simp (no_asm) add: AL_sum_def)
                 apply (rule, simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply fast
                 apply (simp add: contained_def)
                 apply (rule, clarsimp)
                   apply (drule AL_sum_split,assumption)
                   apply (erule disjE)
                     apply (erule AL_sum3)
                     apply (rule AL_update4)
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) apply (rule AL_update1) apply clarsimp
                       apply (rule AL_update4) apply assumption apply assumption
                     apply (drule_tac H="M[ThisT\<mapsto>(classTP CONS)]" in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
                 apply (erule AL_sum4)
                   apply (rule AL_update4) apply assumption
                     apply (drule_tac H="N[\<nu>\<mapsto>(classTP CONS)]" in AL_domI) apply (simp add: AL_dom_upd1 AL_dom_emp AL_sum_def) apply clarsimp
               apply clarsimp
                   apply (drule AL_upd_split)
                   apply (erule disjE, clarsimp) apply (erule AL_sum4) apply (rule AL_update1) apply clarsimp
                   apply (erule AL_sum3) 
                     apply (drule AL_upd_split)
                     apply (erule disjE, clarsimp) apply (rule AL_update1) apply (simp add: AL_emp1)
           apply (simp add: AL_sum_def AL_dom_upd1 AL_dom_emp) apply clarsimp
done
(*>*)

lemma W_AllocFirstCopy_verified:
        "\<lbrakk>TL \<noteq> HD; distinct [h, t, z, this]; distinct [NIL, CONS, LIST]; subclass_of NIL LIST; \<forall>D. subclass_of D NIL \<longrightarrow> D = NIL;
         \<forall>D. subclass_of D CONS \<longrightarrow> D = CONS; mbody_is LIST AllocFirstCopy ListCopy; mbody_is NIL AllocFirstCopy NilCopy;
         mbody_is CONS AllocFirstCopy AllocFirst; HDTLAx\<rbrakk>
        \<Longrightarrow> UniCtxtVerified (W AllocFirst)"
(*<*)
apply (subgoal_tac "UniCtxtVerified (U AllocFirst)", simp add: UW)
apply (erule U_AllocFirstCopy_verified, assumption+)
done
(*>*)

(*<*)
end
(*>*)
