(*<*)
theory jlapExampleGarbage = ExampleBase:
(*>*) 

subsubsection{*Rules GarbageHP and GarbageN *} 


consts blue::Colour
       green::Colour
       yellow::Colour
       red::Colour
       C::Class
       D::Class
       f1::Field
       f2::Field
       g1::Field
       g2::Field
       g3::Field

constdefs H::HP
"H \<equiv> emp[blue\<mapsto>(C,emp[f1\<mapsto>green][f2\<mapsto>blue])]"
constdefs \<Sigma>::STATE
"\<Sigma> \<equiv> ([blue],emp,H)" 
constdefs N::MP
"N \<equiv> emp[green\<mapsto>intTP][blue\<mapsto>(classTP C)]"
constdefs K::HP
"K \<equiv> emp[blue\<mapsto>(C,emp[f1\<mapsto>green][f2\<mapsto>blue])][yellow\<mapsto>(D,emp[g1\<mapsto>yellow][g2\<mapsto>blue][g3\<mapsto>red])]"
constdefs N'::MP
"N' \<equiv> N[red\<mapsto>intTP][yellow\<mapsto>(classTP D)]"

lemma GarbageHP_example:
   "\<lbrakk> (U, \<Sigma>, N, M, l, b, K, blue, N') : UniBS; 
      distinct [yellow,red, blue,green]; f2 \<noteq> f1; distinct [g1,g2,g3] \<rbrakk> \<Longrightarrow>
        (U, \<Sigma>, N, M, l, b, H, blue, N'):UniBS"
apply (erule_tac d=yellow in UniBS_StaticGarbageHP)
apply (simp add: DOM_def AL_cod_emp AL_dom_delete K_def) apply clarsimp
  apply (drule AbsFieldsD) apply clarsimp
  apply (drule AL_delete6) apply clarsimp
  apply (drule AL_upd_split, clarsimp) apply (erule disjE, clarsimp)
  apply (drule AL_upd_split, clarsimp) apply (erule disjE, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
  apply (simp add: AL_emp1)
apply (simp add: \<Sigma>_def H_def K_def AL_dom_def) apply clarsimp
  apply (drule AL_upd_split, clarsimp)
  apply (erule disjE, clarsimp)
    apply (rule, rule, rule AL_delete5) apply fastsimp
    apply (rule AL_update5) apply (rule AL_update1) apply assumption
  apply (simp add: AL_emp1)
apply (simp add: N'_def)
  apply (rule contained_transitive)
    prefer 2 apply (rule contained_upd) apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
    apply (rule contained_upd) apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
apply (simp add: DOM_def H_def \<Sigma>_def AL_cod_emp AL_dom_upd1 AL_dom_emp)
  apply clarsimp 
  apply (drule AbsFieldsD, clarsimp)
  apply (drule AL_upd_split, simp add: AL_emp1) apply clarsimp
  apply (drule AL_upd_split)
    apply(erule disjE, clarsimp) apply clarsimp
    apply (drule AL_upd_split) apply (simp add: AL_emp1)
apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
apply (simp add: H_def K_def emp_def upd_def) apply fastsimp
done

lemma GarbageN_example1:
   "\<lbrakk> (U, \<Sigma>, N, M, l, b, K, blue, N') : UniBS; 
      distinct [yellow,red, blue,green]; f2 \<noteq> f1; distinct [g1,g2,g3] \<rbrakk> \<Longrightarrow>
        (U, \<Sigma>, N, M, l, b, H, blue, delete N' yellow):UniBS"
apply (rule_tac d=yellow in UniBS_StaticGarbageColour)
  apply (erule GarbageHP_example) apply assumption+
apply (simp add: DOM_def AL_dom_emp AL_cod_emp AL_dom_upd1 H_def) apply clarsimp
  apply (drule AbsFieldsD) apply clarsimp
  apply (drule AL_upd_split, clarsimp) apply (erule disjE, clarsimp)
  apply (drule AL_upd_split, clarsimp) 
  apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
  apply (simp add: AL_emp1)
apply (simp add: N'_def AL_delete_upd_same) apply clarsimp
  apply (drule_tac z=yellow and M=N and y=intTP in AL_delete_upd_diff) apply clarsimp
  apply (subgoal_tac "delete N yellow = N", simp)
    apply (rule contained_upd)
    apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
  apply (rule AL_notdomD_delete) apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
apply (simp add: DOM_def H_def \<Sigma>_def AL_cod_emp AL_dom_upd1 AL_dom_emp)
  apply clarsimp 
  apply (drule AbsFieldsD, clarsimp)
  apply (drule AL_upd_split, simp add: AL_emp1) apply clarsimp
  apply (drule AL_upd_split)
    apply(erule disjE, clarsimp) apply clarsimp
    apply (drule AL_upd_split) apply (simp add: AL_emp1)
apply simp
done

lemma delete_N'yellowredN:
  "distinct [yellow,red, blue,green] \<Longrightarrow> delete (delete N' yellow) red = N"
apply (simp add: N'_def AL_delete_upd_same) apply clarsimp
  apply (drule_tac z=yellow and M=N and y=intTP in AL_delete_upd_diff) apply clarsimp
  apply (subgoal_tac "delete N yellow = N", simp)
    apply (subgoal_tac "delete N[red\<mapsto>intTP] red = delete N red", simp)
      apply (subgoal_tac "delete N red = N", simp) 
      apply (rule AL_notdomD_delete) apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
    apply (rule AL_delete_upd_same)
  apply (rule AL_notdomD_delete) apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
done
lemma GarbageN_example2:
   "\<lbrakk> (U, \<Sigma>, N, M, l, b, K, blue, N') : UniBS; 
      distinct [yellow,red, blue,green]; f2 \<noteq> f1; distinct [g1,g2,g3] \<rbrakk> \<Longrightarrow>
        (U, \<Sigma>, N, M, l, b, H, blue, delete (delete N' yellow) red):UniBS"
apply (rule_tac d=red in UniBS_StaticGarbageColour)
  apply (erule GarbageN_example1) apply assumption+
apply (simp add: DOM_def AL_dom_emp AL_cod_emp AL_dom_upd1 H_def) apply clarsimp
  apply (drule AbsFieldsD) apply clarsimp
  apply (drule AL_upd_split, clarsimp) apply (erule disjE, clarsimp)
  apply (drule AL_upd_split, clarsimp) 
  apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
  apply (simp add: AL_emp1)
apply (simp add: delete_N'yellowredN) apply (rule contained_refl)
apply (simp add: DOM_def H_def \<Sigma>_def AL_cod_emp AL_dom_upd1 AL_dom_emp)
  apply clarsimp 
  apply (drule AbsFieldsD, clarsimp)
  apply (drule AL_upd_split, simp add: AL_emp1) apply clarsimp
  apply (drule AL_upd_split)
    apply(erule disjE, clarsimp) apply clarsimp
    apply (drule AL_upd_split) apply (simp add: AL_emp1)
apply simp
done

lemma GarbageN_example3:
   "\<lbrakk> (U, \<Sigma>, N, M, l, b, K, blue, N') : UniBS; 
      distinct [yellow,red, blue,green]; f2 \<noteq> f1; distinct [g1,g2,g3] \<rbrakk> \<Longrightarrow>
        (U, \<Sigma>, N, M, l, b, H, blue, N):UniBS"
apply (drule GarbageN_example2) apply assumption+
  apply (simp add: delete_N'yellowredN)
done

constdefs K'::HP
"K' \<equiv> emp[blue\<mapsto>(C,emp[f1\<mapsto>green][f2\<mapsto>yellow])][yellow\<mapsto>(D,emp[g1\<mapsto>yellow][g2\<mapsto>blue][g3\<mapsto>red])]"

lemma GarbageHP_example:
   "\<lbrakk> (U, \<Sigma>, N, M, l, b, K', blue, N') : UniBS; 
      distinct [yellow,red, blue,green]; f2 \<noteq> f1; distinct [g1,g2,g3] \<rbrakk> \<Longrightarrow>
        (U, \<Sigma>, N, M, l, b, delete K' yellow, blue, N'):UniBS"
apply (erule_tac d=yellow in UniBS_StaticGarbageHP)
apply (simp add: DOM_def AL_cod_emp AL_dom_delete K'_def) apply clarsimp
  apply (drule AbsFieldsD) apply clarsimp
  apply (drule AL_delete6) apply clarsimp
  apply (drule AL_upd_split, clarsimp) apply (erule disjE, clarsimp)
  apply (drule AL_upd_split, clarsimp) apply (erule disjE, clarsimp)
    apply (drule AL_upd_split, clarsimp) apply (erule disjE) apply clarsimp defer
    apply clarsimp apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
  apply (simp add: AL_emp1)
apply (simp add: \<Sigma>_def H_def K'_def AL_dom_def) apply clarsimp
  apply (drule AL_upd_split, clarsimp)
  apply (erule disjE, clarsimp)
    apply (rule, rule, rule AL_delete5) apply fastsimp
    apply (rule AL_update5) apply (rule AL_update1) apply assumption
  apply (simp add: AL_emp1)
apply (simp add: N'_def)
  apply (rule contained_transitive)
    prefer 2 apply (rule contained_upd) apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
    apply (rule contained_upd) apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
apply (simp add: DOM_def H_def \<Sigma>_def AL_cod_emp AL_dom_upd1 AL_dom_emp)
  apply clarsimp 
  apply (drule AbsFieldsD, clarsimp)
  apply (drule AL_upd_split, simp add: AL_emp1) apply clarsimp
  apply (drule AL_upd_split)
    apply(erule disjE, clarsimp) apply clarsimp
    apply (drule AL_upd_split) apply (simp add: AL_emp1)
apply (simp add: N_def AL_dom_upd1 AL_dom_emp)
apply simp
oops (*proof attempt rightly fails*)

(*<*)
end
(*>*)