(*<*)
theory jlapExampleRelRen1 = ExampleBase:
(*>*) 

subsubsection{*Binary renaming (rule Ren)*} 

consts blue::Colour
       green::Colour
       yellow::Colour
       red::Colour
       bluegreen::Colour
       C::Class
       f1::Field
       f2::Field

constdefs \<Sigma>::STATE
"\<Sigma> \<equiv> ([blue],emp,emp)"
constdefs \<Pi>::STATE
"\<Pi> \<equiv> ([green],emp,emp)"
constdefs N::MP
"N \<equiv> emp[green\<mapsto>intTP][blue\<mapsto>intTP]"

constdefs \<Sigma>'::STATE
"\<Sigma>' \<equiv> ([bluegreen],emp,emp)"
constdefs \<Pi>'::STATE
"\<Pi>' \<equiv> ([bluegreen],emp,emp)"
constdefs N'::MP
"N' \<equiv> emp[bluegreen\<mapsto>intTP]"

constdefs f::Mapping
"f \<equiv> \<lambda> c . if c = green then Some bluegreen else
           if c = blue then Some bluegreen else None"

lemma N_N'_MapN: "\<lbrakk>distinct [blue,green]\<rbrakk> \<Longrightarrow> (N,f,N'):MapN"
apply (simp add: N_def N'_def)
apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp)
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_emp)
    apply (rule MapN_emp) 
    apply (simp add: f_def)
    apply (simp add: AL_emp1)
  apply simp
  apply (simp add: f_def)
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply (simp add: AL_emp1)
  apply (simp add: AL_upd_idempotent)
done

constdefs \<Omega>::STATE
"\<Omega> \<equiv> ([yellow],emp,emp[yellow\<mapsto>(C,emp[f1\<mapsto>red][f2\<mapsto>blue])])"
constdefs \<Xi>::STATE
"\<Xi> \<equiv> ([yellow],emp,emp[yellow\<mapsto>(C,emp[f1\<mapsto>red][f2\<mapsto>green])])"
constdefs NN::MP
"NN \<equiv> emp[green\<mapsto>intTP][blue\<mapsto>intTP][yellow\<mapsto>(classTP C)][red\<mapsto>intTP]"

constdefs \<Omega>'::STATE
"\<Omega>' \<equiv> ([yellow],emp,emp[yellow\<mapsto>(C,emp[f1\<mapsto>red][f2\<mapsto>bluegreen])])"
constdefs \<Xi>'::STATE
"\<Xi>' \<equiv> ([yellow],emp,emp[yellow\<mapsto>(C,emp[f1\<mapsto>red][f2\<mapsto>bluegreen])])"
constdefs NN'::MP
"NN' \<equiv> emp[bluegreen\<mapsto>intTP][yellow\<mapsto>(classTP C)][red\<mapsto>intTP]"

constdefs g::Mapping
"g \<equiv> \<lambda> c . if c = green then Some bluegreen else
           if c = blue then Some bluegreen else 
           if c = yellow then Some yellow else 
           if c = red then Some red else None"

lemma NN_NN'_MapN: "\<lbrakk>distinct [red,yellow,blue,green]; distinct[yellow,bluegreen]\<rbrakk> \<Longrightarrow> (NN,g,NN'):MapN"
apply (simp add: NN_def NN'_def)
apply (rule MapN_cons) apply simp apply (simp add: AL_dom_upd1 AL_dom_emp)
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_emp)
        apply (rule MapN_emp) 
        apply (simp add: g_def)
        apply (simp add: AL_emp1)
        apply simp
      apply (simp add: g_def)
      apply (simp add: AL_update1)
      apply simp
    apply (simp add: g_def)
    apply clarsimp apply (drule AL_upd_split)
      apply clarsimp apply (drule AL_upd_split) 
      apply (simp add: AL_emp1)
    apply simp
  apply (simp add: g_def)
  apply clarsimp apply (drule AL_upd_split)
    apply clarsimp apply (drule AL_upd_split) 
      apply (erule disjE, clarsimp) 
      apply clarsimp apply (drule AL_upd_split) 
        apply (simp add: AL_emp1)
  apply (simp add: AL_upd_idempotent)
done

lemma Ren_Ex1:
   "\<lbrakk> (G, (\<Sigma>,N,\<Pi>), M, l, MM, ll, False, (\<Omega>,NN,\<Xi>)):Typing;
      distinct [red, yellow, blue, green];  distinct[red,yellow,bluegreen]; f2 \<noteq> f1\<rbrakk> \<Longrightarrow>
    (G, (\<Sigma>',N',\<Pi>'), M, l, MM, ll, False, (\<Omega>',NN',\<Xi>')):Typing"
apply (erule_tac f=f and g=g in Ren)
apply (simp add: renState_def)
  apply (rule, rule N_N'_MapN) apply simp
  apply (simp add: Renames_STATE_def \<Sigma>_def \<Sigma>'_def)
    apply (rule, rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def) 
      apply (rule MAP_OPSTACK_emp) apply simp
    apply (rule, rule MAP_STORE_emp)
    apply (rule, rule MapHP_emp)
  apply (simp add: Renames_STATE_def \<Pi>_def \<Pi>'_def)
    apply (rule, rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def) 
      apply (rule MAP_OPSTACK_emp) apply simp
    apply (rule, rule MAP_STORE_emp)
    apply (rule, rule MapHP_emp)
  apply (rule, simp add: f_def N_def dom_def AL_dom_upd1 AL_dom_emp) apply fast
  apply (rule, simp add: f_def ObjIDs_def N_def inj_on_def, clarsimp)
    apply (rule, simp add: AL_update1) apply clarsimp 
    apply (rule, simp add: AL_update1) apply clarsimp 
    apply (drule AL_upd_split) apply clarsimp
    apply (drule_tac c=x in AL_upd_split) apply clarsimp
    apply (simp add: AL_emp1)
  apply (simp add: State_noDangColours_def)
    apply (simp add: N_def AL_dom_def AL_cod_emp AL_dom_emp)
    apply (rule, simp add: AL_update1)
    apply (rule, simp add: AL_emp1)
    apply (rule, simp add: AbsFields_emp)
    apply (rule, simp add: AL_emp1)
    apply (rule, simp add: State_good_def)
      apply (rule, rule AL_EMP)
      apply (rule, rule AL_EMP)
      apply (simp add: HP_good_def AL_emp1)
    apply (rule, rule AL_UPD) apply (rule AL_UPD) apply (rule AL_EMP)
    apply (rule, rule, rule AL_update5) apply(rule AL_update1) apply simp
    apply (rule, simp add: AL_emp1)
    apply (rule, simp add: AbsFields_emp)
    apply (rule, simp add: AL_emp1)
    apply (rule, simp add: State_good_def)
      apply (rule, rule AL_EMP)
      apply (rule, rule AL_EMP)
      apply (simp add: HP_good_def AL_emp1)
    apply (rule AL_UPD) apply (rule AL_UPD) apply (rule AL_EMP)
apply (simp add: renState_def)
  apply (rule, rule NN_NN'_MapN) apply simp apply simp
  apply (simp add: Renames_STATE_def \<Omega>_def \<Omega>'_def)
    apply (rule, rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: g_def) 
      apply (rule MAP_OPSTACK_emp) apply simp
    apply (rule, rule MAP_STORE_emp)
    apply (rule, rule MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp)
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp) 
      apply (simp add: g_def) apply simp
      apply (simp add: g_def) apply simp 
      apply (simp add: g_def) apply simp
  apply (simp add: \<Xi>_def \<Xi>'_def)
    apply (rule, rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: g_def) 
      apply (rule MAP_OPSTACK_emp) apply simp
    apply (rule, rule MAP_STORE_emp)
    apply (rule, rule MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp)
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp) 
      apply (simp add: g_def) apply simp
      apply (simp add: g_def) apply simp 
      apply (simp add: g_def) apply simp
  apply (rule, simp add: g_def NN_def dom_def AL_dom_upd1 AL_dom_emp) apply fast
  apply (rule, simp add: g_def ObjIDs_def NN_def inj_on_def, clarsimp)
    apply (rule, clarsimp)
      apply (drule AL_upd_split) apply clarsimp
      apply (drule_tac c=blue in AL_upd_split) apply clarsimp 
      apply (drule_tac c=blue in AL_upd_split) apply clarsimp 
    apply clarsimp
      apply(rule, clarsimp)
        apply (drule AL_upd_split) apply clarsimp
        apply (drule_tac c=green in AL_upd_split) apply clarsimp 
        apply (drule_tac c=green in AL_upd_split) apply clarsimp 
        apply (drule_tac c=green in AL_upd_split) apply clarsimp 
      apply clarsimp
        apply (drule_tac c=y in AL_upd_split) apply clarsimp 
        apply (drule_tac c=y in AL_upd_split) apply clarsimp 
        apply (drule_tac c=y in AL_upd_split) apply clarsimp 
        apply (drule_tac c=y in AL_upd_split) apply clarsimp 
        apply (simp add: AL_emp1)
  apply (simp add: State_noDangColours_def)
    apply (simp add: NN_def AL_dom_def AL_cod_emp AL_dom_emp)
    apply (rule, rule, rule AL_update5) apply (rule AL_update1) apply fast
    apply (rule, clarsimp) 
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (rule, rule AL_update5) apply (rule AL_update1) apply fast
      apply (simp add: AL_emp1)
    apply (rule, clarsimp) apply(drule AbsFieldsD, clarsimp)
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) 
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (rule, rule AL_update5) apply (rule AL_update5) 
          apply (rule AL_update1) apply fast apply fast
        apply clarsimp
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (rule, rule AL_update1) 
        apply (simp add: AL_emp1)
      apply (simp add: AL_emp1)
    apply (rule, simp add: ObjIDs_def, clarsimp) 
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) apply (rule, rule AL_update5) apply (rule AL_update1) apply fast
      apply (simp add: AL_emp1)
    apply (rule, simp add: State_good_def HP_good_def)
      apply (rule, rule AL_EMP)
      apply (rule, rule AL_UPD, rule AL_EMP)
      apply clarsimp 
      apply (drule AL_upd_split)
      apply (erule disjE, clarsimp) 
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
        apply (simp add: AL_dom_upd1 AL_dom_emp, clarsimp)
          apply (drule AL_cod_split) apply clarsimp
          apply (drule AL_cod_split) apply clarsimp
          apply (simp add: AL_cod_emp)
        apply (simp add: AL_emp1)
    apply (rule, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
    apply (rule, clarsimp)
      apply (rule, rule AL_update5) apply (rule AL_update1) apply fast
    apply (rule, clarsimp)
      apply (drule AL_upd_split)     
      apply (erule disjE, clarsimp) apply (rule, rule AL_update5) apply (rule AL_update1)  apply fast
      apply (simp add: AL_emp1)
    apply (rule, clarsimp) apply (drule AbsFieldsD, clarsimp)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) 
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp)
            apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
            apply fast apply fast apply fast
          apply clarsimp
          apply (drule AL_upd_split)
          apply (erule disjE, clarsimp) apply (rule, rule AL_update1) 
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
    apply (rule, simp add: ObjIDs_def, clarsimp)
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) apply (rule, rule AL_update5, rule AL_update1) apply fast
        apply (simp add: AL_emp1)
    apply (rule, simp add: State_good_def HP_good_def)
      apply (rule, rule AL_EMP)
      apply (rule, rule AL_UPD) apply (rule AL_EMP)
      apply clarsimp
        apply (drule AL_upd_split)
        apply (erule disjE, clarsimp) 
          apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP)
          apply (simp add: AL_dom_upd1 AL_dom_emp, clarsimp)
          apply (drule AL_cod_split)
          apply (erule disjE)
            apply (drule AL_cod_split) apply (simp add: AL_cod_emp)
          apply assumption
        apply (simp add: AL_emp1)
    apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
  apply (simp add: f_def g_def)
  apply (simp add: f_def g_def inj_on_def dom_def, clarsimp)
  apply (simp add: f_def g_def Img_def dom_def)
    apply (rule, rule, clarsimp)
      apply (case_tac "sa=blue", clarsimp) apply clarsimp
    apply fast
done

(*<*)
end
(*>*)