(*<*)
theory jlapExampleUniRen2 = ExampleBase:
(*>*) 

subsubsection{*Rule UniRen*} 


consts blue::Colour
       green::Colour
       yellow::Colour
       red::Colour
       brown::Colour
       pink::Colour
       C::Class
       f1::Field
       f2::Field

constdefs \<Sigma>::STATE
"\<Sigma> \<equiv> ([blue,pink],emp,emp[blue\<mapsto>(C,emp[f1\<mapsto>green])])"
constdefs N::MP
"N \<equiv> emp[green\<mapsto>intTP][pink\<mapsto>intTP][blue\<mapsto>(classTP C)]"
constdefs \<Pi>::STATE
"\<Pi> \<equiv> ([yellow,pink],emp,emp[blue\<mapsto>(C,emp[f1\<mapsto>green])][yellow\<mapsto>(C,emp[f1\<mapsto>red][f2\<mapsto>brown])])"
constdefs N'::MP
"N' \<equiv> N[red\<mapsto>intTP][brown\<mapsto>intTP][yellow\<mapsto>(classTP C)]"

consts fblue::Colour
       fgreen::Colour
       fpink::Colour
       gyellow::Colour
       gred::Colour
       gbrown::Colour

constdefs f::Mapping
"f \<equiv> \<lambda> c . if c = green then Some fgreen else
           if c = blue then Some fblue else 
           if c = pink then Some fpink else None"

constdefs g::Mapping
"g \<equiv> \<lambda> c . if c = green then Some fgreen else
           if c = blue then Some fblue else  
           if c = pink then Some fpink else
           if c = yellow then Some gyellow else
           if c = red then Some gred else 
           if c = brown then Some gbrown else None"

constdefs fN::MP
"fN \<equiv> emp[fgreen\<mapsto>intTP][fpink\<mapsto>intTP][fblue\<mapsto>(classTP C)]"

lemma N_fN_MapN: "\<lbrakk>distinct [pink,blue,green]; distinct [fblue,fgreen]; fpink \<noteq>fblue\<rbrakk> \<Longrightarrow> (N,f,fN):MapN"
apply (simp add: N_def fN_def)
apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp)
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp)
    apply (rule MapN_emp) 
    apply (simp add: f_def)
    apply (simp add: AL_emp1)
  apply simp
  apply (simp add: f_def)
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply (simp add: AL_emp1)
  apply simp
  apply (simp add: f_def)
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply clarsimp
  apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply clarsimp apply (simp add: AL_emp1)
  apply simp
done

constdefs f\<Sigma>::STATE
"f\<Sigma> \<equiv> ([fblue,fpink],emp,emp[fblue\<mapsto>(C,emp[f1\<mapsto>fgreen])])"

constdefs gN'::MP
"gN' \<equiv> fN[gred\<mapsto>intTP][gbrown\<mapsto>intTP][gyellow\<mapsto>(classTP C)]"

constdefs g\<Pi>::STATE
"g\<Pi> \<equiv> ([gyellow,fpink],emp,emp[fblue\<mapsto>(C,emp[f1\<mapsto>fgreen])][gyellow\<mapsto>(C,emp[f1\<mapsto>gred][f2\<mapsto>gbrown])])"

lemma N'_gN'_MapN:"\<lbrakk>distinct [red,yellow,pink,blue,green, brown];
                     fblue \<noteq> fgreen; gred \<noteq> fblue; 
                     gbrown \<noteq> fblue; gyellow \<noteq>  gbrown; 
                     gyellow \<noteq> gred; gyellow \<noteq> fgreen; 
                     fpink \<noteq> fblue; gyellow \<noteq> fpink\<rbrakk> \<Longrightarrow> (N',g,gN'):MapN"
apply (simp add: N_def N'_def gN'_def)
apply (rule MapN_cons) apply simp apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp) 
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp) apply fastsimp
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp)
  apply (rule MapN_cons) apply simp  apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule MapN_emp) 
    apply (simp add: g_def)
    apply (simp add: AL_emp1)
  apply simp
  apply (simp add: g_def)
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply (simp add: AL_emp1)
  apply simp
  apply (simp add: g_def)
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply (simp add: AL_emp1)
  apply simp
  apply (simp add: g_def)
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply (simp add: AL_emp1)
  apply simp
  apply (simp add: g_def)
  apply clarsimp apply rule prefer 2
  apply clarsimp apply rule prefer 2 
  apply clarsimp apply rule prefer 2 
  apply clarsimp apply rule prefer 2  
  apply clarsimp apply rule prefer 2 apply clarsimp apply fast 
  apply fastsimp apply fastsimp apply fastsimp apply fastsimp apply fastsimp
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply (simp add: AL_emp1)
  apply simp
  apply (simp add: g_def)
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp 
  apply clarsimp apply (drule AL_upd_split)
    apply (erule disjE) apply simp apply (simp add: AL_emp1)
  apply clarsimp
  apply (simp add: fN_def)
done

lemma UniRen_FPinkNotFGreen:
   "\<lbrakk> (U, \<Sigma>, N, M, l, \<Pi>, N', L) : UniSS; 
      distinct [yellow,red,brown, pink, blue,green]; 
                     fblue \<noteq> fgreen; gred \<noteq> fblue; 
                     gbrown \<noteq> fblue; gbrown \<noteq> fgreen; gyellow \<noteq>  gbrown; gyellow \<noteq> fblue;
                     gyellow \<noteq> gred; gyellow \<noteq> fgreen; gbrown \<noteq> gred; gred\<noteq> fgreen; 
                     fpink \<noteq> fblue; gyellow \<noteq> fpink; fpink \<noteq> fgreen; gred \<noteq> fpink; gbrown \<noteq> fpink; f2 \<noteq> f1 \<rbrakk> \<Longrightarrow>
        (U, f\<Sigma>, fN, M, l, g\<Pi>, gN', L):UniSS"
apply (rule UniRen) prefer 6 apply assumption
apply (simp add: renUniState_def) 
  apply rule apply (rule N_fN_MapN) apply fastsimp apply fastsimp apply assumption 
  apply (rule, simp add: Renames_STATE_def \<Sigma>_def f\<Sigma>_def) 
    apply rule apply (rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def)
               apply (rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def)
               apply (rule MAP_OPSTACK_emp) apply simp apply simp
    apply rule apply (rule MAP_STORE_emp) 
    apply (rule MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp) 
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
        apply (simp add: f_def) apply simp
      apply (simp add: f_def)
    apply simp
apply (rule, simp add: f_def dom_def N_def AL_dom_upd1 AL_dom_emp) 
     apply (rule, rule) apply clarsimp apply rule apply clarsimp
apply (rule, simp add: inj_on_def f_def ObjIDs_def N_def)
  apply clarsimp
  apply (rule, clarsimp) apply clarsimp
  apply (rule, clarsimp)
    apply (rule, clarsimp) apply clarsimp 
    apply clarsimp apply (drule AL_upd_split) apply clarsimp
       apply (drule_tac c=x in AL_upd_split) apply clarsimp
       apply (drule_tac c=x in AL_upd_split) apply clarsimp apply (simp add: AL_emp1)
apply (simp add:  State_noDangColours_def \<Sigma>_def N_def AL_dom_upd1 AL_dom_emp AL_cod_emp)
  apply (rule, clarsimp) apply (drule AbsFieldsD) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp  
     apply (simp add: AL_emp1)
     apply (simp add: AL_emp1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update1)
  apply (rule, simp add: State_good_def)
    apply (rule, rule AL_EMP)
    apply (rule, rule AL_UPD, rule AL_EMP)
    apply (simp add: HP_good_def, clarsimp)
      apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4, rule AL_update4) apply(rule AL_update1) apply assumption apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
     apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
apply (simp add: renUniState_def, clarsimp) 
  apply rule apply (rule N'_gN'_MapN) apply fastsimp apply simp+
  apply (rule, simp add: Renames_STATE_def \<Pi>_def g\<Pi>_def) 
    apply rule apply (rule_tac fd=gyellow in MAP_OPSTACK_cons) apply fastsimp   
                 apply (simp add: g_def)
               apply (rule_tac fd=fpink in MAP_OPSTACK_cons) apply fastsimp   
                 apply (simp add: g_def) 
               apply (rule MAP_OPSTACK_emp) apply simp apply simp
    apply rule apply (rule MAP_STORE_emp) 
    apply (rule_tac fc=gyellow in MapHP_cons) apply fastsimp 
         apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule_tac fc=fblue in MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp) 
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
        apply (simp add: g_def) apply simp
      apply (simp add: g_def)
    apply simp
      apply (rule_tac fc=gbrown in Map_Fields_cons) apply fastsimp 
         apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule_tac fc=gred in Map_Fields_cons) apply fastsimp 
         apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
     apply (simp add: g_def) apply fastsimp
    apply simp
     apply (simp add: g_def) apply fastsimp
    apply simp
     apply (simp add: g_def) apply fastsimp
  apply (rule, simp add: N_def N'_def g_def dom_def AL_dom_def)
    apply (rule, clarsimp) apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split) apply (erule disjE, simp) apply(simp add: AL_emp1)
    apply clarsimp
      apply (case_tac "x=yellow", clarsimp) apply (rule, rule AL_update1)
      apply (case_tac "x=brown", clarsimp) apply (rule, rule AL_update5, rule AL_update1)
          apply fastsimp
      apply clarsimp
      apply (case_tac "x=red", clarsimp) 
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp
      apply clarsimp
      apply (case_tac "x=blue", clarsimp) 
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp
      apply clarsimp
      apply (case_tac "x=pink", clarsimp) 
      apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp apply fastsimp
      apply clarsimp
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp apply fastsimp apply fastsimp
apply (rule, simp add: inj_on_def f_def ObjIDs_def N_def N'_def)
  apply clarsimp
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (erule disjE, clarsimp)
      apply (erule disjE, clarsimp) apply clarsimp
      apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (erule disjE, clarsimp) apply (simp add: g_def) apply clarsimp
      apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
    apply clarsimp
    apply (erule disjE, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
     apply (erule disjE, clarsimp) apply (simp add: g_def) apply clarsimp
    apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
     apply clarsimp 
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (erule disjE, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (erule disjE, clarsimp) apply clarsimp
      apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1) apply clarsimp
      apply (drule_tac c=x in AL_upd_split, clarsimp) 
      apply (drule_tac c=x in AL_upd_split, clarsimp) apply (simp add: AL_emp1)
apply (simp add:  State_noDangColours_def \<Pi>_def N'_def N_def AL_dom_upd1 AL_dom_emp AL_cod_emp)
  apply (rule, clarsimp) apply (drule AbsFieldsD) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp apply clarsimp
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (simp add: AL_emp1)
     apply clarsimp
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (simp add: AL_emp1)
     apply (simp add: AL_emp1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update5) 
    apply (rule AL_update5, rule AL_update5, rule AL_update1) apply fastsimp apply fastsimp
       apply fastsimp
  apply (rule, simp add: State_good_def)
    apply (rule, rule AL_EMP)
    apply (rule, (rule AL_UPD)+, rule AL_EMP)
    apply (simp add: HP_good_def, clarsimp)
      apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4) apply(rule AL_update1) apply assumption apply clarsimp
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4) apply (rule AL_update4) apply(rule AL_update1) 
             apply fastsimp apply assumption
          apply (simp add: AL_emp1)
      apply clarsimp apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4,rule AL_update4,rule AL_update4,rule AL_update4) 
            apply(rule AL_update4, rule AL_update1) apply assumption+ apply clarsimp
          apply (simp add: AL_emp1)
          apply (simp add: AL_emp1)
     apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD,  rule AL_UPD, rule AL_EMP) 
apply (simp add: f_def g_def)   
apply (simp add: inj_on_def g_def f_def dom_def)
  apply clarsimp
  apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp)
  apply clarsimp
  apply (erule disjE, clarsimp) apply clarsimp
  apply clarsimp
  apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp) apply clarsimp
  apply clarsimp
  apply clarsimp
apply (simp add: Img_def g_def f_def dom_def) 
  apply (rule, rule) apply clarsimp
    apply (case_tac "sa=pink", clarsimp) apply clarsimp
      apply (case_tac "sa=blue", clarsimp) apply clarsimp
  apply fast
done

lemma UniRen_FPink_Is_FGreen:
   "\<lbrakk> (U, \<Sigma>, N, M, l, \<Pi>, N', L) : UniSS; 
      distinct [yellow,red,brown, pink, blue,green]; 
                     fblue \<noteq> fgreen; gred \<noteq> fblue; 
                     gbrown \<noteq> fblue; gbrown \<noteq> fgreen; gyellow \<noteq>  gbrown; gyellow \<noteq> fblue;
                     gyellow \<noteq> gred; gyellow \<noteq> fgreen; gbrown \<noteq> gred; gred\<noteq> fgreen; 
                     fpink \<noteq> fblue; gyellow \<noteq> fpink; fpink = fgreen; gred \<noteq> fpink; gbrown \<noteq> fpink; f2 \<noteq> f1 \<rbrakk> \<Longrightarrow>
        (U, f\<Sigma>, fN, M, l, g\<Pi>, gN', L):UniSS"
apply (rule UniRen) prefer 6 apply assumption
apply (simp add: renUniState_def) 
  apply rule apply (rule N_fN_MapN) apply fastsimp apply fastsimp apply fastsimp 
  apply (rule, simp add: Renames_STATE_def \<Sigma>_def f\<Sigma>_def) 
    apply rule apply (rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def)
               apply (rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def)
               apply (rule MAP_OPSTACK_emp) apply simp apply simp
    apply rule apply (rule MAP_STORE_emp) 
    apply (rule MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp) 
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
        apply (simp add: f_def) apply simp
      apply (simp add: f_def)
    apply simp
apply (rule, simp add: f_def dom_def N_def AL_dom_upd1 AL_dom_emp) 
     apply (rule, rule) apply clarsimp apply rule apply clarsimp
apply (rule, simp add: inj_on_def f_def ObjIDs_def N_def)
  apply clarsimp
  apply (rule, clarsimp) apply (drule_tac c=pink in AL_upd_split) apply clarsimp 
    apply (drule_tac c=pink in AL_upd_split) apply clarsimp apply clarsimp 
  apply (rule, clarsimp) apply (drule_tac c=pink in AL_upd_split) apply clarsimp 
    apply (drule_tac c=pink in AL_upd_split) apply clarsimp apply clarsimp 
    apply (drule AL_upd_split) apply clarsimp
       apply (drule_tac c=x in AL_upd_split) apply clarsimp
       apply (drule_tac c=x in AL_upd_split) apply clarsimp apply (simp add: AL_emp1)
apply (simp add:  State_noDangColours_def \<Sigma>_def N_def AL_dom_upd1 AL_dom_emp AL_cod_emp)
  apply (rule, clarsimp) apply (drule AbsFieldsD) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp  
     apply (simp add: AL_emp1)
     apply (simp add: AL_emp1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update1)
  apply (rule, simp add: State_good_def)
    apply (rule, rule AL_EMP)
    apply (rule, rule AL_UPD, rule AL_EMP)
    apply (simp add: HP_good_def, clarsimp)
      apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4, rule AL_update4) apply(rule AL_update1) apply assumption apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
     apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
apply (simp add: renUniState_def, clarsimp) 
  apply rule apply (rule N'_gN'_MapN) apply fastsimp apply simp+
  apply (rule, simp add: Renames_STATE_def \<Pi>_def g\<Pi>_def) 
    apply rule apply (rule_tac fd=gyellow in MAP_OPSTACK_cons) apply fastsimp   
                 apply (simp add: g_def)
               apply (rule_tac fd=fpink in MAP_OPSTACK_cons) apply fastsimp   
                 apply (simp add: g_def) 
               apply (rule MAP_OPSTACK_emp) apply simp apply simp
    apply rule apply (rule MAP_STORE_emp) 
    apply (rule_tac fc=gyellow in MapHP_cons) apply fastsimp 
         apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule_tac fc=fblue in MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp) 
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
        apply (simp add: g_def) apply simp
      apply (simp add: g_def)
    apply simp
      apply (rule_tac fc=gbrown in Map_Fields_cons) apply fastsimp 
         apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule_tac fc=gred in Map_Fields_cons) apply fastsimp 
         apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
     apply (simp add: g_def) apply fastsimp
    apply simp
     apply (simp add: g_def) apply fastsimp
    apply simp
     apply (simp add: g_def) apply fastsimp
  apply (rule, simp add: N_def N'_def g_def dom_def AL_dom_def)
    apply (rule, clarsimp) apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split) apply (erule disjE, simp) apply(simp add: AL_emp1)
    apply clarsimp
      apply (case_tac "x=yellow", clarsimp) apply (rule, rule AL_update1)
      apply (case_tac "x=brown", clarsimp) apply (rule, rule AL_update5, rule AL_update1)
          apply fastsimp
      apply clarsimp
      apply (case_tac "x=red", clarsimp) 
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp
      apply clarsimp
      apply (case_tac "x=blue", clarsimp) 
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp
      apply clarsimp
      apply (case_tac "x=pink", clarsimp) 
      apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp apply fastsimp
      apply clarsimp
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp apply fastsimp apply fastsimp
apply (rule, simp add: inj_on_def f_def ObjIDs_def N_def N'_def)
  apply clarsimp
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (erule disjE, clarsimp)
      apply (erule disjE, clarsimp) apply clarsimp
      apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (erule disjE, clarsimp) apply (simp add: g_def) apply clarsimp
      apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
    apply clarsimp
    apply (erule disjE, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
     apply (erule disjE, clarsimp) apply (simp add: g_def) apply clarsimp
    apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
     apply clarsimp 
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (erule disjE, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (erule disjE, clarsimp) apply clarsimp
      apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1) apply clarsimp
      apply (drule_tac c=x in AL_upd_split, clarsimp) 
      apply (drule_tac c=x in AL_upd_split, clarsimp) apply (simp add: AL_emp1)
apply (simp add:  State_noDangColours_def \<Pi>_def N'_def N_def AL_dom_upd1 AL_dom_emp AL_cod_emp)
  apply (rule, clarsimp) apply (drule AbsFieldsD) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp apply clarsimp
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (simp add: AL_emp1)
     apply clarsimp
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (simp add: AL_emp1)
     apply (simp add: AL_emp1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update5) 
    apply (rule AL_update5, rule AL_update5, rule AL_update1) apply fastsimp apply fastsimp
       apply fastsimp
  apply (rule, simp add: State_good_def)
    apply (rule, rule AL_EMP)
    apply (rule, (rule AL_UPD)+, rule AL_EMP)
    apply (simp add: HP_good_def, clarsimp)
      apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4) apply(rule AL_update1) apply assumption apply clarsimp
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4) apply (rule AL_update4) apply(rule AL_update1) 
             apply fastsimp apply assumption
          apply (simp add: AL_emp1)
      apply clarsimp apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4,rule AL_update4,rule AL_update4,rule AL_update4) 
            apply(rule AL_update4, rule AL_update1) apply assumption+ apply clarsimp
          apply (simp add: AL_emp1)
          apply (simp add: AL_emp1)
     apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD,  rule AL_UPD, rule AL_EMP) 
apply (simp add: f_def g_def)   
apply (simp add: inj_on_def g_def f_def dom_def)
  apply clarsimp
  apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp)
  apply clarsimp
  apply (erule disjE, clarsimp) apply clarsimp
  apply clarsimp
  apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp) apply clarsimp
  apply clarsimp
  apply clarsimp
apply (simp add: Img_def g_def f_def dom_def) 
  apply (rule, rule) apply clarsimp
    apply (case_tac "sa=pink", clarsimp) apply clarsimp
      apply (case_tac "sa=blue", clarsimp) apply clarsimp
  apply fast
done


lemma UniRen_FPink_Is_FGreen_IdElsewhere:
   "\<lbrakk> (U, \<Sigma>, N, M, l, \<Pi>, N', L) : UniSS; 
      distinct [yellow,red,brown, pink, blue,green,fgreen]; 
                fblue = blue; fgreen = fpink; gred = red; 
                     gbrown = brown; gyellow = yellow; f2 \<noteq> f1 \<rbrakk> \<Longrightarrow>
        (U, f\<Sigma>, fN, M, l, g\<Pi>, gN', L):UniSS"
apply (rule UniRen) prefer 6 apply assumption
apply (simp add: renUniState_def) 
  apply rule apply (rule N_fN_MapN) apply fastsimp apply fastsimp apply fastsimp 
  apply (rule, simp add: Renames_STATE_def \<Sigma>_def f\<Sigma>_def) 
    apply rule apply (rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def)
               apply (rule MAP_OPSTACK_cons) apply fastsimp apply (simp add: f_def)
               apply (rule MAP_OPSTACK_emp) apply simp apply simp
    apply rule apply (rule MAP_STORE_emp) 
    apply (rule MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp) 
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
        apply (simp add: f_def) apply simp
      apply (simp add: f_def)
    apply simp
apply (rule, simp add: f_def dom_def N_def AL_dom_upd1 AL_dom_emp) 
     apply (rule, rule) apply clarsimp apply rule apply clarsimp
apply (rule, simp add: inj_on_def f_def ObjIDs_def N_def)
  apply clarsimp
  apply (rule, clarsimp) apply (drule_tac c=pink in AL_upd_split) apply clarsimp 
    apply (drule_tac c=pink in AL_upd_split) apply clarsimp apply clarsimp 
  apply (rule, clarsimp) 
    apply (rule, clarsimp) 
      apply (drule_tac c=pink in AL_upd_split) apply clarsimp 
      apply (drule_tac c=pink in AL_upd_split) apply clarsimp apply clarsimp 
    apply clarsimp
      apply (drule AL_upd_split) apply clarsimp
       apply (drule_tac c=x in AL_upd_split) apply clarsimp
       apply (drule_tac c=x in AL_upd_split) apply clarsimp apply (simp add: AL_emp1)
apply (simp add:  State_noDangColours_def \<Sigma>_def N_def AL_dom_upd1 AL_dom_emp AL_cod_emp)
  apply (rule, clarsimp) apply (drule AbsFieldsD) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp  
     apply (simp add: AL_emp1)
     apply (simp add: AL_emp1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update1)
  apply (rule, simp add: State_good_def)
    apply (rule, rule AL_EMP)
    apply (rule, rule AL_UPD, rule AL_EMP)
    apply (simp add: HP_good_def, clarsimp)
      apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4, rule AL_update4) 
            apply(rule AL_update1) apply assumption apply assumption
          apply (simp add: AL_emp1)
        apply (simp add: AL_emp1)
     apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_EMP)
apply (simp add: renUniState_def, clarsimp) 
  apply rule apply (rule N'_gN'_MapN) apply fastsimp apply simp+ apply fastsimp apply fastsimp
  apply (rule, simp add: Renames_STATE_def \<Pi>_def g\<Pi>_def) 
    apply rule apply (rule_tac fd=gyellow in MAP_OPSTACK_cons) apply fastsimp   
                 apply (simp add: g_def)
               apply (rule_tac fd=fpink in MAP_OPSTACK_cons) apply fastsimp   
                 apply (simp add: g_def) 
               apply (rule MAP_OPSTACK_emp) apply simp apply simp
    apply rule apply (rule MAP_STORE_emp) 
    apply (rule_tac fc=gyellow in MapHP_cons) apply fastsimp 
         apply (simp add: AL_dom_upd1 AL_dom_emp) 
    apply (rule_tac fc=fblue in MapHP_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule MapHP_emp) 
      apply (rule Map_Fields_cons) apply fastsimp apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
        apply (simp add: g_def) apply simp
      apply (simp add: g_def)
    apply simp
      apply (rule_tac fc=gbrown in Map_Fields_cons) apply fastsimp 
         apply (simp add: AL_dom_upd1 AL_dom_emp)
      apply (rule_tac fc=gred in Map_Fields_cons) apply fastsimp 
         apply (simp add: AL_dom_emp)
      apply (rule Map_Fields_emp)
     apply (simp add: g_def) apply fastsimp
    apply simp
     apply (simp add: g_def) apply fastsimp
    apply simp
     apply (simp add: g_def) apply fastsimp
  apply (rule, simp add: N_def N'_def g_def dom_def AL_dom_def)
    apply (rule, clarsimp) apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split, clarsimp)
       apply (drule AL_upd_split) apply (erule disjE, simp) apply(simp add: AL_emp1)
    apply clarsimp
      apply (case_tac "x=yellow", clarsimp) apply (rule, rule AL_update1)
      apply (case_tac "x=brown", clarsimp) apply (rule, rule AL_update5, rule AL_update1)
          apply fastsimp
      apply clarsimp
      apply (case_tac "x=red", clarsimp) 
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp
      apply clarsimp
      apply (case_tac "x=blue", clarsimp) 
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp
      apply clarsimp
      apply (case_tac "x=pink", clarsimp) 
      apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp apply fastsimp
      apply clarsimp
        apply (rule, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update5, rule AL_update1)
          apply fastsimp apply fastsimp apply fastsimp apply fastsimp apply fastsimp
apply (rule, simp add: inj_on_def f_def ObjIDs_def N_def N'_def)
  apply clarsimp
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (erule disjE, clarsimp)
      apply (erule disjE, clarsimp) apply clarsimp
      apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (erule disjE, clarsimp) apply (simp add: g_def) apply clarsimp
      apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
    apply clarsimp
    apply (erule disjE, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
      apply (drule AL_upd_split, clarsimp)
     apply (erule disjE, clarsimp) apply (simp add: g_def) apply clarsimp
    apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1)
     apply clarsimp 
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (drule AL_upd_split, clarsimp)
    apply (erule disjE, clarsimp)
      apply (drule AL_upd_split, clarsimp)
      apply (erule disjE, clarsimp) apply clarsimp
      apply (drule AL_upd_split, clarsimp) 
      apply (drule AL_upd_split, clarsimp) apply (simp add: AL_emp1) apply clarsimp
      apply (drule_tac c=x in AL_upd_split, clarsimp) 
      apply (drule_tac c=x in AL_upd_split, clarsimp) apply (simp add: AL_emp1)
apply (simp add:  State_noDangColours_def \<Pi>_def N'_def N_def AL_dom_upd1 AL_dom_emp AL_cod_emp)
  apply (rule, clarsimp) apply (drule AbsFieldsD) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp apply clarsimp
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (simp add: AL_emp1)
     apply clarsimp
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (drule AL_upd_split, erule disjE) apply clarsimp 
     apply (simp add: AL_emp1)
     apply (simp add: AL_emp1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update1)
  apply (rule, simp add: ObjIDs_def) apply (rule, rule AL_update5) 
    apply (rule AL_update5, rule AL_update5, rule AL_update1) apply fastsimp apply fastsimp
       apply fastsimp
  apply (rule, simp add: State_good_def)
    apply (rule, rule AL_EMP)
    apply (rule, (rule AL_UPD)+, rule AL_EMP)
    apply (simp add: HP_good_def, clarsimp)
      apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4) apply(rule AL_update1) apply assumption apply clarsimp
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4) apply (rule AL_update4) apply(rule AL_update1) 
             apply fastsimp apply assumption
          apply (simp add: AL_emp1)
      apply clarsimp apply (drule AL_upd_split, erule disjE) apply clarsimp
        apply (rule, rule AL_UPD, rule AL_EMP) 
        apply (simp add: AL_cod_def AL_dom_def, clarsimp)
        apply (drule AL_upd_split, erule disjE) apply clarsimp 
          apply (rule, rule AL_update4,rule AL_update4,rule AL_update4,rule AL_update4) 
            apply(rule AL_update4, rule AL_update1) apply assumption+ apply clarsimp
          apply (simp add: AL_emp1)
          apply (simp add: AL_emp1)
     apply (rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD, rule AL_UPD,  rule AL_UPD, rule AL_EMP) 
apply (simp add: f_def g_def)   
apply (simp add: inj_on_def g_def f_def dom_def)
  apply clarsimp
apply (simp add: Img_def g_def f_def dom_def) 
  apply (rule, rule) apply clarsimp
    apply (case_tac "sa=pink", clarsimp) apply clarsimp
      apply (case_tac "sa=blue", clarsimp) apply clarsimp
  apply fast
done

(*<*)
end
(*>*)