theory INSTR_GET = UniSatSec:

lemma State_welldef_Get1:
  "\<lbrakk> State_welldef (c # S, \<Gamma>, HH) N; H\<down>c = Some (C, F); F\<down>f = Some d; AL_sum H Ha HH\<rbrakk>
    \<Longrightarrow> State_welldef (d # S, \<Gamma>, HH) N"
apply (simp add: State_welldef_def, clarsimp)
  apply (rule, rule_tac X="AbsFields HH" in SetTriv) 
                               apply (drule AL_sum3, assumption) apply (erule AbsFieldsI) apply assumption 
                             apply assumption 
  apply (rule, rule_tac Y="insert c (set S \<union> AL_cod \<Gamma> \<union> AbsFields HH) \<inter> ObjIDs N" in SetTriv101)
    apply (rule, clarsimp) 
    apply (subgoal_tac "d:AbsFields HH", clarsimp) 
    apply (drule AL_sum3, assumption) apply (erule AbsFieldsI) apply assumption
   apply assumption
apply (simp add: State_good_def)
done

lemma Values_Represented_GET:
  "\<lbrakk> bf\<down>c = Some (C, F); F\<down>f = Some d; bd\<down>ay = Some (D, Flds);
     Flds\<down>f = Some va;  I c = Some ay\<rbrakk>
   \<Longrightarrow> Values_Represented ca (d # S, \<Gamma>, bf) (va # ops, aj, bd) I \<subseteq> 
       Values_Represented ca (c # S, \<Gamma>, bf) (RVal (Loc ay) # ops, aj, bd) I"
apply (simp add: Values_Represented_def)
apply (rule, simp add: OpsValues_Represented_def, clarsimp)
  apply (case_tac n, clarsimp)
    apply (simp add: FieldValues_Represented_def, clarsimp)
  apply (rule_tac x="Suc nat" in exI, simp)
apply (rule, fast)
apply (rule, simp add: AddrValues_Represented_def, clarsimp)
apply (simp add: FieldValues_Represented_def, clarsimp)
done

lemma Get_unisat:
  "\<lbrakk> unisat (RVal (Loc ay) # ops, aj, h) (c # S, \<Gamma>, bf) ao I;
     H\<down>c = Some (C, F); F\<down>f = Some d; h\<down>ay = Some (D, Flds); Flds\<down>f = Some va; 
     AL_sum H Ha bf\<rbrakk>
  \<Longrightarrow> unisat (va # ops, aj, h) (d # S, \<Gamma>, bf) ao I"
apply (frule AL_sum3, assumption)
apply (simp add: unisat_def, clarsimp)
apply (frule_tac n=0 in State_welldef_OPS_lookup) apply simp apply clarsimp
apply (subgoal_tac "\<exists> Ca . tp = classTP Ca")
prefer 2 apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
         apply (simp add: State_typecorrect_def, clarsimp)
         apply (simp add: Opstack_typecorrect_def)
         apply (erule_tac x=0 in allE, clarsimp)
apply clarsimp
apply (subgoal_tac "I c = Some ay") 
prefer 2 apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
        apply (simp add: uniqueValues_def)
             apply (erule_tac x=c in allE, erule impE) apply (simp add: DOM_def) 
        apply clarsimp
        apply (subgoal_tac "RVal (Loc ay) : Values_Represented c (c # S, \<Gamma>, bf) (RVal (Loc ay) # ops, aj, h) I") 
          prefer 2 apply (subgoal_tac "RVal (Loc ay) : ValuesRepresented c (c # S, \<Gamma>, bf) (RVal (Loc ay) # ops, aj, h) I")  
                   apply (simp add: ValRepEQ) apply (rule ValuesRepresented2)
        apply (subgoal_tac "Values_Represented c (c # S, \<Gamma>, bf) (RVal (Loc ay) # ops, aj, h) I = {v}")
        prefer 2 apply (simp add: ValRepEQ)
        apply (drule SetTrivPut2, assumption)
        apply clarsimp
        apply (simp add: State_typecorrect_def Heap_typecorrect_expand, clarsimp)
             apply (erule_tac x=c in allE, erule_tac x=C in allE, erule_tac x=F in allE, clarsimp)
        apply (subgoal_tac "RVal(Loc a) : Values_Represented c (c # S, \<Gamma>, bf) (RVal (Loc ay) # ops, aj, h) I")
          apply (drule SetTrivPut2, assumption)
          apply clarsimp
        apply (rotate_tac 11) apply (erule thin_rl, erule thin_rl)
        apply (simp add: Values_Represented_def) 
        apply (rule disjI2, rule disjI2, rule disjI1) 
        apply (simp add: AddrValues_Represented_def) apply (erule AL_domI)
apply (rule, erule State_welldef_Get1, assumption+)
apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
  apply (subgoal_tac "State_typecorrect ao (d # S, \<Gamma>, bf) (va # ops, aj, h) I", rule, assumption)
  prefer 2 apply (simp add: State_typecorrect_def, clarsimp)
    apply (simp add: Opstack_typecorrect_def, clarsimp)
    apply (case_tac n, clarsimp) 
      apply ( simp add: Heap_typecorrect_def) 
        apply (erule_tac x=c in allE, erule impE) apply (erule AL_domI)
        apply clarsimp
        apply (simp add: HeapAbstractsAt_def) apply clarsimp
        apply (simp add: Fields_typecorrect_def) apply (erule_tac x=f in allE, clarsimp)
      apply clarsimp apply (erule_tac x="Suc nat" in allE, clarsimp)
    apply (subgoal_tac "DOM (d # S, \<Gamma>, bf) \<subseteq> DOM (c # S, \<Gamma>, bf)")
    prefer 2 apply (simp add: DOM_def, rule, clarsimp)
           apply (drule AbsFieldsI) apply assumption
           apply (drule AL_sum_absFields, assumption) apply simp
           apply fast
    apply (rule, simp add: uniqueValues_def, clarsimp)
      apply (subgoal_tac "\<exists>v. Values_Represented ca (d # S, \<Gamma>, bf) (va # ops, aj, h) I = {v}",simp add:ValRepEQ) 
      apply (rule SetTrivUnique)             
        apply (erule State_typecorrect_VR_notEmpty, assumption)
    apply (erule_tac x=ca in allE, erule impE, erule SetTriv, assumption)
      apply (erule exE)+
      apply (subgoal_tac "Values_Represented ca (c # S, \<Gamma>, bf) (RVal (Loc ay) # ops, aj, h) I = {v}")
      prefer 2 apply (simp add: ValRepEQ)
      apply (rotate_tac -2, erule thin_rl)
      apply clarsimp
      apply (drule SetTriv, erule Values_Represented_GET, assumption+)
      apply (drule SetTriv, erule Values_Represented_GET, assumption+)
      apply fastsimp
  apply fast
done

lemma Get_Invariant:
  "\<lbrakk> H\<down>c = Some (D, F); F\<down>f = Some d; 
     unisat (RVal (Loc ah) # ops, aa, b) (c # S, \<Gamma>, bb) N0 I; AL_sum N Nx N0;  b\<down>ah = Some (dd, Flds); 
        Flds\<down>f = Some v; AL_sum H Ha bb\<rbrakk>
       \<Longrightarrow> Invariant ca (d # S, \<Gamma>, bb) (v # ops, aa, b) I N0 (c # S, \<Gamma>, bb) (RVal (Loc ah) # ops, aa, b) I"
apply (frule AL_sum3, assumption)
apply (simp add: unisat_def, clarsimp)
apply (frule_tac n=0 in State_welldef_OPS_lookup) apply simp apply clarsimp
apply (subgoal_tac "\<exists> Ca . tp = classTP Ca")
prefer 2 apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
         apply (simp add: State_typecorrect_def, clarsimp)
         apply (simp add: Opstack_typecorrect_def)
         apply (erule_tac x=0 in allE, clarsimp)
apply clarsimp
apply (subgoal_tac "I c = Some ah")
prefer 2 apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
        apply (simp add: uniqueValues_def)
             apply (erule_tac x=c in allE, erule impE) apply (simp add: DOM_def) 
        apply clarsimp
        apply (subgoal_tac "RVal (Loc ah) : Values_Represented c (c # S, \<Gamma>, bb) (RVal (Loc ah) # ops, aa, b) I") 
          prefer 2 apply (subgoal_tac "RVal (Loc ah) : ValuesRepresented c (c # S, \<Gamma>, bb) (RVal (Loc ah) # ops, aa, b) I")  
                   apply (simp add: ValRepEQ) apply (rule ValuesRepresented2)
        apply (subgoal_tac "Values_Represented c (c # S, \<Gamma>, bb) (RVal (Loc ah) # ops, aa, b) I = {va}")
        prefer 2 apply (simp add: ValRepEQ)
        apply (drule SetTrivPut2, assumption)
        apply clarsimp
        apply (simp add: State_typecorrect_def Heap_typecorrect_expand, clarsimp)
             apply (erule_tac x=c in allE, erule_tac x=D in allE, erule_tac x=F in allE, clarsimp)
        apply (subgoal_tac "RVal(Loc a) : Values_Represented c (c # S, \<Gamma>, bb) (RVal (Loc ah) # ops, aa, b) I")
          apply (drule SetTrivPut2, assumption)
          apply clarsimp
        apply (rotate_tac 12) apply (erule thin_rl, erule thin_rl)
        apply (simp add: Values_Represented_def) 
        apply (rule disjI2, rule disjI2, rule disjI1) 
        apply (simp add: AddrValues_Represented_def) apply (erule AL_sum3a) apply (erule AL_domI) 
apply (simp add: Invariant_def)
apply clarsimp
  apply (simp add: Values_Represented_def)
  apply (simp add: OpsValues_Represented_def, clarsimp)
    apply (case_tac n,clarsimp)  apply (simp add: FieldValues_Represented_def) 
    apply clarsimp apply (erule_tac x="Suc nat" in allE, clarsimp)
done

lemma UniGet_SoundUni:
"\<lbrakk>get_ins M l = Some (getfield C f); \<Sigma> = (c # S, \<Gamma>, H); H\<down>c = Some (D, F); F\<down>f = Some d; \<Pi> = (d # S, \<Gamma>, H);
        NN = N; L = {l + 1}\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> 
             contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (unfold UniSS_UniSecN_def)
apply rule apply simp
apply (rule allI)+
apply (rule impI)+
apply (rule, clarsimp)
apply (rule, clarsimp) apply (rule contained_refl)
apply (rule, clarsimp)
apply (rule, clarsimp) apply (rule contained_refl)
apply (rule, rule)
apply (rule allI)+
apply (rule impI)+
apply clarsimp
apply (drule GetElim1) apply assumption apply clarsimp
apply (simp add: SD_sum_def, clarsimp)
apply (rule_tac x=I in exI, rule) 
     apply (rule Get_unisat) 
       apply (rule unisat_MPextensional)
         apply (erule unisat_HPextensional) apply (erule AL_sum_extensional, assumption) apply assumption
         apply (erule AL_sum_extensional, assumption)
       apply assumption apply assumption apply assumption apply assumption 
   apply assumption apply assumption 
apply clarsimp 
    apply (rule_tac H=bb in Invariant_leftHPextensional)
      apply (rule Get_Invariant) apply assumption+
      apply (erule AL_sum_extensional, assumption) 
      apply assumption 
done

(*<*)
end
(*>*)