theory INSTR_NEW = UniSatSec:

lemma State_welldef_NewSubclass:
 "\<lbrakk> State_welldef (S, \<Gamma>, HH) NN; c \<notin> AL_dom NN; subclass_of C1 C\<rbrakk> 
  \<Longrightarrow> State_welldef (c # S, \<Gamma>, HH[c\<mapsto>(C1, emp)]) NN[c\<mapsto>(classTP C)]"
apply (simp add: State_welldef_def, clarsimp)
apply (simp add: AL_dom_upd1)
apply (rule, fast)
apply (rule, fast)
apply (rule, fast)
apply (subgoal_tac "c \<notin>AL_dom HH")
  apply (drule_tac C=C1 in AbsFields_insert_freshLoc) apply clarsimp
  apply (rule, fast)
  apply (simp add: ObjIDs_insertObj)
  apply (rule, fast)
  apply (rule, fast)
  apply (rule, simp add: State_good_def, clarsimp)
    apply (rule, erule AL_UPD)
    apply (simp add: HP_good_def) apply clarsimp 
      apply (drule AL_upd_split) apply (erule disjE, clarsimp) 
                                   apply (rule, rule AL_EMP) apply (simp add: AL_cod_emp)
                                 apply clarsimp apply (erule_tac x=ca in allE, clarsimp)
                                   apply (drule SetTriv, assumption) apply (simp add: AL_dom_upd1)
(*    apply (erule HP_good_insert) apply assumption apply assumption*)
    apply (erule AL_UPD)
apply clarsimp  apply fast
done

lemma State_welldefNew3_13:
  "\<lbrakk>State_welldef (S, \<Gamma>, H) N; cl \<notin> AL_dom N; b\<down>z = None\<rbrakk>
    \<Longrightarrow> ValuesRepresented cl (cl # S, \<Gamma>, H[cl\<mapsto>(C,emp)]) (RVal (Loc z) # a, aa, b[z\<mapsto>(C,emp)]) 
          (\<lambda>x. if x = cl then Some z else  I x)
        = {(RVal(Loc z))}"
apply (simp add: State_welldef_def ValuesRepresented_def, clarsimp)
apply (rule, clarsimp) apply (simp add: AL_dom_def)  
apply (erule disjE, clarsimp) apply (case_tac n, clarsimp) 
  apply clarsimp apply (subgoal_tac "S!nat : set S")  apply (drule_tac x="S ! nat" in SetTriv, assumption) apply clarsimp apply simp
apply (erule disjE, clarsimp) apply (subgoal_tac "cl : AL_cod \<Gamma>") 
                                apply (drule_tac x=cl in SetTriv, assumption) apply clarsimp 
                              apply (simp add: AL_cod_def) apply (rule, assumption)
apply (erule disjE, clarsimp) 
apply clarsimp apply (case_tac "d=cl", clarsimp) 
                 apply (simp add: AL_update1) apply (simp add: AL_emp1) 
               apply clarsimp apply (drule AL_upd_split, clarsimp)
                              apply (drule AL_upd_split, clarsimp)  
                                apply (erule disjE, clarsimp) apply (simp add: AL_emp1) 
                                apply clarsimp apply (subgoal_tac "cl : AbsFields H") apply (drule_tac x=cl in SetTriv, assumption) apply clarsimp 
                                               apply (erule AbsFieldsI) apply assumption 
apply clarsimp 
  apply (erule_tac x=0 in allE, clarsimp)
done

lemma uniqueValues_NewSubclass:
  "\<lbrakk>State_welldef (S, \<Gamma>, HH) NN; h\<down>z = None; c \<notin> AL_dom NN; subclass_of C D;
     State_typecorrect NN (S, \<Gamma>, HH) (ops, s, h) I; uniqueValues (S, \<Gamma>, HH) (ops, s, h) I\<rbrakk>
    \<Longrightarrow> uniqueValues (c # S, \<Gamma>, HH[c\<mapsto>(C, emp)]) (RVal (Loc z) # ops, s, h[z\<mapsto>(C, emp)])
        (\<lambda>x. if x = c then Some z else I x)"
apply (simp add: uniqueValues_def, clarsimp)
    apply (case_tac "c=ca", clarsimp)
      apply (rotate_tac 5, erule thin_rl) 
      apply (rule_tac x="RVal (Loc z)" in exI) 
      apply (erule State_welldefNew3_13) apply assumption apply assumption
    apply (erule_tac x=ca in allE, erule impE) apply (simp add: DOM_def, clarsimp)
      apply (erule disjE, fast)
      apply (erule disjE, simp add: AL_dom_upd1) apply (erule disjE, fast) apply assumption
      apply (simp add: AbsFields_expand, clarsimp)
        apply (drule AL_upd_split) apply (erule disjE, simp add: AL_emp1) apply clarsimp
    apply (erule exE) apply (rule_tac x=v in exI)
    apply (simp (no_asm) add: ValuesRepresented_def)
    apply (rule, clarsimp) apply clarsimp
    apply (rule, clarsimp)
      apply (erule disjE) apply clarsimp apply (case_tac n, clarsimp) apply clarsimp
                          apply (subgoal_tac "ops!nat : ValuesRepresented (S ! nat) (S, \<Gamma>, HH) (ops, s, h) I", clarsimp)
                          apply (rotate_tac -3, erule thin_rl)
                          apply (simp add: ValuesRepresented_def) apply (rule disjI1) apply (rule_tac x=nat in exI, simp)
      apply (erule disjE) apply clarsimp 
                          apply (subgoal_tac "x : ValuesRepresented ca (S, \<Gamma>, HH) (ops, s, h) I", clarsimp)
                          apply (rotate_tac -4, erule thin_rl)
                          apply (simp add: ValuesRepresented_def) apply (rule disjI2) apply (rule disjI1)
                            apply (rule_tac x=xa in exI, simp)
      apply (erule disjE) apply clarsimp 
                          apply (subgoal_tac "RVal(Loc a) : ValuesRepresented ca (S, \<Gamma>, HH) (ops, s, h) I", clarsimp)
                          apply (rotate_tac -4, erule thin_rl)
                          apply (simp add: AL_dom_upd1)
                          apply (simp add: ValuesRepresented_def) apply clarsimp 
                          apply (case_tac "d=c", clarsimp)  apply (simp add: AL_update1 AL_emp1) 
                          apply clarsimp apply (drule AL_update3) apply fast 
                          apply (drule AL_upd_split) 
                          apply (erule disjE) apply clarsimp apply (simp add: AL_emp1) 
                          apply clarsimp 
                          apply (subgoal_tac "x : ValuesRepresented ca (S, \<Gamma>, HH) (ops, s, h) I", clarsimp)
                          apply (rotate_tac -9, erule thin_rl)
                          apply (simp add: ValuesRepresented_def) apply clarsimp
    apply clarsimp
      apply (subgoal_tac "v:ValuesRepresented ca (S, \<Gamma>, HH) (ops, s, h) I")
      prefer 2 apply (rotate_tac -3, erule thin_rl, erule thin_rl, erule thin_rl) apply fast
      apply (rotate_tac 7, erule thin_rl)
      apply (simp add: ValuesRepresented_def)
      apply (erule disjE) apply clarsimp apply (erule_tac x="Suc n" in allE, simp) 
      apply (erule disjE) apply clarsimp 
      apply (erule disjE) apply clarsimp apply (simp add: AL_dom_upd1)
      apply clarsimp apply (erule_tac x=d in allE, clarsimp) 
        apply (erule disjE, clarsimp) apply (drule State_welldef_Heap_lookup) apply assumption apply clarsimp 
          apply (drule_tac H=NN in AL_domI) apply simp 
        apply clarsimp 
          apply (erule_tac x=Da in allE, erule_tac x=F in allE,erule impE) apply (erule AL_update5a, assumption)  
          apply (erule_tac x=f in allE, clarsimp) 
          apply (erule_tac x=Ca in allE, erule_tac x=G in allE, erule impE) 
            apply (rule AL_update5, assumption) apply clarsimp 
          apply clarsimp 
done

lemma StateSatisfiesAbstraction_NewSubclass:
  "\<lbrakk> StateSatisfiesAbstraction (ops, s, h) (S, \<Gamma>, HH) NN I; 
     State_welldef (S, \<Gamma>, HH) NN; h\<down>z = None;c \<notin> AL_dom NN; subclass_of E C\<rbrakk>
  \<Longrightarrow> StateSatisfiesAbstraction (RVal (Loc z) # ops, s, h[z\<mapsto>(E, emp)]) (c # S, \<Gamma>, HH[c\<mapsto>(E, emp)])
        NN[c\<mapsto>(classTP C)] (\<lambda>x. if x = c then Some z else I x)"
apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
apply (rule, simp add: State_typecorrect_def, clarsimp)
  apply rule apply (erule Opstack_typecorrect_FreshInsertInOPS) apply simp
    apply (simp add: State_welldef_def, clarsimp) apply fast
  apply rule apply (erule_tac v="RVal (Loc z)" in Store_typecorrect_FreshInsert) apply simp
    apply (simp add: State_welldef_def, clarsimp) apply fast
  apply (simp add: Heap_typecorrect_def, clarsimp)
    apply (frule AL_domD, clarsimp)
    apply (drule AL_upd_split)
    apply (erule disjE, clarsimp)
      apply (simp add: AL_update1)
      apply (rotate_tac -2, erule thin_rl, erule thin_rl)
      apply (rule, simp add: HeapAbstractsAt_def AL_update1) 
        apply rule apply (simp add : subclass_of_refl)
        apply (rule Fields_tc_emp_emp)
      apply (rule domI) apply simp
    apply clarsimp apply (erule_tac x=ca in allE, erule impE, erule AL_domI)
      apply clarsimp apply (frule_tac H=NN in AL_domI)
      apply (rule_tac x=Ca in exI)
      apply (rule, erule AL_update5) apply assumption
      apply (rule, simp add: HeapAbstractsAt_def, clarsimp) 
        apply (rule, clarsimp)
        apply clarsimp apply (drule AL_update3a) apply assumption
          apply clarsimp 
          apply (rule_tac x=Ea in exI, clarsimp)
          apply (rule_tac x=G in exI)
          apply rule apply (rule AL_update5, assumption) 
              apply (case_tac "z = y", clarsimp, assumption)
          apply (simp add: Fields_typecorrect_def, clarsimp)
            apply (erule_tac x=f in allE, clarsimp)
            apply (rule_tac x=tp in exI, clarsimp)
            apply (rule AL_update5, assumption)
            apply (drule_tac d=caa in AL_domI) apply fast
       apply (rule domI) apply (subgoal_tac "ca \<noteq> c", clarsimp) apply simp apply fast
  apply (rule, erule uniqueValues_NewSubclass, assumption+) 
  apply rule 
    apply (rule, clarsimp)
    apply (simp add: DOM_def ObjIDs_insertObj)
    apply (rule_tac m=I in domD)  
        apply (rule SetTriv) prefer 2 apply assumption 
        apply clarsimp apply (simp add: AL_dom_upd1) apply clarsimp
        apply (simp add: AbsFields_expand, clarsimp) apply (drule AL_upd_split, clarsimp) 
                                                   apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
                                                   apply clarsimp
  apply (subgoal_tac "c \<notin> ObjIDs NN")
  prefer 2 apply clarsimp apply (drule SetTriv) apply (rule ObjIDs_in_Dom) apply simp
    apply (simp (no_asm) add: inj_on_def, clarsimp)
      apply (rule, clarsimp) 
        apply (subgoal_tac "y :AL_dom HH") prefer 2 apply (simp add: AL_dom_upd1)
        apply (simp add:State_typecorrect_def Heap_typecorrect_expand, clarsimp)
        apply (drule_tac H=HH in AL_domD, clarsimp)
        apply (erule_tac x=y in allE, clarsimp) 
    apply clarsimp
    apply (rule, clarsimp) apply (simp add: AL_dom_upd1)
        apply (simp add:State_typecorrect_def Heap_typecorrect_expand, clarsimp)
        apply (drule_tac H=HH in AL_domD, clarsimp)
        apply (erule_tac x=x in allE, clarsimp) 
        apply (erule_tac x=b in allE, clarsimp) 
    apply clarsimp apply (simp add: AL_dom_upd1)
          apply (erule inj_onD, simp) apply assumption apply assumption
done

lemma unisat_NewSubclass:
  "\<lbrakk> unisat (a, aa, b) (S, \<Gamma>, bc) N I ; c \<notin> AL_dom N; b\<down>z = None; subclass_of C D\<rbrakk>
    \<Longrightarrow> unisat (RVal (Loc z) # a, aa, b[z\<mapsto>(C, emp)]) 
            (c # S, \<Gamma>, bc[c\<mapsto>(C, emp)]) 
            (N[c\<mapsto>(classTP D)])
           (\<lambda>x. if x = c then Some z else I x) "
apply (simp add: unisat_def, clarsimp)
apply rule apply (erule State_welldef_NewSubclass) apply assumption apply assumption
apply (erule StateSatisfiesAbstraction_NewSubclass) apply assumption+ 
done

lemma New_ValuesRepresented21New13:
  "\<lbrakk>AL_dom bc \<subseteq> AL_dom N; ca \<in> AL_dom N; ca \<noteq> c\<rbrakk>
        \<Longrightarrow> ValuesRepresented ca (S, \<Gamma>, bc[c\<mapsto>(C, emp)]) (a, aa, b[z\<mapsto>(C, emp)]) (\<lambda>x. if x = c then Some z else I x)
           \<subseteq> ValuesRepresented ca (S, \<Gamma>, bc) (a, aa, b) I"
apply (simp add: ValuesRepresented_def) apply clarsimp
    apply (erule disjE, clarsimp) 
    apply (simp add: AL_dom_upd1, clarsimp)
  apply (case_tac "d=c", clarsimp) apply (simp add: AL_update1 AL_emp1) 
  apply clarsimp apply (drule AL_upd_split) apply (erule disjE, clarsimp) 
                 apply clarsimp 
  apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, erule impE) apply assumption
  apply (erule_tac x=f in allE, erule impE, assumption)
           apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply (simp add: AL_emp1) apply clarsimp
           apply (erule_tac x=C in allE, clarsimp)
done

lemma New_Invariant:
 "\<lbrakk> unisat (a, aa, b) (S, \<Gamma>, bc) N I; ca \<in> AL_dom N; c \<notin> AL_dom N\<rbrakk>
 \<Longrightarrow> Invariant ca (c # S, \<Gamma>, bc[c\<mapsto>(C, emp)]) 
                (RVal (Loc z) # a, aa, b[z\<mapsto>(C, emp)])
                (\<lambda>x. if x = c then Some z else I x)
               N (S, \<Gamma>, bc) (a, aa, b) I"
apply (simp add: Invariant_def ValRepEQ)
apply (subgoal_tac "ca \<noteq> c") prefer 2 apply fast
apply clarsimp
apply (simp add: unisat_def, (erule conjE)+)
apply (erule SetTriv)
    apply (rule SetTriv109) apply (erule ValuesRepresented1)
    apply (rule New_ValuesRepresented21New13) apply (erule State_welldef_lookupHeap) apply assumption+
done

lemma UniNew_SoundUniSubclass:
  "\<lbrakk>get_ins M l = Some (new C); \<Sigma> = (S, \<Gamma>, H); c \<notin> AL_dom N; L = {l + 1}; \<Pi> = (c # S, \<Gamma>, H[c \<mapsto>(C, emp)]);
        NN = N[c\<mapsto>(classTP D)]; subclass_of C D\<rbrakk>
       \<Longrightarrow> get_ins M l \<noteq> Some vreturn \<and>
          (\<forall>n S \<Gamma> H Sp \<Gamma>p Hp.
              UniCtxtUniValidN n U \<longrightarrow>
              \<Sigma> = (S, \<Gamma>, H) \<longrightarrow> \<Pi> = (Sp, \<Gamma>p, Hp) \<longrightarrow> AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)"
apply (unfold UniSS_UniSecN_def)
apply rule apply simp
apply (rule allI)+
apply (rule impI)+
apply (rule, clarsimp) apply (erule SetTriv) apply (rule AL_dom_upd)
apply (rule, clarsimp, erule contained_upd)
apply (rule, clarsimp) apply (erule SetTriv) apply (rule AL_dom_upd)
apply (rule, clarsimp, erule contained_upd)
apply (rule, rule)
apply (rule allI)+
apply (rule impI)+
apply clarsimp
apply (drule NewElim1) apply assumption apply clarsimp
apply (simp add: SD_sum_def, clarsimp)
(*apply (rule_tac x="(\<lambda>x. if x = c then Some (nextLoc b) else (I |` AL_dom N0) x)" in exI)*)
apply (rule_tac x="(\<lambda>x. if x = c then Some ah else I x)" in exI)
(*apply (rule_tac x="(\<lambda>x. if x : AL_dom N0 then J x else  Some (nextLoc ba))" in exI)*)
apply (subgoal_tac "c\<notin> AL_dom Nx") prefer 2 apply (subgoal_tac "c:AL_dom N[c\<mapsto>(classTP D)]", fast)
                                            apply (rule AL_dom_upd2)
apply (subgoal_tac "c\<notin> AL_dom N0") prefer 2 apply (simp add: AL_sum_def)
apply (subgoal_tac "\<forall>x ca. (N0[c\<mapsto>(classTP D)]\<down>x = Some ca) = (N1\<down>x = Some ca)")
prefer 2 apply clarsimp apply (erule AL_sum_upd_sum_extensional) apply assumption  apply (simp add: AL_dom_upd1)
apply (subgoal_tac "\<forall>x ca. (bb[c\<mapsto>(C, emp)]\<down>x = Some ca) = (bc\<down>x = Some ca)")
prefer 2 apply clarsimp apply (erule AL_sum_upd_sum_extensional) apply assumption apply (simp add: AL_dom_upd1)
apply rule apply (rule unisat_HPextensional) 
             apply (rule unisat_MPextensional) 
               apply (erule unisat_NewSubclass) 
                 apply assumption 
                 apply assumption
                 apply assumption
               apply assumption
               apply assumption
             apply assumption
             apply assumption
apply clarsimp
apply (rule_tac H="upd bb c (C, emp)" in Invariant_leftHPextensional) 
  apply (erule New_Invariant) apply assumption+
  apply clarsimp
  apply (erule AL_UPD) 
done

end