theory InvokeBasics = UniSatSec:

consts absFrame::"(Colour list \<times> (Var list) \<times> VarContext \<times> (Colour list)) set"
inductive absFrame intros
absFrameNil: "\<lbrakk>oo=ops\<rbrakk> \<Longrightarrow> (ops,[],emp,oo) : absFrame"
absFrameCons: "\<lbrakk>(oo,params,S,ops) : absFrame; SS =S[x\<mapsto>v]\<rbrakk>
            \<Longrightarrow> (v # oo, x # params,SS,ops):absFrame"

lemma absFrame_ListLength[rule_format]:
  "(S1, P1, \<Gamma>1, S) \<in> absFrame \<Longrightarrow> length S1 = length P1 + length S"
apply (erule absFrame.induct)
  apply clarsimp
apply clarsimp 
done

lemma absFrame_List_D_Left[rule_format]:
  "(T, P1, \<Gamma>1, S) \<in> absFrame \<Longrightarrow> \<forall> n . n < length T \<longrightarrow> length P1 \<le> n \<longrightarrow> S!(n - length P1) = T!n"
apply (erule absFrame.induct)
  apply clarsimp
apply clarsimp
  apply (case_tac n, clarsimp) 
  apply clarsimp
done

lemma absFrame_List_D_Right[rule_format]:
  "(T, P1, \<Gamma>1, S) \<in> absFrame \<Longrightarrow> \<forall> n . n < length S \<longrightarrow> n + length P1 < length T \<and> S!n = T!(n + length P1)"
apply (erule absFrame.induct)
  apply clarsimp
apply clarsimp
done

lemma absFrame_List_D_Right2[rule_format]:
  "(T, P1, \<Gamma>1, S) \<in> absFrame \<Longrightarrow> set S \<subseteq> set T"
apply (erule absFrame.induct)
  apply clarsimp
apply clarsimp apply fast
done

lemma Frame_ListLength[rule_format]:
  "(S1, P1, \<Gamma>1, S) \<in> Frame \<Longrightarrow> length S1 = length P1 + length S"
apply (erule Frame.induct)
  apply clarsimp
apply clarsimp 
done

lemma Frame_List_D_Left[rule_format]:
  "(T, P1, \<Gamma>1, S) \<in> Frame \<Longrightarrow> \<forall> n . n < length T \<longrightarrow> length P1 \<le> n \<longrightarrow> S!(n - length P1) = T!n"
apply (erule Frame.induct)
  apply clarsimp
apply clarsimp
  apply (case_tac n, clarsimp) 
  apply clarsimp
done

lemma Frame_List_D_Right[rule_format]:
  "(T, P1, \<Gamma>1, S) \<in> Frame \<Longrightarrow> \<forall> n . n < length S \<longrightarrow> n + length P1 < length T \<and> S!n = T!(n + length P1)"
apply (erule Frame.induct)
  apply clarsimp
apply clarsimp
done

lemma absFrame_domGamma: "(S1, P1, \<Gamma>, S) \<in> absFrame \<Longrightarrow> AL_dom \<Gamma> = set P1"
apply (erule absFrame.induct)
apply (simp add: AL_dom_emp)
apply (simp add:AL_dom_upd1)
done

lemma absFrame_codGamma: "(S1, P1, \<Gamma>, S) \<in> absFrame \<Longrightarrow> AL_cod \<Gamma> \<subseteq> set S1"
apply (erule absFrame.induct)
apply (simp add: AL_cod_emp)
apply clarsimp
apply (subgoal_tac "xa : AL_cod S \<or> xa: {v}") apply fast
apply (subgoal_tac "xa :  AL_cod S \<union> {v}") apply fast
apply (erule SetTriv)
apply (rule AL_cod_upd1)
done

lemma absFrame_Gamma[rule_format]: "(S1, P1, \<Gamma>, S) \<in> absFrame \<Longrightarrow> \<Gamma>\<down>x = Some y \<longrightarrow> y:set S1"
apply (erule absFrame.induct)
apply (simp add: AL_emp1)
apply clarsimp apply (drule AL_upd_split) apply clarsimp
done

lemma Frame_Gamma[rule_format]: "(S1, P1, s, S) \<in> Frame \<Longrightarrow> s\<down>x = Some y \<longrightarrow> y:set S1"
apply (erule Frame.induct)
apply (simp add: AL_emp1)
apply clarsimp apply (drule AL_upd_split) apply clarsimp
done

lemma absFrameFrame_StoreLookup[rule_format]:
  "(S1, P1, \<Gamma>, S) \<in> absFrame \<Longrightarrow> \<forall> ops s ops1 x y. (ops, P1, s, ops1) \<in> Frame \<longrightarrow> 
                                                    \<Gamma>\<down>x = Some y \<longrightarrow> (\<exists> n v . n < length S1 \<and> S1!n = y \<and> ops!n = v \<and> s\<down>x = Some v)"
apply (erule absFrame.induct)
apply (simp add: AL_emp1)
apply clarsimp apply (erule thin_rl) 
  apply (erule Frame.elims)  apply clarsimp apply clarsimp 
  apply (erule_tac x=ooa in allE, erule_tac x=Sa in allE, erule impE) apply (rule, assumption) 
  apply (drule AL_upd_split)
  apply (erule disjE, clarsimp) apply (rule_tac x=0 in exI, simp) apply (rule AL_update1)
  apply clarsimp
  apply (erule_tac x=xa in allE, erule_tac x=y in allE, clarsimp) 
  apply (rule_tac x="Suc n" in exI, simp)
  apply (erule AL_update4) apply assumption
done

lemma absFrame_D_AL:"(S, P1, \<Gamma>, T) \<in> absFrame \<Longrightarrow> \<Gamma> \<in> AL"
apply (erule absFrame.induct)
apply (rule AL_EMP)
apply clarsimp apply (erule AL_UPD)
done

lemma absFrameFrame_OpstackLookup[rule_format]:
  "(S1, P1, \<Gamma>, S) \<in> absFrame \<Longrightarrow> \<forall> ops s ops1 m y. (ops, P1, s, ops1) \<in> Frame \<longrightarrow> m < length S \<longrightarrow>
                                                    S!m = y \<longrightarrow> (\<exists> n v . n < length S1 \<and> S1!n = y \<and> ops1!m = ops!n)"
apply (erule absFrame.induct)
apply clarsimp apply (erule Frame.elims, clarsimp) apply (rule_tac x=m in exI, simp)
               apply clarsimp
apply clarsimp apply (erule thin_rl) 
  apply (erule Frame.elims) apply clarsimp apply clarsimp 
  apply (erule_tac x=ooa in allE, erule_tac x=Sa in allE,  erule_tac x=opsb in allE, erule impE, assumption) 
  apply (erule_tac x=m in allE, clarsimp)
  apply (rule_tac x="Suc n" in exI, simp)
done

lemma absFrameFrame_OpsValues_Represented:
  "\<lbrakk>(S1, P1, \<Gamma>, S) \<in> absFrame; (ops, P1, s, ops1) \<in> Frame\<rbrakk>
   \<Longrightarrow> OpsValues_Represented c S ops1 \<subseteq> OpsValues_Represented c S1 ops"
apply (simp add: OpsValues_Represented_def, clarsimp)
apply (drule absFrameFrame_OpstackLookup, assumption) apply assumption apply simp apply clarsimp apply (rule_tac x=na in exI, simp)
done

lemma absFrame_State_welldef:
  "\<lbrakk>(S1, P1, \<Gamma>1, S) \<in> absFrame; State_welldef (S1, \<Gamma>, bb) af\<rbrakk> \<Longrightarrow> State_welldef ([], \<Gamma>1, bb) af"
apply (simp add: State_welldef_def)
apply (erule conjE)+
apply rule apply (rule SetTriv101) apply (erule absFrame_codGamma) apply assumption
apply rule apply (rule SetTriv101) prefer 2 apply assumption apply (drule absFrame_codGamma) apply (rotate_tac -1) apply fast
apply (simp add: State_good_def)
  apply (erule absFrame_D_AL) 
done

lemma absFrame_typecorrect[rule_format]:
  "(T, P1, \<Gamma>, S) \<in> absFrame \<Longrightarrow> (\<forall> a SS ops . (a, P1, SS, ops) \<in> Frame \<longrightarrow> Opstack_typecorrect N T a \<longrightarrow>
    Store_typecorrect N \<Gamma> SS)"
apply (erule absFrame.induct)
apply clarsimp
  apply (erule Frame.elims, clarsimp) apply (simp add: Store_typecorrect_def AL_emp1)
  apply clarsimp
apply clarsimp
  apply (erule Frame.elims, clarsimp) 
  apply clarsimp apply (erule_tac x=ooa in allE, erule_tac x=Sa in allE, erule impE, rule,  assumption)
                 apply (erule impE) apply (erule Opstack_typecorrect_Tail) 
                 apply (simp add: Store_typecorrect_def, clarsimp)
                 apply (drule AL_upd_split)
                 apply (erule disjE, clarsimp)
                   apply (simp add: Opstack_typecorrect_def)
                   apply (erule_tac x=0 in allE, clarsimp)
                   apply (rule_tac x=va in exI, simp add: AL_update1)
                 apply (erule_tac x=x in allE, clarsimp)
                   apply (rule, rule, erule AL_update5) apply assumption
                   apply assumption
done

lemma absFrame_DOM_InvS:"(S1, P1, \<Gamma>1, S) \<in> absFrame \<Longrightarrow> DOM ([], \<Gamma>1, K) \<subseteq> DOM (S1, \<Gamma>, K)"
apply (erule absFrame.induct)
apply (simp_all add: DOM_def AL_cod_emp) apply fast
apply clarsimp
  apply rule apply (rule SetTriv101) apply (rule AL_cod_upd1) apply fast
  apply fast
done

lemma absFrame_set_leftover: "(T, params, \<Gamma>, S) \<in> absFrame \<Longrightarrow> set S \<subseteq> set T"
apply clarsimp
apply (simp add: set_conv_nth) apply clarsimp
apply (drule absFrame_List_D_Right) apply assumption apply clarsimp
apply (rule_tac x="i + length params" in exI, simp)
done

lemma absFrame_StoreCod_InvV:"(T, P1, \<Gamma>, d # S) \<in> absFrame \<Longrightarrow> AL_cod \<Gamma>[this\<mapsto>d] \<subseteq> set T"
apply (frule absFrame_codGamma)
apply (drule absFrame_set_leftover)
apply (rule SetTriv101) apply (rule AL_cod_upd1) apply clarsimp
done

lemma absFrame_State_welldefInvV:
  "\<lbrakk>(S1, P1, \<Gamma>, d # S) \<in> absFrame; State_welldef (S1, \<Delta>, K) N\<rbrakk> \<Longrightarrow> State_welldef ([], \<Gamma>[this\<mapsto>d], K) N"
apply (simp add: State_welldef_def)
apply (erule conjE)+
apply (frule absFrame_StoreCod_InvV)
apply (rule, erule SetTriv101) apply assumption
apply rule apply (rule_tac Y="(set S1 \<union> AL_cod \<Delta> \<union> AbsFields K) \<inter> ObjIDs N" in SetTriv101) prefer 2 apply assumption apply fast 
apply (simp add: State_good_def, (erule conjE)+) apply (rule AL_UPD) apply (erule absFrame_D_AL)
done

lemma absFrame_DOM_InvV:"(S1, P1, \<Gamma>1, d#S) \<in> absFrame \<Longrightarrow> DOM ([], \<Gamma>1[this\<mapsto>d], K) \<subseteq> DOM (S1, \<Gamma>, K)"
apply (simp_all add: DOM_def)
  apply rule
    apply (rule SetTriv101) apply(erule absFrame_StoreCod_InvV) apply fast
apply fast
done

lemma absFrame_InvS_StateSatisfiesAbstraction:
  "\<lbrakk> (S1, P1, \<Gamma>1, S) \<in> absFrame;(a, P1, SS, ops) \<in> Frame; StateSatisfiesAbstraction (a, aa, b) (S1, \<Gamma>, bb) af I\<rbrakk>
  \<Longrightarrow> StateSatisfiesAbstraction ([], SS, b) ([], \<Gamma>1, bb) af I"
apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
apply (simp add: State_typecorrect_def, clarsimp)
apply rule apply (simp add: Opstack_typecorrect_def)
apply rule apply (erule absFrame_typecorrect) apply assumption apply assumption
apply (rule, simp add: uniqueValues_def, clarsimp)
  apply (erule_tac x=c in allE, erule impE) apply (erule SetTriv, erule absFrame_DOM_InvS)
  apply (erule exE)
  apply (rule_tac x=v in exI)
  apply (subgoal_tac "Values_Represented c ([], \<Gamma>1, bb) ([], SS, b) I = {v}", simp add: ValRepEQ)
  apply (subgoal_tac "Values_Represented c (S1, \<Gamma>, bb) (a, aa, b) I = {v}")
  prefer 2 apply (simp add: ValRepEQ)
  apply (subgoal_tac "Values_Represented c ([], \<Gamma>1, bb) ([], SS, b) I=Values_Represented c (S1, \<Gamma>, bb) (a, aa, b) I")
    apply clarsimp
  apply (rotate_tac -1, erule thin_rl)
  apply (simp add: Values_Represented_def)
  apply (rule, clarsimp) 
    apply (rule, simp add:  OpsValues_Represented_def)
    apply (rule, simp add:  OpsValues_Represented_def StoreValues_Represented_def, clarsimp)
      apply (drule absFrameFrame_StoreLookup, assumption) apply assumption apply clarsimp
      apply (rule_tac x=n in exI, clarsimp)
    apply (rule, clarsimp)
    apply clarsimp
  apply clarsimp 
    apply rule
    apply (rule, simp add:  OpsValues_Represented_def DOM_def, clarsimp)
      apply (erule disjE, drule AL_codD, clarsimp) 
        apply (frule absFrameFrame_StoreLookup, assumption) apply assumption apply clarsimp
        apply (subgoal_tac "a ! na = a ! n", clarsimp)        
          apply (simp add:StoreValues_Represented_def)
        apply (subgoal_tac "a!n : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (subgoal_tac "a!na : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (rotate_tac 8) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def)  apply (rule disjI1) apply (rule_tac x=na in exI, simp)
        apply (rotate_tac 8) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def)  apply (rule disjI1) apply (rule_tac x=n in exI, simp)
      apply (erule disjE, simp add: AddrValues_Represented_def Heap_typecorrect_expand) 
        apply (frule AL_domD, clarsimp) apply (erule_tac x="S1!n" in allE, clarsimp)
        apply (subgoal_tac "a!n : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (subgoal_tac "RVal (Loc aaa) : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def) 
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def)  apply (rule disjI1) apply (rule_tac x=n in exI, simp) 
      apply (simp add: FieldValues_Represented_def AbsFields_expand , clarsimp) 
        apply (erule_tac x=d in allE, clarsimp)
        apply (erule_tac x=f in allE, clarsimp)
        apply (simp add: Heap_typecorrect_expand)
        apply (erule_tac x=d in allE, clarsimp)
        apply (simp add: Object_typecorrect_def Fields_typecorrect_def, clarsimp)
        apply (erule_tac x=f in allE, clarsimp)
        apply (subgoal_tac "a!n : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (subgoal_tac "va : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def) apply (rule disjI2) apply (rule disjI2)
           apply (rule disjI2) apply (rule_tac x=d in exI, simp) apply (rule_tac x=f in exI, simp)
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def)  apply (rule disjI1) apply (rule_tac x=n in exI, simp)
    apply (rule, simp add: StoreValues_Represented_def DOM_def, clarsimp)
      apply (erule disjE, drule AL_codD, clarsimp) 
        apply (rule_tac x=ab in exI, simp)
        apply (frule absFrameFrame_StoreLookup, assumption) apply assumption apply clarsimp
        apply (subgoal_tac "a!n : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (subgoal_tac "x : ValuesRepresented (S1 ! n) (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (rotate_tac 8) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def)  apply (rule disjI2) apply (rule disjI1) 
          apply (rule_tac x=xa in exI, simp) 
        apply (rotate_tac 8) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def)  apply (rule disjI1) apply (rule_tac x=n in exI, simp)
      apply (erule disjE, simp add: AddrValues_Represented_def Heap_typecorrect_expand) 
        apply (frule AL_domD, clarsimp) apply (erule_tac x=c in allE, clarsimp)
        apply (subgoal_tac "x : ValuesRepresented c (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (subgoal_tac "RVal (Loc aaa) : ValuesRepresented c (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def) 
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def)  apply (rule disjI2) apply (rule disjI1) 
          apply (rule_tac x=xa in exI, simp) 
      apply (simp add: FieldValues_Represented_def AbsFields_expand , clarsimp) 
        apply (erule_tac x=d in allE, clarsimp)
        apply (erule_tac x=f in allE, clarsimp)
        apply (simp add: Heap_typecorrect_expand)
        apply (erule_tac x=d in allE, clarsimp)
        apply (simp add: Object_typecorrect_def Fields_typecorrect_def, clarsimp)
        apply (erule_tac x=f in allE, clarsimp)
        apply (subgoal_tac "x : ValuesRepresented c (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (subgoal_tac "va : ValuesRepresented c (S1, \<Gamma>, bb) (a, aa, b) I")
          apply (drule SetTrivPut2, assumption) apply clarsimp
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def) apply (rule disjI2) apply (rule disjI2)
           apply (rule disjI2) apply (rule_tac x=d in exI, simp) apply (rule_tac x=f in exI, simp)
        apply (rotate_tac 7) apply (erule thin_rl)
        apply (simp add: ValuesRepresented_def) apply (rule disjI2) apply (rule disjI1) apply (rule_tac x=xa in exI, simp)
    apply (rule, fast)
    apply fast
apply (rule SetTriv101) prefer 2 apply assumption 
  apply (subgoal_tac "DOM ([], \<Gamma>1, bb) \<subseteq> DOM (S1, \<Gamma>, bb)", fast)
  apply (erule absFrame_DOM_InvS) 
done

lemma absFrame_State_welldef_Leftover[rule_format]:
  "(S1, P1, \<Gamma>1, S) \<in> absFrame \<Longrightarrow> State_welldef (S1, \<Gamma>, H) N \<longrightarrow> State_welldef (S, \<Gamma>, H) N"
apply (erule absFrame.induct)
apply clarsimp
apply clarsimp
  apply (drule State_welldef_Tail) apply simp
done

lemma Invoke_State_welldef_preserved1:
  "\<lbrakk> State_welldef (Sa, \<Gamma>', bb) N; State_welldef ([c1], emp, bd) NN; 
        contained N NN; AL_dom bb \<subseteq> AL_dom bd\<rbrakk>
   \<Longrightarrow> State_welldef (Sa, \<Gamma>', bd) NN"
apply (simp add: State_welldef_def, clarsimp) 
apply (rule, erule SetTriv101)  apply (erule contained5)
apply (rule, erule SetTriv101) apply (erule contained5)
apply (rule, clarsimp)
  apply (erule disjE, frule_tac x=x in SetTriv, assumption)
    apply (subgoal_tac "x:ObjIDs N")
      apply (rule SetTriv) prefer 2 apply assumption
      apply (rule_tac X="(set Sa \<union> AL_cod \<Gamma>' \<union> AbsFields bb) \<inter> ObjIDs N" in SetTriv) apply fastsimp apply assumption
      apply (simp add: ObjIDs_def, clarsimp) apply (drule contained2, assumption) apply assumption apply clarsimp
  apply (erule disjE, frule_tac x=x in SetTriv, assumption)
    apply (subgoal_tac "x:ObjIDs N")
      apply (rule SetTriv) prefer 2 apply assumption
      apply (rule_tac X="(set Sa \<union> AL_cod \<Gamma>' \<union> AbsFields bb) \<inter> ObjIDs N" in SetTriv) apply fastsimp apply assumption
      apply (simp add: ObjIDs_def, clarsimp) apply (drule contained2, assumption) apply assumption apply clarsimp
  apply (rule_tac X="insert c1 (AL_cod emp \<union> AbsFields bd) \<inter> ObjIDs NN" in SetTriv) apply fast apply assumption
apply (simp add: State_good_def)
done


lemma State_welldef_ConsMerge:
  "\<lbrakk>State_welldef ([c], emp, H) N; State_welldef (S, \<Gamma>, H) N\<rbrakk>
    \<Longrightarrow> State_welldef (c # S, \<Gamma>, H) N"
apply (simp add: State_welldef_def, clarsimp)
apply (rule, clarsimp)
   apply (case_tac "x=c", clarsimp) apply (rule_tac X="insert c (AL_cod emp \<union> AbsFields H) \<inter> ObjIDs N" in SetTriv) apply fastsimp apply assumption
   apply clarsimp apply (rule_tac X="(set S \<union> AL_cod \<Gamma> \<union> AbsFields H) \<inter> ObjIDs N"  in SetTriv) apply fastsimp apply assumption
apply (simp add: State_good_def)
done

lemma Invoke_Final_State_welldef:
"\<lbrakk> (S1, P1, \<Gamma>1, S) \<in> absFrame; State_welldef (S1, \<Gamma>, bb) N; State_welldef ([c1], emp, bd) NN; 
         AL_sum H Ha bb; AL_sum HH Ha bd; AL_dom H \<subseteq> AL_dom HH; contained N NN\<rbrakk>
       \<Longrightarrow> State_welldef (c1 # S, \<Gamma>, bd) NN"
apply (drule absFrame_State_welldef_Leftover) apply assumption
apply (erule thin_rl)
apply (drule_tac Sa=S in Invoke_State_welldef_preserved1) apply assumption apply assumption 
   apply (simp add: AL_sum_def, clarsimp) apply (rule, rule SetTriv101) apply (erule contained5) apply fast apply fast
apply (erule State_welldef_ConsMerge) apply assumption
done

lemma ValuesRepresented18:
  "\<lbrakk>(S1, P1, \<Gamma>, S) \<in> absFrame; (ops, P1, s, ops1) \<in> Frame\<rbrakk> 
   \<Longrightarrow> ValuesRepresented c ([], \<Gamma>, H) ([], s, h) J \<subseteq> ValuesRepresented c (S1, emp, H) (ops, emp, h) J"
apply (simp add: ValuesRepresented_def)
apply clarsimp
apply (drule absFrameFrame_StoreLookup) apply assumption apply assumption apply clarsimp
apply (erule_tac x=n in allE, clarsimp)
done

lemma ValuesRepresented19[rule_format]:
  "\<lbrakk>(S1, P1, \<Gamma>1, S) \<in> absFrame; (a, P1, SS, ops) \<in> Frame\<rbrakk>
  \<Longrightarrow> ValuesRepresented ca (S, \<Gamma>, bb) (ops, aa, b) I \<subseteq> ValuesRepresented ca (S1, \<Gamma>, bb) (a, aa, b) I"
apply (simp add: ValuesRepresented_def)
apply clarsimp
apply (subgoal_tac "\<exists> c . S!n = c", erule exE) prefer 2 apply simp
apply (drule absFrameFrame_OpstackLookup) apply assumption apply assumption apply assumption apply clarsimp
apply (erule_tac x=na in allE, clarsimp)
done

lemma Frame_TailCons:"(ops, params, S, os) \<in> Frame \<Longrightarrow> \<forall> v os1 . os = v # os1 \<longrightarrow> ((length params) < length ops \<and> ops!(length params) = v)"
apply (erule Frame.induct)
apply clarsimp
apply clarsimp
done

lemma absFrame_TailCons:"(ops, params, S, os) \<in> absFrame \<Longrightarrow> \<forall> v os1 . os = v # os1 \<longrightarrow> ((length params) < length ops \<and> ops!(length params) = v)"
apply (erule absFrame.induct)
apply clarsimp
apply clarsimp
done

lemma ValuesRepresented_InvV0:
 "\<lbrakk>(S1, P1, \<Gamma>1, d # S) \<in> absFrame; (ops, P1, ss, RVal (Loc an) # ops1) \<in> Frame\<rbrakk>
  \<Longrightarrow> ValuesRepresented c ([], [][this\<mapsto>d], K) ([], [][this\<mapsto>(RVal (Loc an))], h) I \<subseteq> ValuesRepresented c (S1, emp, K) (ops, emp, h) I"
apply (simp add: ValuesRepresented_def)
apply clarsimp
apply (drule AL_upd_split)
apply (erule disjE, clarsimp) apply (simp add: AL_update1) apply clarsimp
  apply (drule absFrame_TailCons) apply clarsimp
  apply (drule Frame_TailCons) apply clarsimp
apply clarsimp 
done

lemma ValuesRepresented_StoreUpd:
  "ValuesRepresented c ([], \<Gamma>1[this\<mapsto>d], K) ([], ss[this\<mapsto>(RVal (Loc an))], h) I \<subseteq>
   ValuesRepresented c ([], \<Gamma>1, K) ([], ss, h) I \<union> ValuesRepresented c ([], [][this\<mapsto>d], K) ([], [][this\<mapsto>(RVal (Loc an))], h) I"
apply (simp add: ValuesRepresented_def)
apply (rule, clarsimp)
  apply (drule AL_upd_split)
  apply (erule disjE, clarsimp) apply (simp add: AL_update1) apply clarsimp
    apply (erule_tac x=this in allE, simp add: AL_update1)
  apply clarsimp apply (drule AL_update3, assumption) apply clarsimp
done

lemma ValuesRepresented_InvV:
 "\<lbrakk>(S1, P1, \<Gamma>1, d # S) \<in> absFrame; (ops, P1, ss, RVal (Loc a) # ops1) \<in> Frame\<rbrakk>
 \<Longrightarrow> ValuesRepresented c ([], \<Gamma>1[this\<mapsto>d], K) ([], ss[this\<mapsto>(RVal (Loc a))], h) I \<subseteq>
     ValuesRepresented c (S1, emp, K) (ops, emp, h) I"
apply (rule SetTriv101)
apply (subgoal_tac "ValuesRepresented c ([], upd \<Gamma>1 this d, K) ([], upd ss this (RVal (Loc a)), h) I \<subseteq>
                      ValuesRepresented c ([], \<Gamma>1, K) ([], ss, h) I \<union> ValuesRepresented c ([], upd [] this d, K) ([], upd [] this (RVal (Loc a)), h) I", assumption)
  apply (rule ValuesRepresented_StoreUpd)
apply (subgoal_tac "ValuesRepresented c ([], \<Gamma>1, K) ([], ss, h) I \<subseteq> ValuesRepresented c (S1, emp, K) (ops, emp, h) I")
      apply (subgoal_tac "ValuesRepresented c ([], [][this\<mapsto>d], K) ([], [][this\<mapsto>(RVal (Loc a))], h) I \<subseteq> ValuesRepresented c (S1, emp, K) (ops, emp, h) I") 
      apply fast
 apply (erule ValuesRepresented_InvV0) apply assumption 
    apply (rule SetTriv101)
      apply (erule ValuesRepresented18) apply assumption
      apply (rule ValuesRepresented13)
done

lemma OpsValues_Represented_emp:"OpsValues_Represented c [] [] ={}"
by (simp add: OpsValues_Represented_def)
lemma StoreValues_Represented_emp:"StoreValues_Represented c emp emp = {}"
by (simp add: StoreValues_Represented_def AL_emp1)
lemma AddrValues_Represented_emp:"AddrValues_Represented c emp J = {}"
by (simp add: AddrValues_Represented_def AL_emp1 AL_dom_emp)
lemma FieldValues_Represented_emp:" FieldValues_Represented c emp J emp = {}"
by (simp add: FieldValues_Represented_def AL_emp1 AL_dom_emp)

lemma Values_Represented_split:
"ValuesRepresented c (T, \<Delta>, K) (ops, s, h) J = 
ValuesRepresented c (T, \<Delta>, emp) (ops, s, emp) J \<union> ValuesRepresented c ([], emp, K) ([], emp, h) J"
apply (subgoal_tac "Values_Represented c (T, \<Delta>, K) (ops, s, h) J = 
Values_Represented c (T, \<Delta>, emp) (ops, s, emp) J \<union> Values_Represented c ([], emp, K) ([], emp, h) J")
apply (simp add: ValRepEQ)
apply (simp add: Values_Represented_def OpsValues_Represented_emp
   StoreValues_Represented_emp AddrValues_Represented_emp FieldValues_Represented_emp)  apply fast
done

lemma ValuesRepresented21:
    "\<lbrakk>  (S1, P1, \<Gamma>1, S) \<in> absFrame; (a, P1, SS, ops) \<in> Frame;
     ValuesRepresented ca ([c1], emp, HH_Ha) ([va], emp, hh) I1 \<subseteq> ValuesRepresented ca ([], \<Gamma>1, bb) ([], SS, b) I;
     ValuesRepresented ca \<Sigma> \<sigma> I1a \<subseteq> ValuesRepresented ca (c1 # S, \<Gamma>, HH_Ha) (va # ops, aa, hh) I1\<rbrakk>
    \<Longrightarrow> ValuesRepresented ca \<Sigma> \<sigma> I1a \<subseteq> ValuesRepresented ca (S1, \<Gamma>, bb) (a, aa, b) I"
apply (erule SetTriv101) 
apply (subgoal_tac "ValuesRepresented ca ([c1], emp, HH_Ha) ([va], emp, hh) I1 \<union> 
                    ValuesRepresented ca (S, \<Gamma>, HH_Ha) (ops, aa, hh) I1 \<subseteq> ValuesRepresented ca (S1, \<Gamma>, bb) (a, aa, b) I") 
apply (rule SetTriv101) prefer 2 apply (rotate_tac -1) apply assumption 
                        apply (erule thin_rl)+ apply (insert ValuesRepresented14) apply fast 
apply (rotate_tac -1, erule thin_rl) 
apply (rule SetTriv102) apply (erule SetTriv101)
   apply (rule SetTriv101)
     apply (erule ValuesRepresented18) apply assumption
     apply (rule ValuesRepresented13)
apply (rule SetTriv109) apply (rule Values_Represented_split) apply clarsimp 
  apply rule 
    apply (rule SetTriv101) apply (erule ValuesRepresented19) apply assumption
    apply (simp (no_asm) add:  ValuesRepresented_def, clarsimp)
    apply (erule disjE, simp add: AL_dom_emp)
    apply (clarsimp, simp add: AL_emp1)
  apply (rule_tac Y="ValuesRepresented ca (S1, emp, bb) (a, emp, b) I" in SetTriv101) prefer 2 apply (rule ValuesRepresented13)
  apply (rule SetTriv101) apply (rule_tac S="[c1]" and ops="[va]" in ValuesRepresented12)
  apply (erule SetTriv101) apply (erule ValuesRepresented18) apply assumption
done

lemma Invv_SingleVal_Aux:
 "\<lbrakk> (T1, par, \<Delta>1, d # T) \<in> absFrame; (ops, par, SS, RVal (Loc a) # osa) \<in> Frame;
    ValuesRepresented c ([cc], emp, H) ([v], emp, h) J \<subseteq>
      ValuesRepresented c ([], \<Delta>1[this\<mapsto>d], K) ([], SS[this\<mapsto>(RVal (Loc a))], k) I\<rbrakk>
  \<Longrightarrow> ValuesRepresented c ([cc], emp, H) ([v], emp, h) J \<union> ValuesRepresented c (T, \<Delta>, emp) (osa, s, emp) J
       \<subseteq> ValuesRepresented c (T1, \<Delta>, K) (ops, s, k) I"
apply clarsimp
apply rule
  apply (erule SetTriv101) apply (rule SetTriv101) 
  apply (erule ValuesRepresented_InvV) apply assumption 
  apply (rule ValuesRepresented13)
apply (rule SetTriv101)
  apply (rule_tac d=d and v="RVal(Loc a)" in ValuesRepresented9)
  apply (rule SetTriv101) 
  apply (erule ValuesRepresented19) apply assumption 
  apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
  apply (erule disjE, simp add: AL_dom_emp)
  apply (simp add: AL_emp1)
done 

lemma Invs_SingleVal_Aux:
  "\<lbrakk> (T1, P2, \<Delta>1, T) \<in> absFrame; (ops, P2, SS, opsa) \<in> Frame;
     ValuesRepresented d ([c], emp, H) ([v], emp, h) J \<subseteq> ValuesRepresented d ([], \<Delta>1, K) ([], SS, k) I\<rbrakk>
    \<Longrightarrow> ValuesRepresented d ([c], emp, H) ([v], emp, h) J \<union> ValuesRepresented d (T, \<Delta>, emp) (opsa, s, emp) J
       \<subseteq> ValuesRepresented d (T1, \<Delta>, K) (ops, s, k) I"
apply (subgoal_tac "ValuesRepresented d ([], \<Delta>1, K) ([], SS, k) I \<subseteq> ValuesRepresented d (T1, emp, K) (ops, emp, k) I") 
 prefer 2 apply (erule ValuesRepresented18, assumption)
 apply (drule SetTriv101, assumption)
 apply (subgoal_tac "ValuesRepresented d ([c], emp, H) ([v], emp, h) J \<subseteq> ValuesRepresented d (T1, \<Delta>, K) (ops, ac, k) I")
 prefer 2 apply (rotate_tac -1, erule SetTriv101) apply (rule ValuesRepresented13)
 apply clarsimp
apply rule apply (erule SetTriv101) apply (rule ValuesRepresented13) 
 apply clarsimp
 apply (drule_tac x=x in SetTriv104) apply (rule Values_Represented_split) apply clarsimp
 apply (erule disjE) apply (rule SetTriv) prefer 2 apply (erule ValuesRepresented19) apply assumption
 apply (erule SetTriv)
 apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
 apply (erule disjE, clarsimp) apply (simp add: AL_dom_emp)
 apply clarsimp apply (simp add: AL_emp1)
apply (erule SetTriv) apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
 apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
 apply (erule disjE, clarsimp) apply (simp add: AL_dom_emp)
 apply clarsimp apply (simp add: AL_emp1)
done

lemma VR_X:"\<lbrakk>c=S!n; n < length S\<rbrakk> \<Longrightarrow> ops!n : ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I"
apply (simp add: ValuesRepresented_def)
apply (rule disjI1)
apply (rule_tac x=n in exI, simp)
done

lemma InvV_InvokerIsSubclassUni:
  "\<lbrakk> unisat (ops1, s1, h1) (S1, \<Gamma>, H) N I;
     (ops1, params, s, RVal (Loc a) # os) \<in> Frame; h1\<down>a = Some (C, Flds);
     (S1, params, \<Gamma>1, d # S) \<in> absFrame; H\<down>d = Some (D, F)\<rbrakk> 
  \<Longrightarrow> subclass_of C D"
apply (drule Frame_TailCons) apply clarsimp 
         apply (drule absFrame_TailCons) apply clarsimp
         apply (simp add: unisat_def, clarsimp)
         apply (simp add: StateSatisfiesAbstraction_def, clarsimp) 
         apply (simp add: State_typecorrect_def, clarsimp)
         apply (simp add: Heap_typecorrect_expand)
         apply (erule_tac x="S1 ! length params" in allE, clarsimp)
         apply (subgoal_tac "(I (S1 ! length params)) = Some a", clarsimp)
           apply (simp add: Object_typecorrect_def) 
         apply (simp add: uniqueValues_def)
         apply (erule_tac x="S1 ! length params" in allE, erule impE) apply (simp add: DOM_def,clarsimp)
         apply (subgoal_tac "(ops1 ! length params) : ValuesRepresented (S1 ! length params) (S1, \<Gamma>, H) (ops1, s1, h1) I")
         prefer 2 apply (rule VR_X) apply simp apply assumption
         apply clarsimp
         apply (subgoal_tac "(RVal(Loc aa)) : ValuesRepresented (S1 ! length params) (S1, \<Gamma>, H) (ops1, s1, h1) I")
         prefer 2 apply (rule ValuesRepresented3) apply (erule AL_domI) apply assumption 
         apply clarsimp apply (subgoal_tac "RVal (Loc aa) = RVal (Loc a)",fast) apply clarsimp 
done

lemma InvokeV_Final_State_welldef:
"\<lbrakk> (S1, P1, \<Gamma>1, d # S) \<in> absFrame; State_welldef (S1, \<Gamma>, bc) N; State_welldef ([c], emp, HHa) NN; 
         AL_sum H Ha bc; AL_sum HH Ha HHa; AL_dom H \<subseteq> AL_dom HH; contained N NN\<rbrakk>
       \<Longrightarrow> State_welldef (c # S, \<Gamma>, HHa) NN"
apply (drule absFrame_State_welldef_Leftover) apply assumption
apply (erule thin_rl)
apply (drule_tac Sa="d#S" in Invoke_State_welldef_preserved1) apply assumption apply assumption 
   apply (simp add: AL_sum_def, clarsimp) apply (rule, rule SetTriv101) apply (erule contained5) apply fast apply fast
apply (erule State_welldef_ConsMerge) apply (erule State_welldef_Tail) 
done

lemma InvS_StateSatisfiesAbstraction:
  "\<lbrakk> (a, P1, SS, ops) \<in> Frame; (S1, P1, \<Gamma>1, S) \<in> absFrame; 
     State_welldef (S1, \<Gamma>, bb) af;  
     StateSatisfiesAbstraction (a, aa, b) (S1, \<Gamma>, bb) af I; 
     StateSatisfiesAbstraction ([va], emp, hh) ([c1], emp, HHa) NNa I1;
     
     contained af ak; contained af NNa; contained N NN; contained NN ap;

     AL_sum N Na af; AL_sum ap Na ak; AL_sum NN Na NNa; 
     \<forall>c. c \<in> AL_dom af \<longrightarrow> Invariant c ([c1], emp, HHa) ([va], emp, hh) I1 af ([], \<Gamma>1, bb) ([], SS, b) I\<rbrakk>
    \<Longrightarrow> StateSatisfiesAbstraction (va # ops, aa, hh) (c1 # S, \<Gamma>, HHa) NNa I1"
apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
apply (subgoal_tac "State_typecorrect NNa (c1 # S, \<Gamma>, HHa) (va # ops, aa, hh) I1", rule, assumption)
prefer 2 apply (simp add: State_typecorrect_def, clarsimp)
                        apply (rule, simp add: Opstack_typecorrect_def, clarsimp)
                          apply (case_tac n, clarsimp) 
                          apply clarsimp apply (drule_tac S=S in absFrame_List_D_Right) apply assumption apply clarsimp
                                         apply (erule_tac x="nat + length P1" in allE, erule impE, assumption) apply clarsimp
                                         apply (drule_tac NN=NNa in contained3, assumption) apply (rule_tac x=tpa in exI, clarsimp) 
                                         apply (drule_tac S=ops and n="nat + length P1" in Frame_List_D_Left) apply simp apply simp
                                         apply clarsimp
                        apply (simp add: Store_typecorrect_def, clarsimp)
                          apply (erule_tac x=x in allE, erule_tac x=c in allE, erule impE, assumption) apply clarsimp
                                         apply (drule_tac NN=NNa in contained3, assumption) apply (rule_tac x=tp in exI, clarsimp)
apply (frule_tac S=S in absFrame_ListLength) apply (frule_tac S=ops in Frame_ListLength) apply clarsimp
                        apply (subgoal_tac "DOM (c1 # S, \<Gamma>, HHa) = DOM ([c1], emp, HHa) \<union> DOM (S, \<Gamma>, emp)")
                        prefer 2 apply (rule DOM_split_equals) 
apply (rule, simp add: uniqueValues_def, clarsimp)
  apply (rule, clarsimp)
    apply (erule_tac x=c in allE, erule impE, assumption) apply (erule exE)
    apply (case_tac "c \<in> DOM (S1, \<Gamma>, bb)") 
      apply (erule_tac x=c in allE, erule impE) apply (erule SetTriv, erule State_welldef_DOM_ALdom)
      apply (simp add: Invariant_def ValRepEQ) apply (erule conjE)+
      apply (erule_tac x=c in allE, erule impE, assumption) apply (erule exE)
      apply (frule absFrame_State_welldef_Leftover) apply assumption 
      apply (frule_tac d=c and c=c1 and v=va and s=aa and H=HHa and 
             h=hh and k=b and J=I1 and I=I and K=bb and \<Delta>=\<Gamma> in Invs_SingleVal_Aux) 
         apply assumption apply clarsimp
      apply (rule_tac x=v in exI)
      apply (subgoal_tac "ValuesRepresented c (c1 # S, \<Gamma>, HHa) (va # ops, aa, hh) I1 = 
                         ValuesRepresented c ([c1], emp, HHa) ([va], emp, hh) I1 \<union>
                         ValuesRepresented c (S, \<Gamma>, HHa) (ops, aa, hh) I1") 
      prefer 2 apply (rule ValuesRepresented14)
      apply rule prefer 2 apply clarsimp 
      apply (erule SetTriv109) apply clarsimp 
      apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, HHa) (ops, aa, hh) I1 =
             ValuesRepresented c (S, \<Gamma>, emp) (ops, aa, emp) I1 \<union> ValuesRepresented c ([], emp, HHa) ([], emp, hh) I1")
        apply clarsimp
        apply (erule disjE) apply (rotate_tac -2, erule thin_rl) apply fast 
        apply (drule_tac x=x and Y="ValuesRepresented c ([c1], emp, HHa) ([va], emp, hh) I1" in SetTriv) 
          apply (rule ValuesRepresented15)
          apply clarsimp
      apply (rule Values_Represented_split)
    apply (subgoal_tac "ValuesRepresented c (S1, \<Gamma>, bb) (a, aa, b) I = {}")
    prefer 2 apply (erule ValuesRepresented_notin_DOM)
    apply (rotate_tac 13) apply (erule thin_rl)
    apply (rule_tac x=v in exI)
      apply (subgoal_tac "ValuesRepresented c (c1 # S, \<Gamma>, HHa) (va # ops, aa, hh) I1 = 
                         ValuesRepresented c ([c1], emp, HHa) ([va], emp, hh) I1 \<union> ValuesRepresented c (S, \<Gamma>, HHa) (ops, aa, hh) I1") 
      prefer 2 apply (rule ValuesRepresented14)
      apply rule prefer 2 apply clarsimp 
      apply (erule SetTriv109) apply clarsimp 
       apply (drule SetTriv, rule ValuesRepresented19) apply assumption apply assumption
       apply (subgoal_tac "x \<in> Values_Represented c (S1, \<Gamma>, HHa) (a, aa, hh) I1") prefer 2 apply (simp add: ValRepEQ)
       apply (subgoal_tac "Values_Represented c (S1, \<Gamma>, bb) (a, aa, b) I = {}") prefer 2 apply (simp add: ValRepEQ)
       apply (subgoal_tac "Values_Represented c ([c1], emp, HHa) ([va], emp, hh) I1 = {v}") prefer 2 apply (simp add: ValRepEQ)
       apply (rotate_tac -4, erule thin_rl) apply (simp add: Values_Represented_def)
       apply (erule disjE, clarsimp) apply fast
       apply fast
  apply clarsimp
    apply (subgoal_tac "c \<in> DOM (S1, \<Gamma>, bb)")
    prefer 2 apply (simp add: DOM_def) apply (simp add: AL_dom_emp AbsFields_emp) apply clarsimp
             apply (drule SetTriv, erule absFrame_List_D_Right2) apply simp

      apply (erule_tac x=c in allE, erule impE) apply (erule SetTriv, erule State_welldef_DOM_ALdom)
      apply (simp add: Invariant_def ValRepEQ) apply (erule conjE)+
      apply (erule_tac x=c in allE, erule impE, assumption) apply (erule exE)
      apply (frule absFrame_State_welldef_Leftover) apply assumption 
      apply (frule_tac d=c and c=c1 and v=va and s=aa and H=HHa and 
             h=hh and k=b and J=I1 and I=I and K=bb and \<Delta>=\<Gamma> in Invs_SingleVal_Aux) 
         apply assumption apply clarsimp
      apply (rule_tac x=v in exI)
      apply (subgoal_tac "ValuesRepresented c (c1 # S, \<Gamma>, HHa) (va # ops, aa, hh) I1 = 
                         ValuesRepresented c ([c1], emp, HHa) ([va], emp, hh) I1 \<union>
                         ValuesRepresented c (S, \<Gamma>, HHa) (ops, aa, hh) I1") 
      prefer 2 apply (rule ValuesRepresented14)
      apply clarsimp apply (rotate_tac -3) apply(erule thin_rl) 
      apply rule apply clarsimp 
        apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, HHa) (ops, aa, hh) I1 =
             ValuesRepresented c (S, \<Gamma>, emp) (ops, aa, emp) I1 \<union> ValuesRepresented c ([], emp, HHa) ([], emp, hh) I1")
        prefer 2 apply (rule Values_Represented_split)
        apply clarsimp apply (rotate_tac -1, erule thin_rl) 
        apply (erule disjE) apply fast
        apply (drule_tac x=x and Y="ValuesRepresented c ([c1], emp, HHa) ([va], emp, hh) I1" in SetTriv) 
          apply (rule ValuesRepresented15)
          apply (drule_tac x=x in SetTriv) apply assumption apply simp
      apply clarsimp
        apply(subgoal_tac "\<exists> w . w:ValuesRepresented c (S, \<Gamma>, HHa) (ops, aa, hh) I1")
        prefer 2 apply (subgoal_tac "State_typecorrect NNa (S, \<Gamma>, HHa) (ops, aa, hh) I1") 
                   apply (drule_tac N=NNa and \<Sigma>="(S, \<Gamma>, HHa)" and c=c in State_typecorrect_VR_notEmpty) 
                    apply (simp add: DOM_def) apply (erule disjE) apply (erule disjI1)
                      apply (rotate_tac -1, erule disjE) apply (rule disjI2) apply (erule disjI1)
                      apply (rotate_tac -1, erule disjE) apply (simp add: AL_dom_emp)
                      apply (simp add: AbsFields_emp) 
                   apply (simp add: ValRepEQ) apply fast
                 apply (erule State_typecorrect_Tail)
        apply clarsimp
          apply (subgoal_tac "w:ValuesRepresented c (S, \<Gamma>, emp) (ops, aa, emp) I1 \<union> 
                                ValuesRepresented c ([], emp, HHa) ([], emp, hh) I1", clarsimp)
          prefer 2 apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, HHa) (ops, aa, hh) I1 =
                                       ValuesRepresented c (S, \<Gamma>, emp) (ops, aa, emp) I1 \<union> 
                                ValuesRepresented c ([], emp, HHa) ([], emp, hh) I1", clarsimp)
                   apply (rule Values_Represented_split)
          apply (erule disjE) apply (drule_tac x=w in SetTriv, assumption) apply simp
          apply (drule_tac x=w and X="ValuesRepresented c ([], emp, HHa) ([], emp, hh) I1"
                   and Y="ValuesRepresented c ([c1], emp, HHa) ([va], emp, hh) I1" in SetTriv)
            apply (rule ValuesRepresented15)
          apply (drule_tac x=w and Y="{v}" in SetTriv, assumption) apply simp
(*The final 20 lines differ from the proof in ../13/12/ due to the elimination of dom I subseteq dom I1 from the postcondition*)
apply clarsimp
                        apply (rule_tac m=I1 in domD) 
                        apply (erule disjE) 
                          apply (rule_tac X="DOM ([c1], emp, HHa) \<inter> ObjIDs NNa" in SetTriv) apply simp apply assumption
                        apply (subgoal_tac "x:set S \<or> x:AL_cod \<Gamma>")
                        prefer 2 apply (simp add: DOM_def AL_dom_emp AbsFields_emp) 
                        apply (subgoal_tac "x: AL_dom af")
                        prefer 2 apply (erule disjE, rule SetTriv) prefer 2 apply (erule State_welldef_OPS_lookup_set_dom)
                                                                            apply (erule SetTriv, erule absFrame_List_D_Right2)
                                 apply (rule SetTriv) prefer 2 apply (erule State_welldef_Store_lookup_cod_dom) apply assumption
                        apply (subgoal_tac "x:ObjIDs af")
                        prefer 2 apply (simp add: ObjIDs_def, drule AL_domD, clarsimp) apply(drule contained3, assumption, clarsimp)
                        apply (subgoal_tac "x:dom I")
                        prefer 2 apply (rule_tac X="DOM (S1, \<Gamma>, bb) \<inter> ObjIDs af" in SetTriv) prefer 2 apply assumption
                                 apply clarsimp apply (simp add: DOM_def) 
                                 apply (erule disjE) apply (rule disjI1) apply (erule SetTriv, erule absFrame_List_D_Right2) apply simp
                        apply (erule_tac x=x in allE, erule impE, assumption)
                        apply (simp add: Invariant_def, clarsimp)
done

lemma absFrame_InvV_StateSatisfiesAbstraction:
"\<lbrakk>(S, Q, \<Gamma>, c # T) \<in> absFrame; (ops, Q, tt, RVal (Loc am) # os1) \<in> Frame;
    NN\<down>c = Some (classTP C); 
     StateSatisfiesAbstraction (ops, t, k) (S, \<Delta>, K) NN J;  State_welldef (S, \<Delta>, K) NN\<rbrakk>
    \<Longrightarrow> StateSatisfiesAbstraction ([], tt[this\<mapsto>(RVal (Loc am))], k) ([], \<Gamma>[this\<mapsto>c], K) NN J"
apply (simp add: StateSatisfiesAbstraction_def, clarsimp) 
apply (subgoal_tac "State_typecorrect NN ([], \<Gamma>[this\<mapsto>c], K) ([], tt[this\<mapsto>(RVal (Loc am))], k) J", rule, assumption)
prefer 2
    apply (simp add: State_typecorrect_def, clarsimp) 
    apply (rule, simp add: Opstack_typecorrect_def) 
    apply (simp (no_asm) add: Store_typecorrect_def, clarsimp) 
      apply (drule AL_upd_split) 
      apply (erule disjE, clarsimp)  
        apply (simp add: AL_update1)
      apply clarsimp apply (drule absFrameFrame_StoreLookup) apply assumption apply assumption apply clarsimp 
        apply (drule State_welldef_OPS_lookup) apply assumption apply clarsimp
        apply (rule, rule, erule AL_update5) apply assumption
        apply (simp add: Opstack_typecorrect_def) apply (erule_tac x=n in allE, clarsimp)
apply (subgoal_tac "DOM ([], \<Gamma>[this\<mapsto>c], K) \<subseteq> DOM (S, \<Delta>, K)")
prefer 2 apply (erule absFrame_DOM_InvV)
apply (rule, simp add:uniqueValues_def, clarsimp)
    apply (erule_tac x=ca in allE, erule impE, erule SetTriv, assumption) apply (erule exE)
    apply (rule_tac x=v in exI)
    apply rule apply (erule SetTriv110) apply (rule SetTriv101) apply (erule ValuesRepresented_InvV) apply assumption
                                        apply (rule ValuesRepresented13)
    apply (subgoal_tac "\<exists> w . w:ValuesRepresented ca ([], \<Gamma>[this\<mapsto>c], K) ([], tt[this\<mapsto>(RVal (Loc am))], k) J")
    prefer 2 apply (subgoal_tac "ValuesRepresented ca ([], \<Gamma>[this\<mapsto>c], K) ([], tt[this\<mapsto>(RVal (Loc am))], k) J \<noteq> {}", fast)
             apply (subgoal_tac "Values_Represented ca ([], \<Gamma>[this\<mapsto>c], K) ([], tt[this\<mapsto>(RVal (Loc am))], k) J \<noteq> {}", simp add: ValRepEQ)
             apply (erule State_typecorrect_VR_notEmpty) apply assumption
    apply (erule exE)
    apply (subgoal_tac "w=v", clarsimp)
    apply (drule_tac x=w in SetTriv) apply (rule SetTriv101) apply (erule ValuesRepresented_InvV) apply assumption
                                        apply (rule_tac \<Gamma>=\<Delta> and s=t in ValuesRepresented13) apply clarsimp
apply (rule SetTriv101) prefer 2 apply assumption apply fast
done

lemma InvS_Invariant:
  "\<lbrakk> Invariant ca ([c], emp, bd) ([v], emp, hh) I1 N0 ([], \<Gamma>1, bc) ([], SS, b) I;
     (S1, P1, \<Gamma>1, S) \<in> absFrame; (a, P1, SS, ops) \<in> Frame; 
     State_welldef (S1, \<Gamma>, bc) N0; State_welldef ([c], emp, bd) N1; 
     contained N0 N1; AL_dom bc \<subseteq> AL_dom bd\<rbrakk>
   \<Longrightarrow> Invariant ca (c # S, \<Gamma>, bd) (v # ops, aa, hh) I1 N0 (S1, \<Gamma>, bc) (a, aa, b) I"
apply (unfold Invariant_def, clarsimp)
apply (simp add: ValRepEQ)
apply (erule SetTriv)
 apply (rule ValuesRepresented21) 
   apply assumption+ apply fast
done

lemma InvV_StateSatisfiesAbstraction:
 "\<lbrakk> (S1, P1, (\<Gamma>1::VarContext), (d1::Colour) # S) \<in> absFrame; (ai, P1, Sa, RVal (Loc av) # os) \<in> Frame;
     State_welldef (S1, \<Gamma>, bf) ao;
     StateSatisfiesAbstraction (ai, aj, bd) (S1, \<Gamma>, bf) ao I;
     StateSatisfiesAbstraction ([va], emp, hh) ([c1], emp, bh) NN I1; 

     contained ao NN;
     \<forall>c. c \<in> AL_dom ao \<longrightarrow>
         Invariant c ([c1], emp, bh) ([va], emp, hh) I1 ao ([], \<Gamma>1[this\<mapsto>d1], bf) ([], Sa[this\<mapsto>(RVal (Loc av))], bd) I\<rbrakk>
    \<Longrightarrow> StateSatisfiesAbstraction (va # os, aj, hh) (c1 # S, \<Gamma>, bh) NN I1"
apply (simp add: StateSatisfiesAbstraction_def, clarsimp)
apply (subgoal_tac "State_typecorrect NN (c1 # S, \<Gamma>, bh) (va # os, aj, hh) I1", rule, assumption)
prefer 2 apply (simp add: State_typecorrect_def, clarsimp)
                        apply (rule, simp add: Opstack_typecorrect_def, clarsimp)
                          apply (case_tac n, clarsimp) 
                          apply clarsimp apply (drule_tac S="d1#S" and n="Suc nat" in absFrame_List_D_Right) apply simp apply clarsimp
                                         apply (erule_tac x="Suc(nat + length P1)" in allE, erule impE, assumption) apply clarsimp
                                         apply (drule_tac c="(S1 ! Suc (nat + length P1))" in contained3, assumption) 
                                         apply (rule_tac x=tpa in exI, clarsimp)
                                         apply (drule_tac S="RVal (Loc av) # os" and n="Suc(nat + length P1)" in Frame_List_D_Left) apply simp apply simp
                                         apply clarsimp
                        apply (simp add: Store_typecorrect_def, clarsimp)
                          apply (erule_tac x=x in allE, erule_tac x=c in allE, erule impE, assumption) apply clarsimp
                                         apply (drule_tac c=c in contained3, assumption) apply (rule_tac x=tp in exI, clarsimp) 
apply (frule_tac S="d1 # S" in absFrame_ListLength) apply (frule_tac S="RVal (Loc av) # os" in Frame_ListLength) apply clarsimp
apply (subgoal_tac "DOM (c1 # S, \<Gamma>, bh) = DOM ([c1], emp, bh) \<union> DOM (S, \<Gamma>, emp)")
prefer 2 apply (rule DOM_split_equals)
apply (rule, simp add: uniqueValues_def, clarsimp)
  apply (rule, clarsimp)
    apply (erule_tac x=c in allE, erule impE, assumption) apply (erule exE)
    apply (case_tac "c \<in> DOM (S1, \<Gamma>, bf)") 
      apply (erule_tac x=c in allE, erule impE) apply (erule SetTriv, erule State_welldef_DOM_ALdom)
      apply (simp add: Invariant_def ValRepEQ) apply (erule conjE)+
      apply (erule_tac x=c in allE, erule impE, assumption) apply (erule exE)
      apply (frule absFrame_State_welldef_Leftover) apply assumption 
      apply (drule_tac c=c and cc=c1 and v=va and s=aj and H=bh and h=hh and 
               K=bf and k=bd and \<Delta>=\<Gamma> and J=I1 and I=I in Invv_SingleVal_Aux) 
        apply assumption apply clarsimp
      apply (subgoal_tac "vaa=v")
      prefer 2 apply (subgoal_tac "v:ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1")
                 apply (drule_tac X="ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1" 
                         and Y="ValuesRepresented c (S1, \<Gamma>, bf) (ai, aj, bd) I" in SetTriv) apply fast
                 apply clarsimp
               apply fast
      apply clarsimp
      apply (rule_tac x=v in exI)
      apply (subgoal_tac "ValuesRepresented c (c1 # S, \<Gamma>, bh) (va # os, aj, hh) I1 = 
                         ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1 \<union> ValuesRepresented c (S, \<Gamma>, bh) (os, aj, hh) I1") 
      prefer 2 apply (rule ValuesRepresented14)
      apply rule prefer 2 apply clarsimp 
      apply (erule SetTriv109) apply clarsimp 
      apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, bh) (os, aj, hh) I1 =
                 ValuesRepresented c (S, \<Gamma>, emp) (os, aj, emp) I1 \<union> ValuesRepresented c ([], emp, bh) ([], emp, hh) I1")
        apply clarsimp
        apply (rotate_tac -1, erule thin_rl)
        apply (erule disjE) apply fast
        apply (drule_tac x=x and Y="ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1" in SetTriv)
          apply (rule ValuesRepresented15)
          apply clarsimp
      apply (rule Values_Represented_split)
    apply (subgoal_tac "ValuesRepresented c (S1, \<Gamma>, bf) (ai, aj, bd) I = {}")
    prefer 2 apply (erule ValuesRepresented_notin_DOM)
    apply (rotate_tac 7) apply (erule thin_rl)
    apply (rule_tac x=v in exI)
      apply (subgoal_tac "ValuesRepresented c (c1 # S, \<Gamma>, bh) (va # os, aj, hh) I1 = 
                         ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1 \<union> ValuesRepresented c (S, \<Gamma>, bh) (os, aj, hh) I1") 
      prefer 2 apply (rule ValuesRepresented14)
      apply rule prefer 2 apply clarsimp 
      apply (erule SetTriv109) apply clarsimp 
       apply (drule_tac x=x in SetTriv, rule SetTriv101) apply (rule ValuesRepresented9)
            apply (erule ValuesRepresented19) apply assumption 
       apply (subgoal_tac "x \<in> Values_Represented c (S1, \<Gamma>, bh) (ai, aj, hh) I1") prefer 2 apply (simp add: ValRepEQ)
       apply (subgoal_tac "Values_Represented c (S1, \<Gamma>, bf) (ai, aj, bd) I = {}") prefer 2 apply (simp add: ValRepEQ)
       apply (subgoal_tac "Values_Represented c ([c1], emp, bh) ([va], emp, hh) I1 = {v}") prefer 2 apply (simp add: ValRepEQ)
       apply (rotate_tac -4, erule thin_rl, simp add: Values_Represented_def)
       apply (erule disjE, clarsimp) apply fast
       apply fast
  apply clarsimp
    apply (subgoal_tac "c \<in> DOM (S1, \<Gamma>, bf)") 
      prefer 2 apply (simp add: DOM_def) apply (simp add: AL_dom_emp AbsFields_emp) apply clarsimp
               apply (drule_tac x=c in SetTriv, rule SetTriv101)
                 prefer 2 apply (erule absFrame_List_D_Right2) 
                 apply clarsimp 
               apply simp
    apply (erule_tac x=c in allE, erule impE) apply (erule SetTriv, erule State_welldef_DOM_ALdom)
      apply (simp add: Invariant_def ValRepEQ) apply (erule conjE)+
      apply (erule_tac x=c in allE, erule impE, assumption) apply (erule exE)
      apply (frule absFrame_State_welldef_Leftover) apply assumption 
      apply (drule_tac c=c and cc=c1 and v=va and s=aj and H=bh and h=hh and 
               K=bf and k=bd and \<Delta>=\<Gamma> and J=I1 and I=I in Invv_SingleVal_Aux) 
        apply assumption apply clarsimp
      apply (rule_tac x=v in exI)
      apply (subgoal_tac "ValuesRepresented c (c1 # S, \<Gamma>, bh) (va # os, aj, hh) I1 = 
                         ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1 \<union>
                         ValuesRepresented c (S, \<Gamma>, bh) (os, aj, hh) I1") 
      prefer 2 apply (rule ValuesRepresented14)
      apply clarsimp apply (rotate_tac -3) apply(erule thin_rl) 
      apply rule apply clarsimp 
        apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, bh) (os, aj, hh) I1 =
             ValuesRepresented c (S, \<Gamma>, emp) (os, aj, emp) I1 \<union> ValuesRepresented c ([], emp, bh) ([], emp, hh) I1")
        prefer 2 apply (rule Values_Represented_split)
        apply clarsimp apply (rotate_tac -1, erule thin_rl) 
        apply (erule disjE) apply fast
        apply (drule_tac x=x and Y="ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1" in SetTriv) 
          apply (rule ValuesRepresented15)
          apply (drule_tac x=x in SetTriv) apply assumption apply simp
      apply clarsimp
        apply(subgoal_tac "\<exists> w . w:ValuesRepresented c (S, \<Gamma>, bh) (os, aj, hh) I1")
        prefer 2 apply (subgoal_tac "State_typecorrect NN (S, \<Gamma>, bh) (os, aj, hh) I1") 
                   apply (drule_tac N=NN and \<Sigma>="(S, \<Gamma>, bh)" and c=c in State_typecorrect_VR_notEmpty) 
                    apply (simp add: DOM_def) apply (erule disjE) apply (erule disjI1)
                      apply (rotate_tac -1, erule disjE) apply (rule disjI2) apply (erule disjI1)
                      apply (rotate_tac -1, erule disjE) apply (simp add: AL_dom_emp)
                      apply (simp add: AbsFields_emp) 
                   apply (simp add: ValRepEQ) apply fast
                 apply (erule State_typecorrect_Tail)
        apply clarsimp
          apply (subgoal_tac "w:ValuesRepresented c (S, \<Gamma>, emp) (os, aj, emp) I1 \<union> 
                                ValuesRepresented c ([], emp, bh) ([], emp, hh) I1", clarsimp)
          prefer 2 apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, bh) (os, aj, hh) I1 =
                                       ValuesRepresented c (S, \<Gamma>, emp) (os, aj, emp) I1 \<union> 
                                ValuesRepresented c ([], emp, bh) ([], emp, hh) I1", clarsimp)
                   apply (rule Values_Represented_split)
          apply (erule disjE) apply (drule_tac x=w in SetTriv, assumption) apply simp
          apply (drule_tac x=w and X="ValuesRepresented c ([], emp, bh) ([], emp, hh) I1"
                   and Y="ValuesRepresented c ([c1], emp, bh) ([va], emp, hh) I1" in SetTriv)
            apply (rule ValuesRepresented15)
          apply (drule_tac x=w and Y="{v}" in SetTriv, assumption) apply simp
          (*The following 20 lines differ from the proof in ../13/12/ due to the eliminatrion of dom I subseteq dom I1 from the postcondition*)
   apply clarsimp apply (erule disjE) apply fast
                        apply (subgoal_tac "x:set S \<or> x:AL_cod \<Gamma>")
                        prefer 2 apply (simp add: DOM_def AL_dom_emp AbsFields_emp) 
                        apply (subgoal_tac "x: AL_dom ao")
                        prefer 2 apply (erule disjE, rule SetTriv) prefer 2 apply (erule State_welldef_OPS_lookup_set_dom)
                                                                            apply (rule_tac X="set(d1 # S)" in SetTriv) apply simp
                                                                            apply (erule absFrame_List_D_Right2)
                                 apply (rule SetTriv) prefer 2 apply (erule State_welldef_Store_lookup_cod_dom) apply assumption
                        apply (subgoal_tac "x:ObjIDs ao")
                        prefer 2 apply (simp add: ObjIDs_def, drule AL_domD, clarsimp) apply(drule contained3, assumption, clarsimp)
                        apply (subgoal_tac "x:dom I")
                        prefer 2 apply (rule_tac X="DOM (S1, \<Gamma>, bf) \<inter> ObjIDs ao" in SetTriv) prefer 2 apply assumption
                                 apply clarsimp apply (simp add: DOM_def) 
                                 apply (erule disjE) apply (rule disjI1) apply (rule_tac X="set(d1 # S)" in SetTriv) apply simp
                                                                            apply (erule absFrame_List_D_Right2) apply simp
                        apply (erule_tac x=x in allE, erule impE, assumption)
                        apply (simp add: Invariant_def)
                        apply clarsimp
done


lemma InvV_Invariant:
"\<lbrakk> Invariant ca ([c], emp, HHa) ([v], emp, hh) I1 N ([], \<Gamma>1[this\<mapsto>d], bc) ([], Sa[this\<mapsto>(RVal (Loc aj))], b) I;
   (S1, P1, \<Gamma>1, d # S) \<in> absFrame; (a, P1, Sa, RVal (Loc aj) # os) \<in> Frame;
   State_welldef (S1, \<Gamma>, bc) N;  State_welldef ([c], emp, HHa) NN; 
   contained N NN; AL_dom bc \<subseteq> AL_dom HHa\<rbrakk>
  \<Longrightarrow> Invariant ca (c # S, \<Gamma>, HHa) (v # os, aa, hh) I1 N (S1, \<Gamma>, bc) (a, aa, b) I"
apply (unfold Invariant_def, clarsimp)
apply (simp add: ValRepEQ)
apply (erule SetTriv)
apply (subgoal_tac "ValuesRepresented ca (c # S, \<Gamma>, HHa) (v # os, aa, hh) I1 = 
                               ValuesRepresented ca ([c], emp, HHa) ([v], emp, hh) I1 \<union> 
                               ValuesRepresented ca (S, \<Gamma>, HHa) (os, aa, hh) I1", clarsimp)
           prefer 2 apply (rule ValuesRepresented14)
           apply rule
             apply (erule SetTriv101) apply (rule SetTriv101) apply (erule ValuesRepresented_InvV) apply assumption
                                                              apply (rule ValuesRepresented13)
apply (rule SetTriv109) apply (rule Values_Represented_split) apply clarsimp
apply rule
            apply (rule SetTriv101) apply (rule_tac d=d and v="RVal (Loc aj)" in ValuesRepresented9)
            apply (rule SetTriv101) apply (erule ValuesRepresented19) apply assumption
            apply (rule_tac Y="ValuesRepresented ca (S1, \<Gamma>, emp) (a, aa, emp) I" in SetTriv101) 
             apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
              apply (erule disjE, simp add: AL_dom_emp)
              apply (simp add: AL_emp1)
             apply (subgoal_tac "ValuesRepresented ca (S1, \<Gamma>, bc) (a, aa, b) I =
                       ValuesRepresented ca (S1, \<Gamma>, emp) (a, aa, emp) I \<union>
                       ValuesRepresented ca ([], emp, bc) ([], emp, b) I", clarsimp) 
              apply (rule Values_Represented_split)
apply (rule_tac Y="ValuesRepresented ca ([c], emp, HHa) ([v], emp, hh) I1" in SetTriv101)
  apply (rule ValuesRepresented9)
  apply (erule SetTriv101) 
  apply (rule SetTriv101) apply (erule ValuesRepresented_InvV) apply assumption
  apply (rule ValuesRepresented13)
done

end