theory InvokeRelationalBasics = SatSec + InvokeBasics:

lemma absFrame_welldef:
  "\<lbrakk>(S1, P1, \<Gamma>1, S) \<in> absFrame; (T1, P2, \<Delta>1, T) \<in> absFrame; 
   welldef ((S1, \<Gamma>, bb), af, T1, \<Delta>, bc)\<rbrakk> \<Longrightarrow> 
   welldef (([], \<Gamma>1, bb), af, [], \<Delta>1, bc)"
apply (simp add: welldef_def)
apply (erule conjE)+
apply rule apply (erule absFrame_State_welldef, assumption)
apply (erule absFrame_State_welldef, assumption)
done

lemma InvV_InvokerIsSubclass:
  "\<lbrakk> sat (ops1, s1, h1) (ops2, s2, h2) ((S1, \<Gamma>, H), N, (T1, \<Delta>, K)) I J;
     (ops1, params, s, RVal (Loc a) # os) \<in> Frame; h1\<down>a = Some (C, Flds);
     (S1, params, \<Gamma>1, d # S) \<in> absFrame; H\<down>d = Some (D, F)\<rbrakk> 
  \<Longrightarrow> subclass_of C D"
apply (simp add: unisat_sat, (erule conjE)+)
apply (erule InvV_InvokerIsSubclassUni, assumption+)
done

lemma ValuesRepresented16:
  "\<lbrakk>welldef ((S, \<Gamma>, bb), af, T, \<Delta>, bc);c \<notin> AL_dom af\<rbrakk>
   \<Longrightarrow> ValuesRepresented c (c2 # T, \<Delta>, KK_Ka) (vb # ops, ac, hha) J1 = ValuesRepresented c ([c2], emp, KK_Ka) ([vb], emp, hha) J1"
apply (simp add: ValuesRepresented_def)
apply (rule, clarsimp)
  apply (erule disjE, clarsimp) apply (case_tac n,clarsimp) apply clarsimp
     apply (drule welldef_OPS_lookupR) apply assumption apply clarsimp apply (drule AL_domI) apply simp
  apply (erule disjE, clarsimp) apply (drule welldef_Store_lookupR) apply assumption apply clarsimp apply (drule AL_domI,simp)
  apply assumption
apply clarsimp
  apply (erule disjE, clarsimp) apply (erule_tac x=0 in allE, clarsimp)
  apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
  apply assumption
done

lemma Invs_SingleVal_Aux2:
  "\<lbrakk> (T1, P2, \<Delta>1, T) \<in> absFrame; (ops, P2, SS, opsa) \<in> Frame;
     ValuesRepresented d ([c], emp, H) ([v], emp, h) J \<subseteq> ValuesRepresented d ([], \<Delta>1, K) ([], SS, k) I\<rbrakk>
    \<Longrightarrow> ValuesRepresented d ([c], emp, H) ([v], emp, h) J \<union> ValuesRepresented d (T, \<Delta>, H) (opsa, s, h) J
       \<subseteq> ValuesRepresented d (T1, \<Delta>, K) (ops, s, k) I"
apply (rule_tac Y="ValuesRepresented d ([c], emp, H) ([v], emp, h) J \<union> ValuesRepresented d (T, \<Delta>, emp) (opsa, s, emp) J" in SetTriv101)
prefer 2 apply (erule Invs_SingleVal_Aux) apply assumption+
apply clarsimp
apply rule apply fast
apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
done

lemma Invv_SingleVal_Aux2:
 "\<lbrakk> (T1, par, \<Delta>1, d # T) \<in> absFrame; (ops, par, SS, RVal (Loc a) # osa) \<in> Frame;
    ValuesRepresented c ([cc], emp, H) ([v], emp, h) J \<subseteq>
      ValuesRepresented c ([], \<Delta>1[this\<mapsto>d], K) ([], SS[this\<mapsto>(RVal (Loc a))], k) I\<rbrakk>
  \<Longrightarrow> ValuesRepresented c ([cc], emp, H) ([v], emp, h) J \<union> ValuesRepresented c (T, \<Delta>, H) (osa, s, h) J
       \<subseteq> ValuesRepresented c (T1, \<Delta>, K) (ops, s, k) I"
apply (rule_tac Y="ValuesRepresented c ([cc], emp, H) ([v], emp, h) J \<union> ValuesRepresented c (T, \<Delta>, emp) (osa, s, emp) J" in SetTriv101)
prefer 2 apply (erule Invv_SingleVal_Aux) apply assumption+
apply clarsimp
apply rule apply fast
apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
done

end