(*<*)
theory LanguageCommon = Main:
(*>*)

section{*Preliminaries*}

text{*Both languages are defined over an unspecified category of
program variables.*}

typedecl Var

text{*Since arithmetic operations are modelled as unimplemented
functions, we introduce the type of values in this section. In
preparation of a future extension to heaps, we include domains of
addresses and references.*}

typedecl Addr 

consts freshAddr:: "Addr set \<Rightarrow> Addr"
axioms freshAddr_fresh:"freshAddr X \<notin> X"

text{*A reference is either null or an address.*}

datatype Ref = Nullref | Loc Addr

text{* "Proper" values are either arithmetic (currently only integers)
or references.*}

datatype Val = RVal Ref | IVal int

(*<*)
end
(*>*)