(*<*)
theory RSD = AbstrState:
(*>*)

section{*RSDs and Indistinguishability relations*}

subsection{*RSDs*}
types RSD = "STATE \<times> MP \<times> STATE"

constdefs RSD_sum::"RSD \<Rightarrow> HP \<Rightarrow> MP \<Rightarrow> HP \<Rightarrow> RSD \<Rightarrow> bool"
"RSD_sum \<gamma> H N K \<delta> \<equiv> 
  (case \<gamma> of (LEFT1,N1,RIGHT1) \<Rightarrow>
  (case \<delta> of (LEFT2,NN,RIGHT2) \<Rightarrow>
    (case LEFT1 of (S,\<Gamma>,H1) \<Rightarrow>
    (case RIGHT1 of (T,\<Delta>,K1) \<Rightarrow>
    (\<exists> HH KK. LEFT2 = (S,\<Gamma>,HH) \<and> RIGHT2 = (T,\<Delta>,KK) \<and> HH:AL \<and> KK:AL \<and> NN:AL \<and>
                      AL_sum H1 H HH \<and> AL_sum K1 K KK \<and> AL_sum N1 N NN  \<and> 
                      AL_dom H1 \<inter> AL_dom H = {} \<and> AL_dom N1 \<inter> AL_dom N = {} \<and> AL_dom K1 \<inter> AL_dom K = {})))))"

lemma RSD_sum_sum:
 "\<lbrakk>RSD_sum ((S, \<Gamma>, HH), NN, T, \<Delta>, KK) Ha Na Ka ((ad, ae, bb), af, ag, ah, bc); N:AL;
    AL_dom H \<inter> AL_dom H1 = {}; AL_dom K \<inter> AL_dom K1 = {};AL_dom N \<inter> AL_dom N1 = {};
    AL_sum H H1 HH; AL_sum K K1 KK; AL_sum N N1 NN; AL_sum H1 Ha Ha1; AL_sum K1 Ka Ka1; AL_sum N1 Na Na1\<rbrakk>
  \<Longrightarrow> RSD_sum ((S, \<Gamma>, H), N, T, \<Delta>, K) Ha1 Na1 Ka1 ((ad, ae, bb), af, ag, ah, bc)"
apply (simp add: RSD_sum_def) apply clarsimp
apply (rule, erule AL_sum_sum) apply assumption apply assumption
apply (rule, erule AL_sum_sum) apply assumption apply assumption
apply (rule, erule AL_sum_sum) apply assumption apply assumption
apply rule apply (subgoal_tac "AL_dom Ha1 = AL_dom H1 \<union> AL_dom Ha", clarsimp) apply (rotate_tac -1, erule thin_rl) 
           apply (subgoal_tac "AL_dom HH = AL_dom H \<union> AL_dom H1", clarsimp) apply (rotate_tac -1, erule thin_rl) apply fast
           apply (simp add: AL_sum_def)
           apply (simp add: AL_sum_def)
apply rule apply (subgoal_tac "AL_dom Na1 = AL_dom N1 \<union> AL_dom Na", clarsimp) apply (rotate_tac -1, erule thin_rl) 
           apply (subgoal_tac "AL_dom NN = AL_dom N \<union> AL_dom N1", clarsimp) apply (rotate_tac -1, erule thin_rl) apply fast
           apply (simp add: AL_sum_def)
           apply (simp add: AL_sum_def)
apply (subgoal_tac "AL_dom Ka1 = AL_dom K1 \<union> AL_dom Ka", clarsimp) apply (rotate_tac -1, erule thin_rl) 
           apply (subgoal_tac "AL_dom KK = AL_dom K \<union> AL_dom K1", clarsimp) apply (rotate_tac -1, erule thin_rl) apply fast
           apply (simp add: AL_sum_def)
           apply (simp add: AL_sum_def)
done

lemma RSD_sum_onlyHP:
  "RSD_sum ((S, \<Gamma>, H), N, (T, \<Delta>, K)) Ha Na Ka ((S0, \<Gamma>0, H0), N0, (T0, \<Delta>0, K0)) \<Longrightarrow> 
   RSD_sum ((S1, \<Gamma>1, H), N, (T1, \<Delta>1, K)) Ha Na Ka ((S1, \<Gamma>1, H0), N0, T1, \<Delta>1, K0)"
by (simp add: RSD_sum_def)

lemma RSD_sum_SD_sum:
 "RSD_sum (\<Sigma>,N,\<Sigma>1) H N1 K (\<Pi>,NN,\<Pi>1) \<Longrightarrow> 
SD_sum \<Sigma> H \<Pi> \<and> SD_sum \<Sigma>1 K \<Pi>1 \<and> AL_sum N N1 NN \<and> AL_dom N \<inter> AL_dom N1 = {}"
apply (simp add: RSD_sum_def SD_sum_def)
apply (case_tac \<Sigma>, clarsimp)
apply (case_tac \<Sigma>1, clarsimp)
done

constdefs welldef::"RSD \<Rightarrow> bool"
"welldef \<gamma> \<equiv>  (case \<gamma> of (\<Sigma>,N,\<Pi>) \<Rightarrow> State_welldef \<Sigma> N \<and> State_welldef \<Pi> N)"

lemma welldef_AL: "welldef (\<Sigma> , N, \<Pi>) \<Longrightarrow> N:AL" 
apply (simp add: welldef_def State_welldef_def) apply (case_tac \<Sigma>, clarsimp)
done

lemma welldef_MPextensional:"\<lbrakk>welldef (\<Sigma>, N, \<Pi>); \<forall> x c. (N\<down>x = Some c) = (NN\<down>x = Some c); NN \<in> AL\<rbrakk>
    \<Longrightarrow> welldef (\<Sigma>, NN, \<Pi>)"
apply (simp add: welldef_def, erule conjE)
apply rule
  apply (erule State_welldef_MPextensional) apply clarsimp apply assumption
  apply (erule State_welldef_MPextensional) apply clarsimp apply assumption
done

lemma welldef_leftHPextensional:"\<lbrakk>welldef ((S,\<Gamma>,H), N, \<Pi>); \<forall> x c. (H\<down>x = Some c) = (HH\<down>x = Some c); HH \<in> AL\<rbrakk>
    \<Longrightarrow> welldef ((S,\<Gamma>,HH), N, \<Pi>)"
apply (simp add: welldef_def, erule conjE)
apply (erule State_welldef_HPextensional)  apply clarsimp apply assumption
done

lemma welldef_left_HP_AL: "welldef ((S,\<Gamma>,H), N, \<Pi>) \<Longrightarrow> H:AL" 
by (simp add: welldef_def State_welldef_def State_good_def) 

lemma welldef_right_HP_AL: "welldef (\<Pi>, N, (S,\<Gamma>,H)) \<Longrightarrow> H:AL" 
by (simp add: welldef_def State_welldef_def State_good_def) 

lemma welldef_D_Heap_ObjIDs: "welldef ((S,\<Gamma>,H),N,(T,\<Delta>,K)) \<Longrightarrow> AL_dom H \<subseteq> ObjIDs N" 
apply (simp add:welldef_def, erule conjE)
apply (erule State_welldef_D_Heap_ObjIDs)
done

lemma welldef_Tail: "welldef ((c # S, \<Gamma>, H), N, (T, \<Delta>, K))  \<Longrightarrow> welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K))"
apply (simp add: welldef_def) apply clarsimp 
apply (erule State_welldef_Tail)
done

lemma welldef_symm:"welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) \<Longrightarrow> welldef ((T, \<Delta>, K),N,(S, \<Gamma>, H))"
by (simp add: welldef_def)

lemma welldef_RET: "welldef ((c # S, \<Gamma>, H), N, (T,\<Delta>,K)) \<Longrightarrow> welldef (([c], emp, H), N, (T,\<Delta>,K))"
apply (simp add: welldef_def, clarsimp) 
apply (erule State_welldef_RET)
done

lemma welldef_ConsCons:
  "\<lbrakk> welldef ((S, \<Gamma>, H), NN, T, \<Delta>, K);
     AL_sum N Na NN; c \<notin> AL_dom N; c \<notin> AL_dom Na\<rbrakk>
  \<Longrightarrow> welldef ((c # S, \<Gamma>, H), NN[c\<mapsto>intTP], (c # T, \<Delta>, K))"
apply (simp add: welldef_def, clarsimp)
apply rule
  apply (erule State_welldef_ConsCons) apply assumption+
  apply (erule State_welldef_ConsCons) apply assumption+
done


lemma welldef_insertL:
  "\<lbrakk> welldef ((S, \<Gamma>, H), N, T, \<Delta>, K); cl \<notin> AL_dom N\<rbrakk>
  \<Longrightarrow> welldef ((cl # S, \<Gamma>, H[cl\<mapsto>(C, emp)]), N[cl\<mapsto>(classTP C)], T, \<Delta>, K)"
apply (simp add: welldef_def, clarify)
apply (rule, erule State_welldef_insertL) apply assumption
apply (rule State_welldef_MP_contained, assumption) apply (erule contained_upd)
apply (rule AL_CONS) apply (erule  State_welldef_D_AL) apply assumption apply simp
done

lemma welldef_MP_contained:
  "\<lbrakk> welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) ; contained N M;  M \<in> AL\<rbrakk>
  \<Longrightarrow> welldef ((S, \<Gamma>, H), M, (T, \<Delta>, K))"
apply (simp add: welldef_def, clarify)
apply (rule, erule State_welldef_MP_contained) apply assumption
apply assumption
apply (erule State_welldef_MP_contained) apply assumption
  apply assumption
done


lemma welldef_OPS_lookupL_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); n < length S\<rbrakk> \<Longrightarrow> (S ! n) : AL_dom N"
apply (simp add: welldef_def, clarsimp)
apply (erule State_welldef_OPS_lookup_dom) apply assumption
done

lemma welldef_OPS_lookupL:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); n < length S\<rbrakk> \<Longrightarrow> \<exists> tp . N\<down>(S ! n) = Some tp"
apply (drule welldef_OPS_lookupL_dom, assumption)
apply (drule AL_domD, clarsimp)
done

lemma welldef_OPS_lookupR_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); n < length T\<rbrakk> \<Longrightarrow> (T ! n) : AL_dom N"
apply (drule welldef_symm)
apply (erule welldef_OPS_lookupL_dom, assumption)
done

lemma welldef_OPS_lookupR:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); n < length T\<rbrakk> \<Longrightarrow> \<exists> tp . N\<down>(T ! n) = Some tp"
apply (drule welldef_OPS_lookupR_dom, assumption)
apply (drule AL_domD, clarsimp)
done

lemma welldef_Store_lookupL_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); \<Gamma>\<down>x = Some c\<rbrakk> \<Longrightarrow> c:AL_dom N"
apply (simp add: welldef_def, erule conjE)
apply (erule State_welldef_Store_lookup_dom, assumption) 
done
lemma welldef_Store_lookupL:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); \<Gamma>\<down>x = Some c\<rbrakk> \<Longrightarrow> \<exists> tp . N\<down>c = Some tp"
apply (drule welldef_Store_lookupL_dom, assumption)
apply (drule AL_domD, clarsimp)
done

lemma welldef_Store_lookupR_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); \<Delta>\<down>x = Some c\<rbrakk> \<Longrightarrow> c:AL_dom N"
apply (drule welldef_symm)
apply (erule welldef_Store_lookupL_dom, assumption)
done

lemma welldef_Store_lookupR:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); \<Delta>\<down>x = Some c\<rbrakk> \<Longrightarrow> \<exists> tp p. N\<down>c = Some tp"
apply (drule welldef_Store_lookupR_dom, assumption)
apply (drule AL_domD, clarsimp)
done

lemma welldef_Heap_lookupL_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); H\<down>c = Some (D, G)\<rbrakk>
       \<Longrightarrow> c : AL_dom N"
apply (simp add: welldef_def, erule conjE)
apply (erule State_welldef_Heap_lookup_dom, assumption)
done

lemma welldef_Heap_lookupL:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); H\<down>c = Some (D, G)\<rbrakk>
       \<Longrightarrow> \<exists> tp . N\<down>c = Some tp"
apply (drule welldef_Heap_lookupL_dom, assumption)
apply (drule AL_domD) apply clarsimp
done

lemma welldef_Heap_lookupR_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); K\<down>c = Some (D, G)\<rbrakk>
       \<Longrightarrow> c : AL_dom N"
apply (drule welldef_symm)
apply (erule welldef_Heap_lookupL_dom,assumption)
done

lemma welldef_Heap_lookupR:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); K\<down>c = Some (D, G)\<rbrakk>
       \<Longrightarrow> \<exists> tp . N\<down>c = Some tp"
apply (drule welldef_Heap_lookupR_dom, assumption)
apply (drule AL_domD) apply clarsimp
done

lemma welldef_Field_lookupL_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); H\<down>c = Some (D, G); G\<down>f = Some d\<rbrakk>
       \<Longrightarrow> d : AL_dom N"
apply (simp add: welldef_def, erule conjE)
apply (erule State_welldef_Field_lookup_dom, assumption, assumption)
done
lemma welldef_Field_lookupL:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); H\<down>c = Some (D, G); G\<down>f = Some d\<rbrakk>
       \<Longrightarrow> \<exists> tp . N\<down>d = Some tp"
apply (drule welldef_Field_lookupL_dom, assumption, assumption)
apply (drule AL_domD) apply clarsimp
done

lemma welldef_Field_lookupR_dom:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); K\<down>c = Some (D, G); G\<down>f = Some d\<rbrakk>
       \<Longrightarrow> d:AL_dom N"
apply (drule welldef_symm)
apply (erule welldef_Field_lookupL_dom, assumption, assumption)
done

lemma welldef_Field_lookupR:
"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); K\<down>c = Some (D, G); G\<down>f = Some d\<rbrakk>
       \<Longrightarrow> \<exists> tp . N\<down>d = Some tp"
apply (drule welldef_Field_lookupR_dom, assumption, assumption)
apply (drule AL_domD, clarsimp)
done

lemma welldef_lookupHeapL:"welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) \<Longrightarrow> AL_dom H \<subseteq> AL_dom N" 
apply (simp add: welldef_def, erule conjE) 
apply (erule State_welldef_lookupHeap)
done
lemma welldef_lookupHeapR:"welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) \<Longrightarrow> AL_dom K \<subseteq> AL_dom N" 
apply (drule welldef_symm) 
apply (erule welldef_lookupHeapL)
done
lemma welldef_lookupHeap1L:"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); c: AL_dom H\<rbrakk> \<Longrightarrow> c : AL_dom N" 
apply (erule SetTriv) apply (erule welldef_lookupHeapL)
done
lemma welldef_lookupHeap1R:"\<lbrakk>welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)); c: AL_dom K\<rbrakk> \<Longrightarrow> c : AL_dom N"
apply (erule SetTriv) apply (erule welldef_lookupHeapR)
done

lemma welldef_OPS_lookupL_set_dom:
"welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) \<Longrightarrow> set S \<subseteq> AL_dom N"
apply (simp add: welldef_def, erule conjE)
apply (erule State_welldef_OPS_lookup_set_dom)
done

lemma welldef_OPS_lookupR_set_dom:
"welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) \<Longrightarrow> set T \<subseteq> AL_dom N"
apply (drule welldef_symm)
apply (erule welldef_OPS_lookupL_set_dom)
done
lemma welldef_Store_lookupL_cod_dom:
"welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) \<Longrightarrow> AL_cod \<Gamma> \<subseteq> AL_dom N"
apply (simp add: welldef_def, erule conjE)
apply (erule State_welldef_Store_lookup_cod_dom)
done

lemma welldef_Store_lookupR_cod_dom:
"welldef ((S, \<Gamma>, H), N, (T, \<Delta>, K)) \<Longrightarrow> AL_cod \<Delta>  \<subseteq> AL_dom N"
apply (drule welldef_symm)
apply (erule welldef_Store_lookupL_cod_dom)
done

lemma welldef_D_good: "welldef (\<Sigma>,N,\<Pi>) \<Longrightarrow> State_welldef \<Sigma> N \<and> State_welldef \<Pi> N \<and> N:AL"
apply (simp add: welldef_def, erule conjE) 
apply (erule State_welldef_D_AL)
done

end