theory RSDInterpretation = RSD+StateInterpretation:

consts twSet::"((Val set) \<times> (Val set)) set"
inductive twSet intros
twSetEmp: "\<lbrakk>X = {}; Y = {}\<rbrakk> \<Longrightarrow> (X,Y):twSet"
twSetEmpL: "\<lbrakk>X = {}; Y = {v}\<rbrakk> \<Longrightarrow> (X,Y):twSet"
twSetEmpR: "\<lbrakk>Y = {}; X = {v}\<rbrakk> \<Longrightarrow> (X,Y):twSet"
twSetVW: "\<lbrakk>X = {v}; Y = {w}; v=w\<rbrakk> \<Longrightarrow> (X,Y):twSet"

lemma twSet_Triv1: "\<lbrakk>(X,Y):twSet; X=XX\<rbrakk> \<Longrightarrow> (XX,Y):twSet" by simp

lemma twSet_Triv2: "\<lbrakk>(X,Y):twSet; XX=X\<rbrakk> \<Longrightarrow> (XX,Y):twSet" by simp

lemma twSet_Triv3: "\<lbrakk>(X,Y):twSet; Y=YY\<rbrakk> \<Longrightarrow> (X,YY):twSet" by simp

lemma twSet_Triv4: "\<lbrakk>(X,Y):twSet; YY=Y\<rbrakk> \<Longrightarrow> (X,YY):twSet" by simp

lemma twSet_Triv6[rule_format]: "(X,Y) : twSet \<Longrightarrow> \<forall> x1 x2. x1:X \<longrightarrow> x2:X \<longrightarrow> x1 = x2"
by (erule twSet.elims, auto)

lemma twSet_Triv7[rule_format]: "(X,Y) : twSet \<Longrightarrow> \<forall> y1 y2. y1:Y \<longrightarrow> y2:Y \<longrightarrow> y1 = y2"
by (erule twSet.elims, auto)

lemma twSet_Triv8[rule_format]: "(X,Y) : twSet \<Longrightarrow> \<forall> x . x:X \<longrightarrow> X={x}"
by (erule twSet.elims, auto)

lemma twSet_Triv9[rule_format]: "(X,Y):twSet \<Longrightarrow> XX \<subseteq> X \<longrightarrow> (XX,Y):twSet" 
apply (erule twSet.elims) 
apply clarsimp apply (rule twSetEmp) apply simp apply simp
apply clarsimp apply (rule twSetEmpL) apply simp apply simp
apply clarsimp apply (case_tac "XX={}", clarsimp) apply (rule twSetEmp) apply simp apply simp 
               apply (subgoal_tac "XX = {v}", clarsimp)  apply (rule twSetEmpR) apply simp apply simp apply fast 
apply clarsimp apply (case_tac "XX={}", clarsimp) apply (rule twSetEmpL) apply simp apply simp 
               apply (rule_tac v=w in twSetVW) apply fast apply simp apply simp 
done

lemma twSet_Triv10[rule_format]: "(X,Y):twSet \<Longrightarrow> YY \<subseteq> Y \<longrightarrow> (X,YY):twSet" 
apply (erule twSet.elims) 
apply clarsimp apply (rule twSetEmp) apply simp apply simp
apply clarsimp apply (case_tac "YY={}", clarsimp) apply (rule twSetEmp) apply simp apply simp 
               apply (subgoal_tac "YY = {v}", clarsimp)  apply (rule twSetEmpL) apply simp apply simp apply fast 
apply clarsimp apply (rule twSetEmpR) apply simp apply simp
apply clarsimp apply (case_tac "YY={}", clarsimp) apply (rule twSetEmpR) apply simp apply simp 
               apply (rule_tac v=w and w=w in twSetVW) apply simp apply fast apply simp
done

lemma twSet_AtMostSingletonL:"(X,Y):twSet \<Longrightarrow> X = {} \<or> (\<exists> v . X = {v})"
by (erule twSet.elims, auto)

lemma twSet_AtMostSingletonR:"(X,Y):twSet \<Longrightarrow> Y = {} \<or> (\<exists> v . Y = {v})"
by (erule twSet.elims, auto)

lemma ValuesRepresented8:
  "\<lbrakk> (ValuesRepresented d (S, \<Gamma>, H) (ops, s, h) I, ValuesRepresented d (T, \<Delta>, K) (ab, ac, ba) J) \<in> twSet; 
      RVal (Loc a) :ValuesRepresented d (S, \<Gamma>, H) (ops, s, h) I; d:AL_dom H; AL_dom H \<subseteq> dom I\<rbrakk>
   \<Longrightarrow> I d = Some a"
apply (erule twSet.elims)
  apply clarsimp
  apply clarsimp
  apply clarsimp apply (frule SetTriv, assumption) apply (drule domD, clarsimp)
    apply (rotate_tac -2, erule thin_rl, simp add: ValuesRepresented_def) apply (drule SetSingleton2) apply clarsimp
  apply clarsimp apply (frule SetTriv, assumption) apply (drule domD, clarsimp)
    apply (rotate_tac -2, erule thin_rl, simp add: ValuesRepresented_def) apply (drule SetSingleton2) apply clarsimp
done
    
lemma ValuesRepresented8_1:
  "\<lbrakk> (ValuesRepresented d (c # d # S, \<Gamma>, H) (v # RVal (Loc a) # ops, s, h) I, 
      ValuesRepresented d (T, \<Delta>, K) (ab, ac, ba) J) \<in> twSet; 
      d:AL_dom H; AL_dom H \<subseteq> dom I\<rbrakk>
   \<Longrightarrow> I d = Some a"
apply (erule ValuesRepresented8) 
  apply (rule ValuesRepresented7)
  apply assumption
  apply assumption
done

lemma twSet_TailL[rule_format]:
 "(X,Y):twSet \<Longrightarrow> 
  \<forall> c d S \<Gamma> H v ops s h I. X = ValuesRepresented c (d # S,\<Gamma>, H) (v#ops, s, h) I \<longrightarrow> 
                           (ValuesRepresented c (S,\<Gamma>, H) (ops, s, h) I,Y):twSet"
apply (erule twSet.elims)
apply clarsimp apply (rule twSetEmp) apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I \<subseteq> ValuesRepresented c (d # S, \<Gamma>, H) (v # ops, s, h) I") apply fast apply (rule ValuesRepresented9) apply simp
apply clarsimp apply (rule twSetEmpL) apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I \<subseteq> ValuesRepresented c (d # S, \<Gamma>, H) (va # ops, s, h) I") apply fast apply (rule ValuesRepresented9) apply simp
apply clarsimp apply (case_tac "ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I = {}") apply (erule twSetEmp) apply simp 
               apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I = {v}") apply (rule twSetEmpR) apply simp apply assumption
                 apply (erule SetSingleton3) apply assumption apply (rule ValuesRepresented9)
apply clarsimp apply (case_tac "ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I = {}")
                 apply (erule_tac v=w in twSetEmpL) apply simp
               apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I = {w}") 
                 apply (erule_tac w=w in twSetVW) apply simp apply simp
               apply (erule SetSingleton3) apply assumption apply (rule ValuesRepresented9) 
done

lemma twSet_splitL[rule_format]:
  "(X, Y) \<in> twSet \<Longrightarrow> 
   \<forall> c d S \<Gamma> H w ops s h I. X = ValuesRepresented c (d # S, \<Gamma>, H) (w # ops, s, h) I \<longrightarrow>
                            ((c = d \<and> X = {w}) \<or> (c \<noteq> d \<and> X = ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I))"
apply (erule twSet.elims)
apply clarsimp
  apply (case_tac "c=d", clarsimp) 
    apply (subgoal_tac "w:ValuesRepresented d (d # S, \<Gamma>, H) (w # ops, s, h) I", fast)
    apply (rule ValuesRepresented2)
  apply clarsimp
  apply (drule_tac c=c and d=d and S=S and \<Gamma>=\<Gamma> and H=H and v=w and ops=ops and aa=s and b=h and I=I in ValuesRepresented1) apply clarsimp
apply clarsimp
  apply (case_tac "c=d", clarsimp) 
    apply (subgoal_tac "w:ValuesRepresented d (d # S, \<Gamma>, H) (w # ops, s, h) I", fast)
    apply (rule ValuesRepresented2)
  apply clarsimp
  apply (drule_tac c=c and d=d and S=S and \<Gamma>=\<Gamma> and H=H and v=w and ops=ops and aa=s and b=h and I=I in ValuesRepresented1) apply clarsimp
apply clarsimp
  apply (case_tac "c=d", clarsimp)
    apply (subgoal_tac "ValuesRepresented d (d # S, \<Gamma>, H) (w # ops, s, h) I = {v}") prefer 2 apply fast
    apply (drule SetSingleton2) apply (erule conjE)
    apply (erule_tac x=w in allE, erule impE) apply (rule ValuesRepresented2)
    apply simp
  apply clarsimp apply (subgoal_tac "ValuesRepresented c (d # S, \<Gamma>, H) (w # ops, s, h) I = ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I",fast) 
    apply (erule ValuesRepresented1) 
apply clarsimp
  apply (case_tac "c=d", clarsimp)
    apply (subgoal_tac "ValuesRepresented d (d # S, \<Gamma>, H) (wa # ops, s, h) I = {w}") prefer 2 apply fast
    apply (drule SetSingleton2) apply (erule conjE)
    apply (erule_tac x=wa in allE, erule impE) apply (rule ValuesRepresented2)
    apply simp
  apply clarsimp apply (subgoal_tac "ValuesRepresented c (d # S, \<Gamma>, H) (wa # ops, s, h) I = ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I",fast) 
    apply (erule ValuesRepresented1) 
done
lemma twSet_VR1:
  "\<lbrakk> AL_sum H H1 HH; 
     ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I = {} \<or> (\<exists>v. ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I = {v})
   \<rbrakk> \<Longrightarrow> ValuesRepresented c (S, \<Gamma>, H) \<sigma> I \<subseteq>  ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I"
apply (erule disjE, clarsimp)
  apply (simp add: ValuesRepresented_def)
  apply (case_tac \<sigma>, clarsimp)
  apply (rule, clarsimp) apply (erule_tac x="RVal (Loc ab)" in allE, clarsimp) 
                         apply (drule AL_sum_member) apply assumption apply simp
  apply clarsimp apply (erule_tac x=x in allE, clarsimp)
    apply (subgoal_tac "HH\<down>d = Some (D, F)")
    prefer 2 apply (erule AL_sum_entry) apply assumption 
    apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, erule impE, assumption)
    apply (erule_tac x=f in allE, erule impE, assumption)
    apply (erule_tac x=C in allE, erule_tac x=G in allE, erule_tac x=ab in allE, erule impE, assumption)
    apply simp
apply clarsimp
  apply (simp add: ValuesRepresented_def)
  apply (case_tac \<sigma>, clarsimp)
  apply (drule SetSingleton2) apply clarsimp
  apply (erule disjE, clarsimp) 
  apply (rotate_tac -1, erule disjE, clarsimp) 
  apply (rotate_tac -1, erule disjE, clarsimp) apply (erule_tac x="RVal (Loc ab)" in allE, clarsimp) 
                         apply (drule AL_sum_member) apply assumption apply simp
  apply clarsimp apply (erule_tac x=x in allE, clarsimp)
    apply (subgoal_tac "HH\<down>d = Some (D, F)")
    prefer 2 apply (erule AL_sum_entry) apply assumption 
    apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, erule impE, assumption)
    apply (erule_tac x=f in allE, erule impE, assumption)
    apply (erule_tac x=C in allE, erule_tac x=G in allE, erule_tac x=ab in allE, erule impE, assumption)
    apply simp
done

lemma twSet_VR1L:
  "\<lbrakk> AL_sum H H1 HH; 
     (ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I, ValuesRepresented c (T, \<Delta>, KK) \<tau> J) \<in> twSet
   \<rbrakk> \<Longrightarrow> ValuesRepresented c (S, \<Gamma>, H) \<sigma> I \<subseteq>  ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I"
apply (drule twSet_AtMostSingletonL)
apply (erule twSet_VR1, assumption)
done

lemma twSet_VR1R:
  "\<lbrakk> AL_sum K K1 KK; 
     (ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I, ValuesRepresented c (T, \<Delta>, KK) \<tau> J) \<in> twSet
   \<rbrakk> \<Longrightarrow> ValuesRepresented c (T, \<Delta>, K) \<tau> J \<subseteq>  ValuesRepresented c (T, \<Delta>, KK) \<tau> J"
apply (drule twSet_AtMostSingletonR)
apply (erule twSet_VR1, assumption)
done

constdefs singleVal::"Colour \<Rightarrow> RSD \<Rightarrow> State \<Rightarrow> AddrMapping \<Rightarrow> State \<Rightarrow> AddrMapping \<Rightarrow> bool"
"singleVal c \<gamma> \<sigma> I \<tau> J \<equiv>
   (case \<gamma> of (LEFT,N,RIGHT) \<Rightarrow>
       (ValuesRepresented c LEFT \<sigma> I, ValuesRepresented c RIGHT \<tau> J) : twSet)"

lemma singleVal_MPextensional:
  "\<lbrakk>singleVal c (\<Sigma>, N, \<Pi>) \<sigma> I \<tau> J; 
     \<forall> x c . (N\<down>x = Some c) = (NN\<down>x = Some c)\<rbrakk> 
  \<Longrightarrow> singleVal c (\<Sigma>, NN, \<Pi>) \<sigma> I \<tau> J"
by (simp add: singleVal_def)

lemma singleVal_leftHPextensional:
  "\<lbrakk>singleVal c ((S,\<Gamma>,H), N, \<Pi>) \<sigma> I \<tau> J; 
    \<forall> x c . (H\<down>x = Some c) = (HH\<down>x = Some c)\<rbrakk> \<Longrightarrow> singleVal c ((S,\<Gamma>,HH), NN, \<Pi>) \<sigma> I \<tau> J"
apply (frule_tac c=c and S=S and \<Gamma>=\<Gamma> and \<sigma>=\<sigma> and I=I in ValuesRepresented_HPextensional)
(*apply (drule_tac K="snd (snd \<Pi>)" in mkPBij_leftHPextensional)*)
apply (simp add: singleVal_def)
done

lemma singleVal_symm:
 "singleVal c (\<Sigma>, N, \<Pi>) \<sigma> I \<tau> J \<Longrightarrow> singleVal c (\<Pi>, N, \<Sigma>) \<tau> J \<sigma> I"
apply (unfold singleVal_def) apply clarsimp
apply (erule twSet.elims)
apply (rule twSetEmp) apply simp apply simp
apply (rule twSetEmpR) apply simp apply simp
apply (rule twSetEmpL) apply simp apply simp
apply clarsimp apply (rule_tac w=w and v=w in twSetVW) apply simp+ 
done
      
constdefs sat::"State \<Rightarrow> State \<Rightarrow> RSD \<Rightarrow> AddrMapping \<Rightarrow> AddrMapping \<Rightarrow> bool"
"sat \<sigma> \<tau> \<gamma> I J \<equiv>
  welldef \<gamma> \<and>

  (case \<gamma> of (\<Sigma>,N,\<Pi>) \<Rightarrow>

     StateSatisfiesAbstraction \<sigma> \<Sigma> N I \<and>
     StateSatisfiesAbstraction \<tau> \<Pi> N J \<and>

     (\<forall> c  . N\<down>c = Some intTP \<longrightarrow> c:DOM \<Sigma> \<inter> DOM \<Pi> \<longrightarrow> singleVal c \<gamma> \<sigma> I \<tau> J))"

constdefs sat_local::"State \<Rightarrow> State \<Rightarrow> RSD \<Rightarrow> AddrMapping \<Rightarrow> AddrMapping \<Rightarrow> bool"
"sat_local \<sigma> \<tau> \<gamma> I J \<equiv>
  (case \<gamma> of (\<Sigma>,N,\<Pi>) \<Rightarrow>
    State_welldef \<Sigma> N \<and> StateSatisfiesAbstraction \<sigma> \<Sigma> N I \<and>
    State_welldef \<Pi> N \<and> StateSatisfiesAbstraction \<tau> \<Pi> N J \<and>

    (\<forall> c v w . N\<down>c = Some intTP \<longrightarrow> c:DOM \<Sigma> \<inter> DOM \<Pi> \<longrightarrow> 
              v: Values_Represented c \<Sigma> \<sigma> I \<longrightarrow> w: Values_Represented c \<Pi> \<tau> J \<longrightarrow> 
              singleVal c \<gamma> \<sigma> I \<tau> J))"

lemma sat_satlocal1:"sat \<sigma> \<tau> \<gamma> I J \<Longrightarrow> sat_local \<sigma> \<tau> \<gamma> I J"
apply (simp add: sat_def sat_local_def, clarsimp)
apply (case_tac \<gamma>, clarsimp)
apply (simp add: welldef_def)
done

lemma satlocal_sat1:"sat_local \<sigma> \<tau> \<gamma> I J \<Longrightarrow> sat \<sigma> \<tau> \<gamma> I J"
apply (simp add: sat_def sat_local_def)
apply (case_tac \<gamma>, clarsimp)
apply (simp add: welldef_def)
apply clarsimp
apply (erule_tac x=c in allE, clarsimp)
apply (simp add: singleVal_def ValRepEQ)
  apply (subgoal_tac "\<exists> v . ValuesRepresented c (a, aa, b) \<sigma> I = {v}", erule exE)
  prefer 2 apply (simp add:  StateSatisfiesAbstraction_def uniqueValues_def)
    apply (subgoal_tac "\<exists> w . ValuesRepresented c (ac, ad, ba) \<tau> J = {w}", erule exE)
    prefer 2 apply (simp add:  StateSatisfiesAbstraction_def uniqueValues_def)
    apply fast
done

lemma satlocal_sat:"sat_local \<sigma> \<tau> \<gamma> I J = sat \<sigma> \<tau> \<gamma> I J"
apply rule
apply (erule satlocal_sat1)
apply (erule sat_satlocal1)
done

lemma sat_AL:"sat s t (\<Sigma> , N, \<Pi>) I J \<Longrightarrow> N:AL" 
apply (simp add: sat_def, (erule conjE)+)
apply (erule welldef_AL)
done

lemma sat_left_HP_AL:"sat s t ((S,\<Gamma>,H) , N, \<Pi>) I J \<Longrightarrow> H:AL" 
apply (simp add: sat_def, (erule conjE)+)
apply (erule welldef_left_HP_AL)
done

lemma sat_right_HP_AL:"sat s t (\<Pi>, N, (S,\<Gamma>,H)) I J \<Longrightarrow> H:AL" 
apply (simp add: sat_def, (erule conjE)+)
apply (erule welldef_right_HP_AL)
done

lemma sat_MPextensional:
"\<lbrakk>sat \<sigma> \<tau> (\<Sigma>, N, \<Pi>) I J; \<forall> x c . (N\<down>x = Some c) = (NN\<down>x = Some c); NN \<in> AL\<rbrakk> \<Longrightarrow> sat \<sigma> \<tau> (\<Sigma>, NN, \<Pi>) I J"
apply (simp add: sat_def, clarsimp)
apply (rule, erule welldef_MPextensional) apply simp apply assumption
apply (rule, erule StateSatisfiesAbstraction_MPextensional) apply simp
apply (rule, erule StateSatisfiesAbstraction_MPextensional) apply simp
apply clarsimp
apply (erule_tac x=c in allE, erule impE, assumption, erule impE, simp)
apply (erule singleVal_MPextensional) apply simp
done

lemma sat_leftHPextensional:
 "\<lbrakk> sat \<sigma> \<tau> ((S,\<Gamma>,H), N, \<Pi>) I J; 
    \<forall> x c . (H\<down>x = Some c) = (HH\<down>x = Some c); HH \<in> AL\<rbrakk> 
 \<Longrightarrow> sat \<sigma> \<tau> ((S,\<Gamma>,HH), N, \<Pi>) I J"
apply (simp add: sat_def, clarsimp)
apply (rule, erule welldef_leftHPextensional) apply simp apply assumption
apply (case_tac \<sigma>, clarsimp)
apply (rule, erule StateSatisfiesAbstraction_HP_extensional) apply simp
apply clarsimp
apply (erule_tac x=c in allE, erule impE, assumption)
apply (subgoal_tac "AL_dom H = AL_dom HH \<and> AbsFields H = AbsFields HH")
  apply (erule impE, simp add: DOM_def) 
  apply (erule singleVal_leftHPextensional) apply simp
apply (simp add: AL_dom_def AbsFields_expand)
done
         
lemma sat_symm: "sat \<sigma> \<tau> (\<Sigma>,N,\<Pi>) I J \<Longrightarrow> sat \<tau> \<sigma> (\<Pi>,N,\<Sigma>) J I"
apply (unfold sat_def) apply clarsimp
apply (case_tac \<sigma>, clarsimp)
apply (case_tac \<tau>, clarsimp)
apply (case_tac \<Sigma>, clarsimp)
apply (case_tac \<Pi>, clarsimp)
apply (rule, erule welldef_symm)
apply clarsimp
apply (erule_tac x=c in allE,clarsimp)
apply (erule singleVal_symm)
done

lemma singleVal_Tail: 
 "\<lbrakk>StateSatisfiesAbstraction (ops, s, h) (S, \<Gamma>, H) N I;ca \<in> DOM (S, \<Gamma>, H);
  singleVal ca ((c # S, \<Gamma>, H), N, a, aa, b) (v # ops, s, h) I (ab, ac, ba) J\<rbrakk>
  \<Longrightarrow> singleVal ca ((S, \<Gamma>, H), N, a, aa, b) (ops, s, h) I (ab, ac, ba) J"
apply (simp add: singleVal_def)
apply (erule twSet_Triv9)
  apply (rule  ValuesRepresented9)
done

lemma sat_Tail:"sat (v # ops, s, h) \<tau> ((c#S, \<Gamma>, H), N, \<Pi>) I J
       \<Longrightarrow> sat (ops, s, h) \<tau> ((S, \<Gamma>, H), N, \<Pi>) I J"
apply (unfold sat_def, clarsimp)
apply (case_tac \<Pi>, clarsimp)
apply (rule, erule welldef_Tail)
apply (case_tac \<tau>, clarsimp)
apply (subgoal_tac "StateSatisfiesAbstraction (ops, s, h) (S, \<Gamma>, H) N I", simp)
prefer 2 apply (erule StateSatisfiesAbstraction_Tail)
apply clarsimp
apply (erule_tac x=ca in allE, clarsimp)
apply (erule impE) apply (simp add: DOM_def)
apply (erule singleVal_Tail) apply assumption+
done

lemma unisat_sat:"sat \<sigma> \<tau> (\<Sigma>,N,\<Pi>) I J = 
    (unisat \<sigma> \<Sigma> N I \<and> unisat \<tau> \<Pi> N J \<and> 
    (\<forall> c . N\<down>c = Some intTP \<longrightarrow> c:DOM \<Sigma> \<inter> DOM \<Pi> \<longrightarrow> singleVal c (\<Sigma>,N,\<Pi>) \<sigma> I \<tau> J))"
apply (simp add: sat_def unisat_def welldef_def)
apply (rule, clarsimp) 
apply clarsimp
done

lemma sat_HDHD:
 "sat (v # os, s, h) (w # osa, sa, k) ((c # S, \<Gamma>, H), N, d # T, \<Delta>, K) I J
  \<Longrightarrow> sat ([v], emp, h) ([w], emp, k) (([c], emp, H), N, [d], emp, K) I J"
apply (simp add: sat_def, clarsimp)
apply (rule, simp add: State_welldef_def welldef_def, clarsimp)
  apply (rule, simp add: AL_cod_emp)
  apply (rule, rule_tac Y="insert c (set S \<union> AL_cod \<Gamma> \<union> AbsFields H) \<inter> ObjIDs N" in SetTriv101)
     apply (simp add: AL_cod_emp) apply fast
    apply assumption
  apply (rule, simp add: State_good_def) apply (rule AL_EMP)
  apply (simp add: AL_cod_emp)
  apply (rule, rule_tac Y="insert d (set T \<union> AL_cod \<Delta> \<union> AbsFields K) \<inter> ObjIDs N" in SetTriv101)
     apply (simp add: AL_cod_emp) apply fast
    apply assumption
  apply (simp add: State_good_def) apply (rule AL_EMP)
apply (rule, erule StateSatisfiesAbstraction_HD)
apply (rule, erule StateSatisfiesAbstraction_HD)
apply (rule allI)+ apply rule
apply (erule_tac x=ca in allE, erule impE, assumption)
apply clarsimp apply (erule impE, simp add: DOM_def  AL_cod_emp) apply rule apply fastsimp apply fastsimp
apply (simp add: singleVal_def)
apply (rule twSet_Triv9)
  apply (erule twSet_Triv10)
  apply (rule SetTriv101)
  apply (rule_tac \<Gamma>=\<Delta> and s=sa in ValuesRepresented13)
  apply (rule ValuesRepresented_HD)
apply (rule SetTriv101)
  apply (rule_tac \<Gamma>=\<Gamma> and s=s in ValuesRepresented13)
  apply (rule ValuesRepresented_HD)
done

end
