theory RSD_TYPING = UniTyping + RuleConstConst + RuleNewNew + RuleBinopBinop + 
                    RuleInvsInvs + RuleInvvInvv + RuleInvsInvv + BinaryRen:

consts Typing:: "(Ctxt \<times> RSD \<times> Mbody \<times> Label \<times> Mbody \<times> Label \<times> bool \<times> RSD) set"

inductive Typing intros
TypingUniRetRet: 
  "\<lbrakk>(U, \<Sigma>,N, M,l,b,H,c,N') : UniBS; UniCtxtVerified U; 
    (V, \<Pi>,N, MM,ll,b,K,d,N'') : UniBS; UniCtxtVerified V; 
     \<gamma> = (\<Sigma>,N,\<Pi>); \<delta> = (([c],emp,H),NN,([d],emp,K));
    AL_dom N' \<inter> AL_dom N'' = AL_dom N; AL_sum N' N'' NN\<rbrakk>
    \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, b, \<delta>):Typing"

UniInjectL: "\<lbrakk> (U, \<Sigma>, N, M, l, \<Sigma>1, N1,L) : UniSS; UniCtxtVerified U;
               \<gamma> = (\<Sigma>,N,\<Pi>); 
               \<forall> l1 . l1 : L \<longrightarrow> (G, (\<Sigma>1, N1,\<Pi>), M, l1, MM, ll, True, \<delta>):Typing\<rbrakk>
            \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"

UniInjectR: "\<lbrakk> (U, \<Pi>, N, MM, ll, \<Pi>1, N1,L) : UniSS; UniCtxtVerified U;
               \<gamma> = (\<Sigma>,N,\<Pi>); 
               \<forall> l1 . l1 : L \<longrightarrow> (G, (\<Sigma>, N1,\<Pi>1), M, l, MM, l1, True,\<delta>):Typing\<rbrakk>
            \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False,\<delta>):Typing"

TypingInvSInvV:
  "\<lbrakk> get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeV C2 m2);
     mbody_is c m (P1, code, l0);  mbody_is C2 m2 (P2, code2, l2); 
     \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K));  
     (S1, P1,\<Gamma>1,S):absFrame; (T1, P2,\<Delta>1,d2#T):absFrame; 
     (G,((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;

     K\<down>d2 = Some(D2,F2); subclass_of D2 C2;            
       \<forall> D2' code2' l2'. 
           subclass_of D2' C2 \<longrightarrow> 
            mbody_is D2' m2 (P2,code2',l2') \<longrightarrow>
           (G, (([], \<Gamma>1, H), N, ([], \<Delta>1[this\<mapsto>d2], K)), 
             (P1, code, l0), l0, (P2, code2', l2'), l2', 
             True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing
   \<rbrakk> \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"

TypingInvSInvV3:
  "\<lbrakk> get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeV C2 m2);
     mbody_is c m (P1, code, l0);  mbody_is C2 m2 (P2, code2, l2); 
     \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K));  
     (S1, P1,\<Gamma>1,S):absFrame; (T1, P2,\<Delta>1,d2#T):absFrame; 
     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;

     K\<down>d2 = Some(D2,F2); 
     \<forall> D2'. subclass_of D2' D2 \<longrightarrow> 
            (\<exists>  code2' l2'. mbody_is D2' m2 (P2,code2',l2') \<and>
               (G, (([], \<Gamma>1, H), N, ([], \<Delta>1[this\<mapsto>d2], K)), 
                 (P1, code, l0), l0, (P2, code2', l2'), l2', 
                 True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing)
   \<rbrakk> \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"

TypingFrame:
  "\<lbrakk> (G, \<gamma>, M, l, MM, ll, b, \<delta>) :Typing; RSD_sum \<gamma> H N K \<gamma>1; RSD_sum \<delta> H N K \<delta>1
   \<rbrakk> \<Longrightarrow> (G, \<gamma>1, M, l, MM, ll, b,\<delta>1) :Typing"

TypingConstConst:
  "\<lbrakk> get_ins M l = Some (const (IVal i)); get_ins MM ll = Some (const (IVal i));
     \<gamma> = ((S,\<Gamma>,H),N,(T,\<Delta>,K)); c \<notin> AL_dom N; 
     (G, ((c#S,\<Gamma>,H), N[c\<mapsto>intTP],(c#T,\<Delta>,K)), M, l+1, MM, ll+1, True, \<delta>):Typing\<rbrakk>
  \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"

TypingBinopBinop:
  "\<lbrakk> get_ins M l = Some (binop f); get_ins MM ll = Some (binop f);
     \<gamma> = ((c1#c2#S, \<Gamma>, H), N, c1#c2#T, \<Delta>, K); c \<notin> AL_dom N; 
    N\<down>c1 = Some intTP; N\<down>c2 = Some intTP; 
    isOfType f intTP intTP intTP;
     (G, ((c#S,\<Gamma>,H), N[c\<mapsto>intTP],(c#T,\<Delta>,K)), M, l+1, MM, ll+1, True, \<delta>):Typing\<rbrakk>
  \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"

TypingNewNew:
 "\<lbrakk> get_ins M l = Some (new C1); get_ins MM ll = Some (new C2);
    \<gamma> = ((S,\<Gamma>,H),N,(T,\<Delta>,K)); c \<notin> AL_dom N;
    subclass_of C1 C; subclass_of C2 C;
    (G, ((c#S,\<Gamma>,H[c \<mapsto> (C1,emp)]),N[c \<mapsto> (classTP C)],(c#T,\<Delta>,K[c \<mapsto> (C2,emp)])), M, (l+1), MM, (ll+1), True,\<delta>):Typing \<rbrakk>
 \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"

TypingInvSInvS:
  "\<lbrakk> get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeS c0 m0); 
     mbody_is c m (P1, code, l0); mbody_is c0 m0 (P2, code0, l00); 
     \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K));  
     (S1, P1,\<Gamma>1,S):absFrame; (T1, P2,\<Delta>1,T):absFrame;
     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True,\<delta>):Typing;
     (G, (([], \<Gamma>1, H), N, ([], \<Delta>1, K)), 
         (P1, code, l0), l0, (P2, code0, l00), l00, 
         True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing
   \<rbrakk> \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"

TypingInvVInvV:
   "\<lbrakk> get_ins M l = Some (invokeV C1 m1);  mbody_is C1 m1 (P1, code1, l1); 
      get_ins MM ll = Some (invokeV C2 m2); mbody_is C2 m2 (P2, code2, l2); 
      \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K));  
     (S1, P1,\<Gamma>1,d1#S):absFrame; (T1, P2,\<Delta>1,d2#T):absFrame;

     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;

      H\<down>d1 = Some(D1,F1); subclass_of D1 C1; K\<down>d2 = Some(D2,F2); subclass_of D2 C2;
            
       \<forall> D1' D2' code1' code2' l1' l2'. 
                 subclass_of D1' C1 \<longrightarrow> subclass_of D2' C2 \<longrightarrow> 
                 mbody_is D1' m1 (P1,code1',l1') \<longrightarrow> mbody_is D2' m2 (P2,code2',l2') \<longrightarrow>
         (G, (([], \<Gamma>1[this\<mapsto>d1], H), N, ([], \<Delta>1[this\<mapsto>d2], K)), 
         (P1, code1', l1'), l1', (P2, code2', l2'), l2', 
         True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing\<rbrakk>
     \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"

TypingInvVInvV3:
   "\<lbrakk> get_ins M l = Some (invokeV C1 m1);  mbody_is C1 m1 (P1, code1, l1); 
      get_ins MM ll = Some (invokeV C2 m2); mbody_is C2 m2 (P2, code2, l2); 
      \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K));  
     (S1, P1,\<Gamma>1,d1#S):absFrame; (T1, P2,\<Delta>1,d2#T):absFrame;

     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;

      H\<down>d1 = Some(D1,F1); K\<down>d2 = Some(D2,F2); 
            
      \<forall> D1' D2' . subclass_of D1' D1 \<longrightarrow> subclass_of D2' D2 \<longrightarrow> 
                 (\<exists> code1' code2' l1' l2'. 
                     mbody_is D1' m1 (P1,code1',l1') \<and> mbody_is D2' m2 (P2,code2',l2') \<and>
                    (G, (([], \<Gamma>1[this\<mapsto>d1], H), N, ([], \<Delta>1[this\<mapsto>d2], K)), 
                      (P1, code1', l1'), l1', (P2, code2', l2'), l2', 
                      True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing)\<rbrakk>
     \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"

TypingRetRet: "\<lbrakk> get_ins M l = Some vreturn; get_ins MM ll = Some vreturn;
              \<gamma> = ((c#S,\<Gamma>,H),N,(d#T,\<Delta>,K)); 
              \<delta> = (([c],emp,H),N,([d],emp,K))\<rbrakk>
            \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"

TypingInj: "(G,\<gamma>,M,l,MM,ll,False,\<delta>) : Typing \<Longrightarrow> (G,\<gamma>,M,l,MM,ll,True,\<delta>) : Typing"

TypingAx: "(((M,l),(MM,ll)),\<gamma>,\<delta>) \<in> G \<Longrightarrow> (G,\<gamma>,M,l,MM,ll,True,\<delta>) : Typing"

TypingIfIf:
  "\<lbrakk> get_ins M l = Some (iftrue l1); get_ins MM ll = Some (iftrue ll1);
     \<gamma> = ((c#S,\<Gamma>,H),N,(c#T,\<Delta>,K)); N\<down>c = Some intTP; 
     (G, ((S,\<Gamma>,H), N,(T,\<Delta>,K)), M, l+1, MM, ll+1, True, \<delta>):Typing; 
     (G, ((S,\<Gamma>,H), N,(T,\<Delta>,K)), M, l1, MM, ll1, True, \<delta>):Typing\<rbrakk>
  \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"

Ren:"\<lbrakk>(G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing;
      renState \<gamma> f \<gamma>'; renState \<delta> g \<delta>';
      \<forall> c fc . f c = Some fc \<longrightarrow> g c = Some fc; 
     inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {}\<rbrakk>
     \<Longrightarrow> (G, \<gamma>', M, l, MM, ll, False, \<delta>'):Typing"

lemma TypingInvSInvV2:
  "\<lbrakk> get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeV C2 m2);
     mbody_is c m (P1, code, l0);  mbody_is C2 m2 (P2, code2, l2); 
     \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K));  
     (S1, P1,\<Gamma>1,S):absFrame; (T1, P2,\<Delta>1,d2#T):absFrame;
     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;

     K\<down>d2 = Some(D2,F2); subclass_of D2 C2;            
     \<forall> D2'. subclass_of D2' D2 \<longrightarrow> 
            (\<exists>  code2' l2'. mbody_is D2' m2 (P2,code2',l2') \<and>
               (G, (([], \<Gamma>1, H), N, ([], \<Delta>1[this\<mapsto>d2], K)), 
                 (P1, code, l0), l0, (P2, code2', l2'), l2', 
                 True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing)
   \<rbrakk> \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"
apply (rule TypingInvSInvV3) apply assumption+ done

lemma TypingInvVInvV2:
   "\<lbrakk> get_ins M l = Some (invokeV C1 m1);  mbody_is C1 m1 (P1, code1, l1); 
      get_ins MM ll = Some (invokeV C2 m2); mbody_is C2 m2 (P2, code2, l2); 
      \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K));  
     (S1, P1,\<Gamma>1,d1#S):absFrame; (T1, P2,\<Delta>1,d2#T):absFrame;

     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;

      H\<down>d1 = Some(D1,F1); subclass_of D1 C1; K\<down>d2 = Some(D2,F2); subclass_of D2 C2;
            
      \<forall> D1' D2' . subclass_of D1' D1 \<longrightarrow> subclass_of D2' D2 \<longrightarrow> 
                 (\<exists> code1' code2' l1' l2'. 
                     mbody_is D1' m1 (P1,code1',l1') \<and> mbody_is D2' m2 (P2,code2',l2') \<and>
                    (G, (([], \<Gamma>1[this\<mapsto>d1], H), N, ([], \<Delta>1[this\<mapsto>d2], K)), 
                      (P1, code1', l1'), l1', (P2, code2', l2'), l2', 
                      True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing)\<rbrakk>
     \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"
apply (rule TypingInvVInvV3) apply assumption+ done

lemma NewNewSmall:
 "\<lbrakk> get_ins M l = Some (new C1); get_ins MM ll = Some (new C2);
    \<gamma> = ((S,\<Gamma>,emp),emp,(T,\<Delta>,emp));
    subclass_of C1 C; subclass_of C2 C;
    (G, ((c#S,\<Gamma>,emp[c \<mapsto> (C1,emp)]),emp[c \<mapsto> (classTP C)],(c#T,\<Delta>,emp[c \<mapsto> (C2,emp)])), M, (l+1), MM, (ll+1), True, \<delta>):Typing \<rbrakk>
 \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (erule_tac c=c in TypingNewNew) apply assumption+ apply (simp add: AL_dom_emp) apply assumption+
done

lemma TypingFrame_expand:
  "\<lbrakk> (G, ((S,\<Gamma>,H),N,(T,\<Delta>,K)), M, l, MM, ll, b, ((Sx,\<Gamma>x,Hx),Nx,(Tx,\<Delta>x,Kx))) :Typing; 
      AL_sum H HH H1; AL_sum N NN N1; AL_sum K KK K1; AL_dom H \<inter> AL_dom HH = {}; AL_dom N \<inter> AL_dom NN = {}; AL_dom K \<inter> AL_dom KK = {};
      AL_sum Hx HH Hx1; AL_sum Nx NN Nx1; AL_sum Kx KK Kx1; AL_dom H1 \<inter> AL_dom HH = {}; AL_dom N1 \<inter> AL_dom NN = {}; AL_dom K1 \<inter> AL_dom KK = {};
      AL_dom Hx \<inter> AL_dom HH = {}; AL_dom Nx \<inter> AL_dom NN = {}; AL_dom Kx \<inter> AL_dom KK = {};
      AL_dom Hx1 \<inter> AL_dom HH = {}; AL_dom Nx1 \<inter> AL_dom NN = {}; AL_dom Kx1 \<inter> AL_dom KK = {}; H1:AL; N1:AL;K1:AL;Hx1:AL;Nx1:AL;Kx1:AL
   \<rbrakk> \<Longrightarrow> (G, ((S,\<Gamma>,H1),N1,(T,\<Delta>,K1)), M, l, MM, ll, b, ((Sx,\<Gamma>x,Hx1),Nx1,(Tx,\<Delta>x,Kx1))) :Typing"
apply (erule TypingFrame)
apply (simp add: RSD_sum_def) apply (rule, assumption) apply (rule, assumption) apply (rule, assumption) apply simp
apply (simp add: RSD_sum_def)
done

lemma TypingMP_extend:
  "\<lbrakk>(G, ((S,\<Gamma>,H),N,(T,\<Delta>,K)), M, l, MM, ll, False, ((Sx,\<Gamma>x,Hx),Nx,(Tx,\<Delta>x,Kx))) :Typing;
     c \<notin> AL_dom N; c \<notin> AL_dom Nx; H \<in> AL; K \<in> AL; N :AL; Hx \<in> AL; Kx \<in> AL; Nx :AL
   \<rbrakk> \<Longrightarrow> (G, ((S,\<Gamma>,H),N[c\<mapsto>tp],(T,\<Delta>,K)), M, l, MM, ll, False, ((Sx,\<Gamma>x,Hx),Nx[c\<mapsto>tp],(Tx,\<Delta>x,Kx))) :Typing"
apply (erule_tac N="upd emp c tp" in TypingFrame)
apply (simp add: RSD_sum_def)  apply (rule, erule AL_UPD)
  apply (rule, rule AL_sum_emp2) apply (rule, rule AL_sum_emp2)  
  apply rule apply (simp add: AL_sum_def) apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (rule, erule contained_upd)
   apply (simp add: contained_def, clarsimp) apply (drule AL_upd_split) apply (erule disjE, simp add: AL_emp1) apply clarsimp apply (rule AL_update1)
    apply (simp add: AL_emp1)
  apply (simp add: AL_dom_emp AL_dom_upd1)
apply (simp add: RSD_sum_def)  apply (rule, erule AL_UPD)
  apply (rule, rule AL_sum_emp2) apply (rule, rule AL_sum_emp2)  
  apply rule apply (simp add: AL_sum_def) apply (rule, simp add: AL_dom_upd1 AL_dom_emp) apply (rule, erule contained_upd)
   apply (simp add: contained_def, clarsimp) apply (drule AL_upd_split) apply (erule disjE, simp add: AL_emp1) apply clarsimp apply (rule AL_update1)
    apply (simp add: AL_emp1)
  apply (simp add: AL_dom_emp AL_dom_upd1)
done   

lemma TypingInvSInvS_NoQQ:
  "\<lbrakk> get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeS c0 m0); 
     mbody_is c m (P1, code, l0); mbody_is c0 m0 (P2, code0, l00); 
     \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K)); 
     (S1, P1,\<Gamma>1,S):absFrame; (T1, P2,\<Delta>1,T):absFrame;
     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;
     (G, (([], \<Gamma>1, H), N, ([], \<Delta>1, K)), 
         (P1, code, l0), l0, (P2, code0, l00), l00, 
         True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing
   \<rbrakk> \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"
apply (erule TypingInvSInvS)
apply assumption
apply assumption
apply assumption
apply assumption 
apply assumption
apply assumption
apply assumption
apply assumption
done

lemma TypingRetRetLEQ: "\<lbrakk> get_ins M l = Some vreturn; get_ins MM ll = Some vreturn;
              \<gamma> = ((c#S,\<Gamma>,H),N,(d#T,\<Delta>,K)); 
              \<delta> = (([c],emp,H),N,([d],emp,K))\<rbrakk>
            \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
(*apply (rule TypingLEQ)*)
apply (erule TypingRetRet)
apply assumption
apply assumption
apply assumption
(*apply assumption
apply (rule LAT6)*)
done

lemma TypingRetRetIDDerivable:
  "\<lbrakk> get_ins M l = Some vreturn; get_ins MM ll = Some vreturn;
     \<gamma> = ((c#S,\<Gamma>,H),N,(c#T,\<Delta>,K)); 
     \<delta> = (([c],emp,H),N,([c],emp,K))\<rbrakk>
  \<Longrightarrow> (G,  \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (erule TypingRetRetLEQ)
apply assumption
apply assumption
apply assumption
(*apply assumption*)
done

lemma UniInjectDerivable:
  "\<lbrakk> (U, \<Sigma>, N, M, l, \<Sigma>1, N1,{l1}) : UniSS; UniCtxtVerified U; 
      \<gamma> = (\<Sigma>,N,\<Pi>); (G, (\<Sigma>1, N1,\<Pi>), M, l1, MM, ll, True, \<delta>):Typing\<rbrakk>
      \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (erule UniInjectL) apply assumption apply assumption apply clarsimp
done

lemma TypingInvSInvS_LEQ:
  "\<lbrakk> get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeS c0 m0); 
     mbody_is c m (P1, code, l0); mbody_is c0 m0 (P2, code0, l00); 
     \<gamma> = ((S1, \<Gamma>, H), N, (T1, \<Delta>, K)); 
     (S1, P1,\<Gamma>1,S):absFrame; (T1, P2,\<Delta>1,T):absFrame;
     (G, ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)), M, (l + 1), MM ,(ll + 1), True, \<delta>):Typing;
     (G, (([], \<Gamma>1, H), N, ([], \<Delta>1, K)), (P1, code, l0), l0, (P2, code0, l00), l00, True, (([c1], emp, HH), NN, ([c2], emp, KK))):Typing
   \<rbrakk> \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>) :Typing"
apply (erule TypingInvSInvS_NoQQ)
apply assumption
apply assumption
apply assumption
apply assumption
apply assumption
apply assumption
apply assumption
(*apply (erule TypingLEQ) 
  apply assumption*)
  apply assumption
done

lemma TypingPutDerivable:
  "\<lbrakk> get_ins M l = Some (putfield C f); \<gamma> = ((c1#c2#S,\<Gamma>,H),N,(T,\<Delta>,K));
     H\<down>c2 = Some(D,F); H1 = H[c2 \<mapsto> (D,F[f \<mapsto> c1])]; 
     (G, ((S,\<Gamma>,H1),N,(T,\<Delta>,K)), M, (l+1), MM, ll, True, \<delta>):Typing\<rbrakk>
  \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (rule UniInjectDerivable)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply assumption
prefer 2 apply simp
apply (erule UniPut) apply fastsimp apply assumption apply simp apply simp apply simp
done

lemma TypingNewDerivable:
  "\<lbrakk> get_ins M l = Some (new C); \<gamma> = ((S,\<Gamma>,H),N,(T,\<Delta>,K));
     cl \<notin> AL_dom N; subclass_of C D;
     (G, ((cl#S,\<Gamma>,H[cl \<mapsto> (C,emp)]),N[cl \<mapsto> (classTP D)],(T,\<Delta>,K)), M, (l+1), MM, ll, True, \<delta>):Typing\<rbrakk>
     \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (rule UniInjectDerivable)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply assumption
prefer 2 apply simp
apply (erule UniNew) apply fastsimp apply assumption apply simp apply assumption apply simp apply simp
done

lemma TypingGetDerivable:
  "\<lbrakk> get_ins M l = Some (getfield C f); \<gamma> = ((c1#S,\<Gamma>,H),N,(T,\<Delta>,K));
     H\<down>c1 = Some(D,F); F\<down>f = Some c2; 
     (G, ((c2#S,\<Gamma>,H),N,(T,\<Delta>,K)), M, (l+1), MM, ll, True, \<delta>):Typing\<rbrakk>
  \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (rule UniInjectDerivable)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply assumption
prefer 2 apply simp
apply (erule UniGet) apply fastsimp apply assumption+ apply simp apply simp apply simp
done

lemma TypingInvSDerivable:
  "\<lbrakk> get_ins M l = Some (invokeS c m);  mbody_is c m (P1, code, l0); 
     \<gamma> = ((S1, \<Gamma>, H),N, \<Pi>); (S1, P1,\<Gamma>1,S):absFrame; 
     (U, ([], \<Gamma>1, H), N, (P1, code, l0), l0, True, HH, c1, NN) : UniBS;
     UniCtxtVerified U; NN:AL;
    (G, ((c1 # S, \<Gamma>, HH), NN,\<Pi>), M, (l+1), MM, ll, True, \<delta>):Typing\<rbrakk>
  \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (rule UniInjectDerivable)
prefer 2 apply assumption
prefer 2 apply assumption
prefer 2 apply simp
apply (erule UniInvS) apply assumption apply fastsimp apply assumption+
                      apply fastsimp apply simp apply assumption apply assumption
done

lemma TypingIfDerivable:
  "\<lbrakk> get_ins M l = Some (iftrue pc); \<gamma> = ((c#S,\<Gamma>,H),N,\<Pi>);
     (G, ((S,\<Gamma>,H),N,\<Pi>), M, (l+1), MM, ll, True, \<delta>):Typing; 
     (G, ((S,\<Gamma>,H),N,\<Pi>), M, pc, MM, ll, True, \<delta>):Typing\<rbrakk>
  \<Longrightarrow> (G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing"
apply (rule UniInjectL)
prefer 2 apply (rule UniCtxtVerified_emp)
prefer 2 apply assumption
apply (erule UniIf) apply fastsimp apply simp apply simp apply simp 
apply clarsimp 
done

text{*The syntactic counterpart to context validity, the formal justification of a proof
context, is the \emph{derivability} of all entries.*}

constdefs CtxtVerified::"Ctxt \<Rightarrow> bool"
"CtxtVerified G \<equiv> 
  \<forall> M l MM ll \<gamma> \<delta>. (((M,l),(MM,ll)),\<gamma>,\<delta>) \<in> G \<longrightarrow>
                       ( preserved \<gamma> \<delta> \<and>(G, \<gamma>, M, l, MM, ll, False, \<delta>):Typing)"

text{*The soundness of the proof system is shown in file RSDSound.*}

(*<*)
end
(*>*)