theory RuleBinopBinop = RuleConstConst:

lemma Invariant_BinopBinop:
  "\<lbrakk> Invariant ca (a, ab, bd) ([v], emp, h) I1 af[c\<mapsto>intTP] (c # S, \<Gamma>, bb) (f va wa # ops, aa, b) I;
     c \<notin> AL_dom N; ca \<in> AL_dom af; AL_dom N \<inter> AL_dom Na = {}; AL_sum N Na af ; c\<notin> AL_dom Na\<rbrakk>
       \<Longrightarrow> Invariant ca (a, ab, bd) ([v], emp, h) I1 af (c1 # c2 # S, \<Gamma>, bb) (va # wa # ops, aa, b) I"
apply (simp add: Invariant_def)
apply (subgoal_tac "ca \<noteq> c", clarsimp) prefer 2 apply (simp add: AL_sum_def) apply fastsimp
apply (rule, clarsimp) apply (simp add: ObjIDs_def, clarsimp)
  apply (subgoal_tac "af[c\<mapsto>intTP]\<down>ca = Some (classTP C)", clarsimp) apply (erule_tac x=C in allE, simp)
  apply (erule AL_update5a) apply assumption
apply (erule SetTriv101)
  apply (simp add: ValRepEQ)
  apply (rule SetTriv109)
    apply (erule ValuesRepresented1)
  apply (rule SetTriv101)
    apply (rule ValuesRepresented9)
    apply (rule ValuesRepresented9)
done

(* safe is not needed: operations over integers are safe as we only have equality relation here!
constdefs safe::"(Val \<Rightarrow> Val \<Rightarrow> Val) \<Rightarrow> bool"
"safe f == \<forall> v w vv ww . (v,w):twiddleVal \<longrightarrow> (vv,ww):twiddleVal \<longrightarrow> (f v vv,f w ww):twiddleVal"
*)
constdefs isOfType::"(Val \<Rightarrow> Val \<Rightarrow> Val) \<Rightarrow> TP \<Rightarrow> TP \<Rightarrow> TP \<Rightarrow> bool"
"isOfType f tp1 tp2 tp == \<forall> v w . typecorrect v tp1 \<longrightarrow> typecorrect w tp2 \<longrightarrow> typecorrect (f v w) tp"

lemma BinopBinop_Sound:
"\<lbrakk> get_ins M l = Some (binop f); get_ins MM ll = Some (binop f); 
   \<gamma> = ((c1#c2#S, \<Gamma>, H), N, c1#c2#T, \<Delta>, K); c \<notin> AL_dom N; 
   N\<down>c1 = Some intTP; N\<down>c2 = Some intTP; 
   isOfType f intTP intTP intTP;
   SecN index ((c # S, \<Gamma>, H), N[c\<mapsto>intTP], c # T, \<Delta>, K) M (l + 1) MM (ll + 1) \<delta>\<rbrakk>
 \<Longrightarrow> SecN (Suc index) \<gamma> M l MM ll \<delta>" 
apply clarsimp
apply (unfold SecN_def)
apply (erule conjE)
apply (subgoal_tac "preserved ((c1 # c2 # S, \<Gamma>, H), N, c1 # c2 # T, \<Delta>, K) \<delta>")
prefer 2 apply (rotate_tac -1, erule thin_rl,  erule thin_rl, erule thin_rl) apply (simp add: preserved_def)
         apply (case_tac \<delta>, clarsimp) 
         apply (rule contained_transitive) prefer 2 apply assumption apply (rule contained_upd) apply assumption
apply (rule, assumption)
apply (rule, rule, rule)
apply (rule allI)+ apply (rule impI)+
apply (erule eval_cases) apply clarsimp apply clarsimp
apply (drule BinopElim1, assumption) apply clarsimp
apply (erule eval_cases) apply clarsimp apply clarsimp
apply (drule BinopElim1, assumption) apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith7)
apply (erule_tac x="f va wa # ops" in allE, erule_tac x=aa in allE, erule_tac x=b in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE)
apply (erule_tac x="f vb wb # opsa" in allE, erule_tac x=ac in allE, erule_tac x=ba in allE)
apply (erule_tac x=k in allE, erule_tac x=w in allE)
apply (simp add: RSD_sum_def, clarsimp)
apply (case_tac \<delta>,clarsimp) 
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=bb in allE, erule_tac x="upd af c intTP" in allE, erule_tac x=bc in allE, clarsimp)
apply (erule_tac x=bd in allE, erule_tac x=ak in allE, erule_tac x=be in allE)
apply (erule_tac x=I in allE, erule_tac x=J in allE) 
apply (subgoal_tac "c \<notin> AL_dom Na")
prefer 2 apply (rotate_tac -1, erule thin_rl)         
         apply (subgoal_tac "c : AL_dom ad", fast)
         apply (simp add: preserved_def, (erule conjE)+) apply (erule contained6, rule AL_dom_upd2) 
apply (subgoal_tac "c \<notin> AL_dom af")
prefer 2 apply (rotate_tac -2, erule thin_rl)
         apply (simp add: AL_sum_def)
apply (rotate_tac -3, erule impE) 
  apply (simp add: sat_def, clarsimp)
  apply (subgoal_tac "State_welldef (S, \<Gamma>, bb) af")
  prefer 2 apply (simp add: welldef_def, erule conjE) 
           apply (rule State_welldef_Tail) apply (erule State_welldef_Tail)
  apply (subgoal_tac " State_welldef (T, \<Delta>, bc) af")
  prefer 2 apply (simp add: welldef_def, erule conjE) 
           apply (rule State_welldef_Tail) apply (erule State_welldef_Tail)
  apply (rule, rule welldef_ConsCons) 
    apply (simp add: welldef_def) 
    apply assumption apply assumption apply assumption 
  apply (simp add: welldef_def, clarsimp)
  apply (subgoal_tac "typecorrect (f va wa) intTP")
  prefer 2 apply (simp add: isOfType_def) 
           apply (erule_tac x=va in allE, erule impE)
             apply (simp add: StateSatisfiesAbstraction_def State_typecorrect_def Opstack_typecorrect_def,clarsimp)
             apply (erule_tac x=0 in allE, clarsimp)
             apply (drule_tac H=N and x=c1 in AL_sum3,assumption) apply simp
           apply (erule_tac x=wa in allE, erule impE)
             apply (simp add: StateSatisfiesAbstraction_def State_typecorrect_def Opstack_typecorrect_def,clarsimp)
             apply (erule_tac x=1 in allE, clarsimp)
             apply (drule_tac H=N and x=c2 in AL_sum3,assumption) apply simp
           apply assumption
  apply (rule, rule StateSatisfiesAbstraction_freshInt) 
    apply (rule StateSatisfiesAbstraction_Tail) apply (erule StateSatisfiesAbstraction_Tail)
    apply assumption 
    apply assumption
    apply assumption 
  apply (subgoal_tac "typecorrect (f vb wb) intTP")
  prefer 2 apply (simp add: isOfType_def) 
           apply (erule_tac x=vb in allE, erule impE)
             apply (simp add: StateSatisfiesAbstraction_def State_typecorrect_def Opstack_typecorrect_def,clarsimp)
             apply (rotate_tac -13, erule_tac x=0 in allE, clarsimp)
             apply (drule_tac H=N and x=c1 in AL_sum3,assumption) apply simp
           apply (erule_tac x=wb in allE, erule impE)
             apply (simp add: StateSatisfiesAbstraction_def State_typecorrect_def Opstack_typecorrect_def,clarsimp)
             apply (rotate_tac -13, erule_tac x=1 in allE, clarsimp)
             apply (drule_tac H=N and x=c2 in AL_sum3,assumption) apply simp
          apply assumption
  apply (rule, rule StateSatisfiesAbstraction_freshInt) 
      apply (rule StateSatisfiesAbstraction_Tail) apply (erule StateSatisfiesAbstraction_Tail) 
      apply assumption  
      apply assumption
      apply assumption 
  apply clarsimp apply (drule AL_upd_split) 
                 apply (erule disjE, clarsimp) 
                   apply (simp add: singleVal_def)
                   apply (rule twSet_Triv2) prefer 2 apply (rule ValuesRepresented14)
                   apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, bb) (ops, aa, b) I = {}", clarsimp)
                   prefer 2 apply (erule_tac S=S in State_welldef_notinMP_ValuesRepresented_Empty) apply assumption
                   apply (rule twSet_Triv4) prefer 2 apply (rule ValuesRepresented14)
                   apply (subgoal_tac "ValuesRepresented c (T, \<Delta>, bc) (opsa, ac, ba) J = {}", clarsimp)
                   prefer 2 apply (erule_tac S=T in State_welldef_notinMP_ValuesRepresented_Empty) apply assumption
                   apply (rule twSet_Triv2)
                   prefer 2 apply (rule ValuesRepresented_State_welldef1) 
                            apply (rule State_welldef_Tail) apply (erule State_welldef_Tail) apply assumption
                   apply (rule twSet_Triv4) 
                   prefer 2 apply (rule ValuesRepresented_State_welldef1)
                            apply (rule State_welldef_Tail) apply (erule State_welldef_Tail) apply assumption 
                   apply (rule twSetVW) apply simp apply simp 
                 apply (subgoal_tac "va=vb", clarsimp)
                   (*apply (simp add: safe_def)*)
                 prefer 2
                   apply (erule_tac x=c1 in allE, erule impE) apply(erule AL_sum3) apply assumption
                   apply (erule impE, simp add: DOM_def)
                         apply (subgoal_tac "Values_Represented c1 (c1 # c2 # S, \<Gamma>, bb) (va # wa # ops, aa, b) I \<noteq> {}")
                         prefer 2 apply (rule_tac N=af in State_typecorrect_VR_notEmpty) 
                                  apply (simp add: StateSatisfiesAbstraction_def)
                                  apply (simp add: DOM_def)
                         apply (subgoal_tac "Values_Represented c1 (c1 # c2 # T, \<Delta>, bc) (vb # wb # opsa, ac, ba) J \<noteq> {}")
                         prefer 2 apply (rule_tac N=af in State_typecorrect_VR_notEmpty) 
                                  apply (simp add: StateSatisfiesAbstraction_def)
                                  apply (simp add: DOM_def)
                       apply (erule twSet.elims) apply (simp add: ValRepEQ) apply (simp add: ValRepEQ) apply (simp add: ValRepEQ) 
                       apply clarsimp
                       apply (subgoal_tac "va:ValuesRepresented c1 (c1 # c2 # S, \<Gamma>, bb) (va # wa # ops, aa, b) I", clarsimp)
                       prefer 2 apply (rule ValuesRepresented2)
                       apply (subgoal_tac "vb:ValuesRepresented c1 (c1 # c2 # T, \<Delta>, bc) (vb # wb # opsa, ac, ba) J", clarsimp)
                       apply (rule ValuesRepresented2)
                 apply (subgoal_tac "wa=wb", clarsimp)
                   (*apply (simp add: safe_def)*)
                   apply (erule_tac x=c2 in allE, erule impE) apply(erule AL_sum3) apply assumption
                   apply (erule impE, simp add: DOM_def)
                         apply (subgoal_tac "Values_Represented c2 (c1 # c2 # S, \<Gamma>, bb) (vb # wa # ops, aa, b) I \<noteq> {}")
                         prefer 2 apply (rule_tac N=af in State_typecorrect_VR_notEmpty) 
                                  apply (simp add: StateSatisfiesAbstraction_def)
                                  apply (simp add: DOM_def)
                         apply (subgoal_tac "Values_Represented c2 (c1 # c2 # T, \<Delta>, bc) (vb # wb # opsa, ac, ba) J \<noteq> {}")
                         prefer 2 apply (rule_tac N=af in State_typecorrect_VR_notEmpty) 
                                  apply (simp add: StateSatisfiesAbstraction_def)
                                  apply (simp add: DOM_def)
                       apply (erule twSet.elims) apply (simp add: ValRepEQ) apply (simp add: ValRepEQ) apply (simp add: ValRepEQ) 
                       apply clarsimp
                       apply (subgoal_tac "wa:ValuesRepresented c2 (c1 # c2 # S, \<Gamma>, bb) (vb # wa # ops, aa, b) I", clarsimp)
                       prefer 2 apply (rule ValuesRepresented7)
                       apply (subgoal_tac "wb:ValuesRepresented c2 (c1 # c2 # T, \<Delta>, bc) (vb # wb # opsa, ac, ba) J", clarsimp)
                       apply (rule ValuesRepresented7)
                 apply clarsimp
                   apply (erule_tac x=ca in allE, erule impE, assumption)
                   apply (erule impE, rule) apply (simp add: DOM_def) 
                                            apply (rotate_tac -4, erule disjE, simp) apply (rule disjI2, erule disjI2)
                               apply (simp add: DOM_def) 
                                            apply (rotate_tac -3, erule disjE, simp) apply (rule disjI2, erule disjI2)
                   apply (simp add: singleVal_def)
                   apply (rule twSet_Triv2) prefer 2 apply (rule ValuesRepresented1) apply fast
                   apply (rule twSet_Triv4) prefer 2 apply (rule ValuesRepresented1) apply fast
                   apply (rule twSet_Triv9) apply (erule twSet_Triv10) 
                                            apply (rule SetTriv101) apply (rule ValuesRepresented9) apply (rule ValuesRepresented9)
                                            apply (rule SetTriv101) apply (rule ValuesRepresented9) apply (rule ValuesRepresented9)
apply (rotate_tac -1, erule impE) 
  apply (rule, erule AL_UPD)
  apply (rule, erule AL_sum_upd_upd2) apply assumption apply assumption 
  apply (simp add: AL_dom_upd1)
apply clarsimp
apply (rule, rule)
  apply rule apply assumption
  apply (rule, rule)
    apply (erule_tac x=ca in allE, rotate_tac -1, erule impE, simp add: AL_dom_upd1)
    apply (erule conjE)
    apply rule apply (rule_tac N=N in Invariant_BinopBinop) apply assumption+
    apply (erule_tac N=N in Invariant_BinopBinop, assumption+) 
done

end