theory RuleConstConst = SatSec:

lemma ValuesRepresented_State_welldef1:
 "\<lbrakk> State_welldef (S, \<Gamma>, H) N; c \<notin> AL_dom N\<rbrakk> 
 \<Longrightarrow> ValuesRepresented c ([c], emp, H) ([v], emp, h) I = {v}"
apply (simp add: ValuesRepresented_def, rule, clarsimp)
apply (erule disjE, clarsimp)
  apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
  apply (erule disjE, clarsimp) apply (drule State_welldef_lookupHeap1) apply assumption apply simp 
  apply clarsimp apply (drule State_welldef_Field_lookup) apply assumption apply assumption 
    apply clarsimp apply (drule_tac H=N in AL_domI) apply simp
apply clarsimp
done

lemma Invariant_ConstConst:
  "\<lbrakk> Invariant ca (ad, ae, bh) ([v], emp, h) I1 af[c\<mapsto>intTP] (c # S, \<Gamma>, bf) (w # ai, aj, bd) I; 
     c \<notin> AL_dom N; ca \<in> AL_dom af; AL_dom N \<inter> AL_dom Na = {}; AL_sum N Na af ; c\<notin> AL_dom Na\<rbrakk>
  \<Longrightarrow> Invariant ca (ad, ae, bh) ([v], emp, h) I1 af (S, \<Gamma>, bf) (ai, aj, bd) I"
apply (simp add: Invariant_def)
apply (subgoal_tac "ca \<noteq> c", clarsimp) prefer 2 apply (simp add: AL_sum_def) apply fastsimp
apply (rule, clarsimp) apply (simp add: ObjIDs_def, clarsimp)
  apply (subgoal_tac "af[c\<mapsto>intTP]\<down>ca = Some (classTP C)", clarsimp) apply (erule_tac x=C in allE, clarsimp)
  apply (erule AL_update5a) apply assumption
apply (erule SetTriv101)
  apply (simp add: ValRepEQ)
  apply (drule_tac S=S and \<Gamma>=\<Gamma> and H=bf and v=w and ops=ai and aa=aj and b=bd and I=I in ValuesRepresented1) apply simp
done

lemma ConstConst_Sound:
"\<lbrakk> get_ins M l = Some (const (IVal i)); get_ins MM ll = Some (const (IVal i)); 
   \<gamma> = ((S, \<Gamma>, H), N, T, \<Delta>, K); c \<notin> AL_dom N; 
   SecN index ((c # S, \<Gamma>, H), N[c\<mapsto>intTP], c # T, \<Delta>, K) M (l + 1) MM (ll + 1) \<delta>\<rbrakk>
 \<Longrightarrow> SecN (Suc index) \<gamma> M l MM ll \<delta>" 
apply clarsimp
apply (unfold SecN_def)
apply (erule conjE)
apply (subgoal_tac "preserved ((S, \<Gamma>, H), N, T, \<Delta>, K) \<delta>")
prefer 2 apply (rotate_tac -1, erule thin_rl) apply (simp add: preserved_def)
         apply (case_tac \<delta>, clarsimp) 
         apply (rule contained_transitive) prefer 2 apply assumption apply (rule contained_upd) apply assumption
apply (rule, assumption)
apply clarsimp
apply (erule eval_cases) apply clarsimp apply clarsimp
apply (drule ConstElim1, assumption) apply clarsimp
apply (erule eval_cases) apply clarsimp apply clarsimp
apply (drule ConstElim1, assumption) apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith7)
apply (erule_tac x="IVal i # a" in allE, erule_tac x=aa in allE, erule_tac x=b in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE)
apply (erule_tac x="IVal i # ab" in allE, erule_tac x=ac in allE, erule_tac x=ba in allE)
apply (erule_tac x=k in allE, erule_tac x=w in allE)
apply (simp add: RSD_sum_def, clarsimp)
apply (case_tac \<delta>,clarsimp) 
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=bb in allE, erule_tac x="upd af c intTP" in allE, erule_tac x=bc in allE, clarsimp)
apply (erule_tac x=bd in allE, erule_tac x=ak in allE, erule_tac x=be in allE)
apply (erule_tac x=I in allE, erule_tac x=J in allE) 
apply (subgoal_tac "c \<notin> AL_dom Na")
prefer 2 apply (rotate_tac -1, erule thin_rl)         
         apply (subgoal_tac "c : AL_dom ag", fast)
         apply (simp add: preserved_def, (erule conjE)+) apply (erule contained6, rule AL_dom_upd2) 
apply (subgoal_tac "c \<notin> AL_dom af")
prefer 2 apply (rotate_tac -2, erule thin_rl)
         apply (simp add: AL_sum_def)
apply (rotate_tac -3, erule impE) 
  apply (simp add: sat_def, clarsimp) 
  apply (rule, erule welldef_ConsCons) apply assumption apply assumption apply assumption 
  apply (simp add: welldef_def, clarsimp)
    apply (rule, erule StateSatisfiesAbstraction_freshInt) apply simp apply assumption apply assumption
    apply (rule, erule StateSatisfiesAbstraction_freshInt) apply simp apply assumption apply assumption
  apply clarsimp apply (drule AL_upd_split) 
                 apply (erule disjE, clarsimp) apply (rotate_tac -5, erule thin_rl) 
                   apply (simp add: singleVal_def)
                   apply (rule twSet_Triv2) prefer 2 apply (rule ValuesRepresented14)
                   apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, bb) (a, aa, b) I = {}", clarsimp)
                   prefer 2 apply (erule_tac S=S in State_welldef_notinMP_ValuesRepresented_Empty) apply assumption 
                   apply (rule twSet_Triv4) prefer 2 apply (rule ValuesRepresented14)
                   apply (subgoal_tac "ValuesRepresented c (T, \<Delta>, bc) (ab, ac, ba) J = {}", clarsimp)
                   prefer 2 apply (erule_tac S=T in State_welldef_notinMP_ValuesRepresented_Empty) apply assumption 
                   apply (rule twSet_Triv2) prefer 2 apply (erule ValuesRepresented_State_welldef1) apply assumption
                   apply (rule twSet_Triv4) prefer 2 apply (erule ValuesRepresented_State_welldef1) apply assumption
                   apply (rule twSetVW) apply simp apply simp apply simp 
                 apply clarsimp
                   apply (erule_tac x=ca in allE, erule impE, assumption)
                   apply (erule impE) apply rule apply (simp add: DOM_def) apply (erule disjE) apply simp apply assumption 
                                       apply (simp add: DOM_def) apply (rotate_tac -3,erule disjE) apply simp apply assumption 
                   apply (simp add: singleVal_def)
                   apply (rule twSet_Triv2) prefer 2 apply (rule ValuesRepresented1) apply fast
                   apply (erule twSet_Triv4) apply (rule ValuesRepresented1) apply fast
apply (rotate_tac -1, erule impE) 
  apply (rule, erule AL_UPD)
  apply (rule, erule AL_sum_upd_upd2) apply assumption apply assumption 
  apply (simp add: AL_dom_upd1)
apply clarsimp
(*apply (rotate_tac -1, erule impE) 
  apply (erule HP_good_subset, rule contained_refl) apply (simp add: AL_dom_upd)
apply (rotate_tac -1, erule impE) 
  apply (erule HP_good_subset, rule contained_refl) apply (simp add: AL_dom_upd)
apply clarsimp
  apply (rule, rule, rule, rule, rule, rule, rule, rule, rule)*)
apply (rule, rule)
(*  apply rule apply assumption
  apply rule apply assumption
  apply rule apply assumption
  apply rule apply assumption 
(-  apply rule apply (simp add: preserved_def)
             apply (case_tac \<delta>, clarsimp) 
             apply (rule contained_transitive) prefer 2 apply assumption apply (rule contained_upd) apply assumption-)*)
  apply rule apply assumption
(*  apply rule apply assumption*)
  apply (rule, rule)
    apply (erule_tac x=ca in allE, rotate_tac -1, erule impE, simp add: AL_dom_upd1)
    apply (erule conjE)
    apply rule apply (erule_tac N=N in Invariant_ConstConst, assumption+)
    apply (erule_tac N=N in Invariant_ConstConst, assumption+) 
done

end