theory RuleInvsInvs = InvokeRelationalBasics:

lemma InvSInvS_sat_Frame:
  "\<lbrakk> sat (a, aa, b) (ab, ac, ba) ((ad, ae, bb), af, (ag, ah, bc)) I J; 
     (S1, P1, \<Gamma>1, S) \<in> absFrame; (T1, P2, \<Delta>1, T) \<in> absFrame; 
     (a, P1, SS, ops) \<in> Frame; (ab, P2, SSa, opsa) \<in> Frame;
     RSD_sum ((S1, \<Gamma>, H), N, T1, \<Delta>, K) Ha Na Ka ((ad, ae, bb), af, ag, ah, bc)\<rbrakk>
   \<Longrightarrow> sat ([], SS, b) ([], SSa, ba) (([], \<Gamma>1, bb), af, [], \<Delta>1, bc) I J"
apply (simp add: sat_def)
apply (simp add: RSD_sum_def)
apply (erule conjE)+
apply (rule, clarsimp) apply (erule absFrame_welldef, assumption, assumption)
apply (rule, clarsimp) apply (erule absFrame_InvS_StateSatisfiesAbstraction, assumption, assumption)
apply (rule, clarsimp) apply (erule absFrame_InvS_StateSatisfiesAbstraction, assumption, assumption)
apply clarsimp
apply (erule_tac x=c in allE, erule impE, assumption)
  apply (erule impE, rule) apply (erule SetTriv, erule absFrame_DOM_InvS) apply (erule SetTriv, erule absFrame_DOM_InvS)
  apply (simp add: singleVal_def)
  apply (rule twSet_Triv9)
    apply (erule twSet_Triv10)
    apply (rule SetTriv101)
      apply (erule ValuesRepresented18) apply assumption
      apply (rule ValuesRepresented13)
    apply (rule SetTriv101)
      apply (erule ValuesRepresented18) apply assumption
      apply (rule ValuesRepresented13)
done

lemma InvSInvS_Invariant_Aux:
"\<lbrakk> Invariant ca ([c1], emp, bd) ([va], emp, hh) I1 N ([], \<Gamma>1, bb) ([], SS, b) I; 
  Invariant ca (ad, ae, bf) ([v], emp, h) I1a NN (c1 # S, \<Gamma>, bd) (va # ops, aa, hh) I1;
  State_welldef (S1, \<Gamma>, bb) N; (a, P1, SS, ops) \<in> Frame; (S1, P1, \<Gamma>1, S) \<in> absFrame;
  State_welldef ([c1], emp, bd) NN; State_welldef (ad, ae, bf) ap;
        ca \<in> AL_dom N; 
        contained N NN; AL_dom bb \<subseteq> AL_dom bd; contained NN ap; AL_dom bd \<subseteq> AL_dom bf; AL_sum H Ha bb;
        AL_sum HH Ha bd;
        AL_sum bh Ha bf\<rbrakk>
       \<Longrightarrow> Invariant ca (ad, ae, bf) ([v], emp, h) I1a N (S1, \<Gamma>, bb) (a, aa, b) I"
apply (unfold Invariant_def, clarsimp)
apply (simp add: ValRepEQ)
apply (rule, clarsimp) apply (drule contained_ObjIds_subset) apply fast
apply (erule SetTriv101)
  apply (erule ValuesRepresented21) 
    apply assumption+ apply fast
done

lemma InvSInvS_Invariant:
  "\<lbrakk> (a, P1, SS, ops) \<in> Frame; (S1, P1, \<Gamma>1, S) \<in> absFrame; 
     Invariant ca ([c1], emp, HHa) ([va], emp, hh) I1 af ([], \<Gamma>1, bb) ([], SS, b) I;
     Invariant ca (an, ao, bd) ([v], emp, h) I1a NNa (c1 # S, \<Gamma>, HHa) (va # ops, aa, hh) I1;
     State_welldef (S1, \<Gamma>, bb) af; State_welldef ([c1], emp, HHa) NNa;State_welldef (an, ao, bd) ak; 

     ca \<in> AL_dom af; 
     AL_sum N Na af;  contained N NN; AL_sum NN Na NNa; AL_sum ap Na ak; contained NN ap;

     AL_sum HH Ha HHa; AL_sum H Ha bb; AL_sum bf Ha bd; AL_dom H \<subseteq> AL_dom HH; AL_dom HH \<subseteq> AL_dom bf\<rbrakk>
   \<Longrightarrow> Invariant ca (an, ao, bd) ([v], emp, h) I1a af (S1, \<Gamma>, bb) (a, aa, b) I"
apply (rule InvSInvS_Invariant_Aux) apply assumption 
                       apply assumption apply assumption 
                       apply assumption apply assumption
                       apply assumption apply assumption 
                       apply assumption 
                       apply (simp (no_asm) add: contained_def,clarsimp) 
                         apply (drule AL_sum_split, assumption)
                         apply (erule disjE) apply (erule AL_sum3) apply (erule contained3, assumption)
                         apply (erule AL_sum4, assumption)
                       apply (simp add: AL_sum_def) apply rule apply fast apply fast
                       apply (simp (no_asm) add: contained_def,clarsimp) 
                         apply (drule AL_sum_split, assumption)
                         apply (erule disjE) apply (erule AL_sum3) apply (erule contained3, assumption)
                         apply (erule AL_sum4, assumption)
                       apply (simp add: AL_sum_def) apply rule apply fast apply fast
                       apply assumption apply assumption 
                       apply assumption
done

lemma InvsInvs_SingleVal:
  "\<lbrakk> (S1, P1,\<Gamma>1,S):absFrame; (T1, P2,\<Delta>1,T):absFrame;
     (a, P1, SS, ops) \<in> Frame; (ab, P2, SSa, opsa) \<in> Frame; 
     singleVal ca ((S1, \<Gamma>, bb), N, T1, \<Delta>, bc) (a, aa, b) I (ab, ac, ba) J;
     Invariant ca ([c1], emp, HH_Ha) ([va], emp, hh) I1 N ([], \<Gamma>1, bb) ([], SS, b) I;
     Invariant ca ([c2], emp, KK_Ka) ([vb], emp, hha) J1 N ([], \<Delta>1, bc) ([], SSa, ba) J;
     State_welldef (S, \<Gamma>, bb) N; State_welldef (T, \<Delta>, bc) N\<rbrakk>
  \<Longrightarrow> singleVal ca ((c1 # S, \<Gamma>, HH_Ha), NN, c2 # T, \<Delta>, KK_Ka) (va # ops, aa, hh) I1 (vb # opsa, ac, hha) J1"
apply (simp add: singleVal_def Invariant_def  ValRepEQ)
 apply (rule twSet_Triv2) prefer 2 apply (rule ValuesRepresented14)
 apply (rule twSet_Triv4) prefer 2 apply (rule ValuesRepresented14)
 apply clarsimp
 apply (rule twSet_Triv9)
   apply (erule twSet_Triv10)
     apply (erule Invs_SingleVal_Aux2) apply assumption+
   apply (erule Invs_SingleVal_Aux2) apply assumption+
done

lemma InvSInvS_Sound:
  "\<lbrakk> get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeS c0 m0); mbody_is c m (P1, code, l0); mbody_is c0 m0 (P2, code0, l00);
     (S1, P1, \<Gamma>1, S) \<in> absFrame; (T1, P2, \<Delta>1, T) \<in> absFrame; 
     SecN n ((c1 # S, \<Gamma>, HH), NN, (c2 # T, \<Delta>, KK)) M (Suc l) MM (Suc ll) \<delta>;
     SecN n (([], \<Gamma>1, H), N, [], \<Delta>1, K) (P1, code, l0) l0 (P2, code0, l00) l00 (([c1], emp, HH), NN, [c2], emp, KK)\<rbrakk>
   \<Longrightarrow> SecN (Suc n) ((S1, \<Gamma>, H), N, (T1, \<Delta>, K)) M l MM ll \<delta>"
apply (unfold SecN_def) apply clarify
apply rule apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
  apply (simp add: preserved_def) apply (case_tac \<delta>, clarsimp) 
    apply (rule, erule contained_transitive, assumption)
    apply (rule, erule SetTriv101, assumption)
    apply (erule SetTriv101, assumption)
apply clarify
apply (erule eval_cases) apply clarsimp apply clarify
apply (drule InvokeSElim1) apply assumption apply clarify
apply (erule eval_cases) apply clarsimp apply clarify
apply (drule InvokeSElim1) apply assumption apply clarify
apply clarsimp
apply (simp add: mbody_is_def) apply clarsimp
apply (rotate_tac 6)
apply (erule_tac x=ka in allE, erule_tac x=kb in allE, erule impE, erule Arith_15) 
apply (subgoal_tac "AL_dom HH \<inter> AL_dom Ha = {}")
prefer 2 apply (case_tac \<delta>, clarsimp)
         apply (rule_tac Y="AL_dom bf" in SetTriv103)
           apply (simp add: preserved_def)
           apply (simp add: RSD_sum_def)
apply (frule_tac N=HH in AL_sum_exists_AL)
apply (erule exE, rename_tac HHa, erule conjE)
apply (subgoal_tac "AL_dom KK \<inter> AL_dom Ka = {}")
prefer 2 apply (case_tac \<delta>, clarsimp)
         apply (rule_tac Y="AL_dom bg" in SetTriv103)
           apply (simp add: preserved_def)
           apply (simp add: RSD_sum_def)
apply (frule_tac N=KK in AL_sum_exists_AL)
apply (erule exE, rename_tac KKa, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom Na = {}")
prefer 2 apply (simp add: RSD_sum_def, (erule conjE)+) 
         apply (case_tac \<delta>, clarsimp)
         apply (rule_tac Y="AL_dom ap" in SetTriv103)
           apply (simp add: preserved_def, (erule conjE)+) apply (erule contained5) 
           apply assumption
apply (frule_tac N=NN in AL_sum_exists_AL)
apply (erule exE, rename_tac NNa, erule conjE)
apply (erule_tac x="[]" in allE)
apply (erule_tac x=SS in allE)
apply (erule_tac x=b in allE)
apply (erule_tac x=hh in allE)
apply (erule_tac x=va in allE)
apply (erule_tac x="[]" in allE)
apply (erule_tac x=SSa in allE)
apply (erule_tac x=ba in allE)
apply (erule_tac x=hha in allE)
apply (erule_tac x=vb in allE)
apply (erule_tac x=Ha in allE)
apply (erule_tac x=Na in allE)
apply (erule_tac x=Ka in allE)
apply (erule_tac x="[]" in allE)
apply (erule_tac x=\<Gamma>1 in allE)
apply (erule_tac x=bb in allE)
apply (erule_tac x=af in allE)
apply (erule_tac x="[]" in allE)
apply (erule_tac x=\<Delta>1 in allE)
apply (erule_tac x=bc in allE)
apply (erule_tac x="[c1]" in allE)
apply (erule_tac x=emp in allE)
apply (erule_tac x=HHa in allE)
apply (erule_tac x=NNa in allE)
apply (erule_tac x="[c2]" in allE)
apply (erule_tac x=emp in allE)
apply (erule_tac x=KKa in allE)
apply (erule_tac x=I in allE, rotate_tac -1)
apply (erule_tac x=J in allE)
apply (erule impE) 
  apply (rotate_tac -10, erule thin_rl)
  apply (erule InvSInvS_sat_Frame) apply assumption apply assumption apply assumption 
    apply assumption apply assumption 
apply (erule impE) apply (erule RSD_sum_onlyHP)
apply (erule impE) apply (rotate_tac -10, erule thin_rl) apply (simp add: RSD_sum_def)
apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith_16) 
apply (erule_tac x="va # ops" in allE)
apply (erule_tac x=aa in allE)
apply (erule_tac x=hh in allE)
apply (erule_tac x=h in allE)
apply (erule_tac x=v in allE)
apply (erule_tac x="vb # opsa" in allE)
apply (erule_tac x=ac in allE)
apply (erule_tac x=hha in allE)
apply (erule_tac x=k in allE)
apply (erule_tac x=w in allE)
apply (erule_tac x=Ha in allE, rotate_tac -1)
apply (erule_tac x=Na in allE, rotate_tac -1)
apply (erule_tac x=Ka in allE, rotate_tac -1)
apply (erule_tac x="c1#S" in allE)
apply (erule_tac x=\<Gamma> in allE)
apply (erule_tac x=HHa in allE, rotate_tac -1)
apply (erule_tac x=NNa in allE, rotate_tac -1)
apply (erule_tac x="c2#T" in allE)
apply (erule_tac x=\<Delta> in allE)
apply (erule_tac x=KKa in allE, rotate_tac -1)
apply (case_tac \<delta>, clarsimp)
apply (erule_tac x=an in allE)
apply (erule_tac x=ao in allE)
apply (erule_tac x=bd in allE)
apply (erule_tac x=ak in allE)
apply (erule_tac x=aq in allE)
apply (erule_tac x=ar in allE)
apply (erule_tac x=be in allE)
apply (erule_tac x=I1 in allE)
apply (erule_tac x=J1 in allE)
apply (erule impE) defer
apply (erule impE) apply (simp add: RSD_sum_def)
apply (erule impE) apply (simp add: RSD_sum_def) 
(*apply (erule impE) apply (simp add: RSD_sum_def) *)
apply clarsimp 
  apply (rule, rule) (*, rule, rule, rule, rule, rule, rule, rule)*)
  apply (rule, simp add: RSD_sum_def)
(*  apply (rule, erule SetTriv101, assumption)
  apply (rule, erule SetTriv101, assumption)
  apply (rule, simp add: RSD_sum_def)*)
  apply (rule, simp add: preserved_def, clarsimp)
  apply (erule_tac x=ca in allE, erule impE, assumption, clarsimp)
(*         apply (drule_tac H=Ha and K=Ka in preserved_RSD_sum) 
           apply (subgoal_tac "RSD_sum (([], \<Gamma>1, H), N, [], \<Delta>1, K) Ha Na Ka (([], \<Gamma>1, bb), af, [], \<Delta>1, bc)", assumption) apply (simp add: RSD_sum_def) 
           apply (subgoal_tac "RSD_sum (([c1], emp, HH), NN, [c2], emp, KK) Ha Na Ka (([c1], emp, bd), ak, [c2], emp, be)", assumption) 
             apply (simp add: RSD_sum_def) 
         apply (drule_tac H=Ha and K=Ka in preserved_RSD_sum) 
           apply (subgoal_tac " RSD_sum ((c1 # S, \<Gamma>, HH), NN, c2 # T, \<Delta>, KK) Ha Na Ka ((c1 # S, \<Gamma>, bd), ak, c2 # T, \<Delta>, be)", assumption)
             apply (simp add: RSD_sum_def) apply assumption*)
         apply (simp add: RSD_sum_def, clarsimp) apply (case_tac \<delta>, clarsimp)
         apply (erule_tac x=ca in allE, erule impE) 
           apply (simp add: AL_sum_def)  apply (erule disjE) apply (rule disjI1) apply (erule contained6, assumption) apply clarsimp
         apply (simp add: sat_def welldef_def, clarsimp)
           apply (rule, erule InvSInvS_Invariant) apply assumption+
           apply (erule InvSInvS_Invariant) apply assumption+
apply (simp add: sat_def RSD_sum_def, clarsimp)
apply (subgoal_tac "contained af ak")
prefer 2 apply (simp add: preserved_def) 
                            apply (simp (no_asm) add: contained_def, clarsimp)
                            apply (drule AL_sum_split, assumption)
                            apply (erule disjE) apply (erule AL_sum3) apply (erule contained3) apply (erule contained3, assumption)
                            apply (erule AL_sum4) apply assumption
apply (subgoal_tac "contained af NNa")
prefer 2 apply (simp add: preserved_def) 
         apply (simp (no_asm) add: contained_def, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE) apply (erule AL_sum3) apply (erule contained3, assumption)
                            apply (erule AL_sum4) apply assumption
apply (subgoal_tac "welldef ((c1 # S, \<Gamma>, HHa), NNa, c2 # T, \<Delta>, KKa) \<and>
          StateSatisfiesAbstraction (va # ops, aa, hh) (c1 # S, \<Gamma>, HHa) NNa I1 \<and>
          StateSatisfiesAbstraction (vb # opsa, ac, hha) (c2 # T, \<Delta>, KKa) NNa J1", simp)
prefer 2 apply rule apply (simp add: welldef_def, clarsimp)
             apply rule apply (erule Invoke_Final_State_welldef) apply assumption apply assumption apply assumption apply assumption
                          apply (simp add: preserved_def) 
                          apply assumption
             apply (erule Invoke_Final_State_welldef) apply assumption apply assumption apply assumption apply assumption
                          apply (simp add: preserved_def) 
                          apply assumption
         apply rule apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule_tac ak=ak and N=N and NN=NN and ap=ap in InvS_StateSatisfiesAbstraction, assumption+) apply simp 
         apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule_tac ak=ak and N=N and NN=NN and ap=ap in InvS_StateSatisfiesAbstraction, assumption+) apply simp 
apply clarsimp
apply (case_tac "ca:AL_dom af")
  apply (erule_tac x=ca in allE, erule impE, assumption) 
  apply (subgoal_tac "af\<down>ca = Some intTP") prefer 2 apply (simp add: preserved_def)
                                                     apply (drule AL_domD, clarsimp)
                                                     apply (drule_tac NN=NNa in contained3, assumption) apply clarsimp
  apply clarsimp
  apply (subgoal_tac "singleVal ca ((S1, \<Gamma>, bb), af, T1, \<Delta>, bc) (a, aa, b) I (ab, ac, ba) J")
      apply (rule_tac N=af in InvsInvs_SingleVal) apply assumption+
        apply (simp add: welldef_def, clarsimp) apply (erule absFrame_State_welldef_Leftover, assumption)
        apply (simp add: welldef_def, clarsimp) apply (erule absFrame_State_welldef_Leftover, assumption)
  apply (case_tac "ca \<in> DOM (S1, \<Gamma>, bb)")
    apply (case_tac "ca \<in> DOM (T1, \<Delta>, bc)")
      apply (erule_tac x=ca in allE, erule impE, assumption, erule mp, simp)
    apply (subgoal_tac "uniqueValues (S1, \<Gamma>, bb) (a, aa, b) I")
      apply (simp add: uniqueValues_def singleVal_def) 
      apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
      apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply assumption
    apply (simp add: StateSatisfiesAbstraction_def)
  apply (case_tac "ca \<in> DOM (T1, \<Delta>, bc)")
    apply (subgoal_tac "uniqueValues (T1, \<Delta>, bc) (ab, ac, ba) J")
      apply (simp add: uniqueValues_def singleVal_def) 
      apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
      apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply assumption
    apply (simp add: StateSatisfiesAbstraction_def) 
  apply (simp add: singleVal_def) apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM) 
(*ca \<notin> AL_dom af*)
  apply (subgoal_tac "singleVal ca (([c1], emp, HHa), NNa, [c2], emp, KKa) ([va], emp, hh) I1 ([vb], emp, hha) J1")
    apply (simp add: singleVal_def)
    apply (rule twSet_Triv2) 
      apply (erule twSet_Triv4)
       apply (rule ValuesRepresented16) prefer 2 apply assumption 
          apply (simp add: welldef_def, clarsimp) 
          apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
          apply (erule absFrame_State_welldef_Leftover, assumption)
      apply (rule ValuesRepresented16) prefer 2 apply assumption 
          apply (simp add: welldef_def, clarsimp) 
          apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
          apply (erule absFrame_State_welldef_Leftover, assumption)
  apply (erule_tac x=ca in allE, erule impE, assumption, erule mp)
    apply (simp add: DOM_def welldef_def) apply (erule conjE)+
    apply rule apply (rotate_tac -9, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule absFrame_set_leftover) 
                 apply (drule_tac x=ca in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)
    apply (rotate_tac -8, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule absFrame_set_leftover) 
                 apply (drule_tac x=ca in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)
done

end