theory RuleInvsInvv = InvokeRelationalBasics:
lemma InvSInvV_satFrame:
  "\<lbrakk> sat (ops, s, h) (ops1,t,k) ((S2,\<Gamma>2,H2), NN, (T2,\<Delta>2,K2)) I J; 
     (S1, P1, \<Gamma>1, S) \<in> absFrame;
     (T1, Q1, \<Delta>1, c # T) \<in> absFrame;
     (ops, P1, ss, os) \<in> Frame; 
     (ops1, Q1, tt, RVal (Loc am) # os1) \<in> Frame; 
     SD_sum (S1, \<Gamma>, H) Ha (S2,\<Gamma>2,H2);
     SD_sum (T1, \<Delta>, K) Ka (T2,\<Delta>2,K2);
     NN\<down>c = Some (classTP C)\<rbrakk>
   \<Longrightarrow> sat ([], ss, h) ([],tt[this\<mapsto>(RVal(Loc am))],k) (([], \<Gamma>1, H2), NN, ([],\<Delta>1[this\<mapsto>c],K2)) I J"
apply (simp add: sat_def, clarsimp)
apply (frule AL_domI)
apply (simp add: SD_sum_def)
apply (erule conjE)+
apply (simp add: welldef_def, (erule conjE)+)
apply (rule, erule absFrame_State_welldef, assumption) 
apply (rule, erule absFrame_State_welldefInvV, assumption)
apply (rule, erule absFrame_InvS_StateSatisfiesAbstraction, assumption+)
apply (rule, erule absFrame_InvV_StateSatisfiesAbstraction, assumption+)
apply (rule, rule, rule)
apply (erule conjE)
apply (erule_tac x=ca in allE, erule impE, assumption)
apply (erule impE)
  apply rule apply (erule SetTriv, erule absFrame_DOM_InvS)
  apply (erule SetTriv, erule absFrame_DOM_InvV)
apply (simp add: singleVal_def)
  apply (rule twSet_Triv9)
    apply (erule twSet_Triv10)
      apply (rule SetTriv101) apply (erule ValuesRepresented_InvV) apply assumption
                              apply (rule ValuesRepresented13)
    apply (rule SetTriv101)
      apply (erule ValuesRepresented18) apply assumption
      apply (rule ValuesRepresented13)
done

lemma InvsInvv_SingleVal:
 "\<lbrakk>  (S1, P1, \<Gamma>1, S) \<in> absFrame; (T1, P2, \<Delta>1, d2 # T) \<in> absFrame; 
     (a, P1, SS, ops) \<in> Frame;  (ab, P2, Sa, RVal (Loc an) # os) \<in> Frame;  
     singleVal ca ((S1, \<Gamma>, bb), af, T1, \<Delta>, bc) (a, aa, b) I (ab, ac, ba) J;
     Invariant ca ([c1], emp, HHa) ([va], emp, hh) I1 af ([], \<Gamma>1, bb) ([], SS, b) I;
     Invariant ca ([c2], emp, KKa) ([vb], emp, hha) J1 af ([], \<Delta>1[this\<mapsto>d2], bc) ([], Sa[this\<mapsto>(RVal (Loc an))], ba) J\<rbrakk>
     \<Longrightarrow> singleVal ca ((c1 # S, \<Gamma>, HHa), NNa, c2 # T, \<Delta>, KKa) (va # ops, aa, hh) I1 (vb # os, ac, hha) J1"
apply (simp add: singleVal_def Invariant_def  ValRepEQ)
 apply (rule twSet_Triv2) prefer 2 apply (rule ValuesRepresented14)
 apply (rule twSet_Triv4) prefer 2 apply (rule ValuesRepresented14)
apply (erule conjE)+
 apply (rule twSet_Triv9)
   apply (erule twSet_Triv10)
     apply (erule Invv_SingleVal_Aux2, assumption+) 
     apply (erule Invs_SingleVal_Aux2, assumption+)
done

lemma InvSInvVSound:
"\<lbrakk>get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeV C2 m2); mbody_is c m (P1, code, l0);
        mbody_is C2 m2 (P2, code2, l2); (S1, P1, \<Gamma>1, S) \<in> absFrame; (T1, P2, \<Delta>1, d2 # T) \<in> absFrame; 
        K\<down>d2 = Some (D2, F2); subclass_of D2 C2;
        CtxtValidN n G; SecN n ((c1 # S, \<Gamma>, HH), NN, c2 # T, \<Delta>, KK) M (Suc l) MM (Suc ll) \<delta>;
        \<forall>D2'. subclass_of D2' C2 \<longrightarrow>
              (\<forall>code2' l2'.
                  mbody_is D2' m2 (P2, code2', l2') \<longrightarrow>
                  (\<forall>n. CtxtValidN n G \<longrightarrow>
                       SecN n (([], \<Gamma>1, H), N, [], \<Delta>1[this\<mapsto>d2], K) (P1, code, l0) l0 (P2, code2', l2') l2' (([c1], emp, HH), NN, [c2], emp, KK)))\<rbrakk>
       \<Longrightarrow> SecN (Suc n) ((S1, \<Gamma>, H), N, T1, \<Delta>, K) M l MM ll \<delta>"
apply (unfold SecN_def)
apply (erule conjE)+
apply (subgoal_tac "preserved (([], \<Gamma>1, H), N, [], \<Delta>1[this\<mapsto>d2], K) (([c1], emp, HH), NN, [c2], emp, KK)")
prefer 2  apply (rotate_tac -1, erule thin_rl) 
          apply (erule_tac x=C2 in allE, erule impE, simp add: subclass_of_refl)
          apply (erule_tac x=code2 in allE, erule_tac x=l2 in allE, erule impE, assumption)
          apply clarsimp
apply (subgoal_tac "preserved ((S1, \<Gamma>, H), N, T1, \<Delta>, K) \<delta>", rule, assumption)
prefer 2 apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -3, erule thin_rl)
         apply (simp add: preserved_def, case_tac \<delta>, clarsimp)
         apply (rule, erule contained_transitive, assumption)
         apply (rule, erule SetTriv101, assumption)
         apply (erule SetTriv101, assumption)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeSElim1) apply assumption apply clarify 
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeVElim1) apply assumption apply clarify 
apply clarsimp
apply (simp add: RSD_sum_def, clarsimp)
apply (simp add: mbody_is_def, clarsimp)
apply (case_tac \<delta>, clarsimp)
apply (erule_tac x=d in allE, erule impE)
  apply (rule subclass_of_trans)
    apply (rule InvV_InvokerIsSubclass) apply (erule sat_symm) apply assumption apply assumption apply assumption
        apply (erule AL_sum3, assumption)
    apply assumption
apply (erule_tac x=code1 in allE, erule_tac x=l1 in allE, erule impE)
  apply (rule_tac x=CDEFd in exI, simp)
apply (erule_tac x=n in allE, erule impE, assumption)
apply (rotate_tac -1, erule_tac x=ka in allE, erule_tac x=kb in allE, erule impE, erule Arith_15) 
apply (subgoal_tac "d2 : ObjIDs af")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: sat_def welldef_def, clarsimp)
         apply (rule SetTriv, erule AL_domI) apply (rule SetTriv101, erule AL_sum3b) apply (erule State_welldef_D_Heap_ObjIDs)
apply (simp add: ObjIDs_def, clarsimp)
apply (frule_tac c=d2 and S=S and T=T in InvSInvV_satFrame)
  apply assumption apply assumption
  apply assumption apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply assumption
apply (erule_tac x="[]" in allE, erule_tac x=SS in allE, erule_tac x=b in allE)
apply (erule_tac x=hh in allE, erule_tac x=va in allE, clarsimp)
apply (erule_tac x="[]" in allE, erule_tac x="Sa[this\<mapsto>(RVal (Loc an))]" in allE, erule_tac x=ba in allE)
apply (erule_tac x=hha in allE, erule_tac x=vb in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=bb in allE, erule_tac x=af in allE, erule_tac x=bc in allE)
apply (subgoal_tac "AL_dom HH \<inter> AL_dom Ha = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) 
         apply (rotate_tac 9) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bf" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=HH in AL_sum_exists_AL)
apply (erule exE, rename_tac HHa, erule conjE)
apply (subgoal_tac "AL_dom KK \<inter> AL_dom Ka = {}")
prefer 2 apply (rotate_tac -4, erule thin_rl) 
         apply (rotate_tac 12) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bg" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=KK in AL_sum_exists_AL)
apply (erule exE, rename_tac KKa, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom Na = {}")
prefer 2 apply (rotate_tac -7, erule thin_rl) 
         apply (rotate_tac 15) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom ag" in SetTriv103)
           apply (simp add: preserved_def, (erule conjE)+) apply (erule contained5)
           apply assumption
apply (frule_tac N=NN in AL_sum_exists_AL)
apply (erule exE, rename_tac NNa, erule conjE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE)
apply (erule_tac x=I in allE, erule_tac x=J in allE)
apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith_16) 
apply (erule_tac x="va # ops" in allE, erule_tac x=aa in allE, erule_tac x=hh in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
apply (erule_tac x="vb # os" in allE, erule_tac x=ac in allE, erule_tac x=hha in allE)
apply (erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE, clarsimp)
apply (erule_tac x=bd in allE, erule_tac x=ak in allE, erule_tac x=be in allE, clarsimp)
apply (subgoal_tac "contained af NNa")
prefer 2 apply (simp add: preserved_def, (erule conjE)+)
         apply (erule contained8, assumption, assumption) 
apply (erule_tac x=I1 in allE, erule_tac x=J1 in allE, erule impE)
  apply (simp add: sat_def, clarsimp)
  apply (subgoal_tac "welldef ((c1 # S, \<Gamma>, HHa), NNa, c2 # T, \<Delta>, KKa) \<and>
          StateSatisfiesAbstraction (va # ops, aa, hh) (c1 # S, \<Gamma>, HHa) NNa I1 \<and>
          StateSatisfiesAbstraction (vb # os, ac, hha) (c2 # T, \<Delta>, KKa) NNa J1", simp)
  prefer 2 apply (rule, simp add: welldef_def, clarsimp)
    apply rule apply (erule Invoke_Final_State_welldef) apply assumption apply assumption apply assumption apply assumption
                          apply (simp add: preserved_def) 
                          apply assumption 
      apply (erule InvokeV_Final_State_welldef) apply assumption apply assumption
                 apply assumption apply assumption apply (simp add: preserved_def) apply (simp add: preserved_def)
     apply rule apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule_tac ak=NNa and N=N and Na=Na and ap=NN and NN=NN in InvS_StateSatisfiesAbstraction) apply assumption+ 
               apply (rule contained_refl) apply assumption+ apply simp
     apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule InvV_StateSatisfiesAbstraction) apply assumption+ apply simp
  apply clarsimp
  apply (erule_tac x=ca in allE, erule impE, assumption)
  apply (case_tac "ca : AL_dom af")
    apply (subgoal_tac "af\<down>ca = Some intTP") prefer 2 apply (simp add: preserved_def)
                                                         apply (drule AL_domD, clarsimp)
                                                         apply (drule_tac NN=NNa and c=ca in contained3, assumption) apply clarsimp
    apply (erule_tac x=ca in allE, erule impE, assumption, erule conjE)
    apply (subgoal_tac "singleVal ca ((S1, \<Gamma>, bb), af, T1, \<Delta>, bc) (a, aa, b) I (ab, ac, ba) J")
      apply (rule InvsInvv_SingleVal) apply assumption+
    apply (case_tac "ca \<in> DOM (S1, \<Gamma>, bb)")
      apply (case_tac "ca \<in> DOM (T1, \<Delta>, bc)")
        apply (erule_tac x=ca in allE, erule impE, assumption, erule mp, simp)
      apply (subgoal_tac "uniqueValues (S1, \<Gamma>, bb) (a, aa, b) I")
        apply (simp add: uniqueValues_def singleVal_def) 
        apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
        apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply assumption
      apply (simp add: StateSatisfiesAbstraction_def)
    apply (case_tac "ca \<in> DOM (T1, \<Delta>, bc)")
      apply (subgoal_tac "uniqueValues (T1, \<Delta>, bc) (ab, ac, ba) J")
        apply (simp add: uniqueValues_def singleVal_def) 
        apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
        apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply assumption
      apply (simp add: StateSatisfiesAbstraction_def) 
    apply (simp add: singleVal_def) apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM) 
  (*ca \<notin> AL_dom af*)
  apply (subgoal_tac "singleVal ca (([c1], emp, HHa), NNa, [c2], emp, KKa) ([va], emp, hh) I1 ([vb], emp, hha) J1")
   apply (simp add: singleVal_def)
  apply (rule twSet_Triv2) 
    apply (erule twSet_Triv4)
         apply (rule ValuesRepresented16) prefer 2 apply assumption 
           apply (simp add: welldef_def, clarsimp) 
             apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
             apply (rule State_welldef_Tail) apply (erule absFrame_State_welldef_Leftover, assumption)
      apply (rule ValuesRepresented16) prefer 2 apply assumption 
         apply (simp add: welldef_def, clarsimp) 
         apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
         apply (erule absFrame_State_welldef_Leftover, assumption)
  apply (erule mp)
    apply (simp add: DOM_def welldef_def) apply (erule conjE)+
    apply rule apply (rotate_tac -11, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule absFrame_set_leftover) 
                 apply (drule_tac x=ca in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)
    apply (rotate_tac -10, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca and Y="set (d2#T)" in SetTriv) apply simp apply fast 
                                                  apply (drule_tac x=ca in SetTriv, erule absFrame_set_leftover)
                 apply (drule_tac x=ca in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)
apply clarsimp
apply (rule_tac x=I1a in exI, rule_tac x=J1a in exI)
apply clarsimp
  apply (erule_tac x=ca in allE, erule impE, assumption)
  apply (erule_tac x=ca in allE, erule impE) apply (erule contained6,assumption)
  apply (erule conjE)+
  apply rule apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
             apply (drule_tac \<Gamma>=\<Gamma> and aa=aa in InvS_Invariant) apply assumption apply assumption 
               apply (simp add: sat_def welldef_def)
               prefer 2 apply assumption
               apply (simp add: sat_def welldef_def)
               apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
               apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
  apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
             apply (drule_tac \<Gamma>=\<Delta> and aa=ac in InvV_Invariant) apply assumption apply assumption 
               apply (simp add: sat_def welldef_def)
               prefer 2 apply assumption
               apply (simp add: sat_def welldef_def)
               apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
               apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption

done

(*lemma InvSInvV2Sound:
"\<lbrakk>get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeV C2 m2); mbody_is c m (P1, code, l0);
        mbody_is C2 m2 (P2, code2, l2); (S1, P1, \<Gamma>1, S) \<in> absFrame; (T1, P2, \<Delta>1, d2 # T) \<in> absFrame; 
        K\<down>d2 = Some (D2, F2); subclass_of D2 C2;
        CtxtValidN n G; SecN n ((c1 # S, \<Gamma>, HH), NN, c2 # T, \<Delta>, KK) M (Suc l) MM (Suc ll) \<delta>;
        \<forall>D2'. subclass_of D2' D2 \<longrightarrow>
              (\<exists> code2' l2'.
                  mbody_is D2' m2 (P2, code2', l2') \<and>
                  (\<forall>n. CtxtValidN n G \<longrightarrow>
                       SecN n (([], \<Gamma>1, H), N, [], \<Delta>1[this\<mapsto>d2], K) (P1, code, l0) l0 (P2, code2', l2') l2' (([c1], emp, HH), NN, [c2], emp, KK)))\<rbrakk>
       \<Longrightarrow> SecN (Suc n) ((S1, \<Gamma>, H), N, T1, \<Delta>, K) M l MM ll \<delta>"
apply (unfold SecN_def)
apply (erule conjE)+
apply (subgoal_tac "preserved (([], \<Gamma>1, H), N, [], \<Delta>1[this\<mapsto>d2], K) (([c1], emp, HH), NN, [c2], emp, KK)")
prefer 2  apply (rotate_tac -1, erule thin_rl) 
          apply (erule_tac x=D2 in allE, erule impE, simp add: subclass_of_refl)
          apply clarsimp
apply (subgoal_tac "preserved ((S1, \<Gamma>, H), N, T1, \<Delta>, K) \<delta>", rule, assumption)
prefer 2 apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl)
         apply (simp add: preserved_def, case_tac \<delta>, clarsimp)
         apply (rule, erule contained_transitive, assumption)
         apply (rule, erule SetTriv101, assumption)
         apply (erule SetTriv101, assumption)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeSElim1) apply assumption apply clarify 
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeVElim1) apply assumption apply clarify 
apply clarsimp
apply (simp add: HRSD_sum_def, clarsimp)
apply (simp add: mbody_is_def, clarsimp)
apply (case_tac \<delta>, clarsimp)
apply (erule_tac x=d in allE, erule impE)
    apply (rule InvV_InvokerIsSubclass) apply (erule sat_symm) apply assumption apply assumption apply assumption
        apply (erule AL_sum3, assumption)
apply (erule exE)+ apply (erule conjE)+
apply (erule_tac x=n in allE, erule impE, assumption)
apply (rotate_tac -1, erule_tac x=ka in allE, erule_tac x=kb in allE, erule impE, erule Arith_15) 
apply (subgoal_tac "d2 : ObjIDs af")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: sat_def welldef_def, clarsimp)
         apply (rule SetTriv, erule AL_domI) apply (rule SetTriv101, erule AL_sum3b) apply (erule State_welldef_D_Heap_ObjIDs)
apply (simp add: ObjIDs_def, clarsimp)
apply (frule_tac c=d2 and S=S and T=T in InvSInvV_satFrame)
  apply assumption apply assumption
  apply assumption apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply assumption
apply (erule_tac x="[]" in allE, erule_tac x=SS in allE, erule_tac x=b in allE)
apply (erule_tac x=hh in allE, erule_tac x=va in allE, clarsimp)
apply (erule_tac x="[]" in allE, erule_tac x="Sa[this\<mapsto>(RVal (Loc an))]" in allE, erule_tac x=ba in allE)
apply (erule_tac x=hha in allE, erule_tac x=vb in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=bb in allE, erule_tac x=af in allE, erule_tac x=bc in allE)
apply (subgoal_tac "AL_dom HH \<inter> AL_dom Ha = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) 
         apply (rotate_tac 9) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bf" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=HH in AL_sum_exists_AL)
apply (erule exE, rename_tac HHa, erule conjE)
apply (subgoal_tac "AL_dom KK \<inter> AL_dom Ka = {}")
prefer 2 apply (rotate_tac -4, erule thin_rl) 
         apply (rotate_tac 12) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bg" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=KK in AL_sum_exists_AL)
apply (erule exE, rename_tac KKa, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom Na = {}")
prefer 2 apply (rotate_tac -7, erule thin_rl) 
         apply (rotate_tac 15) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom ag" in SetTriv103)
           apply (simp add: preserved_def, (erule conjE)+) apply (erule contained5)
           apply assumption
apply (frule_tac N=NN in AL_sum_exists_AL)
apply (erule exE, rename_tac NNa, erule conjE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE)
apply (erule_tac x=I in allE, erule_tac x=J in allE)
apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith_16) 
apply (erule_tac x="va # ops" in allE, erule_tac x=aa in allE, erule_tac x=hh in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
apply (erule_tac x="vb # os" in allE, erule_tac x=ac in allE, erule_tac x=hha in allE)
apply (erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE, clarsimp)
apply (erule_tac x=bd in allE, erule_tac x=ak in allE, erule_tac x=be in allE, clarsimp)
apply (subgoal_tac "contained af NNa")
prefer 2 apply (simp add: preserved_def, (erule conjE)+)
         apply (erule contained8, assumption, assumption) 
apply (erule_tac x=I1 in allE, erule_tac x=J1 in allE, erule impE)
  apply (simp add: sat_def, clarsimp)
  apply (rule, simp add: welldef_def, clarsimp)
    apply rule apply (erule Invoke_Final_State_welldef) apply assumption apply assumption apply assumption apply assumption
                          apply (simp add: preserved_def) 
                          apply assumption 
    apply (erule InvokeV_Final_State_welldef) apply assumption apply assumption
                 apply assumption apply assumption apply (simp add: preserved_def) apply (simp add: preserved_def)
  apply rule apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule_tac ak=NNa and N=N and Na=Na and ap=NN and NN=NN in InvS_StateSatisfiesAbstraction) apply assumption+ 
               apply (rule contained_refl) apply assumption+ apply simp
  apply rule apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule InvV_StateSatisfiesAbstraction) apply assumption+ apply simp
  apply clarsimp
  apply (erule_tac x=tp in allE, erule_tac x=ca in allE, erule impE, assumption)
  apply (case_tac "ca : AL_dom af")
    apply (subgoal_tac "af\<down>ca = Some tp") prefer 2 apply (simp add: preserved_def)
                                                         apply (drule AL_domD, clarsimp)
                                                         apply (drule_tac NN=NNa and c=ca in contained3, assumption) apply clarsimp
    apply (erule_tac x=ca in allE, clarsimp)
    apply (erule_tac x=tp in allE, erule_tac x=ca in allE, erule impE, assumption)
      apply (rule InvsInvv_SingleVal) apply assumption+
  (-ca \<notin> AL_dom af-)
   apply (simp add: singleVal_def)
  apply (rule twSet_Triv2) 
    apply (erule twSet_Triv4)
         apply (rule ValuesRepresented16) prefer 2 apply assumption 
           apply (simp add: welldef_def, clarsimp) 
             apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
             apply (rule State_welldef_Tail) apply (erule absFrame_State_welldef_Leftover, assumption)
      apply (rule ValuesRepresented16) prefer 2 apply assumption 
         apply (simp add: welldef_def, clarsimp) 
         apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
         apply (erule absFrame_State_welldef_Leftover, assumption)

apply clarsimp
apply (rule_tac x=I1a in exI, rule_tac x=J1a in exI)
apply clarsimp
  apply (erule_tac x=ca in allE, erule impE, assumption)
  apply (erule_tac x=ca in allE, erule impE) apply (erule contained6,assumption)
  apply (erule conjE)+
  apply rule apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
             apply (drule_tac \<Gamma>=\<Gamma> and aa=aa in InvS_UniInvariant) apply assumption apply assumption 
               apply (simp add: sat_def welldef_def)
               prefer 2 apply assumption
               apply (simp add: sat_def welldef_def)
               apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
               apply (simp add: UniInvariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
  apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
             apply (drule_tac \<Gamma>=\<Delta> and aa=ac in InvV_UniInvariant) apply assumption apply assumption 
               apply (simp add: sat_def welldef_def)
               prefer 2 apply assumption
               apply (simp add: sat_def welldef_def)
               apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
               apply (simp add: UniInvariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
done
*)

lemma InvSInvV3Sound:
"\<lbrakk>get_ins M l = Some (invokeS c m); get_ins MM ll = Some (invokeV C2 m2); mbody_is c m (P1, code, l0);
        mbody_is C2 m2 (P2, code2, l2); (S1, P1, \<Gamma>1, S) \<in> absFrame; (T1, P2, \<Delta>1, d2 # T) \<in> absFrame; 
        K\<down>d2 = Some (D2, F2); 
        CtxtValidN n G; SecN n ((c1 # S, \<Gamma>, HH), NN, c2 # T, \<Delta>, KK) M (Suc l) MM (Suc ll) \<delta>;
        \<forall>D2'. subclass_of D2' D2 \<longrightarrow>
              (\<exists> code2' l2'.
                  mbody_is D2' m2 (P2, code2', l2') \<and>
                  (\<forall>n. CtxtValidN n G \<longrightarrow>
                       SecN n (([], \<Gamma>1, H), N, [], \<Delta>1[this\<mapsto>d2], K) (P1, code, l0) l0 (P2, code2', l2') l2' (([c1], emp, HH), NN, [c2], emp, KK)))\<rbrakk>
       \<Longrightarrow> SecN (Suc n) ((S1, \<Gamma>, H), N, T1, \<Delta>, K) M l MM ll \<delta>"
apply (unfold SecN_def)
apply (erule conjE)+
apply (subgoal_tac "preserved (([], \<Gamma>1, H), N, [], \<Delta>1[this\<mapsto>d2], K) (([c1], emp, HH), NN, [c2], emp, KK)")
prefer 2  apply (rotate_tac -1, erule thin_rl) 
          apply (erule_tac x=D2 in allE, erule impE, simp add: subclass_of_refl)
          apply clarsimp
apply (subgoal_tac "preserved ((S1, \<Gamma>, H), N, T1, \<Delta>, K) \<delta>", rule, assumption)
prefer 2 apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl)
         apply (simp add: preserved_def, case_tac \<delta>, clarsimp)
         apply (rule, erule contained_transitive, assumption)
         apply (rule, erule SetTriv101, assumption)
         apply (erule SetTriv101, assumption)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (rule, rule, rule)
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeSElim1) apply assumption apply clarify 
apply (erule eval_cases) apply clarsimp apply clarsimp 
apply (drule InvokeVElim1) apply assumption apply clarify 
apply clarsimp
apply (simp add: RSD_sum_def, clarsimp)
apply (simp add: mbody_is_def, clarsimp)
apply (case_tac \<delta>, clarsimp)
apply (erule_tac x=d in allE, erule impE)
    apply (frule_tac H=K in AL_sum3, assumption)
    apply (rule InvV_InvokerIsSubclass) apply (erule sat_symm) apply assumption apply assumption apply assumption apply assumption
apply (erule exE)+ apply (erule conjE)+
apply (erule_tac x=n in allE, erule impE, assumption)
apply (rotate_tac -1, erule_tac x=ka in allE, erule_tac x=kb in allE, erule impE, erule Arith_15) 
apply (subgoal_tac "d2 : ObjIDs af")
prefer 2 apply (rotate_tac -1, erule thin_rl)
         apply (simp add: sat_def welldef_def, clarsimp)
         apply (rule SetTriv, erule AL_domI) apply (rule SetTriv101, erule AL_sum3b) apply (erule State_welldef_D_Heap_ObjIDs)
apply (simp add: ObjIDs_def, clarsimp)
apply (frule_tac c=d2 and S=S and T=T in InvSInvV_satFrame)
  apply assumption apply assumption
  apply assumption apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply (simp add: SD_sum_def) apply (rule,simp) apply (rule,assumption) apply assumption
  apply assumption
apply (erule_tac x="[]" in allE, erule_tac x=SS in allE, erule_tac x=b in allE)
apply (erule_tac x=hh in allE, erule_tac x=va in allE, clarsimp)
apply (erule_tac x="[]" in allE, erule_tac x="Sa[this\<mapsto>(RVal (Loc an))]" in allE, erule_tac x=ba in allE)
apply (erule_tac x=hha in allE, erule_tac x=vb in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=bb in allE, erule_tac x=af in allE, erule_tac x=bc in allE)
apply (subgoal_tac "AL_dom HH \<inter> AL_dom Ha = {}")
prefer 2 apply (rotate_tac -1, erule thin_rl) 
         apply (rotate_tac 9) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bf" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=HH in AL_sum_exists_AL)
apply (erule exE, rename_tac HHa, erule conjE)
apply (subgoal_tac "AL_dom KK \<inter> AL_dom Ka = {}")
prefer 2 apply (rotate_tac -4, erule thin_rl) 
         apply (rotate_tac 12) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom bg" in SetTriv103)
           apply (simp add: preserved_def)
           apply assumption
apply (frule_tac N=KK in AL_sum_exists_AL)
apply (erule exE, rename_tac KKa, erule conjE)
apply (subgoal_tac "AL_dom NN \<inter> AL_dom Na = {}")
prefer 2 apply (rotate_tac -7, erule thin_rl) 
         apply (rotate_tac 15) apply (erule thin_rl)
         apply (rule_tac Y="AL_dom ag" in SetTriv103)
           apply (simp add: preserved_def, (erule conjE)+) apply (erule contained5)
           apply assumption
apply (frule_tac N=NN in AL_sum_exists_AL)
apply (erule exE, rename_tac NNa, erule conjE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE)
apply (erule_tac x=I in allE, erule_tac x=J in allE)
apply clarsimp
apply (erule_tac x=ma in allE, erule_tac x=mb in allE, erule impE, erule Arith_16) 
apply (erule_tac x="va # ops" in allE, erule_tac x=aa in allE, erule_tac x=hh in allE)
apply (erule_tac x=h in allE, erule_tac x=v in allE, clarsimp)
apply (erule_tac x="vb # os" in allE, erule_tac x=ac in allE, erule_tac x=hha in allE)
apply (erule_tac x=k in allE, erule_tac x=w in allE, clarsimp)
apply (erule_tac x=Ha in allE, erule_tac x=Na in allE, erule_tac x=Ka in allE)
apply (erule_tac x=HHa in allE, erule_tac x=NNa in allE, erule_tac x=KKa in allE, clarsimp)
apply (erule_tac x=bd in allE, erule_tac x=ak in allE, erule_tac x=be in allE, clarsimp)
apply (subgoal_tac "contained af NNa")
prefer 2 apply (simp add: preserved_def, (erule conjE)+)
         apply (erule contained8, assumption, assumption) 
apply (erule_tac x=I1 in allE, erule_tac x=J1 in allE, erule impE)
  apply (simp add: sat_def, clarsimp)
  apply (rule, simp add: welldef_def, clarsimp)
    apply rule apply (erule Invoke_Final_State_welldef) apply assumption apply assumption apply assumption apply assumption
                          apply (simp add: preserved_def) 
                          apply assumption 
    apply (erule InvokeV_Final_State_welldef) apply assumption apply assumption
                 apply assumption apply assumption apply (simp add: preserved_def) apply (simp add: preserved_def)
  apply rule apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule_tac ak=NNa and N=N and Na=Na and ap=NN and NN=NN in InvS_StateSatisfiesAbstraction) apply assumption+ 
               apply (rule contained_refl) apply assumption+ apply simp
  apply rule apply (simp add: welldef_def preserved_def, (erule conjE)+) 
             apply (erule InvV_StateSatisfiesAbstraction) apply assumption+ apply simp
  apply clarsimp
  apply (erule_tac x=ca in allE, erule impE, assumption)
  
  apply (case_tac "ca : AL_dom af")
    apply (subgoal_tac "af\<down>ca = Some intTP") prefer 2 apply (simp add: preserved_def)
                                                         apply (drule AL_domD, clarsimp)
                                                         apply (drule_tac NN=NNa and c=ca in contained3, assumption) apply clarsimp
    apply (erule_tac x=ca in allE, erule impE, assumption, erule conjE)
    apply (subgoal_tac "singleVal ca ((S1, \<Gamma>, bb), af, T1, \<Delta>, bc) (a, aa, b) I (ab, ac, ba) J")
      apply (rule InvsInvv_SingleVal) apply assumption+
    apply (case_tac "ca \<in> DOM (S1, \<Gamma>, bb)")
      apply (case_tac "ca \<in> DOM (T1, \<Delta>, bc)")
        apply (erule_tac x=ca in allE, erule impE, assumption, erule mp, simp)
      apply (subgoal_tac "uniqueValues (S1, \<Gamma>, bb) (a, aa, b) I")
        apply (simp add: uniqueValues_def singleVal_def) 
        apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
        apply (rule twSetEmpR) apply (erule ValuesRepresented_notin_DOM) apply assumption
      apply (simp add: StateSatisfiesAbstraction_def)
    apply (case_tac "ca \<in> DOM (T1, \<Delta>, bc)")
      apply (subgoal_tac "uniqueValues (T1, \<Delta>, bc) (ab, ac, ba) J")
        apply (simp add: uniqueValues_def singleVal_def) 
        apply (erule_tac x=ca in allE, erule impE, assumption, erule exE)
        apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) apply assumption
      apply (simp add: StateSatisfiesAbstraction_def) 
    apply (simp add: singleVal_def) apply (rule twSetEmp) apply (erule ValuesRepresented_notin_DOM) apply (erule ValuesRepresented_notin_DOM)
  (*ca \<notin> AL_dom af*)
  apply (subgoal_tac "singleVal ca (([c1], emp, HHa), NNa, [c2], emp, KKa) ([va], emp, hh) I1 ([vb], emp, hha) J1")
   apply (simp add: singleVal_def)
  apply (rule twSet_Triv2) 
    apply (erule twSet_Triv4)
         apply (rule ValuesRepresented16) prefer 2 apply assumption 
           apply (simp add: welldef_def, clarsimp) 
             apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
             apply (rule State_welldef_Tail) apply (erule absFrame_State_welldef_Leftover, assumption)
      apply (rule ValuesRepresented16) prefer 2 apply assumption 
         apply (simp add: welldef_def, clarsimp) 
         apply rule apply (erule absFrame_State_welldef_Leftover, assumption) 
         apply (erule absFrame_State_welldef_Leftover, assumption)
  apply (erule mp)
    apply (simp add: DOM_def welldef_def) apply (erule conjE)+
    apply rule apply (rotate_tac -11, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule absFrame_set_leftover) 
                 apply (drule_tac x=ca in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)
    apply (rotate_tac -10, erule disjE, erule disjI1)
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca and Y="set (d2#T)" in SetTriv) apply simp apply fast 
                                                  apply (drule_tac x=ca in SetTriv, erule absFrame_set_leftover)
                 apply (drule_tac x=ca in SetTriv, erule State_welldef_OPS_lookup_set_dom) apply simp
               apply (rotate_tac -1, erule disjE) apply (drule_tac x=ca in SetTriv, erule State_welldef_Store_lookup_cod_dom) apply simp
               apply (rule disjI2) apply (erule disjI2)

apply clarsimp
apply (rule_tac x=I1a in exI, rule_tac x=J1a in exI)
apply clarsimp
  apply (erule_tac x=ca in allE, erule impE, assumption)
  apply (erule_tac x=ca in allE, erule impE) apply (erule contained6,assumption)
  apply (erule conjE)+
  apply rule apply (rotate_tac -1, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
             apply (drule_tac \<Gamma>=\<Gamma> and aa=aa in InvS_Invariant) apply assumption apply assumption 
               apply (simp add: sat_def welldef_def)
               prefer 2 apply assumption
               apply (simp add: sat_def welldef_def)
               apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
               apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
  apply (rotate_tac -2, erule thin_rl) apply (rotate_tac -2, erule thin_rl) 
             apply (drule_tac \<Gamma>=\<Delta> and aa=ac in InvV_Invariant) apply assumption apply assumption 
               apply (simp add: sat_def welldef_def)
               prefer 2 apply assumption
               apply (simp add: sat_def welldef_def)
               apply (simp add: AL_sum_def preserved_def, clarsimp) apply rule apply fast apply fast
               apply (simp add: Invariant_def, clarsimp)
                 apply rule apply rule apply(erule impE, assumption)
                            apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset) apply simp
                 apply (erule SetTriv101) apply assumption
done


end
