theory SatSec = UniSatSec + RSDInterpretation:

constdefs preserved::"RSD \<Rightarrow> RSD \<Rightarrow> bool"
"preserved \<gamma> \<delta> \<equiv>
  (case \<gamma> of (\<Sigma>, N, \<Pi>) \<Rightarrow> 
  (case \<delta> of (\<Sigma>', N', \<Pi>') \<Rightarrow> 
    contained N N' \<and> AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom (snd (snd \<Sigma>')) \<and> 
    AL_dom (snd(snd \<Pi>)) \<subseteq> AL_dom (snd (snd \<Pi>'))))"

lemma preserved_RSD_sum:
  "\<lbrakk>preserved \<gamma> \<delta>; RSD_sum \<gamma> H N K \<gamma>1; RSD_sum \<delta> H N K \<delta>1\<rbrakk> \<Longrightarrow> preserved \<gamma>1 \<delta>1"
apply (simp add: preserved_def RSD_sum_def)
apply (case_tac \<gamma>, clarsimp)
apply (case_tac \<delta>, clarsimp)
apply (case_tac \<gamma>1, clarsimp)
apply (case_tac \<delta>1, clarsimp)
apply (rule, simp (no_asm) add: contained_def, clarsimp)
  apply (drule AL_sum_split, assumption)
  apply (erule disjE) 
    apply (drule contained3, assumption) apply (erule AL_sum3, assumption)
  apply (erule AL_sum4, assumption)
apply (simp add: AL_sum_def,  safe)
apply (erule SetTriv, assumption)
apply (erule SetTriv, assumption)
done

constdefs Sec::
  "RSD \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> RSD \<Rightarrow> bool"
"Sec \<gamma> M l MM ll \<delta> \<equiv> preserved \<gamma> \<delta> \<and>
      (\<forall> s h v t k w H N K \<gamma>1 \<delta>1 I J.
          sat s t \<gamma>1 I J \<longrightarrow> 
          RSD_sum \<gamma> H N K \<gamma>1 \<longrightarrow> RSD_sum \<delta> H N K \<delta>1 \<longrightarrow>
          H:AL \<longrightarrow> N:AL \<longrightarrow> K:AL \<longrightarrow>
          Opsem M l s h v \<longrightarrow> Opsem MM ll t k w \<longrightarrow>
          (\<exists> I1 J1 . sat ([v],emp,h) ([w],emp,k) \<delta>1 I1 J1 \<and>   
                        (\<forall> c . c : AL_dom (fst(snd \<gamma>1)) \<longrightarrow> 
                                   (Invariant c (fst \<delta>1) ([v],emp,h) I1 (fst(snd \<gamma>1)) (fst \<gamma>1) s I \<and> 
                                    Invariant c (snd(snd \<delta>1)) ([w],emp,k) J1 (fst(snd \<gamma>1)) (snd(snd \<gamma>1)) t J))))"

constdefs SecN::
  "nat \<Rightarrow> RSD \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> RSD \<Rightarrow> bool"
"SecN nn \<gamma> M l MM ll \<delta> \<equiv> preserved \<gamma> \<delta> \<and>
    (\<forall> n m . n+m \<le> nn \<longrightarrow>
      (\<forall> s h v t k w H N K \<gamma>1 \<delta>1 I J.
          sat s t \<gamma>1 I J \<longrightarrow> 
          RSD_sum \<gamma> H N K \<gamma>1 \<longrightarrow> RSD_sum \<delta> H N K \<delta>1 \<longrightarrow>
          H:AL \<longrightarrow> N:AL \<longrightarrow> K:AL \<longrightarrow>
          (M, l, s, n, h, v):Exec \<longrightarrow> (MM, ll, t, m, k, w):Exec \<longrightarrow>
          (\<exists> I1 J1 . sat ([v],emp,h) ([w],emp,k) \<delta>1 I1 J1 \<and>   
                        (\<forall> c . c : AL_dom (fst(snd \<gamma>1)) \<longrightarrow> 
                                   (Invariant c (fst \<delta>1) ([v],emp,h) I1 (fst(snd \<gamma>1)) (fst \<gamma>1) s I \<and> 
                                    Invariant c (snd(snd \<delta>1)) ([w],emp,k) J1 (fst(snd \<gamma>1)) (snd(snd \<gamma>1)) t J)))))"

lemma SecN_subN:
  "\<lbrakk>SecN nn \<gamma> M l MM ll \<delta>; n \<le> nn\<rbrakk> \<Longrightarrow> SecN n \<gamma> M l MM ll \<delta>"
(*<*)
apply (simp add: SecN_def) 
apply clarsimp 
apply (erule_tac x=na in allE, erule_tac x=m in allE, clarsimp)
done
(*>*)

lemma SecN_Sec:
 "(\<forall> n . SecN n \<gamma> M l MM ll \<delta>) \<Longrightarrow> Sec \<gamma> M l MM ll \<delta>"
(*<*)
apply (simp add: Sec_def SecN_def Opsem_def, clarify)
apply (erule_tac x="n+na" in allE)
apply (erule_tac x=n in allE, erule_tac x=na in allE, clarsimp)
done
(*>*)

lemma Sec_SecN:"Sec \<gamma> M l MM ll \<delta> \<Longrightarrow> SecN n \<gamma> M l MM ll \<delta>"
(*<*)
apply (unfold Sec_def SecN_def Opsem_def) 
apply (erule conjE, rule, assumption)
apply (rule allI)+ apply (rule impI) apply (rule allI)+ apply (rule impI)+ 
apply (erule_tac x=s in allE, erule_tac x= h in allE, erule_tac x=v in allE)
apply (erule_tac x=t in allE, erule_tac x= k in allE, erule_tac x=w in allE) 
apply (erule_tac x=H in allE, erule_tac x=N in allE, erule_tac x=K in allE)
apply (erule_tac x=\<gamma>1 in allE, erule_tac x=\<delta>1 in allE, erule_tac x=I in allE, erule_tac x=J in allE)
apply fast
done
(*>*)

types "Ctxt" = "(((Mbody \<times> Label) \<times> (Mbody \<times> Label)) \<times> RSD \<times> RSD) set"

text{*Context validity, and its relatived version are defined as follows.*}

constdefs CtxtValid::"Ctxt \<Rightarrow> bool"
"CtxtValid G \<equiv> \<forall> M l MM ll \<gamma> \<delta>. 
   (((M,l),(MM,ll)),\<gamma>,\<delta>) \<in> G \<longrightarrow> Sec \<gamma> M l MM ll \<delta>"

constdefs CtxtValidN::"nat \<Rightarrow> Ctxt \<Rightarrow> bool"
"CtxtValidN n G \<equiv> \<forall> M l MM ll \<gamma> \<delta>. 
  (((M,l),(MM,ll)),\<gamma>,\<delta>) \<in> G \<longrightarrow> SecN n \<gamma> M l MM ll \<delta>"

lemma CtxtValidN_sub:"CtxtValidN (Suc n) G \<Longrightarrow> CtxtValidN n G"
(*<*)
apply (simp add: CtxtValidN_def)
apply clarsimp
apply (rule SecN_subN) apply fast
apply simp
done
(*>*)

lemma CtxtValidN_CtxtValid: "(\<forall> n. CtxtValidN n U) \<Longrightarrow> CtxtValid U"
(*<*)
apply (simp add: CtxtValid_def CtxtValidN_def)
apply clarsimp
  apply (rule SecN_Sec) apply (rule, erule_tac x=n in allE, simp)
done
(*>*)

lemma CtxtValid_CtxtValidN:"CtxtValid U \<Longrightarrow> CtxtValidN n U"
(*<*)
apply (simp add: CtxtValid_def CtxtValidN_def)
apply clarsimp
  apply (rule Sec_SecN) apply fast
done
(*>*)

text{*A variant of the unary small-step indexed relation, useful for
injecting unary judgements into relational ones, i.e. the proof of
rules UniInjectL and UniInjectR, plus some auxiliary lemmas for this
notion*}

constdefs UniSS_Sec::"STATE \<Rightarrow> MP \<Rightarrow> STATE \<Rightarrow> MP \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> (Label set) \<Rightarrow> bool"
"UniSS_Sec \<Sigma> N \<Pi> NN M l L \<equiv> AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom  (snd(snd \<Pi>))  \<and> contained N NN \<and> 
                       (\<forall> \<sigma> \<tau> I J n l1 \<sigma>1 H Nx N0 \<Sigma>0 \<Pi>0 N1  \<Lambda>.
                                       sat \<sigma> \<tau> (\<Sigma>0,N0, \<Lambda>) I J \<longrightarrow>
                                       SD_sum \<Sigma> H \<Sigma>0 \<longrightarrow> SD_sum \<Pi> H \<Pi>0 \<longrightarrow>
                                       AL_sum N Nx N0 \<longrightarrow> AL_dom NN \<inter> AL_dom Nx = {} \<longrightarrow>
                                       AL_sum NN Nx N1 \<longrightarrow>
                                       H:AL \<longrightarrow> Nx:AL \<longrightarrow> N0:AL \<longrightarrow> (snd(snd \<Sigma>0)):AL \<longrightarrow> (snd(snd \<Pi>0)):AL \<longrightarrow> N1 :AL \<longrightarrow>
                                       (M,l,\<sigma>, n, l1, \<sigma>1) : Step \<longrightarrow> 
                                       (\<exists> I1 J1. l1 : L \<and> sat \<sigma>1 \<tau> (\<Pi>0, N1, \<Lambda>) I1 J1 \<and>
                                               (\<forall> c . c : AL_dom N0 \<longrightarrow> 
                                                      (Invariant c \<Lambda> \<tau> J1 N0 \<Lambda> \<tau> J \<and>
                                                       Invariant c \<Pi>0 \<sigma>1 I1 N0 \<Sigma>0 \<sigma> I))))"
lemma sat_UniSec_Sec_Aux:
 "\<lbrakk>sat (a, aa, b) (ab, ac, ba) ((af, ag, bc), N0, al, am, bf) I J; SD_sum \<Sigma> H (af, ag, bc); SD_sum \<Pi> H (ah, ai, bd);
        AL_sum N Nx N0; AL_dom NN \<inter> AL_dom Nx = {}; AL_sum NN Nx N1; H \<in> AL; Nx \<in> AL; N0 \<in> AL; bc \<in> AL; bd \<in> AL; N1 \<in> AL;
        AL_dom (snd (snd \<Sigma>)) \<subseteq> AL_dom (snd (snd \<Pi>)); contained N NN; l1 \<in> L;
        contained N0 N1; unisat (ad, ae, bb) (ah, ai, bd) N1 I1;
        \<forall>c. c \<in> AL_dom N0 \<longrightarrow> Invariant c (ah, ai, bd) (ad, ae, bb) I1 N0 (af, ag, bc) (a, aa, b) I\<rbrakk>
       \<Longrightarrow> sat (ad, ae, bb) (ab, ac, ba) ((ah, ai, bd), N1, al, am, bf) I1 J"
  apply (simp add: unisat_sat, (erule conjE)+)
  apply rule apply (simp add: unisat_def, (erule conjE)+) 
             apply (rule, erule State_welldef_MP_contained) apply assumption 
             apply assumption
             apply (simp add: StateSatisfiesAbstraction_def, (erule conjE)+)
               apply (rule, simp add: State_typecorrect_def, clarsimp)
                 apply (rule, simp add: Opstack_typecorrect_def, clarsimp) 
                   apply (erule_tac x=n in allE, clarsimp) apply (rule, rule) 
                   apply (erule contained3, assumption) apply assumption
                 apply (rule, simp add: Store_typecorrect_def, clarsimp)
                   apply (erule_tac x=x in allE, clarsimp) apply (rule, rule) apply (erule contained3, assumption) apply assumption
                 apply (simp add: Heap_typecorrect_def, clarsimp)
                 apply (erule_tac x=c in allE, clarsimp) apply (rule, rule) apply (erule contained3, assumption) 
                 apply rule prefer 2 apply clarsimp
                 apply (erule HeapAbstractsAt_contained) apply assumption
               apply rule apply (rule SetTriv) prefer 2 apply assumption apply clarsimp 
                 apply (drule_tac x=x in SetTriv, erule_tac \<Sigma>="(al, am, bf)" in State_welldef_DOM_ALdom) 
                 apply (simp add: ObjIDs_def, clarsimp)
                 apply (drule_tac d=x in AL_domD, clarsimp)
                 apply (drule contained3, assumption) apply clarsimp
  apply clarsimp apply (simp add: singleVal_def)
  apply (simp add: unisat_def, clarsimp)
  apply (frule SetTriv, erule_tac N=N0 in State_welldef_DOM_ALdom)
  apply (subgoal_tac "uniqueValues (al, am, bf) (ab, ac, ba) J")
  prefer 2 apply (simp add: unisat_def StateSatisfiesAbstraction_def)
  apply (simp add: uniqueValues_def) apply (erule_tac x=c in allE, erule impE, assumption, erule exE)
    apply (frule AL_domD, clarsimp)
      apply (drule contained3, assumption) apply clarsimp
      apply (erule_tac x=c in allE, clarsimp)
      apply (erule_tac x=c in allE, clarsimp)
      apply (subgoal_tac "(ValuesRepresented c (af, ag, bc) (a, aa, b) I, ValuesRepresented c (al, am, bf) (ab, ac, ba) J) \<in> twSet")
        apply clarsimp
        apply (erule twSet_Triv9)
          apply (simp add: Invariant_def ValRepEQ) 
      apply  (case_tac "c \<in> DOM (af, ag, bc)", clarsimp)
      apply (rule twSetEmpL) apply (erule ValuesRepresented_notin_DOM) 
                             apply (simp add: unisat_def StateSatisfiesAbstraction_def)
done

lemma UniSS_UniSec_UniSS_Sec:"UniSS_UniSec \<Sigma> N \<Pi> NN M l L \<Longrightarrow> UniSS_Sec \<Sigma> N \<Pi> NN M l L"
apply (simp only: UniSS_UniSec_def  UniSS_Sec_def)
apply (rule, simp)
apply (rule, simp)
apply (rule allI)+ apply (rule impI)+
apply (erule conjE)+
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE, erule_tac x=n in allE)
apply (erule_tac x=l1 in allE, erule_tac x=\<sigma>1 in allE)
apply (erule_tac x=H in allE, erule_tac x=Nx in allE, erule_tac x=N0 in allE)
apply (erule_tac x=\<Sigma>0 in allE, erule_tac x=\<Pi>0 in allE, erule_tac x=N1 in allE)
apply (erule impE) apply (simp add: unisat_sat)
apply (erule impE) apply (simp add: RSD_sum_SD_sum)
apply (erule impE) apply (simp add: RSD_sum_SD_sum)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule exE) apply (erule conjE)
apply (subgoal_tac "contained N0 N1")
prefer 2 apply (simp (no_asm) add: contained_def, clarsimp)
                     apply (drule AL_sum_split, assumption)
                     apply (erule disjE)
                       apply (erule AL_sum3) apply (erule contained3, assumption)
                       apply (erule AL_sum4, assumption)
apply (case_tac \<Lambda>, clarsimp)
apply (rule_tac x=I1 in exI, rule_tac x=J in exI)
apply rule apply (erule sat_UniSec_Sec_Aux, assumption+)
apply clarsimp
  apply (simp add: Invariant_def)
done

end