(*<*)
theory Trivialities = Main:

lemma EqualsTrans:"\<lbrakk>x=y;x=z\<rbrakk> \<Longrightarrow> z=y" by simp

(*appears to be missing in the Isabelle library Map.thy*)
lemma ranD:"a : ran m \<Longrightarrow> \<exists>b. m b = Some a"
by (unfold ran_def, auto)

lemma SetXXX:"X\<noteq>{} \<Longrightarrow> \<exists> x. x:X" by fast

lemma SetTriv1[rule_format]: "{} = X \<Longrightarrow> \<forall> x . x: X \<longrightarrow> False" by fast

lemma SetSingleton: "\<lbrakk>X \<noteq> {}; \<forall> x y . x:X \<longrightarrow> y:X \<longrightarrow> x=y\<rbrakk> \<Longrightarrow> \<exists> x . X = {x}"
by fast

lemma SetSingleton2: "X = {v} \<Longrightarrow> v:X \<and> (\<forall> w . w:X \<longrightarrow> w=v)"
by fast

lemma SetSingleton3: "\<lbrakk>{x} = Y; Z \<noteq> {}; Z \<subseteq> Y\<rbrakk> \<Longrightarrow> Z = {x}" 
apply clarsimp by fast

lemma SetSingleton4: "X \<subseteq> {v} \<Longrightarrow> X={} \<or> X={v}" by fast

lemma SetTriv:"\<lbrakk>x:X; X \<subseteq> Y\<rbrakk> \<Longrightarrow> x:Y" by fast

lemma SetTriv101: "\<lbrakk>X\<subseteq>Y ; Y\<subseteq>Z\<rbrakk> \<Longrightarrow> X \<subseteq> Z" by fast

lemma SetTriv102: "\<lbrakk>X \<subseteq> Z; Y\<subseteq> Z\<rbrakk> \<Longrightarrow> X \<union> Y \<subseteq> Z" by fast

lemma SetTriv103:"\<lbrakk>X \<subseteq> Y; Y\<inter>Z={}\<rbrakk> \<Longrightarrow> X \<inter> Z = {}" by fast

lemma SetTriv104:"\<lbrakk>x:X;X=Y\<rbrakk> \<Longrightarrow> x:Y" by simp

lemma SetTriv105:"\<lbrakk>Y=X;x:X\<rbrakk> \<Longrightarrow> x:Y" by simp

lemma SetTriv106:"\<lbrakk>X \<inter> Y = {}; x:X; y:Y\<rbrakk> \<Longrightarrow> x\<noteq> y" by fast

lemma SetTriv107: "\<lbrakk>x:X;X={}\<rbrakk> \<Longrightarrow> False" by fast

lemma SetTriv108:"\<lbrakk>X\<inter>Y = Z\<rbrakk> \<Longrightarrow> Y\<inter>X = Z" by fast

lemma SetTriv109:"\<lbrakk>X=Y;Y\<subseteq>Z\<rbrakk> \<Longrightarrow> X\<subseteq>Z" by fast

lemma SetTriv110:"\<lbrakk>Y=Z; X\<subseteq>Y\<rbrakk> \<Longrightarrow> X\<subseteq>Z" by fast

lemma SetTriv111:"\<lbrakk>X\<subseteq>X';Y\<subseteq>Y';X'\<inter>Y'={}\<rbrakk> \<Longrightarrow> X\<inter>Y={}" by fast


lemma SetTriv112:"\<lbrakk>X \<inter> Z = {}; Y \<subseteq> Z\<rbrakk> \<Longrightarrow> X \<inter> Y = {}" by fast

lemma SetTriv113: "\<lbrakk>(X \<union> Y) \<inter> Z = {}; X \<inter> Y = {}\<rbrakk> \<Longrightarrow> X \<inter> (Y \<union> Z) = {}" 
by fast

lemma SetTriv114: "A \<subseteq> B \<Longrightarrow> A \<inter> X \<subseteq> B \<inter> X" by fast

lemma SetTriv115: "X \<inter> Y = Z \<Longrightarrow> Y \<inter> (X - Z) = {}" by fast

lemma notin_noteq: "\<lbrakk>x:X;y\<notin>X\<rbrakk> \<Longrightarrow> x\<noteq>y" by fast

lemma Set_InterUnion: "\<lbrakk>X \<inter> Y = {};X \<inter> Z = {}\<rbrakk> \<Longrightarrow> X \<inter> (Z \<union> Y) = {}" by fast

lemma Set_SubsetUnion: "\<lbrakk>X \<subseteq> X'; Y\<subseteq> Y'\<rbrakk> \<Longrightarrow> X \<union> Y \<subseteq> X' \<union> Y'" by fast

lemma inj_on_Triv:
  "\<lbrakk>inj_on I (AL_dom H); d \<noteq> c; c : AL_dom H; d:AL_dom H\<rbrakk> \<Longrightarrow> I d \<noteq> I c"
by (simp add: inj_on_def, fast)

lemma inj_on_triv1: "\<lbrakk> inj_on I (AL_dom bf);  I c2 \<noteq> I d; d \<in> AL_dom bf; c2 \<in> AL_dom bf\<rbrakk> \<Longrightarrow> c2 \<noteq> d"
by (simp add: inj_on_def, fast)

lemma inj_on_triv2: "\<lbrakk> inj_on I (AL_dom bf);  I c2 = I d; d \<in> AL_dom bf; c2 \<in> AL_dom bf\<rbrakk> \<Longrightarrow> c2 = d"
by (simp add: inj_on_def)

lemma inj_on_subset: "\<lbrakk>inj_on f X; Y \<subseteq> X\<rbrakk> \<Longrightarrow> inj_on f Y" 
by (simp add: inj_on_def, fast)

lemma ListTriv[rule_format]: "x \<in> set S \<longrightarrow> (\<exists> n. S ! n = x \<and> n < length S)"
apply (induct S)
apply simp
apply clarsimp
apply (rule, clarsimp) apply (rule_tac x=0 in exI, simp)
apply clarsimp apply (rule_tac x="Suc n" in exI, simp)
done

lemma List_memMap_mem[rule_format]: "a mem map fst M \<longrightarrow> (\<exists> b . (a,b) mem M)"
apply (induct M, clarsimp) apply clarsimp apply (rule_tac x=b in exI, clarsimp)
done

lemma set_map_fst_set[rule_format]:"(x, b) \<in> set M \<longrightarrow> x \<notin> fst ` set M \<longrightarrow> Q" 
apply (induct M)
apply simp
apply clarsimp
done

lemma ListSet1: "c \<in> set S \<Longrightarrow> \<exists>n<length S. S!n = c"
apply (induct S)
apply simp
apply clarsimp
apply (erule disjE, clarsimp) apply (rule_tac x=0 in exI, simp)
apply clarsimp apply (rule_tac x="Suc n" in exI, simp)
done

lemma Arith4: "max (Suc 0) ma + m \<le> N \<Longrightarrow> ma + m \<le> Suc N"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> ma", clarsimp) apply clarsimp
done

lemma Arith5:"max (Suc 0) ma + m \<le> N \<Longrightarrow> ma + m \<le> N"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> ma", clarsimp) apply clarsimp
done

lemma Arith6:"Suc (max (Suc 0) n + max (Suc 0) m) \<le> N \<Longrightarrow> n + m \<le> Suc N"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> n", clarsimp)
  apply (case_tac "Suc 0 \<le> m", clarsimp) apply clarsimp
apply clarsimp
  apply (case_tac "Suc 0 \<le> m", clarsimp) apply clarsimp
done

lemma Arith7: "Suc (max (Suc 0) n + max (Suc 0) m) \<le> N \<Longrightarrow> n + m \<le> N"
 apply (simp add: max_def)  
apply (case_tac "Suc 0 \<le> n", clarsimp)  
  apply (case_tac "Suc 0 \<le> m", clarsimp, clarsimp) 
  apply (case_tac "Suc 0 \<le> m", clarsimp, clarsimp)
done

lemma Arith8: "Suc (Suc (Suc (max (Suc 0) m + max (Suc 0) ma))) \<le> Na \<Longrightarrow>m + ma \<le> Na"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> m")
  apply (clarsimp, case_tac "Suc 0 \<le> ma", clarsimp,clarsimp)
  apply (clarsimp, case_tac "Suc 0 \<le> ma", clarsimp,clarsimp)
done

lemma Arith9 : "Suc (Suc (Suc (Suc (Suc (Suc (Suc (max (Suc 0) ma + max (Suc 0) mb))))))) \<le> Na \<Longrightarrow> ma + mb \<le> Na"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> ma")
  apply (clarsimp, case_tac "Suc 0 \<le> mb", clarsimp,clarsimp)
  apply (clarsimp, case_tac "Suc 0 \<le> mb", clarsimp,clarsimp)
done

lemma Arith10: "Suc (max (Suc 0) m) \<le> n \<Longrightarrow> m \<le> n"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> m", clarsimp) apply clarsimp
done

lemma Arith11: "Suc (Suc (Suc (max (Suc 0) m))) \<le> n \<Longrightarrow> m \<le> n"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> m", clarsimp) apply clarsimp
done

lemma Arith_12: "max nb ma + m \<le> n \<Longrightarrow> ma + m \<le> (n::nat)"
apply (simp add: max_def)
apply (case_tac "nb \<le>ma", auto)
done

lemma Arith_13: "na + max nb ma \<le> n \<Longrightarrow> na + ma \<le> (n::nat)"
apply (simp add: max_def)
apply (case_tac "nb \<le>ma", auto)
done

lemma Arith_14: "Suc (max (Suc 0) ma) + Suc (max (Suc 0) mb) \<le> Suc n \<Longrightarrow> ma + mb \<le> n"
apply (simp add: max_def)
apply (case_tac "Suc 0 \<le> ma", auto)
apply (case_tac "Suc 0 \<le> mb", auto)
apply (case_tac "Suc 0 \<le> mb", auto)
done

lemma Arith_15: "Suc (max (Suc ka) ma + max (Suc kb) mb) \<le> n \<Longrightarrow> ka + kb \<le> n"
apply (simp add: max_def)
apply (case_tac "Suc ka \<le> ma", auto)
apply (case_tac "Suc kb \<le> mb", auto)
apply (case_tac "Suc kb \<le> mb", auto)
done

lemma Arith_16:"Suc (max (Suc ka) ma + max (Suc kb) mb) \<le> n\<Longrightarrow> ma + mb \<le> n"
apply (simp add: max_def)
apply (case_tac "Suc ka \<le> ma", auto)
apply (case_tac "Suc kb \<le> mb", auto)
apply (case_tac "Suc kb \<le> mb", auto)
done

lemma Arith_17 : "\<lbrakk>na \<le> Suc n; na = Suc (max nb m)\<rbrakk> \<Longrightarrow> nb \<le> Suc n"
apply (simp add: max_def)
apply (case_tac "nb \<le> m", auto)
done

lemma Arith_18 : "\<lbrakk>na \<le> Suc n; na = Suc (max nb m)\<rbrakk> \<Longrightarrow> m \<le> n"
apply (simp add: max_def)
apply (case_tac "nb \<le> m", auto)
done

consts rem::"'a \<Rightarrow> 'a list \<Rightarrow> 'a list"
primrec
"rem x [] = []"
"rem x (h#t) = (if x=h then rem x t else h#(rem x t))"

lemma MemRem_Triv1: "x mem (rem x L) \<Longrightarrow> False"
apply (induct L, clarsimp)
apply clarsimp
apply (case_tac "(if x = a then rem x L else a # rem x L)", clarsimp)
apply clarsimp
apply (case_tac "x=a", auto)
apply (case_tac "aa=x", clarsimp) apply clarsimp
done

lemma MemRem_Triv2[rule_format]: "x mem (rem a L) \<longrightarrow> x mem L"
apply (induct L, clarsimp)
apply clarsimp
done

lemma MemRem_Triv3[rule_format]: "x mem L \<longrightarrow> a \<noteq> x \<longrightarrow>x mem (rem a L)"
apply (induct L)
apply clarsimp
apply clarsimp
done

lemma map_add_NoneD: "h x = None \<Longrightarrow> (f ++ h) x = f x" 
by (simp add: map_add_def)

lemma SetTrivUnique:"\<lbrakk>X \<noteq> {}; \<forall> x \<in> X . \<forall> y \<in> X . x=y\<rbrakk> \<Longrightarrow> \<exists> v . X={v}" 
by fast

lemma SetTrivPut2:"\<lbrakk>u:X; X={v}\<rbrakk> \<Longrightarrow> u=v" by fast  

lemma map_set[rule_format]: "\<forall> L . map f L = map g M \<longrightarrow> f ` set L = g ` set M"
apply (induct M) apply clarsimp
apply clarsimp
done

lemma set_fst_map[rule_format]: "(a, b) \<in> set \<Omega> \<longrightarrow> a \<in> fst ` set \<Omega>"
by (induct \<Omega>, auto)

lemma if_split: "\<lbrakk>(if b then None else Some X) = Some Y\<rbrakk> \<Longrightarrow> (\<not> b) \<and> X=Y"
by (case_tac b, clarsimp, clarsimp)
end
(*>*)