theory UnaryRen = Ren + UniSatSec:

lemma State_noDangColours_MPcontained:
  "\<lbrakk>State_noDangColours (S, \<Gamma>, H) N; contained N M; M:AL\<rbrakk> \<Longrightarrow> State_noDangColours (S, \<Gamma>, H) M"
apply (simp add: State_noDangColours_def,clarsimp)
apply (subgoal_tac "AL_dom N \<subseteq> AL_dom M")
prefer 2 apply (erule contained5)
apply (rule, fast)
apply (rule, fast)
apply (rule, fast)
apply (rule, fast)
apply (rule, rule SetTriv101) prefer 2 apply (erule contained_ObjIds_subset) apply assumption
apply (simp add: State_good_def, clarsimp)
  apply (erule HP_good_subset) apply (rule contained_refl) apply assumption
done

lemma State_noDangColours_HPsum:
"\<lbrakk>State_noDangColours (S, \<Gamma>, H) N; State_noDangColours ([], emp, K) N; AL_sum H K HK; HK:AL\<rbrakk> \<Longrightarrow> State_noDangColours (S, \<Gamma>, HK) N"
apply (simp add: State_noDangColours_def, clarsimp)
apply (rule, simp add: AL_sum_def)
apply (rule, simp add: AbsFields_expand, clarsimp)
  apply (drule AL_sum_split) apply assumption
  apply (erule disjE) apply (rule_tac X="{c. \<exists>d C F. H\<down>d = Some (C, F) \<and> (\<exists>f. F\<down>f = Some c)}" in SetTriv) apply fast apply assumption
  apply (rule_tac X="{c. \<exists>d C F. K\<down>d = Some (C, F) \<and> (\<exists>f. F\<down>f = Some c)}" in SetTriv) apply fast apply assumption
apply (rule, simp add: AL_sum_def)
apply (simp add: State_good_def HP_good_def, clarsimp)
  apply (drule AL_sum_split, assumption)
  apply (erule disjE)
    apply (erule_tac x=c in allE, erule_tac x=C in allE, erule_tac x=F in allE, erule mp, assumption)
    apply (erule_tac x=c in allE, erule_tac x=C in allE, erule_tac x=F in allE, erule mp, assumption)
done

lemma MapHP_AbsFields_domf: "(H, f, K) \<in> MapHP \<Longrightarrow> AbsFields H \<subseteq> dom f"
apply (erule MapHP.induct)
apply (simp add: AbsFields_expand AL_emp1) 
apply (simp add: AbsFields_expand, clarsimp)
  apply (drule AL_upd_split)
  apply (erule disjE)
    apply clarsimp apply (drule Map_Fields_D_left) apply assumption apply clarsimp
  apply clarsimp
    apply (rule_tac m=f in domD) 
    apply (rule SetTriv) prefer 2 apply assumption 
    apply clarsimp apply (rule_tac x=d in exI, clarsimp) apply (rule_tac x=fa in exI, assumption)
done

lemma ran_map_add_on_disj_doms: "(dom g) \<inter> (dom f) = {} \<Longrightarrow> ran (g ++ f) = ran g \<union> ran f"
apply (simp add: map_add_def)
apply rule
apply clarsimp
  apply (drule ranD, clarsimp)
  apply (case_tac "f b", clarsimp) apply (erule ranI)
  apply clarsimp apply (drule_tac m=f in ranI) apply simp
apply (rule, clarsimp)
  apply (erule disjE) apply (drule ranD, clarsimp)
    apply (case_tac "x:ran f")  apply (drule ranD, clarsimp) apply (rule_tac a=ba in ranI) apply clarsimp
    apply (rule_tac a=b in ranI)
    apply (case_tac "f b", clarsimp) apply clarsimp apply (drule_tac m=g in domI) apply (drule_tac m=f in domI) apply fast
  apply (drule ranD, clarsimp) apply (rule_tac a=b in ranI) apply clarsimp
done

lemma State_no_dangColours_HPextensional:
  "\<lbrakk>State_noDangColours (S, \<Gamma>, H) N; \<forall> x c . (H\<down>x = Some c) = (K\<down>x = Some c); K:AL\<rbrakk> \<Longrightarrow> State_noDangColours (S, \<Gamma>, K) N"
apply (simp add: State_noDangColours_def)
apply (rule, simp add: AL_dom_def)
apply (rule, simp add: AbsFields_expand)
apply (rule, simp add: AL_dom_def)
apply (simp add: State_good_def HP_good_def)
done

lemma Ren_constructInvMapFields[rule_format]:
"G : AL \<Longrightarrow> AL_cod G \<subseteq> ran f \<longrightarrow> (\<exists> F. (F, f, G) \<in> Map_Fields)"
apply (erule AL.induct)
apply clarsimp apply (rule, rule Map_Fields_emp)
apply clarsimp apply (erule impE) apply (rule SetTriv101) prefer 2 apply assumption apply (simp add: AL_cod_def)
  apply clarsimp apply (rule, rule AL_update5) apply assumption apply (drule AL_domI) apply fast
apply clarsimp
  apply (subgoal_tac "y:ran f") apply (drule ranD) apply clarsimp
    apply (rule, rule Map_Fields_cons)  prefer 3 apply assumption
    prefer 3 apply assumption prefer 3 apply simp apply simp
    apply (drule Map_Fields_dom) apply simp
  apply (rule SetTriv) prefer 2 apply assumption 
    apply (simp add: AL_cod_def) apply (rule_tac x=x in exI, rule AL_update1)
done

lemma Ren_constructInvMapFields_Full[rule_format]:
"G : AL \<Longrightarrow> AL_cod G \<subseteq> ran f \<longrightarrow> (\<exists> F. (F, f, G) \<in> Map_Fields \<and> F:AL \<and> AL_cod F \<subseteq> dom f)"
apply (erule AL.induct)
apply clarsimp apply (rule, rule, rule Map_Fields_emp)
  apply rule apply (rule AL_EMP) apply (simp add: AL_cod_emp) 
apply clarsimp apply (erule impE) apply (rule SetTriv101) prefer 2 apply assumption apply (simp add: AL_cod_def)
  apply clarsimp apply (rule, rule AL_update5) apply assumption apply (drule AL_domI) apply fast
apply clarsimp
  apply (subgoal_tac "y:ran f") apply (drule ranD) apply clarsimp
    apply (rule, rule, rule Map_Fields_cons) prefer 3 apply assumption
    prefer 3 apply assumption prefer 3 apply simp apply simp
    apply (drule Map_Fields_dom) apply simp
  apply (rule, erule AL_UPD)
    apply (simp add: AL_cod_def) apply clarsimp 
     apply (drule AL_upd_split)
     apply (erule disjE, clarsimp) apply clarsimp apply (rule_tac m=f in domD)
      apply (rule SetTriv) prefer 2 apply assumption apply clarsimp apply (rule, assumption) 
   apply (rule SetTriv) prefer 2 apply assumption
    apply (simp add: AL_cod_def) apply (rule_tac x=x in exI, rule AL_update1)
done

lemma MapHP_ReverseExistsAux[rule_format]:
"KK:AL \<Longrightarrow> contained KK K \<longrightarrow>
       AL_dom N \<subseteq> dom f \<longrightarrow> HP_good K (ran f) \<longrightarrow> 
       AL_dom K \<subseteq> Img f (AL_dom N) \<longrightarrow>
        (\<exists> H . (H,f,KK):MapHP \<and> H:AL \<and> AL_dom H \<subseteq> AL_dom N \<and>
               HP_good H (dom f) \<and> AL_dom H \<subseteq> {c . \<exists> x . x: AL_dom KK \<and> f c = Some x})"
apply (erule AL.induct)
apply clarsimp 
    apply (rule, rule, rule MapHP_emp)
    apply (rule, rule AL_EMP)
    apply (simp add: AL_dom_emp)
    apply (simp add: HP_good_def AL_emp1)
apply clarsimp
  apply (erule impE) apply (rule contained_transitive) prefer 2 apply assumption apply (erule contained_upd) 
  apply clarsimp
  apply (subgoal_tac "K\<down>x = Some(a,b)") prefer 2 apply (erule contained3) apply (rule AL_update1)
  apply (frule AL_domI)
  apply (subgoal_tac "x:Img f (AL_dom N)") prefer 2 apply (erule SetTriv) apply assumption 
  apply (subgoal_tac "\<exists> z . z:AL_dom N \<and> f z = Some x") prefer 2 apply (simp add: Img_def) apply clarsimp
  apply (simp add: HP_good_def) apply (erule_tac x=x in allE, clarsimp)
  apply (frule_tac G=b in Ren_constructInvMapFields_Full) apply assumption apply clarsimp
  apply (rule_tac x="H[z\<mapsto>(a,F)]" in exI)
  apply (case_tac "z:AL_dom H") apply (drule MapHP_dom)
    apply (rotate_tac -13) apply (erule thin_rl) apply clarsimp apply (simp add: Img_def)
  apply (rule, rule MapHP_cons) apply fastsimp apply assumption apply assumption  apply assumption apply assumption
    apply simp
  apply (rule,erule AL_UPD)
  apply (rule, simp add: AL_dom_upd1)
  apply rule
    apply clarsimp 
    apply (drule AL_upd_split)
    apply (erule disjE, clarsimp) apply clarsimp
  apply clarsimp apply (simp add: AL_dom_upd1)
    apply (erule disjE) apply clarsimp 
    apply (drule_tac x=xa and Y=" {c. \<exists>x. x \<in> AL_dom M \<and> f c = Some x}" in SetTriv) apply assumption 
    apply clarsimp
done

lemma MapHP_ReverseExists_FullAux[rule_format]:
"KK:AL \<Longrightarrow> contained KK K \<longrightarrow> inj_on f (ObjIDs N) \<longrightarrow>
       AL_dom K \<subseteq> ObjIDs NN \<longrightarrow>
       TypePreserving f N NN \<longrightarrow>
       AL_dom N \<subseteq> dom f \<longrightarrow> HP_good K (ran f) \<longrightarrow> 
       AL_dom K \<subseteq> Img f (AL_dom N) \<longrightarrow>
        (\<exists> H . (H,f,KK):MapHP \<and> H:AL \<and> 
               HP_good H (dom f) \<and> AL_dom H = {c . \<exists> x . x: AL_dom KK \<and> f c = Some x \<and> c:ObjIDs N})"
apply (erule AL.induct)
apply clarsimp 
    apply (rule, rule, rule MapHP_emp)
    apply (rule, rule AL_EMP)
    apply (simp add: AL_dom_emp)
    apply (simp add: HP_good_def AL_emp1)
apply clarsimp
  apply (erule impE) apply (rule contained_transitive) prefer 2 apply assumption apply (erule contained_upd) 
  apply clarsimp
  apply (subgoal_tac "K\<down>x = Some(a,b)") prefer 2 apply (erule contained3) apply (rule AL_update1)
  apply (frule AL_domI)
  apply (subgoal_tac "x:Img f (AL_dom N)") prefer 2 apply (erule SetTriv) apply assumption 
  apply (subgoal_tac "\<exists> z . z:AL_dom N \<and> f z = Some x") prefer 2 apply (simp add: Img_def) apply clarsimp
  apply (simp add: HP_good_def) apply (erule_tac x=x in allE, clarsimp)
  apply (frule_tac G=b in Ren_constructInvMapFields_Full) apply assumption apply clarsimp
  apply (rule_tac x="H[z\<mapsto>(a,F)]" in exI)
  apply (case_tac "z:AL_dom H") apply (drule MapHP_dom)
    apply (rotate_tac -13) apply (erule thin_rl) apply clarsimp apply (simp add: Img_def)
  apply (rule, rule MapHP_cons) apply fastsimp apply assumption apply assumption  apply assumption apply assumption
    apply simp
  apply (rule,erule AL_UPD)
  (*AL_dom H \<subseteq> ObjIDs N \<and>apply (rule, simp add: AL_dom_upd1) *)
  apply rule
    apply clarsimp 
    apply (drule AL_upd_split)
    apply (erule disjE, clarsimp) apply clarsimp
  apply clarsimp apply (simp add: AL_dom_upd1)
  apply (rule, clarsimp)
    apply rule apply (subgoal_tac "x:ObjIDs NN") prefer 2 apply (erule SetTriv) apply assumption
               apply (simp add: ObjIDs_def, clarsimp) apply (drule_tac d=z in AL_domD) apply clarsimp
               apply (drule TypePreserving_D, assumption+) apply clarsimp
    apply clarsimp
  apply clarsimp
    apply (drule_tac x=z and y=xa in inj_onD, simp)
      apply (subgoal_tac "x:ObjIDs NN") prefer 2 apply (erule SetTriv) apply assumption
        apply (drule_tac d=z in AL_domD) apply clarsimp
        apply (drule TypePreserving_D, assumption+) apply (simp add: ObjIDs_def)
      apply assumption
      apply simp
done

lemma MapHP_ReverseExists_FullAux2[rule_format]:
"KK:AL \<Longrightarrow> contained KK K \<longrightarrow> inj_on f (ObjIDs N) \<longrightarrow>
       AL_dom K \<subseteq> ObjIDs NN \<longrightarrow>
       TypePreserving f N NN \<longrightarrow>
       AL_dom N \<subseteq> dom f \<longrightarrow> HP_good K (ran f) \<longrightarrow> 
       AL_dom K \<subseteq> Img f (AL_dom N) \<longrightarrow>
        (\<exists> H . (H,f,KK):MapHP \<and> H:AL \<and> AL_dom H \<subseteq> ObjIDs N \<and>inj_on f (AL_dom H)\<and>
               HP_good H (dom f) \<and> AL_dom H = {c . \<exists> x . x: AL_dom KK \<and> f c = Some x \<and> c:ObjIDs N})"
apply clarsimp
apply (drule  MapHP_ReverseExists_FullAux) apply assumption+ 
apply clarsimp
apply (rule_tac x=H in exI, clarsimp)
apply rule apply fast
apply (erule inj_on_subset) apply fast
done

lemma MapN_D_ObjIDs: "(N, f, NN) \<in> MapN \<Longrightarrow> ObjIDs NN \<subseteq> Img f (AL_dom N)"
apply (frule MapN_TypePreserving) 
apply (simp add: ObjIDs_def, clarsimp)
apply (drule MapN_D_right) apply assumption apply clarsimp
apply (simp add: Img_def) apply (rule_tac x=c in exI, simp)
apply (erule AL_domI)
done

lemma MapHP_ReverseExists_Full2:
 "\<lbrakk>K:AL; AL_dom N \<subseteq> dom f; HP_good K (ran f); inj_on f (ObjIDs N);
   (N,f,NN):MapN; AL_dom K \<subseteq> ObjIDs NN\<rbrakk>
       \<Longrightarrow> (\<exists> H . (H,f,K):MapHP \<and> H:AL \<and> AL_dom H \<subseteq> ObjIDs N  \<and>inj_on f (AL_dom H) \<and>
               HP_good H (dom f) \<and> HPdom_is H f K N)"
apply (simp add: HPdom_is_def)
apply (erule_tac N=N and f=f in MapHP_ReverseExists_FullAux2) apply (rule contained_refl)
apply assumption apply assumption apply (erule MapN_TypePreserving) apply assumption apply assumption
apply (erule SetTriv101) apply (erule MapN_D_ObjIDs)
done
(*
lemma MapHP_ReverseExists_Full2From12:
 "\<lbrakk>K:AL; AL_dom N = dom f; HP_good K (ran f); inj_on f (ObjIDs N);
       TypePreserving f N NN;
       AL_dom K \<subseteq> ran f; AL_dom K \<subseteq> ObjIDs NN\<rbrakk>
       \<Longrightarrow> (\<exists> H . (H,f,K):MapHP \<and> H:AL \<and> AL_dom H \<subseteq> ObjIDs N  \<and>inj_on f (AL_dom H) \<and>
               HP_good H (dom f) \<and> HPdom_is H f K N)"
apply (simp add: HPdom_is_def)
apply (drule_tac N=N and f=f in MapHP_ReverseExists_FullAux2) apply (rule contained_refl)
apply assumption apply assumption apply assumption apply fast apply assumption
apply simp apply (simp add: Img_dom_ran)
apply assumption
apply simp apply (simp add: Img_dom_ran)
done
*)

lemma Ren_constructInvMapFields_Full3[rule_format]:
"G : AL \<Longrightarrow> AL_cod G \<subseteq> AL_dom NN \<longrightarrow> (N,f,NN):MapN \<longrightarrow> (\<exists> F. (F, f, G) \<in> Map_Fields \<and> F:AL \<and> AL_cod F \<subseteq> AL_dom N)"
apply (erule AL.induct)
apply clarsimp apply (rule, rule, rule Map_Fields_emp)
  apply rule apply (rule AL_EMP) apply (simp add: AL_cod_emp) 
apply clarsimp apply (erule impE) apply (rule SetTriv101) prefer 2 apply assumption apply (simp add: AL_cod_def)
  apply clarsimp apply (rule, rule AL_update5) apply assumption apply (drule AL_domI) apply fast
apply clarsimp
  apply (frule MapN_AL_Aux4) apply clarsimp
  apply (subgoal_tac "y:AL_dom NN") apply (drule AL_domD) apply clarsimp
    apply (frule AL_domI) apply (simp add: Img_def, clarsimp)
    apply (rule, rule, rule Map_Fields_cons) prefer 3 apply assumption
    prefer 3 apply assumption prefer 3 apply simp apply simp
    apply (drule Map_Fields_dom) apply simp
  apply (rule, erule AL_UPD)
    apply (simp add: AL_cod_def) apply clarsimp 
     apply (drule AL_upd_split)
     apply (erule disjE, clarsimp) apply clarsimp apply (rule SetTriv) prefer 2 apply assumption apply clarsimp  apply (rule, assumption) 
   apply (rule_tac X="AL_cod M[x\<mapsto>y]" in SetTriv) apply (simp add: AL_cod_def) apply (rule_tac x=x in exI, rule AL_update1)
     apply clarsimp
done

lemma MapHP_ReverseExists_Full3:
 "KK:AL \<Longrightarrow> contained KK K \<longrightarrow> AL_dom N \<subseteq> dom f \<longrightarrow> HP_good K (AL_dom NN) \<longrightarrow> inj_on f (ObjIDs N) \<longrightarrow>
   (N,f,NN):MapN \<longrightarrow> AL_dom K \<subseteq> ObjIDs NN \<longrightarrow>
       (\<exists> H . (H,f,KK):MapHP \<and> H:AL \<and> AL_dom H \<subseteq> ObjIDs N  \<and>inj_on f (AL_dom H) \<and>
               HP_good H (AL_dom N) \<and> HPdom_is H f KK N)"
apply (erule AL.induct)
apply clarsimp 
    apply (rule, rule, rule MapHP_emp)
    apply (rule, rule AL_EMP)
    apply (simp add: AL_dom_emp)
    apply (simp add: HP_good_def AL_emp1)
    apply (simp add: HPdom_is_def AL_dom_emp)
apply clarsimp
  apply (erule impE) apply (rule contained_transitive) prefer 2 apply assumption apply (erule contained_upd) 
  apply clarsimp
  apply (subgoal_tac "K\<down>x = Some(a,b)") prefer 2 apply (erule contained3) apply (rule AL_update1)
  apply (frule AL_domI)
  apply (subgoal_tac "x:Img f (AL_dom N)") 
  prefer 2 apply (erule SetTriv) apply (erule SetTriv101) 
           apply (rule SetTriv101) apply (rule ObjIDs_in_Dom) apply (drule MapN_AL_Aux4) apply simp 
  apply (subgoal_tac "\<exists> z . z:AL_dom N \<and> f z = Some x") prefer 2 apply (simp add: Img_def) apply clarsimp
  apply (simp add: HP_good_def) 
  apply (subgoal_tac " b \<in> AL \<and> AL_cod b \<subseteq> AL_dom NN") prefer 2 apply (erule_tac x=x in allE, erule_tac x=a in allE, erule_tac x=b in allE, erule mp, assumption)
  apply (erule conjE)
  apply (frule_tac G=b and f=f in Ren_constructInvMapFields_Full3) apply assumption apply assumption
  apply clarsimp
  apply (rule_tac x="H[z\<mapsto>(a,F)]" in exI)
  apply (case_tac "z:AL_dom H") apply (drule MapHP_dom)
    apply (rotate_tac -13) apply (erule thin_rl) apply clarsimp apply (simp add: Img_def)
  apply (rule, rule MapHP_cons) apply fastsimp apply assumption apply assumption  apply assumption apply assumption
    apply simp
  apply (rule,erule AL_UPD)
  apply (subgoal_tac "AL_dom H[z\<mapsto>(a, F)] \<subseteq> ObjIDs N", simp)
  prefer 2 apply (simp add: AL_dom_upd1)
           apply (drule_tac H=N in AL_domD, clarsimp)
           apply (drule MapN_D_left, assumption) apply clarsimp 
           apply (drule_tac x=x in SetTriv, assumption)
           apply (simp add: ObjIDs_def)
  apply rule apply (erule inj_on_subset) apply assumption
  apply rule
    apply clarsimp 
    apply (drule AL_upd_split)
    apply (erule disjE, clarsimp) 
    apply clarsimp 
  apply (simp add: HPdom_is_def) 
    apply (rule, rule, clarsimp) apply (simp add: AL_dom_upd1)
      apply (erule disjE) apply clarsimp 
      apply clarsimp
    apply clarsimp apply (simp add: AL_dom_upd1)
      apply (erule disjE)
        apply clarsimp 
        apply (erule inj_onD) apply simp apply assumption apply assumption
      apply clarsimp
done
(*
lemma MapHP_ReverseExists_Full2From12:
 "\<lbrakk>K:AL; AL_dom N = dom f; HP_good K (ran f); inj_on f (ObjIDs N);
       TypePreserving f N NN;
       AL_dom K \<subseteq> ran f; AL_dom K \<subseteq> ObjIDs NN\<rbrakk>
       \<Longrightarrow> (\<exists> H . (H,f,K):MapHP \<and> H:AL \<and> AL_dom H \<subseteq> ObjIDs N  \<and>inj_on f (AL_dom H) \<and>
               HP_good H (dom f) \<and> HPdom_is H f K N)"
apply (simp add: HPdom_is_def)
apply (drule_tac N=N and f=f in MapHP_ReverseExists_FullAux2) apply (rule contained_refl)
apply assumption apply assumption apply assumption apply fast apply assumption
apply simp apply (simp add: Img_dom_ran)
apply assumption
apply simp apply (simp add: Img_dom_ran)
done
*)

lemma MapHP_AL_delete[rule_format]:"(H,f,K):MapHP \<Longrightarrow> AL_dom H \<subseteq> ObjIDs N \<longrightarrow>
  inj_on f (ObjIDs N) \<longrightarrow> (\<forall> x fx. f x = Some fx \<longrightarrow> x:ObjIDs N \<longrightarrow> (delete H x,f,delete K fx):MapHP)"
apply (erule MapHP.induct)
apply clarsimp
  apply (subgoal_tac "(emp::HP) = delete (emp::HP) x", clarsimp)
  apply (subgoal_tac "(emp::HP) = delete (emp::HP) fx", clarsimp)
    apply (rule MapHP_emp)
  apply (simp add: emp_def)
  apply (simp add: emp_def)
apply clarsimp
  apply (erule impE) apply (simp add: AL_dom_upd1)
  apply (case_tac "x=c", clarsimp)    
    apply (simp add: AL_delete_upd_same)
  apply (case_tac "fx = fc")
      apply (drule_tac x=x and y=c and A="ObjIDs N" in inj_onD) apply simp apply assumption apply (simp add: AL_dom_upd1)  apply fast
      apply (frule_tac z=fx and M=fM and y="(C, G)" in AL_delete_upd_diff) apply clarsimp
      apply (erule_tac x=x in allE, clarsimp)
    apply (rule_tac M="(delete M x)" and c=c and C=C and F=F in MapHP_cons) 
      apply (simp add: upd_def) apply (rule, fast) apply clarsimp apply (rule AL_delete_commutative)
      apply (simp add: AL_dom_delete) 
      apply assumption 
      apply assumption apply assumption apply clarsimp
done

lemma MapHP_AL_delete2[rule_format]:"(H,f,K):MapHP \<Longrightarrow> 
  inj_on f (AL_dom H) \<longrightarrow> (\<forall> x fx. f x = Some fx \<longrightarrow> x:AL_dom H \<longrightarrow> (delete H x,f,delete K fx):MapHP)"
apply (erule MapHP.induct)
apply clarsimp
  apply (subgoal_tac "(emp::HP) = delete (emp::HP) x", clarsimp)
  apply (subgoal_tac "(emp::HP) = delete (emp::HP) fx", clarsimp)
    apply (rule MapHP_emp)
  apply (simp add: emp_def)
  apply (simp add: emp_def)
apply clarsimp
  apply (erule impE) apply (simp add: AL_dom_upd1)
  apply (case_tac "x=c", clarsimp)    
    apply (simp add: AL_delete_upd_same) apply (frule AL_notdomD_delete, clarsimp) 
      apply (case_tac "fx : AL_dom fM") apply (drule_tac d=fx in AL_domD, clarsimp) 
                                        apply (drule MapHP_D_right) apply assumption apply clarsimp
                                        apply (drule_tac d=ca in AL_domI) 
                                        apply (drule_tac x=c and y=ca in inj_onD) apply simp apply (simp add: AL_dom_upd1)
                                          apply (simp add: AL_dom_upd1) apply clarsimp
      apply (frule_tac x=fx in AL_notdomD_delete, clarsimp)
  apply (case_tac "fx = fc")
      apply (drule_tac x=x and y=c and A="AL_dom M[c\<mapsto>(C, F)]" in inj_onD) apply simp apply assumption apply (simp add: AL_dom_upd1) apply fast
      apply (frule_tac z=fx and M=fM and y="(C, G)" in AL_delete_upd_diff) apply clarsimp
      apply (erule_tac x=x in allE, clarsimp)
      apply (erule impE) apply (simp add: AL_dom_upd1)
    apply (rule_tac M="(delete M x)" and c=c and C=C and F=F in MapHP_cons) 
      apply (simp add: upd_def) apply (rule, fast) apply clarsimp apply (rule AL_delete_commutative)
      apply (simp add: AL_dom_delete) 
      apply assumption 
      apply assumption apply assumption apply clarsimp
done

lemma ren_InvHP_exists_aux[rule_format]:
  "ba :AL \<Longrightarrow> (\<forall> bc Ha KK K  . AL_dom bc \<inter> AL_dom Ha = {} \<longrightarrow> inj_on f (AL_dom bc) \<longrightarrow> inj_on f (AL_dom Ha) \<longrightarrow>
       AL_sum KK K ba \<longrightarrow> (Ha, f, K) \<in> MapHP \<longrightarrow> (bc, f, KK) \<in> MapHP \<longrightarrow> AL_dom KK \<inter> AL_dom K = {} \<longrightarrow> 
       (\<exists> be . be:AL \<and> (be, f, ba) \<in> MapHP \<and> AL_sum bc Ha be))"
apply (erule AL.induct)
apply clarsimp 
  apply (drule AL_sum_emp3) apply clarsimp 
  apply (erule MapHP.elims) apply clarsimp prefer 2 apply clarsimp apply (simp add: emp_def upd_def)
  apply (erule MapHP.elims) apply clarsimp prefer 2 apply clarsimp apply (simp add: emp_def upd_def)
  apply (rule_tac x=emp in exI)
    apply (rule, rule AL_EMP)
    apply (rule, rule MapHP_emp)
    apply (rule  AL_sum_emp1)
apply clarsimp
apply (case_tac "x:AL_dom KK")
  apply (frule AL_domD, clarsimp)
  apply (frule MapHP_D_right, assumption) apply clarsimp
  apply (erule_tac x="delete bc c" in allE, erule_tac x=Ha in allE)
  apply (erule impE) apply (simp add: AL_dom_delete) apply fast
  apply (erule impE) apply (erule inj_on_subset) apply (simp add: AL_dom_delete) apply fast
  apply (erule impE, assumption) 
  apply (erule_tac x="delete KK x" in allE, erule_tac x=K in allE)
  apply (erule impE) apply (simp add: AL_sum_def, clarsimp)
                     apply (rule, simp add: AL_dom_delete AL_dom_upd1) apply fast
                     apply (rule, simp (no_asm) add: contained_def, clarsimp) 
                       apply (drule AL_delete6) apply clarsimp
                       apply (drule_tac c=ab in contained3, assumption) 
                       apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply clarsimp
                     apply (simp (no_asm) add: contained_def, clarsimp) 
                       apply (drule_tac c=ab in contained3, assumption) 
                       apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply (drule_tac H=K in AL_domI) apply fast
                       apply clarsimp
   apply (erule impE, assumption) 
   apply (erule impE) apply (erule MapHP_AL_delete2) apply assumption apply assumption apply (erule AL_domI) 
   apply (erule impE) apply (simp add: AL_dom_delete) apply fast
   apply clarsimp
   apply (drule AL_sum3) apply assumption apply (simp add: AL_update1) apply clarsimp
   apply (rule_tac x="be[c \<mapsto> (aa,F)]" in exI)
   apply (rule, rule_tac M="delete be c" and x=c and y="(aa, F)" in AL_CONS) apply (erule AL_DEL)
     apply (simp add: AL_dom_delete) 
     apply (simp add: upd_def) apply (rule AL_delete_idempotent)
   apply (subgoal_tac "c\<notin> AL_dom be")
   prefer 2 apply (simp add: AL_sum_def, clarsimp)
            apply rule apply (simp add: AL_dom_delete)
            apply (drule_tac d=c in AL_domI) apply fast
   apply rule
    apply (rule_tac M=be and c=c and C=aa and F=F in MapHP_cons) apply simp apply assumption apply assumption 
      apply assumption apply assumption apply simp
   apply (simp add: AL_sum_def, clarsimp)
     apply (rule, simp add: AL_dom_upd1 AL_dom_delete) 
            apply (drule_tac d=c in AL_domI) apply fast
     apply (rule, simp (no_asm) add: contained_def, clarsimp)
       apply (case_tac "c=a", clarsimp) apply (rule AL_update1)
       apply (rule AL_update5) apply (erule contained3) apply (rule AL_delete5) apply fast apply assumption
         apply assumption
     apply (simp (no_asm) add: contained_def, clarsimp)
       apply (rule AL_update5) apply (erule contained3, assumption) 
         apply (drule_tac d=a in AL_domI) apply fast
(*"x \<notin> AL_dom KK*)
  apply (subgoal_tac "K\<down>x = Some(a,b)")
  prefer 2 apply (drule AL_sum_split) apply (rule AL_update1)
           apply (erule disjE) apply (drule_tac d=x in AL_domI, simp)
           apply assumption
  apply (frule MapHP_D_right, assumption) apply clarsimp
  apply (erule_tac x=bc in allE, erule_tac x="delete Ha c" in allE)
  apply (erule impE) apply (simp add: AL_dom_delete) apply fast
  apply (erule impE, assumption)
  apply (erule impE, erule_tac X="AL_dom Ha" in inj_on_subset)  apply (simp add: AL_dom_delete) apply fast
  apply (erule_tac x=KK in allE, erule_tac x="delete K x" in allE)
  apply (erule impE) apply (simp add: AL_sum_def, clarsimp)
                     apply (rule, simp add: AL_dom_delete AL_dom_upd1) apply (drule AL_domI)  apply (drule AL_domI) 
                       apply (rule, rule, clarsimp)
                         apply (case_tac "xa:AL_dom K", clarsimp) apply clarsimp 
                         apply (case_tac "x=xa", fast) apply fast
                       apply (rule, clarsimp) apply (erule disjE) 
                                                apply (case_tac "x=xa", fast)
                                                apply (subgoal_tac "xa : insert x (AL_dom M)", fast) apply clarsimp
                                              apply clarsimp 
                                                apply (subgoal_tac "xa : insert x (AL_dom M)", fast) apply clarsimp
                     apply (rule, simp (no_asm) add: contained_def, clarsimp) 
                       apply (drule_tac c=aa in contained3, assumption) 
                       apply (drule AL_upd_split)
                       apply (erule disjE, clarsimp) 
                         apply (drule_tac d=x in AL_domI) apply (drule_tac d=x in AL_domI) apply fast 
                       apply clarsimp
                     apply (simp (no_asm) add: contained_def, clarsimp) 
                       apply (drule AL_delete6) apply clarsimp
                       apply (drule_tac c=aa in contained3, assumption) 
                       apply (drule AL_upd_split) apply (erule disjE, clarsimp) apply clarsimp 
   apply (erule impE) apply (erule MapHP_AL_delete2) apply assumption apply assumption apply (erule AL_domI) 
   apply (erule impE, assumption) 
   apply (erule impE) apply (simp add: AL_dom_delete) apply fast
   apply clarsimp
   apply (rule_tac x="be[c \<mapsto> (a,F)]" in exI)
   apply (rule, rule_tac M="delete be c" and x=c and y="(a, F)" in AL_CONS) apply (erule AL_DEL)
     apply (simp add: AL_dom_delete) 
     apply (simp add: upd_def) apply (rule AL_delete_idempotent)
   apply rule
    apply (rule_tac M=be and c=c and C=a and F=F in MapHP_cons) apply simp 
      apply (simp add: AL_sum_def, clarsimp)
      apply (drule_tac d=c in AL_domI) apply (rule, fast) apply (simp add: AL_dom_delete) 
      apply assumption apply assumption apply assumption apply simp
   apply (simp add: AL_sum_def, clarsimp)
     apply (rule, simp add: AL_dom_upd1 AL_dom_delete) 
            apply (drule_tac d=c in AL_domI) apply fast
     apply (rule, simp (no_asm) add: contained_def, clarsimp)
       apply (drule_tac c=aa in contained3, assumption)
       apply (erule AL_update5) apply (drule_tac d=c in AL_domI) apply (drule_tac d=aa in AL_domI) apply fast
     apply (simp (no_asm) add: contained_def, clarsimp)
       apply (case_tac "c=aa", clarsimp) apply (rule AL_update1)
       apply (rule AL_update5) apply (erule_tac N="delete Ha c" in contained3) apply (erule AL_delete5b) apply assumption 
         apply assumption 
done

lemma Ren_State_welldef:
  "\<lbrakk>Renames_STATE (S, \<Gamma>, H) f (T, \<Delta>, K); State_welldef (T, \<Delta>, K) L; (N, f, L) \<in> MapN;  State_noDangColours (S, \<Gamma>, H) N;
        inj_on f (ObjIDs N)\<rbrakk>
 \<Longrightarrow> State_welldef (S, \<Gamma>, H) N"
apply (simp add: State_welldef_def State_noDangColours_def Renames_STATE_def, clarsimp)
apply (simp add: ObjIDs_def, clarsimp)
apply (frule MapN_D_left3, erule AL_domI) apply clarsimp
apply (frule MapN_TypePreserving) 
apply (subgoal_tac "fx : (set T \<union> AL_cod \<Delta> \<union> AbsFields K) \<inter> {c. \<exists>C . L\<down>c = Some (classTP C)}")
  apply (drule SetTriv, assumption)
  apply (drule_tac d=fx and H=K in AL_domD, clarsimp)
  apply (drule MapHP_D_right, assumption)  apply clarsimp
  apply (subgoal_tac "c:AL_dom N", drule_tac d=c in AL_domD, clarsimp)
    apply (frule_tac c=c in TypePreserving_D, assumption) apply assumption 
    apply (frule_tac c=x in TypePreserving_D, assumption) apply assumption 
    apply clarsimp 
    apply (drule_tac x=x and y=c in inj_onD) apply simp apply fast apply fast apply clarsimp apply (erule AL_domI)
  apply (rule SetTriv, erule AL_domI) apply assumption
apply clarsimp
apply (rule, clarsimp)
  apply (erule disjE, subgoal_tac "fx : set T", fast)
    apply (drule MAP_OPSTACK_set_Img, simp add: Img_def) 
  apply (erule disjE)
    apply (drule MAP_STORE_cod_Img, simp add: Img_def)  apply (rule_tac x=x in exI, simp)
  apply (subgoal_tac "fx : AbsFields K", fast)
    apply (drule MapHP_AbsFields_Img2) apply (erule inj_on_subset, assumption) apply (simp add: Img_def)
apply (drule TypePreserving_D) apply assumption apply assumption apply clarsimp
done

lemma Ren_OPSTACK_tc:
  "\<lbrakk> Opstack_typecorrect L T a; (N, f, L) \<in> MapN; 
     State_welldef (S, \<Gamma>, H) N; (S, f, T) \<in> MAP_OPSTACK\<rbrakk>
   \<Longrightarrow> Opstack_typecorrect N S a"
apply (simp add: Opstack_typecorrect_def, clarsimp) 
apply (frule MAP_OPSTACK_length, clarsimp) 
apply (erule_tac x=n in allE, clarsimp)
apply (frule MapN_TypePreserving)
apply (drule MAP_OPSTACK_lookupR) apply simp apply simp apply clarsimp 
apply (drule MapN_D_right) apply assumption apply clarsimp 
apply (drule State_welldef_OPS_lookup) apply assumption apply clarsimp
apply (frule_tac c=c in TypePreserving_D) apply assumption apply assumption apply clarsimp
apply (frule_tac c="S!n" in TypePreserving_D) apply assumption apply assumption apply clarsimp
done

lemma Ren_STORE_tc:
  "\<lbrakk> Store_typecorrect L \<Delta> s; (N, f, L) \<in> MapN;
     State_welldef (S, \<Gamma>, H) N; (\<Gamma>, f, \<Delta>) \<in> MAP_STORE\<rbrakk>
    \<Longrightarrow> Store_typecorrect N \<Gamma> s" 
apply (simp add: Store_typecorrect_def, clarsimp) 
apply (frule MapN_TypePreserving)
apply (frule MAP_STORE_D_left) apply assumption apply clarsimp 
apply (erule_tac x=x in allE, clarsimp)
apply (drule MapN_D_right) apply assumption apply clarsimp 
apply (drule State_welldef_Store_lookup) apply assumption apply clarsimp
apply (frule_tac c=c in TypePreserving_D) apply assumption apply assumption apply clarsimp
done

lemma Ren_Fields_tc:
   "\<lbrakk> (N, f, L) \<in> MapN; (F, f, G) \<in> Map_Fields; Fields_typecorrect L G Ga; 
      State_welldef (S, \<Gamma>, H) N; H\<down>c = Some (C, F)\<rbrakk>
    \<Longrightarrow> Fields_typecorrect N F Ga"
apply (simp add:  Fields_typecorrect_def, clarsimp)
apply (frule MapN_TypePreserving)
apply (frule Map_Fields_D_left) apply assumption apply clarsimp 
apply (erule_tac x=fa in allE, clarsimp)
apply (drule MapN_D_right) apply assumption apply clarsimp 
apply (drule State_welldef_Field_lookup) apply assumption apply assumption apply clarsimp 
apply (frule_tac c=ca in TypePreserving_D) apply assumption apply assumption apply clarsimp
done

lemma Ren_Heap_tc:
  "\<lbrakk> (N, f, L) \<in> MapN; State_noDangColours (S, \<Gamma>, H) N; State_welldef (S, \<Gamma>, H) N; 
      (H, f, K) \<in> MapHP; inj_on I (AL_dom K); Heap_typecorrect L K b I; inj_on f (ObjIDs N)\<rbrakk>
   \<Longrightarrow> Heap_typecorrect N H b (map_compose I f)"
apply (simp add: Heap_typecorrect_def, clarsimp)
apply (frule State_welldef_D_Heap_ObjIDs)
apply (frule SetTriv, assumption) 
apply (simp add: ObjIDs_def, clarsimp)
apply (frule AL_domD, clarsimp)
apply (frule MapHP_D_left) apply (erule inj_on_subset, assumption) apply assumption apply clarsimp
apply (erule_tac x=fc in allE, erule impE, erule AL_domI) apply clarsimp
apply (frule MapN_TypePreserving)
apply (frule TypePreserving_D) apply assumption+ apply clarsimp
apply (rule, simp add: HeapAbstractsAt_def, clarsimp)
  apply (drule map_composeD3) apply clarsimp
  apply (erule Ren_Fields_tc) apply assumption apply assumption apply assumption apply assumption 
apply clarsimp apply (drule_tac g=I and f=f in map_composeD1) apply clarsimp
done

lemma Ren_ValuesRepresented:
  "\<lbrakk> (N, f, L) \<in> MapN; inj_on f (ObjIDs N); State_welldef (S,\<Gamma>,H) N; 
     Renames_STATE (S,\<Gamma>, H) f (T, \<Delta>, K);  f c = Some y\<rbrakk>
   \<Longrightarrow> ValuesRepresented c (S,\<Gamma>,H) s (map_compose I f) \<subseteq> ValuesRepresented y (T, \<Delta>, K) s I"
apply (simp add: ValuesRepresented_def Renames_STATE_def, clarsimp)
apply (case_tac s, clarsimp)
apply (erule disjE, clarsimp)
  apply (frule MAP_OPSTACK_length, clarsimp)
  apply (drule MAP_OPSTACK_lookupL) apply assumption apply simp apply clarsimp
  apply (erule_tac x=n in allE, clarsimp)
apply (erule disjE, clarsimp)
  apply (drule  MAP_STORE_D_left) apply assumption apply clarsimp
apply (erule disjE, clarsimp)
  apply (frule AL_domD, clarsimp)
  apply (drule  MapHP_D_left) apply (erule inj_on_subset) apply (erule State_welldef_D_Heap_ObjIDs) 
                              apply assumption apply clarsimp 
  apply (drule_tac g=I and f=f in map_composeD1)  apply clarsimp apply (erule AL_domI)
apply clarsimp
  apply (frule  MapHP_D_left) apply (erule inj_on_subset) apply (erule State_welldef_D_Heap_ObjIDs) 
                              apply assumption apply clarsimp 
  apply (erule_tac x=fc in allE, clarsimp) 
  apply (drule Map_Fields_D_left) apply assumption apply clarsimp
  apply (erule_tac x=fa in allE, clarsimp)
  apply (erule_tac x=C in allE, erule_tac x=G in allE, erule_tac x=ab in allE, clarsimp)
  apply (frule_tac g=I and f=f and a=d in map_composeD1)  apply clarsimp 
done

lemma Ren_ValuesRepresented1a:
  "\<lbrakk> (N, f, L) \<in> MapN; inj_on f (ObjIDs N); State_welldef (S,\<Gamma>,H) N; 
     Renames_STATE (S,\<Gamma>, H) f (T, \<Delta>, K);  f c = Some y\<rbrakk>
   \<Longrightarrow> ValuesRepresented c (S,\<Gamma>,emp) s (map_compose I f) \<subseteq> ValuesRepresented y (T, \<Delta>, emp) s I"
apply (simp add: ValuesRepresented_def Renames_STATE_def, clarsimp)
apply (case_tac s, clarsimp)
apply (erule disjE, clarsimp)
  apply (frule MAP_OPSTACK_length, clarsimp)
  apply (drule MAP_OPSTACK_lookupL) apply assumption apply simp apply clarsimp
  apply (erule_tac x=n in allE, clarsimp)
apply (erule disjE, clarsimp)
  apply (drule  MAP_STORE_D_left) apply assumption apply clarsimp
apply (erule disjE, clarsimp) apply (simp add: AL_dom_emp)
apply clarsimp apply (simp add: AL_emp1)
done

lemma Ren_ValuesRepresented2:
  "\<lbrakk> (N, f, L) \<in> MapN; inj_on f (ObjIDs N);  State_welldef (S,\<Gamma>,H) N; State_welldef (T, \<Delta>, K) L;
     Renames_STATE (S,\<Gamma>, H) f (T, \<Delta>, K); AL_dom L = ran f; AL_dom N = dom f; c: AL_dom L\<rbrakk>
  \<Longrightarrow> ValuesRepresented c (T, \<Delta>, K) s (map_compose I (Invv f))
          \<subseteq> {u . \<exists>d. f d = Some c \<and> u \<in> ValuesRepresented d (S,\<Gamma>, H) s I}"
apply (simp add: ValuesRepresented_def, clarsimp)
apply (case_tac s, clarsimp)
apply (erule disjE, clarsimp)
  apply (simp add: Renames_STATE_def, clarsimp)
  apply (frule MAP_OPSTACK_length) apply clarsimp
  apply (frule_tac n=n in MAP_OPSTACK_lookupR) apply simp apply simp apply clarsimp
  apply (rule_tac x="S!n" in exI, clarsimp) apply (erule_tac x=n in allE, clarsimp)
apply (erule disjE, clarsimp)
  apply (simp add: Renames_STATE_def, clarsimp)
  apply (drule MAP_STORE_D_right) apply assumption apply clarsimp
  apply (rule_tac x=ca in exI, clarsimp)
apply (erule disjE, clarsimp)
  apply (simp add: Renames_STATE_def, clarsimp)
  apply (frule AL_domD, clarsimp)
  apply (drule_tac fc=c in MapHP_D_right) apply assumption apply clarsimp
  apply (drule map_composeD3, clarsimp)
  apply (frule InvvD_Some) 
  apply (drule_tac x=ca and y=bb in inj_onD, simp)
    apply (rule SetTriv) apply (erule AL_domI) apply (erule State_welldef_D_Heap_ObjIDs)
    apply (subgoal_tac "bb:AL_dom N", drule_tac d=bb in AL_domD, clarsimp)
      apply (drule MapN_TypePreserving)
      apply (drule TypePreserving_D, assumption) apply assumption
      apply (drule SetTriv, erule State_welldef_D_Heap_ObjIDs) apply (simp add: ObjIDs_def)
     apply clarsimp
    apply clarsimp
    apply (rule_tac x=bb in exI, clarsimp)
     apply (erule AL_domI)
apply clarsimp
  apply (simp add: Renames_STATE_def, clarsimp)
  apply (drule MapHP_D_right) apply assumption apply clarsimp
  apply (drule  Map_Fields_D_right, assumption) apply clarsimp
  apply (drule map_composeD3) apply clarsimp
  apply (frule InvvD_Some)
  apply (drule_tac x=ca and y=ba in inj_onD, simp)
    apply (rule SetTriv) apply (erule AL_domI) apply (erule State_welldef_D_Heap_ObjIDs)
    apply (subgoal_tac "ba:AL_dom N", drule_tac d=ba in AL_domD, clarsimp)
      apply (drule MapN_TypePreserving)
      apply (drule TypePreserving_D, assumption) apply assumption
      apply (subgoal_tac "d:AL_dom K") prefer 2 apply (erule AL_domI)
      apply (drule SetTriv, erule State_welldef_D_Heap_ObjIDs) apply (simp add: ObjIDs_def)
     apply clarsimp
    apply clarsimp
  apply (rule_tac x=ca in exI, clarsimp)
done

lemma Ren_ValuesRepresented2a:
  "\<lbrakk> (N, f, L) \<in> MapN; inj_on f (ObjIDs N);  State_welldef (S,\<Gamma>,H) N; State_welldef (T, \<Delta>, K) L;
     Renames_STATE (S,\<Gamma>, H) f (T, \<Delta>, K); AL_dom L = ran f; AL_dom N = dom f; c: AL_dom L\<rbrakk>
  \<Longrightarrow> ValuesRepresented c (T, \<Delta>, emp) s (map_compose I (Invv f))
          \<subseteq> {u . \<exists>d. f d = Some c \<and> u \<in> ValuesRepresented d (S,\<Gamma>, emp) s I}"
apply (simp add: ValuesRepresented_def, clarsimp)
apply (case_tac s, clarsimp)
apply (erule disjE, clarsimp)
  apply (simp add: Renames_STATE_def, clarsimp)
  apply (frule MAP_OPSTACK_length) apply clarsimp
  apply (frule_tac n=n in MAP_OPSTACK_lookupR) apply simp apply simp apply clarsimp
  apply (rule_tac x="S!n" in exI, clarsimp) apply (erule_tac x=n in allE, clarsimp)
apply (erule disjE, clarsimp)
  apply (simp add: Renames_STATE_def, clarsimp)
  apply (drule MAP_STORE_D_right) apply assumption apply clarsimp
  apply (rule_tac x=ca in exI, clarsimp)
apply (erule disjE, clarsimp) apply (simp add: AL_dom_emp)
apply clarsimp apply (simp add: AL_emp1)
done

lemma Renames_STATE_DOM1: "Renames_STATE (S,\<Gamma>,H) f (T, \<Delta>, K) \<Longrightarrow> DOM (T, \<Delta>, K) \<subseteq> Img f (DOM (S,\<Gamma>,H))"
apply (simp add: Renames_STATE_def DOM_def, clarsimp)
apply (simp add: Renames_STATE_def DOM_def MAP_OPSTACK_set_Img MAP_STORE_cod_Img MapHP_dom)
  apply (rule, simp add: Img_def, clarsimp)  apply (rule_tac x=s in exI, simp)
  apply (rule, simp add: Img_def, clarsimp)  apply (rule_tac x=s in exI, simp)
  apply (rule, simp add: Img_def, clarsimp)  apply (rule_tac x=s in exI, simp)
  apply (rule SetTriv101)  apply (erule MapHP_AbsFields_Img)  
    apply (simp add: Img_def, clarsimp)  apply (rule_tac x=s in exI, simp)
done

lemma Renames_STATE_DOM2: "\<lbrakk>Renames_STATE (S,\<Gamma>,H) f (T, \<Delta>, K); inj_on f (AL_dom H)\<rbrakk> \<Longrightarrow> Img f (DOM (S,\<Gamma>,H)) \<subseteq>  DOM (T, \<Delta>, K)"
apply (simp add: Renames_STATE_def DOM_def, clarsimp)
  apply (simp add: MAP_OPSTACK_set_Img MAP_STORE_cod_Img MapHP_dom Img_def, clarsimp)
  apply (erule disjE) apply (rule_tac x=s in exI, simp)
  apply (erule disjE) apply (erule_tac x=s in allE, erule impE, assumption, simp)
  apply (erule disjE) apply (erule_tac x=s in allE, erule impE, assumption, simp)
  apply (drule  MapHP_AbsFields_Img2) apply assumption apply (simp add: Img_def)
done

lemma Renames_STATE_DOM: "\<lbrakk>Renames_STATE (S,\<Gamma>,H) f (T, \<Delta>, K); inj_on f (AL_dom H)\<rbrakk> \<Longrightarrow> Img f (DOM (S,\<Gamma>,H)) = DOM (T, \<Delta>, K)"
apply rule apply (erule Renames_STATE_DOM2, assumption) apply (erule Renames_STATE_DOM1)
done


lemma MapN_D_dom_ran:"\<lbrakk>(N,f,N'):MapN;  AL_dom N \<subseteq> dom f\<rbrakk> \<Longrightarrow> AL_dom N' \<subseteq> ran f"
apply (drule  MapN_AL_Aux4)
apply clarsimp apply (rotate_tac -2, erule thin_rl, simp add: Img_def, clarsimp)
apply (erule ranI)
done

lemma Ren_ValuesRepresented3:
"\<lbrakk>(N, f, L) \<in> MapN; State_noDangColours (S, \<Gamma>, H) N; State_welldef (S, \<Gamma>, H) N; inj_on f (ObjIDs N); AL_dom N \<subseteq> dom f;
        Img f (DOM (S, \<Gamma>, H)) \<subseteq> DOM (T, \<Delta>, K); State_typecorrect L (T, \<Delta>, K) (ops,s,h) I; (S, f, T) \<in> MAP_OPSTACK; (\<Gamma>, f, \<Delta>) \<in> MAP_STORE;
        (H, f, K) \<in> MapHP; length a = length T; DOM (T, \<Delta>, K) \<inter> ObjIDs L \<subseteq> dom I; inj_on I (AL_dom K); c \<in> DOM (S, \<Gamma>, H); f c = Some y;
        ValuesRepresented y (T, \<Delta>, K) (ops,s,h) I = {v}\<rbrakk>
       \<Longrightarrow> ValuesRepresented y (T, \<Delta>, K) (ops,s,h) I \<subseteq> ValuesRepresented c (S, \<Gamma>, H) (ops,s,h) (map_compose I f)"
      apply (simp add: DOM_def)
      apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
      apply (erule disjE, simp add: set_conv_nth, clarsimp) apply (frule MAP_OPSTACK_length) apply clarsimp
        apply (drule_tac n=i in MAP_OPSTACK_lookupL) apply assumption apply simp apply clarsimp 
          apply (subgoal_tac "ops!i : ValuesRepresented (T ! i) (T, \<Delta>, K) (ops,s,h) I", clarsimp)
          apply (rotate_tac -6, erule thin_rl, erule thin_rl) 
          apply (simp add: ValuesRepresented_def, clarsimp) apply (erule_tac x=i in allE, clarsimp)
      apply (erule disjE, drule AL_codD, clarsimp) 
        apply (drule MAP_STORE_D_left) apply assumption apply clarsimp apply (erule_tac x=aa in allE, clarsimp)
          apply (case_tac "s\<down>aa", simp add: State_typecorrect_def Store_typecorrect_def, (erule conjE)+) apply (erule_tac x=aa in allE, clarsimp)
                apply (rotate_tac -1, erule_tac x=y in allE) apply fast apply clarsimp
          apply (subgoal_tac "aaa : ValuesRepresented y (T, \<Delta>, K) (ops,s,h) I", clarsimp)
          apply (rotate_tac -7, erule thin_rl)
          apply (simp add: ValuesRepresented_def, clarsimp)
      apply (erule disjE) apply (frule AL_domD, clarsimp)
          apply (drule MapHP_D_left) apply (erule inj_on_subset) apply (erule State_welldef_D_Heap_ObjIDs)
            apply assumption apply clarsimp
          apply (erule_tac x=c in allE, clarsimp)
          apply (simp add: State_typecorrect_def Heap_typecorrect_def, clarsimp)
          apply (erule_tac x=y in allE, erule impE, erule AL_domI) 
          apply (simp add: HeapAbstractsAt_def, clarsimp)
          apply (subgoal_tac "RVal(Loc ya):ValuesRepresented y (T, \<Delta>, K) (ops,s,h) I", clarsimp)
            apply (simp add: map_compose_def)
          apply (rotate_tac -16, erule thin_rl)
          apply (simp add: ValuesRepresented_def, clarsimp) apply (erule AL_domI)
      apply (simp add: AbsFields_expand, clarsimp)
          apply (drule MapHP_D_left) apply (erule inj_on_subset) apply (erule State_welldef_D_Heap_ObjIDs)
            apply assumption apply clarsimp
          apply (drule Map_Fields_D_left, assumption) apply clarsimp
          apply (erule_tac x=d in allE, clarsimp)
          apply (erule_tac x=fa in allE, clarsimp)
          apply (simp add: State_typecorrect_def Heap_typecorrect_def, clarsimp)
          apply (erule_tac x=fc in allE, erule impE, erule AL_domI) 
          apply (simp add: HeapAbstractsAt_def, clarsimp)
          apply (erule_tac x=E in allE, erule_tac x=Ga in allE, erule_tac x=ya in allE, clarsimp)
          apply (erule impE) apply (simp add: map_compose_def) 
          apply (simp add: Fields_typecorrect_def)
          apply (erule_tac x=fa in allE, clarsimp)
          apply (subgoal_tac "va:ValuesRepresented y (T, \<Delta>, K) (ops,s,h) I", clarsimp)            
          apply (rotate_tac -19, erule thin_rl)
          apply (simp add: ValuesRepresented_def, clarsimp)
done

lemma Ren_StateStateAbstr:
  "\<lbrakk> StateSatisfiesAbstraction s (T, \<Delta>, K) L I; (N, f, L) \<in> MapN; 
     Renames_STATE (S,\<Gamma>,H) f (T, \<Delta>, K); State_noDangColours (S,\<Gamma>,H) N; 
     State_welldef (S, \<Gamma>, H) N;  inj_on f (ObjIDs N); AL_dom N \<subseteq> dom f\<rbrakk>
   \<Longrightarrow> StateSatisfiesAbstraction s (S, \<Gamma> , H) N (map_compose I f)"
apply (frule Renames_STATE_DOM2) apply (erule inj_on_subset) apply (erule State_welldef_D_Heap_ObjIDs)
apply (simp add: StateSatisfiesAbstraction_def  Renames_STATE_def, clarsimp)
apply (case_tac s, clarsimp)
apply (rule, simp add: State_typecorrect_def, clarsimp)
  apply rule apply (erule  Ren_OPSTACK_tc, assumption+)
  apply rule apply (erule  Ren_STORE_tc, assumption+)
  apply (erule Ren_Heap_tc, assumption+)
apply (rule, simp add: uniqueValues_def, clarsimp)
  apply (case_tac "c:dom f", clarsimp)
    apply (erule_tac x=y in allE, erule impE)
    apply (rule SetTriv) prefer 2 apply assumption apply (simp add: Img_def) apply (rule_tac x=c in exI, simp)
    apply (erule exE)
    apply (rule_tac x=v in exI)
    apply (rule, rule SetTriv101) apply (rule_tac T=T and \<Delta>=\<Delta> and K=K in Ren_ValuesRepresented) 
                                    apply assumption apply assumption apply assumption
                                    apply (simp add: Renames_STATE_def) apply assumption
          apply simp
    apply (rule_tac Y=" ValuesRepresented y (T, \<Delta>, K) (a, aa, b) I" in SetTriv101) apply simp
      apply (erule  Ren_ValuesRepresented3, assumption+)
  apply clarsimp apply (drule_tac x=c and Y="AL_dom N" in SetTriv)  apply (simp add: State_welldef_contract) apply fastsimp
apply (rule, drule MAP_OPSTACK_length) apply simp
apply (rule, clarsimp)
  apply (subgoal_tac "x:dom f") prefer 2 apply (erule_tac X="ObjIDs N" in SetTriv) apply (rule SetTriv101, rule ObjIDs_in_Dom) apply assumption
  apply (drule domD, clarsimp) 
  apply (simp add: ObjIDs_def, clarsimp)
  apply (frule MapN_D_left) apply assumption apply clarsimp
  apply (frule MapN_TypePreserving)
  apply (subgoal_tac "ba : DOM (T, \<Delta>, K) \<inter> ObjIDs L")
    apply (drule_tac g=I and f=f in map_composeD1) apply clarsimp apply (rule_tac m=I in domD) apply (rule SetTriv) prefer 2 apply assumption apply simp 
  apply (simp add: ObjIDs_def)
  apply (rule SetTriv) prefer 2 apply assumption apply (simp add: Img_def) apply (rule_tac x=x in exI, simp)
apply (simp (no_asm) add: inj_on_def, clarsimp)
  apply (frule_tac c=x in State_welldef_lookupHeap1, assumption) 
  apply (frule_tac c=y in State_welldef_lookupHeap1, assumption)
  apply (subgoal_tac "x:dom f", drule domD, clarsimp)
  apply (subgoal_tac "y:dom f", drule domD, clarsimp)
  apply (case_tac "ba = bb", clarsimp)
    apply (drule_tac x=x and y=y and A="ObjIDs N" in inj_onD, simp)
      apply (erule SetTriv) apply (erule State_welldef_D_Heap_ObjIDs)
      apply (erule SetTriv) apply (erule State_welldef_D_Heap_ObjIDs)
      apply assumption
    apply (frule_tac a=x and g=I and f=f in map_composeD1) apply clarsimp
    apply (frule_tac a=y and g=I and f=f in map_composeD1) apply clarsimp
    apply (drule MapHP_dom)
    apply (subgoal_tac "ba : AL_dom K") prefer 2 apply (simp add: Img_def) apply (rule_tac x=x in exI, simp)
    apply (subgoal_tac "bb : AL_dom K") prefer 2 apply (simp add: Img_def) apply (rule_tac x=y in exI, simp)
    apply (drule_tac f=I and x=ba and y=bb in inj_onD) apply simp apply assumption apply assumption apply simp
  apply fast
  apply fast
done

lemma Ren_MapHP_exists[rule_format]:
  "bf \<in> AL \<Longrightarrow> (\<forall> KK HH K H. AL_sum KK HH bf \<longrightarrow> AL_dom KK \<inter> AL_dom HH = {} \<longrightarrow> (KK, g, K) \<in> MapHP \<longrightarrow> (HH, g, H) \<in> MapHP \<longrightarrow>
  AL_dom KK \<subseteq> ObjIDs N \<longrightarrow> AL_dom HH \<subseteq> ObjIDs N \<longrightarrow> inj_on g (ObjIDs N) \<longrightarrow> AL_dom N \<subseteq> dom g \<longrightarrow> HP_good KK (AL_dom N) \<longrightarrow>
  HP_good HH (AL_dom N) \<longrightarrow>
  (\<exists> b . b:AL \<and> AL_dom K \<inter> AL_dom H = {} \<and> AL_sum K H b \<and> (bf, g, b) \<in> MapHP))" 
apply (erule AL.induct)
apply clarsimp apply (drule AL_sum_emp3, clarsimp)
  apply (erule MapHP.elims, clarsimp)
    apply (erule MapHP.elims, clarsimp)
      apply (rule_tac x=emp in exI, rule, rule AL_EMP)
      apply (rule, rule AL_sum_emp1)
      apply (rule MapHP_emp)
    apply clarsimp apply (simp add: emp_def upd_def)
  apply clarsimp apply (simp add: emp_def upd_def)
apply clarsimp
apply (frule AL_sum_split) apply (rule AL_update1)
apply (erule disjE)
    apply (frule AL_domI)
    apply (erule_tac x="delete KK x" in allE, erule_tac x=HH in allE)
    apply (erule impE) apply (simp add: AL_sum_def AL_dom_delete AL_dom_upd1) apply clarsimp
                       apply rule apply fast
                       apply (simp (no_asm) add: contained_def, rule)
                       apply clarsimp apply (drule AL_delete6) apply clarsimp
                                      apply (drule_tac c=aa in contained3, assumption) 
                                      apply (drule AL_upd_split)
                                      apply (erule disjE, clarsimp) apply clarsimp
                       apply clarsimp apply (drule_tac c=aa in contained3, assumption) 
                                      apply (drule AL_upd_split)
                                      apply (erule disjE, clarsimp) apply (drule_tac H=HH in AL_domI) apply fast 
                                      apply clarsimp
    apply (erule impE) apply (simp add: AL_sum_def AL_dom_delete AL_dom_upd1) apply clarsimp apply fast
    apply (subgoal_tac "x : dom g", clarsimp) prefer 2 apply (erule SetTriv) apply (erule SetTriv101)
         apply (rule SetTriv101, rule ObjIDs_in_Dom) apply assumption
    apply (frule MapHP_AL_delete2) apply (erule inj_on_subset, assumption) apply assumption apply assumption
    apply (erule_tac x="delete K y" in allE, clarsimp)
    apply (erule_tac x=H in allE, clarsimp)
    apply (erule impE, rule SetTriv101) prefer 2 apply assumption apply (simp add: AL_dom_delete) apply fast
    apply (erule impE) apply (erule_tac H=KK in HP_good_subset) apply (simp add: contained_def, clarsimp)
                                                      apply (drule AL_delete6) apply clarsimp
                                                    apply simp
    apply clarsimp
    apply (frule MapHP_AL) apply assumption apply (erule SetTriv101, rule ObjIDs_in_Dom) apply clarsimp
    apply (drule_tac H=KK in HP_goodD) apply assumption apply clarsimp
    apply (drule_tac N=b in Map_Fields_exists) apply (erule SetTriv101, assumption) apply clarsimp
    apply (rule_tac x="ba[y\<mapsto>(a,Ma)]" in exI)
    apply (rule, rule_tac x=y and y="(a, Ma)" and M="delete ba y" in AL_CONS) apply (erule AL_DEL)
      apply (simp add: AL_dom_delete)
      apply (simp add: upd_def) apply (rule AL_delete_idempotent)
    apply (rule, simp add: Img_def)
      apply (rule, rule, clarsimp) apply (case_tac "s=x", clarsimp) 
                                     apply (drule_tac d=xa in AL_domD, clarsimp) 
                                     apply (drule_tac N=HH in MapHP_D_right) apply assumption apply clarsimp 
                                     apply (case_tac "c=x", clarsimp)
                                       apply (drule_tac d=x and H=HH in AL_domI) apply fast
                                     apply (drule_tac x=x and y=c in inj_onD, simp)
                                       apply (erule SetTriv, assumption) apply (rule SetTriv, erule AL_domI, assumption) apply clarsimp  
                                   apply (case_tac "y=xa", clarsimp) 
                                     apply (drule_tac x=x and y=s in inj_onD, simp)
                                       apply (erule SetTriv, assumption) apply (erule SetTriv, assumption) apply clarsimp 
                                   apply (subgoal_tac "xa: AL_dom (delete K y)", fast) 
                                   apply (simp add: AL_dom_delete)  apply rule apply (rule_tac x=s in exI, simp) apply fast
      apply fast                                   
    apply (rule, simp add: AL_sum_def, clarsimp)
      apply (rule, simp add: AL_dom_upd1 AL_dom_delete) apply (drule MapHP_dom) 
        apply (simp add: Img_def)
        apply (rule, clarsimp) 
          apply (rule, clarsimp) apply (rule_tac x=x in exI, simp)
          apply (rule, clarsimp) apply fast
        apply clarsimp
          apply (rule, rule, clarsimp) 
          apply clarsimp 
    apply (simp (no_asm) add: contained_def, rule)
    apply clarsimp apply (case_tac "aa=y", simp add: AL_update1) apply clarsimp 
                     apply (drule_tac N=KK in  MapHP_D_left) apply (erule inj_on_subset, assumption) apply assumption apply clarsimp
                     apply (erule Map_Fields_unique_Fun_eq) prefer 2 apply assumption apply simp
                   apply (rule AL_update5) apply (erule contained3, erule AL_delete5) apply assumption apply fast
    apply clarsimp apply (case_tac "aa=y", simp add: AL_update1) apply clarsimp 
                     apply (drule MapHP_D_right, assumption) apply clarsimp 
                     apply (drule_tac x=x and y=c in inj_onD, simp) apply (erule SetTriv, assumption)
                        apply (rule SetTriv, erule AL_domI, assumption) apply clarsimp
                     apply (drule_tac H=HH in AL_domI) apply fast
                   apply (rule AL_update5) apply (erule contained3, assumption) apply fast 
    apply (rule MapHP_cons)
      apply fastsimp apply assumption apply assumption apply assumption apply assumption apply simp
apply (frule AL_domI) 
    apply (erule_tac x=KK in allE, erule_tac x="delete HH x" in allE)
    apply (erule impE) apply (simp add: AL_sum_def AL_dom_delete AL_dom_upd1) apply clarsimp
                       apply rule apply (rotate_tac 5) apply (erule thin_rl, erule thin_rl)
                                  apply (rotate_tac 1) apply (erule thin_rl, erule thin_rl) 
                                  apply (rule, rule, clarsimp) apply (case_tac "xa:AL_dom HH", clarsimp) apply clarsimp 
                                    apply fast
                                  apply (rule, clarsimp)
                                    apply (erule disjE) apply (case_tac "xa=x", clarsimp) apply fast apply fast
                                    apply (case_tac "xa=x", clarsimp) apply fast 
                       apply (simp (no_asm) add: contained_def, rule)
                       apply clarsimp apply (drule_tac c=aa in contained3, assumption) 
                                      apply (drule AL_upd_split)
                                      apply (erule disjE, clarsimp) apply (drule_tac H=KK in AL_domI) apply fast 
                                      apply clarsimp
                       apply clarsimp apply (drule AL_delete6) apply clarsimp
                                      apply (drule_tac c=aa in contained3, assumption) 
                                      apply (drule AL_upd_split)
                                      apply (erule disjE, clarsimp) apply clarsimp
    apply (erule impE) apply (simp add: AL_dom_delete) apply fast 
    apply (erule_tac x=K in allE, clarsimp)
    apply (subgoal_tac "x : dom g", clarsimp) prefer 2 apply (erule SetTriv) apply (erule SetTriv101)
         apply (rule SetTriv101, rule ObjIDs_in_Dom) apply assumption
    apply (frule_tac H=HH in MapHP_AL_delete2) apply (erule inj_on_subset, assumption) apply assumption apply assumption
    apply (erule_tac x="delete H y" in allE, clarsimp)
    apply (erule impE) apply (simp add: AL_dom_delete) apply fast 
    apply (erule impE) apply (erule_tac H=HH in HP_good_subset) apply (simp add: contained_def, clarsimp)
                                                      apply (drule AL_delete6) apply clarsimp
                                                    apply simp
    apply clarsimp
    apply (drule_tac H=HH in HP_goodD) apply assumption apply clarsimp
    apply (drule_tac N=b in Map_Fields_exists) apply (erule SetTriv101, assumption) apply clarsimp
    apply (frule_tac N=HH in MapHP_D_left) apply (erule inj_on_subset, assumption) apply assumption apply clarsimp
    apply (frule_tac d=y in AL_domI) 
    apply (rule_tac x="ba[y\<mapsto>(a,Ma)]" in exI)
    apply (rule, rule_tac x=y and y="(a, Ma)" and M="delete ba y" in AL_CONS) apply (erule AL_DEL)
      apply (simp add: AL_dom_delete)
      apply (simp add: upd_def) apply (rule AL_delete_idempotent)
    apply rule apply (drule MapHP_dom) apply (simp add: Img_def)
      apply (rule, rule, clarsimp) apply (case_tac "s=x", clarsimp) apply fast
                                   apply (case_tac "y=xa", clarsimp) 
                                     apply (drule_tac x=x and y=s in inj_onD, simp)
                                       apply (erule SetTriv, assumption) apply (erule SetTriv, assumption) apply clarsimp 
                                   apply (subgoal_tac "xa: AL_dom (delete H y)", fast) 
                                   apply (simp add: AL_dom_delete) apply fast 
      apply fast                                  
    apply (rule, simp add: AL_sum_def, clarsimp)
      apply (rule, simp add: AL_dom_upd1 AL_dom_delete) apply (drule MapHP_dom) 
        apply (simp add: Img_def)
        apply (rule, clarsimp) 
          apply (rule, clarsimp) apply fast
          apply (rule, clarsimp) 
    apply (simp (no_asm) add: contained_def, rule)
    apply clarsimp apply (case_tac "aa=y", simp add: AL_update1) apply clarsimp 
                     apply (drule MapHP_D_right, assumption) apply clarsimp 
                     apply (drule_tac x=x and y=c in inj_onD, simp) apply (erule SetTriv, assumption)
                        apply (rule SetTriv, erule AL_domI, assumption) apply clarsimp
                     apply (drule_tac H=KK in AL_domI) apply fast
                   apply (rule AL_update5) apply (erule contained3, assumption) apply fast 
    apply clarsimp apply (case_tac "aa=y", simp add: AL_update1) apply clarsimp 
                     apply (drule_tac N=HH in MapHP_D_left) apply (erule inj_on_subset, assumption) apply assumption apply clarsimp
                     apply (erule Map_Fields_unique_Fun_eq) prefer 2 apply assumption apply simp
                   apply (rule AL_update5) apply (erule contained3, erule AL_delete5) apply assumption apply fast
    apply (rule MapHP_cons)
      apply fastsimp apply assumption apply assumption apply assumption apply assumption apply simp
done

lemma Ren_fg_Fields[rule_format]:
  "(F, f, G) \<in> Map_Fields \<Longrightarrow> (F \<in> AL \<and> AL_cod F \<subseteq> dom f) \<longrightarrow>(\<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc) \<longrightarrow> (F, g, G) \<in> Map_Fields"
apply (erule Map_Fields.induct)
apply clarsimp apply (rule Map_Fields_emp)
apply clarsimp
  apply (erule impE) apply (frule Map_Fields_AL, simp) apply clarsimp
  apply (subgoal_tac "x:dom f", clarsimp)
  apply (rule SetTriv) prefer 2 apply assumption
  apply (simp add: AL_cod_def) apply clarsimp apply (rule, rule AL_update5, assumption) apply (drule AL_domI) apply fast
apply (erule_tac x=c in allE, clarsimp)
apply (rule Map_Fields_cons) apply fast apply assumption apply assumption apply assumption apply simp
done

lemma Ren_fg_MapHP[rule_format]:
  "(KK, f, K) \<in> MapHP \<Longrightarrow> (\<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc) \<longrightarrow>
         HP_good KK (dom f) \<longrightarrow> (\<forall> L . AL_sum H KK L \<longrightarrow> AL_dom H \<inter> AL_dom KK = {} \<longrightarrow>
         State_noDangColours (S, \<Gamma>, L) N \<longrightarrow> AL_dom N = dom f \<longrightarrow>
        (KK, g, K) \<in> MapHP)"
apply (erule MapHP.induct)
apply clarsimp apply (rule MapHP_emp)
apply clarsimp
  apply (erule impE) apply (erule HP_good_subset) apply (erule contained_upd) apply simp
  apply (erule_tac x="delete L c" in allE)
  apply (erule impE) apply (simp add: AL_sum_def, clarsimp)
                     apply (rule, simp add: AL_dom_upd1 AL_dom_delete) 
                     apply (simp (no_asm) add: contained_def, rule)
                     apply clarsimp apply (drule contained3, assumption)
                       apply (rule AL_delete5) apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast apply assumption
                     apply clarsimp apply (subgoal_tac "a \<noteq> c") 
                                      apply (drule contained3, erule AL_update5a) apply assumption
                                      apply (erule AL_delete5) apply assumption
                                    apply (drule AL_domI) apply (simp add: AL_dom_upd1) apply fast 
  apply (erule impE) apply (simp add: AL_dom_upd1)
  apply (erule impE) apply (simp add: State_noDangColours_def, clarsimp)
                     apply (simp add: AL_dom_delete)
                     apply (rule, rule_tac Y="AL_dom L" in SetTriv101) apply fast apply assumption
                     apply (rule, rule SetTriv101, rule AbsFields_delete) apply assumption
                     apply (rule, rule_tac Y="AL_dom L" in SetTriv101) apply fast apply assumption
                     apply (erule State_good_delete)
  apply (subgoal_tac "g c = Some fc") prefer 2 apply (erule_tac x=c in allE, clarsimp)
  apply (rule MapHP_cons) apply fastsimp apply assumption apply assumption defer apply assumption apply simp
apply (erule Ren_fg_Fields) apply (drule HP_goodD) apply (rule AL_update1) apply assumption
                            apply (erule_tac x=ca in allE, clarsimp)
done

lemma Ren_fg_Map_OPSTACK[rule_format]:
  "(S, f, T) \<in> MAP_OPSTACK \<Longrightarrow> (\<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc) \<longrightarrow>
        (S, g, T) \<in> MAP_OPSTACK"
apply (erule MAP_OPSTACK.induct)
apply clarsimp apply (rule MAP_OPSTACK_emp)
apply (rule, erule impE, assumption)
  apply (erule_tac x=d in allE, clarsimp)
  apply (rule MAP_OPSTACK_cons) apply fastsimp apply assumption apply assumption apply simp
done

lemma Ren_fg_Map_STORE[rule_format]:
  "(s, f, t) \<in> MAP_STORE \<Longrightarrow> (\<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc) \<longrightarrow>
        (s, g, t) \<in> MAP_STORE"
apply (erule MAP_STORE.induct)
apply clarsimp apply (rule MAP_STORE_emp)
apply (rule, erule impE, assumption)
  apply (erule_tac x=c in allE, clarsimp)
  apply (rule MAP_STORE_cons) apply fastsimp apply assumption apply assumption apply assumption apply simp
done

lemma Ren_fg_MapN_contained:
  "\<lbrakk> (ak, f, af) \<in> MapN; (ap, g, bx) \<in> MapN; contained ak ap; (\<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc)\<rbrakk> 
  \<Longrightarrow> contained af bx"
apply (frule_tac N=ap in MapN_TypePreserving)
apply (simp (no_asm) add: contained_def, clarsimp)
apply (drule MapN_D_right, assumption) apply clarsimp
apply (drule contained3, assumption)
apply (erule_tac x=c in allE, clarsimp)
apply (erule_tac f=g in TypePreserving_D) apply assumption apply assumption 
done

lemma Ren_State_welldef2:
  "\<lbrakk> (N, f, L) \<in> MapN; State_welldef (S, \<Gamma>, H) N; 
     Renames_STATE (S, \<Gamma>, H) f (T, \<Delta>, K); inj_on f (ObjIDs N)\<rbrakk>
 \<Longrightarrow> State_welldef (T, \<Delta>, K) L"
apply (simp add: State_welldef_def Renames_STATE_def, clarsimp)
apply (simp add: ObjIDs_def)
apply (frule MapN_TypePreserving)
apply (frule MapN_AL, clarsimp) 
apply (rule, drule MAP_OPSTACK_set_Img, clarsimp)
  apply (erule SetTriv, erule Img_Monotone)
apply (rule, drule MAP_STORE_cod_Img, clarsimp)
  apply (erule SetTriv, erule Img_Monotone)
apply (rule, drule MapHP_dom, clarsimp)
  apply (erule SetTriv, erule Img_Monotone)
apply (rule, drule MapHP_AbsFields_Img)
  apply (erule SetTriv101) apply (erule Img_Monotone)
apply (rule, frule MapHP_dom, clarsimp)
  apply (drule MapN_D_right) apply assumption apply clarsimp
  apply (subgoal_tac "\<exists> d . d: (set S \<union> AL_cod \<Gamma> \<union> AbsFields H) \<and> f d = Some x", clarsimp)
    prefer 2 apply (erule disjE) apply (drule MAP_OPSTACK_set_Img) apply (simp add: Img_def) apply clarsimp apply (rule_tac x=s in exI, simp)
             apply (erule disjE) apply (drule MAP_STORE_cod_Img) apply (simp add: Img_def) apply clarsimp apply (rule_tac x=s in exI, simp)
             apply (drule MapHP_AbsFields_Img) apply (simp add: Img_def) apply (drule SetTriv, assumption) apply clarsimp 
                apply (rule_tac x=s in exI, simp)
             apply (drule_tac x=c and y=d in inj_onD, simp) apply clarsimp
               apply clarsimp apply (subgoal_tac "d:AL_dom N", drule AL_domD, clarsimp) 
                               apply (drule_tac c=d in TypePreserving_D, assumption) apply assumption apply clarsimp
                              apply (rotate_tac -2, erule disjE, erule SetTriv, assumption)
                              apply (rotate_tac -1, erule disjE, erule SetTriv, assumption)
                              apply (erule SetTriv, assumption)
             apply clarsimp
  apply (simp add: Img_def)
    apply (rule_tac x=d in exI, simp) apply (rule SetTriv) prefer 2 apply assumption apply clarsimp
apply (rule, clarsimp)
  apply (drule AL_domD, clarsimp)
  apply (drule MapHP_D_right) apply assumption apply clarsimp
  apply (drule_tac d=c in AL_domI)
  apply (drule_tac x=c and Y="{c. \<exists>C . N\<down>c = Some (classTP C)}" in SetTriv) apply assumption apply clarsimp
  apply (drule TypePreserving_D) apply assumption apply assumption apply clarsimp
apply (simp add: State_good_def) apply clarsimp
  apply (drule MAP_STORE_AL) apply simp
  apply (frule MapHP_AL2) apply assumption apply assumption apply simp
done

lemma Ren_Fields_tc2:
   "\<lbrakk> (N, f, L) \<in> MapN; (F, f, G) \<in> Map_Fields; Fields_typecorrect N F Ga\<rbrakk>
    \<Longrightarrow> Fields_typecorrect L G Ga"
apply (simp add:  Fields_typecorrect_def, clarsimp)
apply (frule MapN_TypePreserving)
apply (frule Map_Fields_D_right) apply assumption apply clarsimp 
apply (erule_tac x=fa in allE, clarsimp)
apply (frule_tac c=ca in TypePreserving_D) apply assumption apply assumption apply clarsimp
done

lemma MAP_OPSTACK_existsRev[rule_format]: 
"State_welldef (T, \<Delta>, K) N \<longrightarrow> (L, f, N) \<in> MapN \<longrightarrow> (\<exists> S . (S,f,T):MAP_OPSTACK \<and> set S \<subseteq> AL_dom L)"
apply (induct T)
apply clarsimp
  apply (rule_tac x="[]" in exI, rule, rule MAP_OPSTACK_emp)
  apply simp
apply clarsimp
  apply (erule impE) apply (erule State_welldef_Tail) apply clarsimp
  apply (drule_tac n=0 in State_welldef_OPS_lookup) apply simp apply clarsimp
  apply (drule MapN_D_right) apply assumption apply clarsimp
  apply (rule, rule, rule MAP_OPSTACK_cons) 
    prefer 4 apply fastsimp prefer 3 apply assumption prefer 2 apply assumption apply simp
    apply (drule_tac d=c in AL_domI) apply fastsimp
done

lemma MAP_STORE_existsRev[rule_format]: 
"\<Delta> : AL \<Longrightarrow> State_welldef (T, \<Delta>, K) N \<longrightarrow> (L, f, N) \<in> MapN \<longrightarrow> (\<exists> \<Gamma> . (\<Gamma>,f,\<Delta>):MAP_STORE \<and> \<Gamma> : AL \<and> AL_cod \<Gamma> \<subseteq> AL_dom L)"
apply (erule AL.induct)
apply clarsimp 
  apply (rule_tac x=emp in exI, rule, rule MAP_STORE_emp)
  apply (simp add: AL_cod_emp) apply (rule AL_EMP)
apply clarsimp
  apply (erule impE) apply (drule_tac x=x in State_welldef_Store_delete) apply (drule AL_notdomD_delete) apply (simp add: upd_def) apply clarsimp
  apply (frule State_welldef_Store_lookup) apply (rule AL_update1) apply clarsimp 
  apply (drule MapN_D_right) apply assumption apply clarsimp
  apply (rule, rule, rule_tac ss=\<Gamma> and tt="delete M x" and x=x and fc=y in MAP_STORE_cons) 
     prefer 5 apply (drule AL_notdomD_delete) apply simp 
     prefer 3 apply assumption
     apply simp 
     apply (drule MAP_STORE_dom) apply simp 
     apply (drule AL_notdomD_delete) apply simp 
  apply (rule, erule AL_UPD)
  apply (drule_tac d=c in AL_domI)
    apply (rule SetTriv101)
      apply (rule AL_cod_upd1) apply fast
done

lemma Renames_STATE_State_welldef_exists_Rev:
  "\<lbrakk>  \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc;  (ak, f, af) \<in> MapN;
      State_noDangColours (as, at, bd) ak; inj_on f (ObjIDs ak); (bf, g, bq) \<in> MapHP; 
      Renames_STATE (as, at, bd) f (ax, ay, bb); State_welldef (S, \<Gamma>, bb) af\<rbrakk>
   \<Longrightarrow> \<exists>S0 \<Gamma>0. State_welldef (S0, \<Gamma>0, bd) ak \<and> Renames_STATE (S0, \<Gamma>0, bd) f (S, \<Gamma>, bb) \<and> Renames_STATE (S0, \<Gamma>0, bf) g (S, \<Gamma>, bq)"
apply (frule_tac T=S in MAP_OPSTACK_existsRev) apply assumption apply (erule exE)+
apply (subgoal_tac "\<Gamma> :AL")
  apply (frule_tac T=S in MAP_STORE_existsRev) apply assumption apply assumption apply (erule exE)+
  apply (subgoal_tac "Renames_STATE (Sa, \<Gamma>', bd) f (S, \<Gamma>, bb)")
  prefer 2 apply (simp add: Renames_STATE_def)
  apply (rule_tac x=Sa in exI, rule_tac x=\<Gamma>' in exI, simp)
  apply rule apply (erule Ren_State_welldef) apply assumption apply assumption
               apply (simp add: State_noDangColours_def  State_good_def)
               apply assumption
  apply (simp add: Renames_STATE_def, clarsimp) 
    apply (rule, erule Ren_fg_Map_OPSTACK) apply simp 
    apply (erule Ren_fg_Map_STORE) apply simp
apply (simp add: State_welldef_def State_good_def)
done

lemma Ren_Invariant:
  "\<lbrakk>\<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {};
         \<forall>c. c \<in> dom f \<longrightarrow>
            Invariant c (bn, bo, bf) \<sigma> I1 ak (as, at, bd) (a, aa, b) (map_compose I f);
         AL_sum bj H bb; 
    State_welldef (bn, bo, bf) ap;
        (ak, f, af) \<in> MapN; (ap, g, bx) \<in> MapN;  contained ak ap; Renames_STATE (bn, bo, bf) g (bu, bv, bq);
         AL_dom ak = dom f;
        AL_dom ap = dom g; AL_dom af = ran f; AL_dom bx = ran g; inj_on f (ObjIDs ak); inj_on g (ObjIDs ap); AL_sum bw H bq; 
        bx \<in> AL; contained af bx; AL_dom bj \<subseteq> AL_dom bw;
    State_welldef (bu, bv, bq) bx; Renames_STATE (as, at, bd) f (ax, ay, bb); State_welldef (as, at, bd) ak; c \<in> ran f\<rbrakk>
       \<Longrightarrow> Invariant c (bu, bv, bq) \<sigma> (map_compose I1 (Invv g)) af (ax, ay, bb) (a, aa, b) I"
apply (subgoal_tac "State_noDangColours (as, at, bd) ak") prefer 2 apply (simp add: State_welldef_def State_noDangColours_def)
apply (simp add: Invariant_def ValRepEQ)
apply (rule, clarsimp)
  apply (drule ranD, clarsimp)
  apply (subgoal_tac "g ba = Some c") prefer 2 apply (erule_tac x=ba in allE, clarsimp)
  apply (subgoal_tac "c:ran g") prefer 2 apply (erule ranI)
  apply (drule f_Invv_f) apply clarsimp
  apply (drule_tac f=f in MapN_TypePreserving)
  apply (subgoal_tac "ba:ObjIDs ak") 
  prefer 2 apply (subgoal_tac "ba:AL_dom ak", drule AL_domD, clarsimp)
           apply (drule TypePreserving_D, assumption) apply assumption
           apply (simp add: ObjIDs_def, clarsimp) 
  apply (frule_tac g=I1 and f="Invv g" in map_composeD1) apply clarsimp
  apply (erule_tac x=ba in allE, erule impE, erule domI) apply clarsimp
  apply (frule_tac g=I and f=f in map_composeD1) apply clarsimp
  apply (subgoal_tac "f x = Some c")
  prefer 2 apply (case_tac "x:dom f") apply (drule domD, clarsimp) 
           apply (drule_tac x=c and y=c in SetTriv106) 
             apply (simp add: Img_def) apply (rule_tac x=x in exI, simp) apply (erule domI)
             apply (simp add: Img_def) apply (rule_tac x=ba in exI, simp) apply (erule domI)
           apply simp
  apply (drule_tac f=f and x=x and y=ba in inj_onD, simp)     
    apply (subgoal_tac "x:AL_dom ak", drule AL_domD, clarsimp)
           apply (drule TypePreserving_D, assumption) apply assumption
           apply (simp add: ObjIDs_def) 
      apply clarsimp
    apply assumption
  apply clarsimp
apply rule 
      apply (drule ranD, clarsimp) 
      apply (subgoal_tac "{ d . g d = Some c } = { d . f d = Some c} ")
      prefer 2 apply (rule, clarsimp) 
                 apply (case_tac "xa:dom f") apply clarsimp
                 apply (subgoal_tac "xa:dom g - dom f") prefer 2 apply clarsimp
                 apply (subgoal_tac "c : Img g (dom g - dom f)") prefer 2 apply (simp add: Img_def) apply (rule_tac x=xa in exI, clarsimp)
                 apply (subgoal_tac "c : Img g (dom f)") apply (drule_tac x=c and y=c in SetTriv106) apply assumption apply assumption apply simp
                 apply (simp add: Img_def) apply (rule_tac x=ba in exI, clarsimp)
               apply (rule, clarsimp)
      apply (rule_tac X="{ u . \<exists> d . g d = Some c \<and> u : ValuesRepresented d (bn, bo, bf) \<sigma> I1}" in SetTriv)
        apply (erule SetTriv)
          apply (erule Ren_ValuesRepresented2) apply assumption apply assumption apply assumption apply assumption
                   apply assumption apply assumption apply (erule_tac x=ba in allE, clarsimp) apply (erule ranI)
      apply clarsimp
        apply (subgoal_tac "d:dom f") prefer 2 apply clarsimp apply (subgoal_tac "d:{d. f d = Some c}", clarsimp) 
                                                              apply (subgoal_tac "d:{d. g d = Some c}", clarsimp) apply fast  
        apply (erule_tac x=d in allE, erule impE, assumption)
        apply (erule conjE)+
        apply (drule SetTriv, assumption) 
        apply (erule SetTriv) apply (rule_tac N=ak in Ren_ValuesRepresented) 
                                          apply assumption
                                          apply assumption
                                          apply assumption
                                          apply assumption
                                          apply (drule_tac m=f in domD, clarsimp) 
done

lemma Renames_noDangColours:
  "\<lbrakk> (N_Na, f ++ fa, ffa_N_Na) \<in> MapN; renUniState ((S, \<Gamma>, H), N) f ((fS, f\<Gamma>, fH), fN);
     Renames_STATE (S, \<Gamma>, H_Ha) (f ++ fa) (fS, f\<Gamma>, fH_HHmap);State_noDangColours (fS, f\<Gamma>, fH_HHmap) ffa_N_Na; 
     AL_sum N Na N_Na; AL_sum H Ha H_Ha; AL_dom Ha \<subseteq> ObjIDs N_Na; HP_good Ha (AL_dom N_Na); H_Ha \<in> AL\<rbrakk>
       \<Longrightarrow> State_noDangColours (S, \<Gamma>, H_Ha) N_Na "
apply (simp add: State_noDangColours_def renUniState_def Renames_STATE_def, clarsimp)
apply (rule, simp add: AL_sum_def, clarsimp) apply (drule SetTriv, assumption) apply clarsimp
apply (rule, simp add: AL_sum_def, clarsimp) apply (drule SetTriv, assumption) apply clarsimp
apply (rule, simp add: AL_sum_def, clarsimp) apply rule 
  apply (erule SetTriv101, fast)
  apply (erule SetTriv101) apply (rule SetTriv101) apply (rule ObjIDs_in_Dom) apply (simp add: AL_sum_def)
apply (rule, rule SetTriv101) apply (erule AbsFields_sum) 
  apply (simp add: AL_sum_def, clarsimp)  apply rule 
  apply (erule SetTriv101, fast)
  apply (erule HP_good_AbsFields)
apply (rule, simp add: AL_sum_def, clarsimp) 
  apply (erule SetTriv) apply (erule SetTriv101, erule contained_ObjIds_subset) 
apply (rule, simp add: State_good_def) apply (simp add: HP_good_def, clarsimp) 
  apply (drule AL_sum_split, assumption)
    apply (erule disjE) 
      apply (erule_tac x=c in allE, erule_tac x=C in allE, erule_tac x=F in allE, erule impE, assumption)
      apply (erule conjE, rule, assumption) apply (erule SetTriv101) apply (simp add: AL_sum_def) apply fast
    apply (erule_tac x=c in allE, erule_tac x=C in allE, erule_tac x=F in allE, erule impE, assumption) apply simp
apply (drule MapN_AL_Aux3, simp)
done

lemma MapN_f_extend_fresh[rule_format]:
  "(N, f, M) \<in> MapN \<Longrightarrow> AL_dom N \<subseteq> dom f \<longrightarrow>  AL_dom N \<inter> X = {} \<longrightarrow> (N, \<lambda>y. if y = freshID (X\<union> dom f) then Some x else f y, M) \<in> MapN"
apply (erule MapN.induct)
apply clarsimp apply (rule MapN_emp)
apply clarsimp apply (erule impE) apply (simp add: AL_dom_upd1) 
               apply (erule impE) apply (simp add: AL_dom_upd1) 
               apply (rule MapN_cons) apply simp apply assumption 
                 apply assumption 
                 prefer 3 apply simp
                 apply clarsimp apply (drule_tac m=f in domI)  apply (subgoal_tac "freshID (X\<union> dom f) \<notin> X\<union> dom f", fast) apply (rule fresh_ID_fresh) 
                 apply clarsimp
done

lemma MapN_InvExists:"M:AL \<Longrightarrow> \<exists> N f . (N,f,M):MapN \<and> AL_dom N = dom f \<and> AL_dom M = ran f \<and> AL_dom N \<inter> X = {} \<and> inj_on f (dom f)"
apply (erule AL.induct)
apply (rule_tac x=emp in exI) apply (rule_tac x="\<lambda> x. None" in exI) 
  apply (rule, rule MapN_emp) 
  apply (simp add: AL_dom_emp)  
apply clarsimp
  apply (rule_tac x="upd Na (freshID (X \<union> dom f)) y" in exI)
  apply (rule_tac x="\<lambda> y . if y = freshID (X\<union> dom f) then Some x else f y" in exI)
  apply (rule, rule_tac fM=M in MapN_cons)
     apply simp 
     apply (subgoal_tac "freshID (X\<union> dom f) \<notin> X\<union> dom f", fast) apply (rule fresh_ID_fresh) 
     apply (erule MapN_f_extend_fresh) apply simp apply simp
     apply simp 
     apply clarsimp apply (drule AL_domI) apply simp 
     apply simp 
  apply (rule, simp add: AL_dom_upd1) 
    apply (rule, clarsimp)
    apply (rule, clarsimp)
    apply (rule, clarsimp)
    apply (rule, clarsimp)
  apply (rule, simp add: AL_dom_upd1) 
    apply (rule, clarsimp)
    apply rule apply (simp add: ran_def) apply clarsimp apply (drule ranD, clarsimp) apply (rule_tac a=b in ranI) apply clarsimp
               apply (drule_tac m=f in domI) apply (subgoal_tac "freshID (X\<union> dom f) \<notin> X\<union> dom f", fast) apply (rule fresh_ID_fresh)
    apply clarsimp apply (drule ranD, clarsimp) 
      apply (case_tac "b = freshID (X \<union> dom f)", clarsimp)
      apply clarsimp apply (drule_tac m=f in ranI) apply simp
  apply (rule, rule,rule, clarsimp) apply (simp add: AL_dom_upd1)
      apply (erule disjE) apply (subgoal_tac "freshID (X\<union> dom f) \<notin> X\<union> dom f", fast) apply (rule fresh_ID_fresh) apply fast  
    apply fast
  apply (simp (no_asm) add: inj_on_def, clarsimp)
    apply (rule, clarsimp) apply (drule_tac m=f in ranI) apply simp
    apply clarsimp
    apply (rule, clarsimp) apply (drule_tac m=f in ranI) apply simp
    apply clarsimp  
      apply (erule_tac x=xa and y=ya in inj_onD, simp) 
      apply (erule_tac m=f in domI) apply (erule_tac m=f in domI) 
done

lemma MapN_extend_f[rule_format]:"(N,f,M):MapN \<Longrightarrow> (\<forall> x . x:AL_dom N \<longrightarrow> f x = g x) \<longrightarrow> (N,g,M):MapN"
apply (erule MapN.induct)
apply clarsimp apply (rule MapN_emp)
apply clarsimp apply (erule impE, clarsimp)  apply (erule_tac x=xa in allE, erule mp) apply (simp add: AL_dom_upd1)
  apply (rule MapN_cons)
    apply simp
    apply assumption
    apply assumption
    apply (erule_tac x=x in allE, erule impE, simp add: AL_dom_upd1) apply fastsimp
    apply simp
    apply simp
done

(*This version worked in V21 but doesn't seem to hold with UnqueValues!
lemma Ren_StateStateAbstr2:
  "\<lbrakk> StateSatisfiesAbstraction (ops,s, h) (S,\<Gamma>,H) N I;
     State_welldef (T, \<Delta>, K) NN; 
     (N, g, NN) \<in> MapN;  (S, g, T) \<in> MAP_OPSTACK;
     (\<Gamma>, g, \<Delta>) \<in> MAP_STORE;
     AL_dom N = dom g;
     inj_on g (ObjIDs N); (H, g, K) \<in> MapHP; State_welldef (S,\<Gamma>,H) N \<rbrakk>
   \<Longrightarrow> StateSatisfiesAbstraction (ops,s, h) (T, \<Delta>, K) NN (map_compose I (Invv g))"
apply (frule MapN_D_dom_ran) apply simp
             apply (simp add:  StateSatisfiesAbstraction_def, clarsimp )
             apply (rule, simp add: State_typecorrect_def, clarsimp)
               apply (rule, simp add: Opstack_typecorrect_def, clarsimp)
                 apply (frule_tac S=S in MAP_OPSTACK_length, clarsimp) 
                 apply (erule_tac x=n in allE, clarsimp)
                 apply (drule_tac S=S in MAP_OPSTACK_lookupL, assumption) apply simp apply clarsimp
                 apply (frule_tac f=g in MapN_TypePreserving)
                 apply (drule TypePreserving_D, assumption) apply assumption apply clarsimp
               apply (rule, simp add: Store_typecorrect_def, clarsimp)
                 apply (frule_tac s=\<Gamma> in MAP_STORE_D_right, assumption) apply clarsimp
                 apply (erule_tac x=x in allE, clarsimp) 
                 apply (drule MAP_STORE_D_left, assumption) apply clarsimp
                 apply (frule_tac f=g in MapN_TypePreserving)
                 apply (drule TypePreserving_D, assumption) apply assumption apply clarsimp 
               apply (simp add: Heap_typecorrect_def, clarsimp)
                 apply (drule AL_domD, clarsimp)
                 apply (frule_tac N=H in MapHP_D_right, assumption) apply clarsimp
                 apply (erule_tac x=ca in allE, erule impE, erule AL_domI) apply clarsimp
                 apply (frule_tac N=N in MapN_TypePreserving)
                 apply (drule TypePreserving_D) apply assumption apply assumption apply clarsimp
                 apply rule prefer 2 apply clarsimp apply (subgoal_tac "c:ran g") prefer 2 apply (erule ranI)
                                                    apply (drule f_Invv_f) apply clarsimp
                                                    apply (drule_tac g=I and f="Invv g" in  map_composeD1) apply clarsimp
                                                    apply (subgoal_tac "x : DOM (S,\<Gamma>,H) \<inter> ObjIDs N", drule SetTriv, assumption) apply clarsimp
                                                    apply (subgoal_tac "x:AL_dom N") prefer 2 apply clarsimp
                                                    apply (drule AL_domD, clarsimp)
                                                    apply (drule_tac f=g in MapN_TypePreserving)
                                                    apply (drule_tac c=x in TypePreserving_D) apply assumption apply assumption apply clarsimp
                                                    apply (simp add: ObjIDs_def)
                                                    apply (drule_tac f=g and x=x and y=ca in inj_onD) apply simp
                                                      apply (simp add: ObjIDs_def) apply (simp add: ObjIDs_def) apply clarsimp
                                                      apply (simp add: DOM_def) apply (drule_tac d=ca in AL_domI) apply simp
                 apply (simp add: HeapAbstractsAt_def, clarsimp)
                   apply (subgoal_tac "ca : AL_dom N") prefer 2 apply clarsimp apply (drule AL_domD, clarsimp)
                     apply (frule_tac f=g in MapN_TypePreserving)
                     apply (drule_tac c=ca in TypePreserving_D) apply assumption apply assumption apply clarsimp
                     apply (drule map_composeD3) apply clarsimp apply (drule InvvD_Some)
                       apply (drule_tac f=g and x=ca and y=ba in inj_onD, simp)
                         apply (simp add: ObjIDs_def)
                         apply (subgoal_tac "ba:AL_dom N") prefer 2 apply clarsimp
                           apply (drule AL_domD, clarsimp)
                           apply (drule_tac f=g in MapN_TypePreserving)
                           apply (drule_tac c=ba in TypePreserving_D) apply assumption apply assumption apply clarsimp
                           apply (simp add: ObjIDs_def)
                         apply clarsimp
                     apply (erule Ren_Fields_tc2, assumption) apply assumption
             apply (rule, simp add: uniqueValues_def, clarsimp)
(-               apply (subgoal_tac "c:AL_dom NN", drule AL_domD, clarsimp)               
               apply (drule MapN_D_right, assumption) apply clarsimp-)
               apply (simp add: DOM_def)
               apply (erule disjE) apply (simp add: set_conv_nth) apply clarsimp
                   apply (frule MAP_OPSTACK_lookupR) apply assumption apply simp apply clarsimp
                   apply (erule_tac x="S!i" in allE, clarsimp) apply (erule impE) apply (rule_tac x=i in exI, simp) 
                     apply (frule_tac S=S in MAP_OPSTACK_length) apply simp apply clarsimp
                apply (rule_tac x=v in exI, rule)
                  apply (simp (no_asm) add: ValuesRepresented_def, clarsimp)
                  apply (erule disjE) apply clarsimp apply (subgoal_tac "")
               apply (drule SetTriv, rule_tac S=S and \<Gamma>=\<Gamma> and H=H and f=g in Renames_STATE_DOM1) apply (simp add: Renames_STATE_def)
               apply (simp add: Img_def, clarsimp)
               apply (erule_tac x=sa in allE, clarsimp)
               apply (rule_tac x=v in exI, rule)
                 apply (simp (no_asm) add:ValuesRepresented_def, clarsimp)
                 apply (erule disjE, clarsimp) 
                   apply (simp add: DOM_def) 
                   apply (frule_tac S=S in MAP_OPSTACK_length) apply simp
                   apply (drule MAP_OPSTACK_lookupL) apply assumption apply simp apply clarsimp
                     apply (subgoal_tac "ops!n : ValuesRepresented sa (S, \<Gamma>, H) (ops, s, h) I", clarsimp)
                     apply (rotate_tac -4, erule thin_rl, simp add: ValuesRepresented_def, clarsimp)
                     apply (erule_tac x=n in allE, clarsimp)
                   apply clarsimp
             apply (rule, drule_tac S=S in MAP_OPSTACK_length) apply simp
             apply (rule,  clarsimp)
               apply (subgoal_tac "x: ran g")
               prefer 2 apply (drule_tac x=x and X="ObjIDs NN" in SetTriv) apply (rule ObjIDs_in_Dom) apply (erule SetTriv, assumption)
               apply (frule f_Invv_f) apply clarsimp
               apply (frule_tac g=I and f="Invv g" in map_composeD1) apply clarsimp
               apply (subgoal_tac "xa:DOM (S, \<Gamma>, H) \<inter> ObjIDs N", drule SetTriv, assumption) apply clarsimp
               apply clarsimp 
                   apply (subgoal_tac "xa:AL_dom N") prefer 2 apply clarsimp 
                   apply (drule AL_domD, clarsimp)
                   apply (drule_tac f=g in MapN_TypePreserving)
                   apply (frule TypePreserving_D, assumption) apply assumption apply (simp add: ObjIDs_def, clarsimp)
                   apply (drule_tac x=x in SetTriv) apply (rule_tac S=S and \<Gamma>=\<Gamma> and H=H and f=g in Renames_STATE_DOM1) (-apply (rule_tac S=bn and \<Gamma>=bo and H=bf and f=g in Renames_STATE_DOM1) -)
                                                      apply (simp add: Renames_STATE_def)
                   apply (simp add: Img_def, clarsimp)
                   apply (subgoal_tac "sa:AL_dom N")
                     apply (drule AL_domD, clarsimp)
                     apply (frule_tac c=sa in TypePreserving_D, assumption) apply assumption apply clarsimp
                     apply (drule_tac f=g and x=sa and y=xa in inj_onD) apply simp apply simp apply simp apply clarsimp
                   apply clarsimp
             apply (simp (no_asm) add: inj_on_def, clarsimp)
               apply (subgoal_tac "x: ObjIDs NN") prefer 2 apply (erule SetTriv) apply (erule State_welldef_D_Heap_ObjIDs)
               apply (subgoal_tac "y: ObjIDs NN") prefer 2 apply (erule SetTriv) apply (erule State_welldef_D_Heap_ObjIDs)
               apply (subgoal_tac "x:ran g") prefer 2 apply (erule_tac X="ObjIDs NN" in SetTriv) apply (rule SetTriv101, rule ObjIDs_in_Dom, assumption)
               apply (subgoal_tac "y:ran g") prefer 2 apply (erule_tac X="ObjIDs NN" in SetTriv) apply (rule SetTriv101, rule ObjIDs_in_Dom, assumption)
               apply (drule f_Invv_f)
               apply (drule f_Invv_f)
               apply clarsimp
               apply (drule_tac g=I and f="Invv g" in map_composeD1)
               apply (drule_tac g=I and f="Invv g" in map_composeD1)
               apply clarsimp
               apply (subgoal_tac "xa:DOM (S, \<Gamma>, H) \<inter> ObjIDs N", frule SetTriv, assumption) apply clarsimp
                 prefer 2 apply (simp add: ObjIDs_def, clarsimp)
                          apply (subgoal_tac "xa:AL_dom N") prefer 2 apply clarsimp
                          apply (drule_tac H=N in AL_domD, clarsimp)
                          apply (drule_tac f=g in MapN_TypePreserving)
                          apply (frule TypePreserving_D, assumption, assumption) apply clarsimp
                          apply (drule_tac d=x in AL_domD, clarsimp)
                          apply (drule MapHP_D_right, assumption, clarsimp) 
                          apply (subgoal_tac "c:AL_dom N") prefer 2 apply clarsimp
                          apply (drule_tac d=c in AL_domD, clarsimp)
                          apply (frule_tac c=c in TypePreserving_D, assumption) apply assumption apply clarsimp
                          apply (drule_tac f=g and x=xa and y=c in inj_onD) apply simp apply simp apply simp apply clarsimp
                          apply (drule_tac d=c in AL_domI, simp add: DOM_def)
               apply (subgoal_tac "xb:DOM (S, \<Gamma>, H) \<inter> ObjIDs N")
                 prefer 2 apply (simp add: ObjIDs_def, clarsimp)
                          apply (subgoal_tac "xb:AL_dom N") prefer 2 apply clarsimp
                          apply (drule_tac H=N in AL_domD, clarsimp)
                          apply (drule_tac f=g in MapN_TypePreserving)
                          apply (frule_tac c=xb in TypePreserving_D, assumption, assumption) apply clarsimp
                          apply (drule_tac d=y in AL_domD, clarsimp)
                          apply (drule MapHP_D_right, assumption, clarsimp) 
                          apply (subgoal_tac "c:AL_dom N") prefer 2 apply clarsimp
                          apply (drule_tac d=c in AL_domD, clarsimp)
                          apply (frule_tac c=c in TypePreserving_D, assumption) apply assumption apply clarsimp
                          apply (drule_tac f=g and x=xb and y=c in inj_onD) apply simp apply simp apply simp apply clarsimp
                          apply (drule_tac d=c in AL_domI, simp add: DOM_def)
               apply (subgoal_tac "xa=xb", clarsimp) 
               apply (erule_tac f=I in inj_onD) apply assumption
                 apply (drule_tac d=x in AL_domD, clarsimp)
                   apply (drule MapHP_D_right, assumption) apply clarsimp
                     apply (subgoal_tac "xa = c", clarsimp) apply (erule AL_domI)
                     apply (erule_tac f=g in inj_onD, simp)
                       apply assumption 
                       apply (rule SetTriv, erule AL_domI) apply (erule State_welldef_D_Heap_ObjIDs)
                 apply (drule_tac d=y in AL_domD, clarsimp)
                   apply (drule MapHP_D_right, assumption) apply clarsimp
                     apply (subgoal_tac "xb = c", clarsimp) apply (erule AL_domI)
                     apply (erule_tac f=g in inj_onD, simp)
                       apply assumption 
                       apply (rule SetTriv, erule AL_domI) apply (erule State_welldef_D_Heap_ObjIDs)
done
*)

lemma MapN_exists[rule_format]: 
    "N:AL \<Longrightarrow> (\<forall> x fx y. f x = Some fx \<longrightarrow> f y = Some fx \<longrightarrow> x:AL_dom N \<longrightarrow> y:AL_dom N \<longrightarrow> N\<down>x = N\<down>y) \<longrightarrow> 
              AL_dom N \<subseteq> dom f \<longrightarrow> (\<exists> M . (N,f,M):MapN)"
apply (erule AL.induct)
apply clarsimp apply (rule_tac x=emp in exI, rule MapN_emp)
apply (rule, rule, erule impE) apply clarsimp apply (erule_tac x=xa in allE, clarsimp)
                         apply (erule_tac x=ya in allE, clarsimp)
                         apply (erule impE, simp add: AL_dom_upd1)
                         apply (erule impE, simp add: AL_dom_upd1)
                         apply (subgoal_tac "x\<noteq> xa")
                           apply (drule_tac L=M and v=y in AL_update2)
                         apply (subgoal_tac "x\<noteq>ya")
                           apply (drule_tac L=M and v=y in AL_update2) 
                           apply clarsimp
                         apply fast
                         apply fast
  apply (erule impE) apply (rule SetTriv101) prefer 2 apply assumption apply (simp add: AL_dom_upd1) apply fast
  apply (erule exE)
  apply (subgoal_tac "x:dom f", drule domD, erule exE) prefer 2 apply (rule SetTriv) prefer 2 apply assumption apply (simp add: AL_dom_upd1)
    apply (rule, rule MapN_cons, assumption) apply assumption apply assumption apply assumption prefer 2 apply simp
    apply clarsimp
    apply (drule MapN_D_right, assumption) apply clarsimp
    apply (erule_tac x=x in allE, erule_tac x=b in allE, clarsimp)
    apply (erule_tac x=c in allE, clarsimp)
    apply (simp add: AL_dom_upd1) apply (erule impE, erule AL_domI)
    apply (simp add: AL_update1)
    apply (case_tac "x=c", clarsimp) apply (drule_tac d=c in AL_domI) apply simp
    apply (subgoal_tac "M[x\<mapsto>y]\<down>c = M\<down>c", clarsimp)
    apply (erule AL_update2)
done

lemma MapN_sum: "\<lbrakk>(M, f, fM) \<in> MapN; NM:AL; AL_sum N M NM; 
        (\<forall> x fx y. f x = Some fx \<longrightarrow> f y = Some fx \<longrightarrow> x:AL_dom NM \<longrightarrow> y:AL_dom NM \<longrightarrow> NM\<down>x = NM\<down>y); AL_dom NM \<subseteq> dom f;
        (N, f, fN) \<in> MapN\<rbrakk> \<Longrightarrow> (\<exists> fNM . (NM, f, fNM) \<in> MapN \<and> AL_sum fN fM fNM)"
apply clarsimp
apply (drule_tac f=f in MapN_exists) apply fast apply assumption
apply clarsimp
  apply (rule_tac x=Ma in exI, simp add: AL_sum_def)
  apply (rule, drule MapN_AL, drule MapN_AL, drule MapN_AL) apply clarsimp
    apply (simp add: Img_union)
  apply (rule, simp (no_asm) add: contained_def, clarsimp)
    apply (drule MapN_D_right, assumption) apply clarsimp
    apply (drule contained3, assumption)
    apply (drule MapN_D_left, assumption) apply clarsimp
  apply (simp (no_asm) add: contained_def, clarsimp)
    apply (drule MapN_D_right, assumption) apply clarsimp
    apply (drule contained3, assumption)
    apply (drule MapN_D_left, assumption) apply clarsimp
done

lemma MapHP_sum: 
  "\<lbrakk> NM:AL; AL_sum N M NM; (M, f, fM) \<in> MapHP; (N, f, fN) \<in> MapHP; HP_good N X; HP_good M X; X\<subseteq> dom f;
     AL_dom N \<subseteq> dom f;AL_dom M \<subseteq> dom f; inj_on f (AL_dom M); inj_on f (AL_dom N); 
     Img f (AL_dom N) \<inter> Img f (AL_dom M) = {}\<rbrakk> 
  \<Longrightarrow> (\<exists> fNM . (NM, f, fNM) \<in> MapHP \<and> AL_sum fN fM fNM)"
apply (subgoal_tac "inj_on f (AL_dom NM)")
prefer 2 apply (simp(no_asm) add: inj_on_def, clarsimp)
         apply (simp add: AL_sum_def, clarsimp)
         apply (erule disjE) 
           apply (frule SetTriv, assumption, drule domD, clarsimp)
           apply (erule disjE) 
             apply (drule_tac x=x and y=y and A="AL_dom N" in inj_onD) apply simp apply assumption apply assumption apply assumption
           apply (drule_tac x=b and y=b in SetTriv106)
             apply (simp add: Img_def) apply (rule_tac x=x in exI, simp)
             apply (simp add: Img_def) apply (rule_tac x=y in exI, simp)
             apply simp
         apply (frule SetTriv, assumption, drule domD, clarsimp)
         apply (erule disjE) 
           apply (drule_tac x=b and y=b in SetTriv106)
             apply (simp add: Img_def) apply (rule_tac x=y in exI, simp)
             apply (simp add: Img_def) apply (rule_tac x=x in exI, simp)
             apply simp
           apply (drule_tac x=x and y=y and A="AL_dom M" in inj_onD) apply simp apply assumption apply assumption apply assumption
apply (subgoal_tac "HP_good NM X")
prefer 2 apply (simp add: HP_good_def, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE)
           apply (erule_tac x=c in allE, clarsimp)
           apply (erule_tac x=c in allE, clarsimp)
apply (drule_tac f=f in MapHP_exists) 
  apply assumption 
  apply (simp add: AL_sum_def)
  apply clarsimp
  apply (rule_tac x=Ma in exI,simp, simp (no_asm) add: AL_sum_def)
  apply (rule, (drule MapHP_dom)+) apply clarsimp apply (simp add: AL_sum_def Img_union)
  apply (rule, simp add: contained_def, clarsimp)
    apply (drule MapHP_D_right, assumption, clarsimp)
    apply (drule AL_sum3, assumption)
    apply (drule_tac N=NM in MapHP_D_left) apply assumption apply assumption apply clarsimp 
    apply (erule Map_Fields_unique) apply assumption
  apply (simp add: contained_def, clarsimp)
    apply (drule MapHP_D_right, assumption, clarsimp)
    apply (drule AL_sum4, assumption)
    apply (drule_tac N=NM in MapHP_D_left) apply assumption apply assumption apply clarsimp 
    apply (erule Map_Fields_unique) apply assumption
done
lemma MapHP_sum_domf: 
  "\<lbrakk> NM:AL; AL_sum N M NM; (M, f, fM) \<in> MapHP; (N, f, fN) \<in> MapHP; HP_good N (dom f); HP_good M (dom f); 
     AL_dom N \<subseteq> dom f;AL_dom M \<subseteq> dom f; inj_on f (AL_dom M); inj_on f (AL_dom N); 
     Img f (AL_dom N) \<inter> Img f (AL_dom M) = {}\<rbrakk> 
  \<Longrightarrow> (\<exists> fNM . (NM, f, fNM) \<in> MapHP \<and> AL_sum fN fM fNM)"
apply (subgoal_tac "inj_on f (AL_dom NM)")
prefer 2 apply (simp(no_asm) add: inj_on_def, clarsimp)
         apply (simp add: AL_sum_def, clarsimp)
         apply (erule disjE) 
           apply (frule SetTriv, assumption, drule domD, clarsimp)
           apply (erule disjE) 
             apply (drule_tac x=x and y=y and A="AL_dom N" in inj_onD) apply simp apply assumption apply assumption apply assumption
           apply (drule_tac x=b and y=b in SetTriv106)
             apply (simp add: Img_def) apply (rule_tac x=x in exI, simp)
             apply (simp add: Img_def) apply (rule_tac x=y in exI, simp)
             apply simp
         apply (frule SetTriv, assumption, drule domD, clarsimp)
         apply (erule disjE) 
           apply (drule_tac x=b and y=b in SetTriv106)
             apply (simp add: Img_def) apply (rule_tac x=y in exI, simp)
             apply (simp add: Img_def) apply (rule_tac x=x in exI, simp)
             apply simp
           apply (drule_tac x=x and y=y and A="AL_dom M" in inj_onD) apply simp apply assumption apply assumption apply assumption
apply (subgoal_tac "HP_good NM (dom f)")
prefer 2 apply (simp add: HP_good_def, clarsimp)
         apply (drule AL_sum_split, assumption)
         apply (erule disjE)
           apply (erule_tac x=c in allE, clarsimp)
           apply (erule_tac x=c in allE, clarsimp)
apply (drule_tac f=f in MapHP_exists) 
  apply assumption 
  apply (simp add: AL_sum_def)
  apply clarsimp
  apply (rule_tac x=Ma in exI,simp, simp (no_asm) add: AL_sum_def)
  apply (rule, (drule MapHP_dom)+) apply clarsimp apply (simp add: AL_sum_def Img_union)
  apply (rule, simp add: contained_def, clarsimp)
    apply (drule MapHP_D_right, assumption, clarsimp)
    apply (drule AL_sum3, assumption)
    apply (drule_tac N=NM in MapHP_D_left) apply assumption apply assumption apply clarsimp 
    apply (erule Map_Fields_unique) apply assumption
  apply (simp add: contained_def, clarsimp)
    apply (drule MapHP_D_right, assumption, clarsimp)
    apply (drule AL_sum4, assumption)
    apply (drule_tac N=NM in MapHP_D_left) apply assumption apply assumption apply clarsimp 
    apply (erule Map_Fields_unique) apply assumption
done

lemma MapN_rev_injective[rule_format]:
  "(N, f, al) \<in> MapN \<Longrightarrow> 
    \<forall> x fx y . f x = Some fx \<longrightarrow> f y = Some fx \<longrightarrow> x \<in> AL_dom N \<longrightarrow>
               y \<in> AL_dom N \<longrightarrow> N\<down>x=N\<down>y"
apply (erule MapN.induct)
apply (simp add: AL_dom_emp)
apply clarsimp
  apply (simp add: AL_dom_upd1)
  apply (erule disjE, clarsimp)
    apply (erule disjE, clarsimp) 
    apply (drule AL_domD, clarsimp)
    apply (drule MapN_D_left) apply assumption apply clarsimp
    apply (simp add: AL_update1)
    apply (subgoal_tac "M[x\<mapsto>y]\<down>ya = M\<down>ya", clarsimp)
    apply (rule AL_update2) apply (drule AL_domI) apply fast
  apply (erule disjE, clarsimp)
    apply (drule AL_domD, clarsimp)
    apply (drule MapN_D_left) apply assumption apply clarsimp
    apply (simp add: AL_update1)
    apply (subgoal_tac "M[x\<mapsto>y]\<down>xa = M\<down>xa", clarsimp)
    apply (rule AL_update2) apply (drule AL_domI) apply fast
  apply (erule_tac x=xa in allE, clarsimp)
    apply (erule_tac x=ya in allE, clarsimp)
    apply (subgoal_tac "M[x\<mapsto>y]\<down>xa = M\<down>xa", clarsimp)
      apply (subgoal_tac "M[x\<mapsto>y]\<down>ya = M\<down>ya", clarsimp)
    apply (rule AL_update2) apply fast
    apply (rule AL_update2) apply fast
done

lemma MapHP_domf:"(H,f,K):MapHP \<Longrightarrow> AL_dom H \<subseteq> dom f"
apply (erule MapHP.induct)
apply (simp add: AL_dom_emp)
apply clarsimp
  apply (simp add: AL_dom_upd1)
  apply (erule disjE, clarsimp)
  apply (drule SetTriv, assumption) apply clarsimp
done
lemma MapN_domf:"(N,f,M):MapN \<Longrightarrow> AL_dom N \<subseteq> dom f"
apply (erule MapN.induct)
apply (simp add: AL_dom_emp)
apply clarsimp
  apply (simp add: AL_dom_upd1)
  apply (erule disjE, clarsimp)
  apply (drule SetTriv, assumption) apply clarsimp
done

lemma MapHP_Rev_good_domf[rule_format]:
"(H,f,K):MapHP \<Longrightarrow> (N,f,NN):MapN \<longrightarrow> HP_good K (AL_dom NN) \<longrightarrow> inj_on f (AL_dom H) \<longrightarrow> HP_good H (dom f)"
apply (erule MapHP.induct)
apply (simp add: HP_good_emp)
apply clarsimp
  apply (erule impE) apply (erule HP_good_subset) apply (rule contained_upd) 
                     apply (case_tac "fM\<down>fc") apply (simp add: AL_dom_def)
                     apply clarsimp 
                       apply (drule MapHP_D_right) apply assumption apply clarsimp
                       apply (drule_tac x=c and y=ca in inj_onD, simp)
                         apply (rule AL_dom_upd2)
                         apply (simp add: AL_dom_upd1) apply (rule disjI2) apply (erule AL_domI)
                         apply (drule_tac d=ca in AL_domI) apply simp
                     apply simp
  apply (erule impE)  apply (erule inj_on_subset) apply (rule AL_dom_upd)
  apply (simp add: HP_good_def, clarsimp)
    apply (drule AL_upd_split)
    apply (erule disjE, clarsimp)
      apply (erule_tac x=fc in allE, erule_tac x=C in allE, erule_tac x=G in allE, erule impE)
        apply (rule AL_update1)
      apply clarsimp apply (frule Map_Fields_AL, clarsimp)
        apply (drule AL_codD, clarsimp)
        apply (drule Map_Fields_D_left, assumption) apply clarsimp
    apply clarsimp
done

lemma MapHP_AL_right: "(H,f,K):MapHP \<Longrightarrow> K:AL"
apply (erule MapHP.induct)
apply (rule AL_EMP)
apply clarsimp
  apply (erule AL_UPD)
done

lemma MapHP_AL_left: "(H,f,K):MapHP \<Longrightarrow> H:AL"
apply (erule MapHP.induct)
apply (rule AL_EMP)
apply clarsimp
  apply (erule AL_UPD)
done

lemma MapN_fplus: "\<lbrakk>(N,f,fN):MapN; dom f \<inter> dom fa = {}\<rbrakk> \<Longrightarrow> (N,f++fa,fN):MapN"
apply (rule MapN_extend_f, assumption) 
apply (drule SetTriv, erule MapN_domf)
apply (case_tac "x:dom fa") apply fast
apply (case_tac "fa x") 
  apply (simp add: map_add_def) apply clarsimp
done

lemma inj_on_MapN_sum:
 "\<lbrakk>(N, g, gN) \<in> MapN; inj_on f (dom f);
     AL_sum N Na NNa; AL_dom gN \<inter> ran f = {};
     AL_dom Na = dom f;  dom f \<inter> dom g = {}; 
     AL_dom N = dom g; inj_on g (ObjIDs N)\<rbrakk>
    \<Longrightarrow> inj_on (g ++ f) (ObjIDs NNa)"
  apply (simp (no_asm) add: inj_on_def, clarsimp)
  apply (simp add: ObjIDs_def, clarsimp)
  apply (frule_tac c=x in AL_sum_split, assumption)
  apply (rotate_tac -1, erule disjE)
    apply (subgoal_tac "f x = None")
    prefer 2 apply (subgoal_tac "x : AL_dom N")
               apply (case_tac "x:dom f")
                 apply (drule_tac X="dom f" and x=x and y=x in SetTriv106) apply assumption apply clarsimp apply simp
               apply clarsimp
            apply (erule AL_domI) 
    apply (frule_tac c=y in AL_sum_split, assumption)
    apply (rotate_tac -1, erule disjE)
      apply (subgoal_tac "f y = None")
      prefer 2 apply (subgoal_tac "y : AL_dom N")
                 apply (case_tac "y:dom f")
                   apply (drule_tac X="dom f" and x=y and y=y in SetTriv106) apply assumption apply clarsimp apply simp
               apply clarsimp
             apply (erule AL_domI)
      apply (simp add: map_add_def)
      apply (erule_tac f=g and A="{c. \<exists>C. N\<down>c = Some (classTP C)}" and x=x and y=y in inj_onD, simp) apply fast apply fast 
    apply (frule_tac H=Na in AL_domI) apply clarsimp
      apply (drule_tac f=g in MapN_D_left, assumption) apply clarsimp
      apply (drule_tac X="AL_dom gN" and x=ya and y=ya in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
  apply (frule_tac H=Na in AL_domI) apply clarsimp 
    apply (frule_tac c=y in AL_sum_split, assumption)
    apply (rotate_tac -1, erule disjE)
      apply (subgoal_tac "y : AL_dom N") prefer 2 apply (erule AL_domI)
        apply (subgoal_tac "f y = None")
        prefer 2 apply (case_tac "y:dom f") 
                    apply (drule_tac X="dom f" and x=y and y=y in SetTriv106) apply assumption apply clarsimp apply simp
                 apply clarsimp
        apply (simp add: map_add_def)
        apply (drule_tac f=g in MapN_D_left, assumption) apply clarsimp
          apply (drule_tac X=" AL_dom gN" in SetTriv106) apply (erule AL_domI) apply (erule ranI) apply simp
    apply (frule_tac H=Na and d=y in AL_domI) apply clarsimp 
      apply (erule_tac f=f in inj_onD, simp) apply (erule domI) apply (erule domI)
done


lemma renUniState_preserved:
" \<lbrakk>renUniState (\<Sigma>, N) f (\<Sigma>', N'); renUniState (\<Pi>, NN) g (\<Pi>', NN'); 
    \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc; inj_on g (dom g - dom f);
     Img g (dom g - dom f) \<inter> Img g (dom f) = {}; AL_dom (snd (snd \<Sigma>)) \<subseteq> AL_dom (snd (snd \<Pi>)); contained N NN\<rbrakk>
    \<Longrightarrow> AL_dom (snd (snd \<Sigma>')) \<subseteq> AL_dom (snd (snd \<Pi>')) \<and> contained N' NN'"
apply (simp add: renUniState_def, clarsimp)
apply (case_tac \<Sigma>, clarsimp)
apply (case_tac \<Pi>, clarsimp)
apply (case_tac \<Sigma>', clarsimp)
apply (case_tac \<Pi>', clarsimp)
apply (rule, simp add: Renames_STATE_def, (erule conjE)+)
  apply (drule_tac N=b in MapHP_dom) 
  apply (drule_tac N=ba in MapHP_dom) 
  apply clarsimp apply (simp add: Img_def, clarsimp)
    apply (erule_tac x=s in allE, clarsimp)
    apply (rule_tac x=s in exI, simp)
    apply (erule SetTriv, assumption)
apply (simp (no_asm) add: contained_def, clarsimp)
  apply (drule MapN_D_right, assumption, clarsimp)
  apply (drule contained3, assumption)
  apply (drule MapN_D_left) apply assumption apply clarsimp
done

end
