theory UniInter = UniSatSec + INSTR_GET + INSTR_PUT + INSTR_NEW + 
                  RuleUniInvS + RuleUniInvV + Rules_UniBasic + Ren + 
                  Garbage + UnaryRenSound:

constdefs UniSS_inter::"UniCtxt \<Rightarrow> STATE \<Rightarrow> MP \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> 
                        STATE \<Rightarrow> MP \<Rightarrow> (Label set) \<Rightarrow> bool"
"UniSS_inter U \<Sigma> N M l \<Pi> NN L \<equiv> 
   get_ins M l \<noteq> Some vreturn \<and>
   (\<forall> n S \<Gamma> H Sp \<Gamma>p Hp. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow> \<Pi> = (Sp,\<Gamma>p,Hp) \<longrightarrow>
                       (AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> 
                        UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L))"

constdefs UniBS_inter::"UniCtxt \<Rightarrow> STATE \<Rightarrow> MP \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> bool \<Rightarrow> HP \<Rightarrow> Colour \<Rightarrow> MP \<Rightarrow> bool"
"UniBS_inter U \<Sigma> N M l b HH c NN \<equiv>
    (\<forall> n k S \<Gamma> H. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow>
                  (b \<longrightarrow> k=n) \<longrightarrow> ((\<not> b) \<longrightarrow> k=Suc n) \<longrightarrow> 
                  (AL_dom H \<subseteq> AL_dom HH \<and> contained N NN \<and> 
                   UniBS_UniSecN k \<Sigma> N HH c NN M l))"

lemma SSGoto_inter:
  "\<lbrakk> get_ins M l = Some (goto pc); L= {pc}; \<Pi> = \<Sigma>; NN=N\<rbrakk>
  \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (rule, rule contained_refl)
apply (simp only: UniSS_UniSecN_def)
apply (rule, clarsimp)
apply (rule, rule contained_refl)
apply (rule allI, rule)
apply (rule allI)+
apply (rule impI)+
apply (rule_tac x=I in exI)
apply clarsimp
apply (drule GotoElim1) apply assumption
apply clarsimp
apply (rule, simp add: SD_sum_def, clarsimp)
apply (rule unisat_HPextensional)
apply (erule unisat_MPextensional)
apply (erule AL_sum_extensional) apply assumption apply assumption
apply (erule AL_sum_extensional) apply assumption apply assumption
apply (rule, rule)
apply (simp add: Invariant_def SD_sum_def ValRepEQ)
  apply clarsimp
  apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, bb) (a, aa, b) I = ValuesRepresented c (S, \<Gamma>, bc) (a, aa, b) I", simp)
  apply (rule ValuesRepresented_HPextensional) apply (erule AL_sum_extensional) apply assumption 
done

lemma SSRen_inter:
  "\<lbrakk> renUniState (\<Sigma>,N) f (f\<Sigma>,fN); renUniState (\<Pi>,N') g (g\<Pi>,gN');
     \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc;
     inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {};
     UniSS_inter U \<Sigma> N M l \<Pi> N' L\<rbrakk>
     \<Longrightarrow> UniSS_inter U f\<Sigma> fN M l g\<Pi> gN' L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (erule_tac x=n in allE, clarsimp)
apply (case_tac \<Sigma>,clarsimp) apply (case_tac \<Pi>,clarsimp)
apply (frule_tac f=f and g=g in renUniState_preserved) apply assumption 
  apply assumption  apply assumption apply assumption apply fastsimp apply assumption
apply (erule conjE)+
apply (rule, simp)
apply (rule, assumption)
apply (rule UnaryRen_UniSound) apply assumption apply assumption 
  apply assumption apply assumption apply assumption apply assumption
done

lemma SSFrame_inter:
  "\<lbrakk> UniSS_inter U \<Sigma> NNN M l \<Pi> NN L; SD_sum \<Sigma> H \<Sigma>1; SD_sum \<Pi> H \<Pi>1;
     AL_sum NNN N NNN1; AL_sum NN N NN1; AL_dom NN \<inter> AL_dom N = {}
   \<rbrakk> \<Longrightarrow> UniSS_inter U \<Sigma>1 NNN1 M l \<Pi>1 NN1 L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (erule_tac x=n in allE, erule impE, assumption)
apply (case_tac \<Sigma>,clarsimp) apply (rename_tac S0 \<Gamma>0 H0) 
apply (case_tac \<Pi>,clarsimp) apply (rename_tac Sp0 \<Gamma>p0 Hp0)
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom Hp \<and> contained NNN1 NN1", clarsimp)
prefer 2
  apply (rule, simp add : AL_sum_def SD_sum_def, clarsimp)
    apply rule apply fast apply fast
  apply (simp (no_asm) add: contained_def, clarsimp)
    apply (drule AL_sum_split, assumption)
    apply (erule disjE) 
      apply (drule contained3, assumption) apply (erule AL_sum3, assumption)
    apply (erule AL_sum4, assumption)
apply (simp only: UniSS_UniSecN_def, (erule conjE)+)
apply (rule, clarsimp)
apply (rule, assumption)
apply (rule allI, rule)
apply (erule_tac x=na in allE, erule impE, assumption)
apply (rule allI)+ apply (rule impI)+
apply (rename_tac Hx Nx N0 \<Sigma>0 \<Pi>0 N1)
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE)
apply (erule_tac x=l1 in allE, erule_tac x=\<sigma>1 in allE)
apply (subgoal_tac "AL_dom H \<inter> AL_dom Hx = {}")
prefer 2 apply (rotate_tac -2,erule thin_rl, erule thin_rl) 
         apply (simp add: SD_sum_def AL_sum_def) apply clarsimp
         apply (rule SetTriv103) prefer 2 apply assumption apply fast 
apply (frule_tac N=H and M=Hx in AL_sum_exists_AL) apply (erule exE, rename_tac H_Hx, erule conjE) 
apply (erule_tac x=H_Hx in allE)
apply (subgoal_tac "AL_dom N \<inter> AL_dom Nx = {}")
prefer 2 apply (rotate_tac -1,erule thin_rl) 
         apply (simp add: SD_sum_def AL_sum_def) apply clarsimp
         apply (rule SetTriv103) prefer 2 apply assumption apply fast 
apply (frule_tac N=N and M=Nx in AL_sum_exists_AL) apply (erule exE, rename_tac N_Nx, erule conjE)
apply (erule_tac x=N_Nx in allE)
apply (erule_tac x=N0 in allE)
apply (erule_tac x=\<Sigma>0 in allE)
apply (erule_tac x=\<Pi>0 in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE,assumption)
apply (erule impE,simp add: SD_sum_def) apply clarsimp 
  apply rule apply (erule AL_sum_sum) apply assumption apply assumption 
  apply (simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE,simp add: SD_sum_def) apply clarsimp 
  apply rule apply (erule AL_sum_sum) apply assumption apply assumption 
  apply (simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE, simp add: AL_sum_def, (erule conjE)+)
  apply (rule, fast)
  apply (rule, erule contained_transitive, assumption)
  apply (simp (no_asm) add: contained_def, clarsimp)
  apply (frule AL_domI, clarsimp)
  apply (erule disjE)
    apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=NNN1 in contained3, assumption)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule_tac NN=N0 in contained3, assumption) 
  apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption)
apply (erule impE, simp add: AL_sum_def, clarsimp) apply fast
apply (erule impE, simp add: AL_sum_def, (erule conjE)+)
  apply (rule, fast)
  apply (rule, erule contained_transitive, assumption)
  apply (simp (no_asm) add: contained_def, clarsimp)
  apply (frule AL_domI, clarsimp)
  apply (erule disjE)
    apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=NN1 in contained3, assumption)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption) 
  apply (drule AL_domD, clarsimp)
    apply (drule_tac NN=N_Nx in contained3, assumption) apply clarsimp
    apply (erule contained3, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule impE, simp)
apply (erule impE, simp)
apply (erule impE, assumption)
apply (erule impE, assumption)
apply (erule exE)+ apply (erule conjE)+
apply (rule_tac x=I1 in exI, simp)
done

lemma SSConst_inter: "\<lbrakk> get_ins M l = Some (const (IVal i));
             \<Sigma> = (S,\<Gamma>,H); c \<notin> AL_dom N; L= {l+1}; 
             \<Pi>=(c#S,\<Gamma>,H); NN=N[c\<mapsto>intTP] \<rbrakk>
         \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(S, \<Gamma>, H)" and U=U in UniConst_SoundUni) apply fastsimp
 apply assumption apply simp apply simp apply simp apply clarsimp
done

lemma SSPop_inter: "\<lbrakk> get_ins M l = Some pop; 
             \<Sigma> = (c#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c#S, \<Gamma>, H)" and N=N and NN=N and U=U in UniPop_SoundUni) apply fastsimp
 apply simp apply simp apply simp apply clarsimp
done

lemma SSDup_inter: "\<lbrakk> get_ins M l = Some dup; 
             \<Sigma> = (c#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(c#c#S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c#S, \<Gamma>, H)" and N=N and NN=N and U=U in UniDup_SoundUni) apply fastsimp
 apply simp apply simp apply simp apply clarsimp
done

lemma SSSwap_inter: "\<lbrakk> get_ins M l = Some swap; 
             \<Sigma> = (c#d#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(d#c#S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c#d#S, \<Gamma>, H)" and N=N and NN=N and U=U in UniSwap_SoundUni) apply fastsimp
  apply simp apply simp apply simp apply clarsimp
done

lemma SSLoad_inter: "\<lbrakk> get_ins M l = Some (load x); 
             \<Sigma> = (S,\<Gamma>,H); \<Gamma>\<down>x = Some c; L= {l+1}; 
             \<Pi>=(c#S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(S, \<Gamma>, H)" and N=N and NN=N and U=U in UniLoad_SoundUni) apply fastsimp
 apply assumption apply simp apply simp apply simp apply clarsimp
done

lemma SSStore_inter: "\<lbrakk> get_ins M l = Some (store x); 
             \<Sigma> = (c#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(S,\<Gamma>[x\<mapsto>c],H); NN=N \<rbrakk>
         \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c#S, \<Gamma>, H)" and N=N and NN=N and U=U in UniStore_SoundUni) apply fastsimp
  apply simp apply simp apply simp apply clarsimp
done

lemma SSUnop_inter: "\<lbrakk>get_ins M l = Some (unop f); \<Sigma> = (c # S,\<Gamma>,H);
              N\<down>c = Some tpp; d \<notin> AL_dom N;  
              \<Pi> = (d#S,\<Gamma>,H); NN=N[d\<mapsto>intTP]; L={l+1};
            \<forall> v . typecorrect v tpp \<longrightarrow> typecorrect (f v) intTP\<rbrakk>
              \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c#S, \<Gamma>, H)" and U=U in UniUnop_SoundUni) apply fastsimp
 apply assumption+ apply simp apply simp apply simp apply assumption apply clarsimp
done

lemma SSBinop_inter:
   "\<lbrakk> get_ins M l = Some (binop f); \<Sigma> = (c1 # c2 # S,\<Gamma>,H);
      N\<down>c1 = Some tp1; N\<down>c2 = Some tp2; c \<notin> AL_dom N;
      \<Pi> = (c#S,\<Gamma>,H); NN=N[c\<mapsto>intTP]; L={l+1}; 
      \<forall> v w . typecorrect v tp1 \<longrightarrow> typecorrect w tp2 \<longrightarrow> typecorrect (f v w) intTP\<rbrakk>
   \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c1# c2 # S, \<Gamma>, H)" and N=N and NN="N[c\<mapsto>intTP]" and U=U in UniBinop_SoundUni) apply fastsimp
 apply assumption+ apply simp apply simp apply simp apply clarsimp apply clarsimp
done

lemma SSPut_inter: "\<lbrakk> get_ins M l = Some (putfield C f); \<Sigma> = (c1#c2#S,\<Gamma>,H);
           H\<down>c2 = Some(D,F); L= {l+1}; 
           \<Pi>=(S,\<Gamma>,H[c2 \<mapsto> (D,F[f \<mapsto> c1])]); NN=N \<rbrakk>
         \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c1# c2 # S, \<Gamma>, H)" and N=N and NN=N and U=U in UniPut_SoundUni) apply fastsimp
 apply assumption apply simp apply simp apply simp apply clarsimp 
done

lemma SSGet_inter:"\<lbrakk> get_ins M l = Some (getfield C f); \<Sigma> = (c1#S,\<Gamma>,H);
          H\<down>c1 = Some(D,F); F\<down>f = Some c2; 
          \<Pi>=(c2#S,\<Gamma>,H); NN=N; L={l+1}\<rbrakk>
        \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(c1 # S, \<Gamma>, H)" and N=N and NN=N and U=U in UniGet_SoundUni) apply fastsimp
 apply assumption+ apply simp apply simp apply simp apply clarsimp 
done

lemma SSNew_inter:"\<lbrakk> get_ins M l = Some (new C); \<Sigma> = (S,\<Gamma>,H);
          cl \<notin> AL_dom N; L= {l+1}; subclass_of C D;
          \<Pi> = (cl#S,\<Gamma>,H[cl \<mapsto> (C,emp)]); NN = N[cl \<mapsto> (classTP D)]\<rbrakk>
          \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (drule_tac \<Sigma>="(S, \<Gamma>, H)" and N=N and NN="N[cl\<mapsto>(classTP D)]" and U=U in UniNew_SoundUniSubclass) apply fastsimp
 apply assumption apply simp apply simp apply simp apply assumption apply clarsimp
done

lemma SSInvS_inter:"\<lbrakk> get_ins M l = Some (invokeS C m);  mbody_is C m (P1, code, l0); 
            \<Sigma> = (S1, \<Gamma>, H); (S1, P1,\<Gamma>1,S):absFrame; 
            \<Pi> = (c # S, \<Gamma>, HH); L = {l+1}; NN:AL;
            UniBS_inter U ([], \<Gamma>1, H) N (P1, code, l0) l0 True HH c NN \<rbrakk>
          \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def UniBS_inter_def, clarsimp)
apply (erule_tac x=n in allE, clarsimp)
apply (rule Uni_InvS_SoundUni) apply assumption+ apply fastsimp apply assumption apply fastsimp apply simp apply assumption+
done

lemma SSIf_inter:"\<lbrakk> get_ins M l = Some (iftrue pc); \<Sigma> = (c#S,\<Gamma>,H);
         L= {l+1,pc}; \<Pi> = (S,\<Gamma>,H); NN=N\<rbrakk>
          \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (rule, rule contained_refl)
apply (simp add: UniSS_UniSecN_def)
apply (rule, rule contained_refl)
apply clarsimp
apply (drule IfElim1) apply assumption
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x c. (bb\<down>x = Some c) = (bc\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "\<forall>x c. (N0\<down>x = Some c) = (N1\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0")
prefer 2 apply (simp add: ObjIDs_def)
apply (drule_tac HH=bc in unisat_HPextensional)
  apply assumption apply assumption
apply (drule_tac NN=N1 in unisat_MPextensional) apply assumption apply assumption
apply (erule disjE) apply clarify
  apply (rule, simp)
  apply (rule_tac x=I in exI)
  apply rule apply (erule unisat_Tail)
  apply clarsimp
    apply (rule_tac H=bb in Invariant_leftHPextensional) 
      apply (simp add: Invariant_def ValRepEQ)
      apply (rule ValuesRepresented9) 
    apply clarsimp
    apply assumption
apply clarify
  apply (rule, simp)
  apply (rule_tac x=I in exI)
  apply rule apply (erule unisat_Tail)
  apply clarsimp
    apply (rule_tac H=bb in Invariant_leftHPextensional) 
      apply (simp add: Invariant_def ValRepEQ)
      apply (rule ValuesRepresented9) 
      apply (rule allI)+ apply rule apply fast
    apply clarsimp
    apply assumption
done

lemma SSPost_extensional_inter:
   "\<lbrakk>  UniSS_inter U \<Sigma> N M l (S,\<Gamma>,H) NN L;
      \<forall> c d . (H\<down>c = Some d) =  (K\<down>c = Some d); K:AL;
      \<forall> c d . (NN\<down>c = Some d) =  (MM\<down>c = Some d); MM:AL\<rbrakk> 
     \<Longrightarrow>  UniSS_inter U \<Sigma> N M l (S,\<Gamma>,K) MM L"
apply (simp add: UniSS_inter_def, clarsimp)
apply (erule_tac x=n in allE, erule impE, assumption)
apply (erule conjE)+
apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom K \<and> contained N MM", erule conjE)
prefer 2 apply rule apply (erule SetTriv101) apply (simp add: AL_dom_def)
         apply (simp (no_asm) add: contained_def, clarsimp)
           apply (drule contained3, assumption) apply clarsimp
apply (rule, assumption)
apply (rule, assumption)
apply (simp only: UniSS_UniSecN_def, (erule conjE)+)
apply (rule, simp)
apply (rule,simp) 
apply (rule, rule)
apply (erule_tac x=na in allE, erule impE, assumption)
apply (rule allI)+
apply (rule impI)+
apply (rename_tac Hb Nx N0 \<Sigma>0 \<Pi>0 N1)
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE, erule_tac x=l1 in allE)
apply (erule_tac x=\<sigma>1 in allE, erule_tac x=Hb in allE, erule_tac x=Nx in allE)
apply (erule_tac x=N0 in allE, erule_tac x=\<Sigma>0 in allE, erule_tac x=\<Pi>0 in allE)
apply (erule_tac x=N1 in allE)
apply (erule impE, assumption)+
apply (erule impE, simp add: SD_sum_def, clarsimp)
   apply (subgoal_tac "AL_dom K = AL_dom H")
     apply rule apply (simp add: AL_sum_def, clarsimp)
     apply (simp (no_asm) add: contained_def, clarsimp) apply (erule contained3, assumption)
     apply simp
   apply (simp add: AL_dom_def)
apply (erule impE, assumption)+
apply (erule impE) apply (subgoal_tac "AL_dom NN = AL_dom MM", clarsimp) apply (simp add: AL_dom_def)
apply (erule impE) apply (subgoal_tac "AL_dom NN = AL_dom MM", simp add: AL_sum_def) 
                     apply (simp (no_asm) add: contained_def, clarsimp) apply (erule contained3, assumption)
                   apply (simp add: AL_dom_def)
apply (erule impE, assumption)+ 
apply assumption 
done

lemma BSVret_inter: "\<lbrakk>get_ins M l = Some vreturn; \<Sigma>=(c # S,\<Gamma>,H);NN=N\<rbrakk>
         \<Longrightarrow> UniBS_inter U \<Sigma> N M l False H c NN"
apply (simp add: UniBS_inter_def, clarsimp)
apply (rule, rule contained_refl)
apply (simp add: UniBS_UniSecN_def)
apply (rule, rule contained_refl)
apply (rule, rule)
apply (rule allI)+
apply (rule impI)+
apply (rule allI)+
apply (rule impI)+
apply (rule allI)+
apply (rule impI)+
apply (drule ExecElim1) apply clarsimp
apply (simp add: SD_sum_def, clarsimp)
apply (subgoal_tac "\<forall>x c. (ba\<down>x = Some c) = (bb\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "\<forall>x c. (N0\<down>x = Some c) = (N1\<down>x = Some c)")
prefer 2 apply (erule AL_sum_extensional, assumption) 
apply (subgoal_tac "ObjIDs N1 = ObjIDs N0")
prefer 2 apply (simp add: ObjIDs_def)
apply (drule_tac HH=bb in unisat_HPextensional)
  apply assumption apply assumption
apply (drule_tac NN=N1 in unisat_MPextensional) apply assumption apply assumption
apply (erule disjE, clarsimp)
  apply (simp add: unisat_def, clarsimp) 
  apply (rule, simp add: State_welldef_def, clarsimp)
    apply (simp add: AL_cod_emp)
    apply (rule, fast)
    apply (simp add: State_good_def) apply (rule AL_EMP)
  apply (rule_tac x=I in exI)
  apply (rule, simp add: StateSatisfiesAbstraction_def, clarsimp)
  apply (subgoal_tac "State_typecorrect N1 ([c], emp, bb) ([v], emp, b) I",rule,assumption)
  prefer 2 apply (simp add: State_typecorrect_def, clarsimp)
    apply (simp add: Opstack_typecorrect_def Store_typecorrect_def)
    apply rule apply (erule_tac x=0 in allE, clarsimp)
    apply rule apply clarsimp apply (simp add: AL_emp1)
    apply (subgoal_tac "DOM ([c], emp, bb) \<subseteq> DOM (c # S, \<Gamma>, bb)")
      apply (rule, simp add: uniqueValues_def, clarsimp)
        apply (erule_tac x=ca in allE, erule impE, erule SetTriv, assumption)
        apply (erule exE) apply (rule_tac x=va in exI)
        apply rule apply (rule_tac Y="ValuesRepresented ca (c # S, \<Gamma>, bb) (v # ops, aa, b) I" in SetTriv101) 
          apply (rule SetTriv101, rule ValuesRepresented_HD) apply (rule ValuesRepresented13) apply simp 
        apply (subgoal_tac "\<exists> w . w: ValuesRepresented ca ([c], emp, bb) ([v], emp, b) I", erule exE)
          apply (subgoal_tac "w=va", clarsimp)
          apply (drule_tac x=w and Y="ValuesRepresented ca (c # S, \<Gamma>, bb) (v # ops, aa, b) I" in SetTriv)
          apply (rule SetTriv101, rule ValuesRepresented_HD) apply (rule ValuesRepresented13) apply simp 
        apply (subgoal_tac " ValuesRepresented ca ([c], emp, bb) ([v], emp, b) I \<noteq> {}") apply fast
        apply (subgoal_tac " Values_Represented ca ([c], emp, bb) ([v], emp, b) I \<noteq> {}") apply (simp add: ValRepEQ)
        apply (erule State_typecorrect_VR_notEmpty) apply assumption
      apply (rule SetTriv101) prefer 2 apply assumption apply fast 
    apply (rule DOM_1)
  apply clarsimp  
  apply (rule_tac H=ba in Invariant_leftHPextensional) 
    apply (simp add: Invariant_def ValRepEQ)
    apply (rule SetTriv101)  apply (rule_tac S=S and ops=ops in ValuesRepresented_HD)
                                   apply (rule_tac \<Gamma>=\<Gamma> and s=aa in ValuesRepresented13)
  apply clarsimp
  apply assumption
apply (erule exE)+ apply (erule conjE)+
  apply (drule RetElim1) apply assumption apply clarsimp 
done

lemma "[| UniCtxtUniValidN n U; UniSS_inter U \<Sigma> N M l \<Sigma>' N' {} |] ==> XX"
apply (simp add: UniSS_inter_def) apply clarsimp
apply (erule_tac x=n in allE, clarsimp)
apply (case_tac \<Sigma>, clarsimp)
apply (case_tac \<Sigma>', clarsimp)
apply (simp add: UniSS_UniSecN_def)??

apply (simp add: UniCtxtUniValidN_def, clarsimp)
lemma BSRun_inter:  "\<lbrakk>UniSS_inter U \<Sigma> N M l \<Sigma>' N' L;
            \<forall> l'. l' : L \<longrightarrow> UniBS_inter U \<Sigma>' N' M l' True H c N'' \<rbrakk>
       \<Longrightarrow> UniBS_inter U \<Sigma> N M l False H c N''"
apply (simp add: UniSS_inter_def UniBS_inter_def, clarsimp)
apply (erule_tac x=n in allE, clarsimp)
apply (case_tac \<Sigma>', clarsimp)
apply (case_tac "L={}", clarsimp)
  apply (simp add: UniSS_UniSecN_def)
  apply (frule UniSS_L_notEmpty) apply (erule exE, rename_tac l')
  apply (erule_tac x=n in allE, clarsimp)
  apply (subgoal_tac "AL_dom bb \<subseteq> AL_dom H \<and> contained N' N''", erule conjE)
  prefer 2 apply (erule_tac x=l' in allE, clarsimp)
  apply (subgoal_tac "AL_dom Ha \<subseteq> AL_dom H \<and> contained N N''")
  prefer 2 apply (rule, fast)
           apply (erule contained_transitive) apply assumption
  apply (erule thin_rl, unfold UniBS_UniSecN_def UniSS_UniSecN_def)
  apply (erule conjE)+
  apply (rule, assumption)
  apply (rule, assumption)
  apply (rule, rotate_tac -1, erule thin_rl, erule thin_rl, simp) 
  apply (rule, assumption)
  apply (rule, rule)
  apply (rule allI)+
  apply (rule impI)+
  apply (drule ExecElim2)
  apply (erule disjE, clarsimp) 
  apply (erule exE)+ apply (erule conjE)+
  apply (rotate_tac 1, erule_tac x=nb in allE, erule impE) apply simp (*apply (, erule Arith_17, assumption) *)
  apply (erule_tac x=\<sigma> in allE, rotate_tac -1, erule_tac x=I in allE)
  apply (erule_tac x=ll in allE, rotate_tac -1, erule_tac x=t in allE)
  apply (erule_tac x=Hb in allE, erule_tac x=Nx in allE, erule_tac x=N0 in allE, erule_tac x=\<Sigma>0 in allE) 
  apply (subgoal_tac "AL_dom bb \<inter> AL_dom Hb = {}")
  prefer 2 apply (rotate_tac -2, erule thin_rl, erule thin_rl)
           apply (simp add: SD_sum_def, clarsimp)
           apply (erule SetTriv103) apply assumption
  apply (frule_tac N=bb in AL_sum_exists_AL) apply (erule exE, rename_tac bb_Hb, erule conjE)
  apply (subgoal_tac "AL_dom N' \<inter> AL_dom Nx = {}")
  prefer 2 apply (rotate_tac -5, erule thin_rl, erule thin_rl)
           apply (rule_tac Y="AL_dom N''" in SetTriv103) apply (erule contained5) apply assumption
  apply (frule_tac N=N' in AL_sum_exists_AL) apply (erule exE, rename_tac N'Nx, erule conjE)
  apply (erule_tac x="(ad, ae, bb_Hb)" in allE, erule_tac x=N'Nx in allE)
  apply (erule impE, assumption)
  apply (erule impE) apply (rotate_tac -7, erule thin_rl) apply (simp add: SD_sum_def)
  apply (erule impE) apply (rotate_tac -7, erule thin_rl) apply (simp add: SD_sum_def)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE) apply (rotate_tac -7, erule thin_rl) apply simp 
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule exE)+ apply (erule conjE)+
  apply (erule_tac x=ll in allE, erule impE, assumption, erule conjE)
  apply (erule_tac x=n in allE, erule impE, assumption)
  apply (erule conjE)+
  apply (erule_tac x=m in allE, erule impE, erule Arith_18, assumption)
  apply (erule_tac x=t in allE, erule_tac x=I1 in allE)
  apply (erule_tac x=h in allE, erule_tac x=v in allE, rotate_tac -1, erule_tac x=Hb in allE)
  apply (erule_tac x=Nx in allE, erule_tac x=N'Nx in allE)
  apply (erule_tac x="(ad, ae, bb_Hb)" in allE, erule_tac x=\<Pi>0 in allE)
  apply (erule_tac x=N1 in allE)
  apply (erule impE, assumption)
  apply (erule impE, simp add: SD_sum_def)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, simp)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule impE, assumption)
  apply (erule exE)+ apply (erule conjE)+
  apply (rule_tac x=I1a in exI, simp)
  apply (subgoal_tac "contained N0 N'Nx")
  prefer 2 apply (rotate_tac -8)
           apply (erule thin_rl, erule thin_rl, erule thin_rl)
           apply (rotate_tac 3)
           apply (erule thin_rl, erule thin_rl)
           apply (simp (no_asm) add: contained_def, clarsimp)
           apply (drule AL_sum_split, assumption)
           apply (erule disjE)
             apply (erule AL_sum3) apply (erule contained3, assumption)
           apply (erule AL_sum4, assumption)           
  apply (rule, rule)
  apply (erule_tac x=d in allE, erule impE, assumption)
  apply (erule_tac x=d in allE, erule impE) apply (erule contained6) apply assumption
  apply (erule conjE)+
    apply (simp add: Invariant_def, clarsimp)
    apply (rule, rule) apply (erule impE, assumption)
                       apply (erule impE) apply (erule SetTriv, erule contained_ObjIds_subset)
                       apply simp
    apply (erule SetTriv101) apply assumption
apply (rule, rule contained_refl)
apply (simp add: UniBS_UniSecN_def)
apply (rule, rule contained_refl)

lemma BSInj_inter: "(U, \<Sigma>,N, M,l,False,H,c,N'') : UniBS \<Longrightarrow> (U, \<Sigma>,N, M,l,True,H,c,N'') : UniBS"

lemma BSAx_inter: "((M,l),(\<Sigma>,N,H,c,N')) \<in> U \<Longrightarrow> (U,\<Sigma>,N, M,l,True,H,c,N') : UniBS"

lemma BSPost_extensional_inter:
  "\<lbrakk> (U, \<Sigma>,N, M,l,b,H,c,N') : UniBS;
     \<forall> c d . (H\<down>c = Some d) =  (K\<down>c = Some d); K:AL;
     \<forall> c d . (N'\<down>c = Some d) =  (MM\<down>c = Some d); MM:AL\<rbrakk>
  \<Longrightarrow> (U, \<Sigma>,N, M,l,b,K,c,MM) : UniBS"

lemma BSStaticGarbageHP_inter: "\<lbrakk> (U, \<Sigma>,N, M,l,b,HH ,c,NN) : UniBS; d \<notin> DOM([c],emp,delete HH d); 
       AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom (delete HH d); contained N NN; d \<notin> DOM \<Sigma>; d \<notin> AL_dom N; K=(delete HH d)
       \<rbrakk> \<Longrightarrow> (U, \<Sigma> ,N, M,l,b,K,c,NN) : UniBS"

lemma BSStaticGarbageColour_inter: 
  "\<lbrakk> (U, \<Sigma>, N, M,l, b, HH ,c, NN) : UniBS; d \<notin> DOM([c],emp,HH);
      contained N (delete NN d); d \<notin> DOM \<Sigma>; NNN= delete NN d\<rbrakk>
   \<Longrightarrow> (U, \<Sigma> ,N, M,l,b,HH,c,NNN) : UniBS"

lemma BSFrame_inter:
  "\<lbrakk> (U, \<Sigma>, NNN, M, l, b, HH, c, NN) : UniBS; SD_sum \<Sigma> H \<Sigma>1; SD_sum ([],emp,HH) H ([],emp,HHH);
     AL_sum NNN N NNN1; AL_sum NN N NN1; AL_dom NN \<inter> AL_dom N = {}
   \<rbrakk> \<Longrightarrow> (U, \<Sigma>1,NNN1, M,l,b,HHH,c,NN1) : UniBS"

lemma SSInvV3_inter:"\<lbrakk> get_ins M l = Some (invokeV C m);  mbody_is C m (P1, code, l0); 
            \<Sigma> = (S1, \<Gamma>, H); (S1, P1,\<Gamma>1,d#S):absFrame; H\<down>d = Some(D,F); 
            \<Pi> = (c # S, \<Gamma>, HH); L = {l+1}; NN:AL;
           \<forall> E . subclass_of E D \<longrightarrow> 
                 (\<exists> code1 l1 . mbody_is E m (P1,code1,l1) \<and>
                               UniBS_inter U ([], upd \<Gamma>1 this d, H) N (P1, code1, l1) l1 True HH c NN)\<rbrakk>
          \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
apply (simp add: UniSS_inter_def UniBS_inter_def, clarsimp)
apply (subgoal_tac "AL_dom H \<subseteq> AL_dom HH \<and> contained N NN", erule conjE)
prefer 2 apply (erule_tac x=D in allE) 
         apply (erule impE, simp add: subclass_of_refl) apply clarsimp  
apply (rule, assumption)
apply (rule, assumption)
apply (erule_tac U=U in Uni_InvV3_SoundUni) apply assumption apply fastsimp apply assumption+ apply fastsimp apply simp 
  apply clarsimp  apply (erule_tac x=E in allE, clarsimp) apply (rule apply assumption apply assumption
   apply assumption apply assumption apply assumption apply assumption
   apply clarsimp apply assumption apply assumption

apply (drule_tac \<Sigma>="(c1# c2 # S, \<Gamma>, H)" and N=N and NN="N[c\<mapsto>intTP]" and U=U in UniBinop_SoundUni) apply fastsimp
 apply assumption+ apply simp apply simp apply simp apply clarsimp apply clarsimp
done


consts UniSS:: "(UniCtxt \<times> STATE \<times> MP \<times> Mbody \<times> Label \<times> STATE \<times> MP \<times> (Label set)) set"
       UniBS:: "(UniCtxt \<times> STATE \<times> MP \<times> Mbody \<times> Label \<times> bool \<times> HP \<times> Colour \<times> MP) set"

inductive UniSS UniBS intros

UniGoto:"\<lbrakk> get_ins M l = Some (goto pc); L= {pc}; \<Pi> = \<Sigma>; NN=N\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L):UniSS"

lemma UniTyping_inter [rule_format]:
  "((U,\<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS \<longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L) \<and>
   ((U,\<Sigma>, N, M,l,b,HH,c,NN) : UniBS \<longrightarrow> UniBS_inter U \<Sigma> N M l b HH c NN)"
apply (rule UniSS_UniBS.induct)
apply (erule UniGoto_inter) apply assumption+
done

lemma UniTyping_SS_inter:"(U,\<Sigma>, N, M, l, \<Pi>, NN, L): UniSS \<Longrightarrow> UniSS_inter U \<Sigma> N M l \<Pi> NN L"
by (simp add: UniTyping_inter)

lemma UniTyping_BS_inter:"(U,\<Sigma>, N, M,l,b,HH,c,NN) : UniBS \<Longrightarrow> UniBS_inter U \<Sigma> N M l b HH c NN"
by (simp add: UniTyping_inter)

lemma UniTypingSoundAux[rule_format]:
  "((U,\<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS \<longrightarrow>
   get_ins M l \<noteq> Some vreturn \<and>
   (\<forall> n S \<Gamma> H Sp \<Gamma>p Hp. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow> \<Pi> = (Sp,\<Gamma>p,Hp) \<longrightarrow>
                      (AL_dom H \<subseteq> AL_dom Hp \<and> contained N NN \<and> UniSS_UniSecN (Suc n) \<Sigma> N \<Pi> NN M l L)))
  \<and>
   ((U,\<Sigma>, N, M,l,b,HH,c,NN) : UniBS \<longrightarrow> 
    (\<forall> n k S \<Gamma> H. UniCtxtUniValidN n U \<longrightarrow> \<Sigma> = (S,\<Gamma>,H) \<longrightarrow>
                  (b \<longrightarrow> k=n) \<longrightarrow> ((\<not> b) \<longrightarrow> k=Suc n) \<longrightarrow> 
                  (AL_dom H \<subseteq> AL_dom HH \<and> contained N NN \<and> UniBS_UniSecN k \<Sigma> N HH c NN M l)))"
apply rule
apply clarsimp apply (drule UniTyping_SS_inter) apply (simp add: UniSS_inter_def) apply fast
apply clarsimp apply (drule UniTyping_BS_inter) apply (simp add: UniBS_inter_def)
done

lemma UniBS_StaticGarbageHP: 
   "\<lbrakk> UniBS_inter U \<Sigma> N M l b HH c NN; d \<notin> DOM([c],emp,delete HH d); 
       AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom (delete HH d); contained N NN; d \<notin> DOM \<Sigma>; d \<notin> AL_dom N; K=(delete HH d)
       \<rbrakk> \<Longrightarrow> UniBS_inter U \<Sigma> N M l b K c NN"