theory UniSatSec = StateInterpretation:

constdefs Invariant::"Colour \<Rightarrow> STATE \<Rightarrow> State \<Rightarrow> AddrMapping \<Rightarrow> MP \<Rightarrow> 
                         STATE \<Rightarrow> State \<Rightarrow> AddrMapping \<Rightarrow> bool"
"Invariant c \<Sigma> \<sigma> I1 N \<Pi> \<tau> I \<equiv> 
  (c : ObjIDs N \<longrightarrow> I1 c = I c) \<and> 
  Values_Represented c \<Sigma> \<sigma> I1 \<subseteq> Values_Represented c \<Pi> \<tau> I"

lemma Invariant_leftHPextensional:
 "\<lbrakk> Invariant c (S,\<Gamma>,H) \<sigma> I1 N \<Sigma> \<tau> I; 
    \<forall> x c . (H\<down>x = Some c) = (HH\<down>x = Some c); H \<in> AL\<rbrakk> 
 \<Longrightarrow> Invariant c (S,\<Gamma>,HH) \<sigma> I1 N \<Sigma> \<tau> I"
apply (frule_tac c=c and S=S and \<Gamma>=\<Gamma> and \<sigma>=\<tau> and I=I in ValuesRepresented_HPextensional)
apply (simp only: Invariant_def ValRepEQ)
apply (erule conjE)+
apply (rule, simp)
apply (rule SetTriv109) apply (rule_tac HH=H in ValuesRepresented_HPextensional) apply clarsimp apply assumption
done

lemma Invariant_rightHPextensional:
  "\<lbrakk> Invariant c \<Sigma> \<sigma> I1 N (S,\<Gamma>,H) \<tau> I; 
     \<forall> x c . (H\<down>x = Some c) = (HH\<down>x = Some c); H \<in> AL\<rbrakk> 
  \<Longrightarrow> Invariant c \<Sigma> \<sigma> I1 N (S,\<Gamma>,HH) \<tau> I"
apply (frule_tac c=c and S=S and \<Gamma>=\<Gamma> and \<sigma>=\<tau> and I=I in ValuesRepresented_HPextensional)
apply (simp add: Invariant_def ValRepEQ)
done

lemma Invariant_MPextensional:
  "\<lbrakk>Invariant c (S, \<Gamma>, H) s I N (T, \<Delta>, K) t J;
        \<forall> x c . (N\<down>x = Some c) = (NN\<down>x = Some c); N \<in> AL\<rbrakk>
     \<Longrightarrow> Invariant c (S, \<Gamma>, H) s I NN (T, \<Delta>, K) t J"
apply (unfold Invariant_def)
apply (erule conjE)+
apply (rule, clarsimp)
  apply (simp add: ObjIDs_def)
apply (simp add: ValRepEQ)
done

lemma Invariant_HPMP_extensional:
  "\<lbrakk>Invariant c (S, \<Gamma>, H) s I N (T, \<Delta>, K) t J; 
        \<forall> x c . (H\<down>x = Some c) = (HH\<down>x = Some c); 
        \<forall> x c . (K\<down>x = Some c) = (KK\<down>x = Some c); 
        \<forall> x c . (N\<down>x = Some c) = (NN\<down>x = Some c); N \<in> AL; H \<in> AL; K \<in> AL\<rbrakk>
     \<Longrightarrow> Invariant c (S, \<Gamma>, HH) s I NN (T, \<Delta>, KK) t J"
apply (unfold Invariant_def)
apply (erule conjE)+
apply (rule, clarsimp)
  apply (simp add: ObjIDs_def)
apply (simp only: ValRepEQ)
apply (subgoal_tac "ValuesRepresented c (S, \<Gamma>, H) s I = ValuesRepresented c (S, \<Gamma>, HH) s I", clarsimp) 
           apply (subgoal_tac "ValuesRepresented c (T, \<Delta>, K) t J = ValuesRepresented c (T, \<Delta>, KK) t J", clarsimp)  
           apply fast 
           apply (rule ValuesRepresented_HPextensional) apply clarsimp
           apply (rule ValuesRepresented_HPextensional) apply clarsimp
done

lemma Invariant_transitive:
 "\<lbrakk> Invariant c \<Omega> \<omega> I1 N \<Pi> \<tau> I; Invariant c \<Sigma> \<sigma> J NN \<Omega> \<omega> I1; 
    contained N NN; State_welldef (T, \<Delta>, snd (snd \<Omega>)) NN;  
     AL_dom (snd (snd \<Pi>)) \<subseteq> AL_dom (snd (snd \<Omega>))\<rbrakk>
       \<Longrightarrow> Invariant c \<Sigma> \<sigma> J N \<Pi> \<tau> I"
apply (simp add: Invariant_def, clarsimp)
apply (rule, clarsimp)
  apply (drule SetTriv) apply (erule contained_ObjIds_subset) apply simp
apply (erule SetTriv101) apply assumption
done
 
constdefs UniSS_UniSecN::"nat \<Rightarrow> STATE \<Rightarrow> MP \<Rightarrow> STATE \<Rightarrow> MP \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> (Label set) \<Rightarrow> bool"
"UniSS_UniSecN nn \<Sigma> N \<Pi> NN M l L \<equiv> AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom  (snd(snd \<Pi>))  \<and> contained N NN \<and> 
                  (\<forall> n . n \<le> nn \<longrightarrow>
                       (\<forall> \<sigma> I l1 \<sigma>1 H Nx N0 \<Sigma>0 \<Pi>0 N1.
                                       unisat \<sigma> \<Sigma>0 N0 I \<longrightarrow>
                                       SD_sum \<Sigma> H \<Sigma>0 \<longrightarrow> SD_sum \<Pi> H \<Pi>0 \<longrightarrow>
                                       AL_sum N Nx N0 \<longrightarrow> AL_dom NN \<inter> AL_dom Nx = {} \<longrightarrow>
                                       AL_sum NN Nx N1 \<longrightarrow>
                                       H:AL \<longrightarrow> Nx:AL \<longrightarrow> N0:AL \<longrightarrow> (snd(snd \<Sigma>0)):AL \<longrightarrow> (snd(snd \<Pi>0)):AL \<longrightarrow> N1 :AL \<longrightarrow>
                                       (M,l,\<sigma>, n, l1, \<sigma>1) : Step \<longrightarrow> 
                                       (\<exists> I1 . l1 : L \<and> unisat \<sigma>1 \<Pi>0 N1 I1 \<and>
                                               (\<forall> c . c : AL_dom N0 \<longrightarrow> 
                                                       Invariant c \<Pi>0 \<sigma>1 I1 N0 \<Sigma>0 \<sigma> I))))"

constdefs UniBS_UniSecN::"nat \<Rightarrow> STATE \<Rightarrow> MP \<Rightarrow> HP => Colour \<Rightarrow> MP \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> bool"
"UniBS_UniSecN nn \<Sigma> N HH c NN M l \<equiv> AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom HH \<and> contained N NN \<and> 
              (\<forall> n . n \<le> nn \<longrightarrow>
                       (\<forall> \<sigma> I h v H Nx N0 \<Sigma>0 \<Pi>0 N1 . 
                                       unisat \<sigma> \<Sigma>0 N0 I \<longrightarrow>
                                       SD_sum \<Sigma> H \<Sigma>0 \<longrightarrow> SD_sum ([c],emp,HH) H \<Pi>0 \<longrightarrow>
                                       AL_sum N Nx N0 \<longrightarrow> AL_dom NN \<inter> AL_dom Nx = {} \<longrightarrow>
                                       AL_sum NN Nx N1 \<longrightarrow>
                                       H:AL \<longrightarrow> Nx:AL \<longrightarrow> N0:AL \<longrightarrow> (snd(snd \<Sigma>0)):AL \<longrightarrow> (snd(snd \<Pi>0)):AL \<longrightarrow> N1 :AL \<longrightarrow>
                                       (M,l,\<sigma>, n, h, v) : Exec \<longrightarrow> 
                                       (\<exists> I1 . unisat ([v],emp,h) \<Pi>0 N1 I1 \<and>
                                               (\<forall> d . d : AL_dom N0 \<longrightarrow> 
                                                       Invariant d \<Pi>0 ([v],emp,h) I1 N0 \<Sigma>0 \<sigma> I))))"

lemma UniBS_UniSecN_subN:
  "\<lbrakk>UniBS_UniSecN k \<Sigma> N HH c NN M l; n \<le> k\<rbrakk> \<Longrightarrow> UniBS_UniSecN n \<Sigma> N HH c NN M l"
apply (simp add: UniBS_UniSecN_def) 
apply clarsimp 
apply (erule_tac x=na in allE, clarsimp)
done

constdefs UniSS_UniSec::"STATE \<Rightarrow> MP \<Rightarrow> STATE \<Rightarrow> MP \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> (Label set) \<Rightarrow> bool"
"UniSS_UniSec \<Sigma> N \<Pi> NN M l L \<equiv> AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom  (snd(snd \<Pi>))  \<and> contained N NN \<and> 
                       (\<forall> \<sigma> I n l1 \<sigma>1 H Nx N0 \<Sigma>0 \<Pi>0 N1.
                                       unisat \<sigma> \<Sigma>0 N0 I \<longrightarrow>
                                       SD_sum \<Sigma> H \<Sigma>0 \<longrightarrow> SD_sum \<Pi> H \<Pi>0 \<longrightarrow>
                                       AL_sum N Nx N0 \<longrightarrow> AL_dom NN \<inter> AL_dom Nx = {} \<longrightarrow>
                                       AL_sum NN Nx N1 \<longrightarrow>
                                       H:AL \<longrightarrow> Nx:AL \<longrightarrow> N0:AL \<longrightarrow> (snd(snd \<Sigma>0)):AL \<longrightarrow> (snd(snd \<Pi>0)):AL \<longrightarrow> N1 :AL \<longrightarrow>
                                       (M,l,\<sigma>, n, l1, \<sigma>1) : Step \<longrightarrow> 
                                       (\<exists> I1 . l1 : L \<and> unisat \<sigma>1 \<Pi>0 N1 I1 \<and>
                                               (\<forall> c . c : AL_dom N0 \<longrightarrow> 
                                                       Invariant c \<Pi>0 \<sigma>1 I1 N0 \<Sigma>0 \<sigma> I)))"

constdefs UniBS_UniSec::"STATE \<Rightarrow> MP \<Rightarrow> HP => Colour \<Rightarrow> MP \<Rightarrow> Mbody \<Rightarrow> Label \<Rightarrow> bool"
"UniBS_UniSec \<Sigma> N HH c NN M l \<equiv> AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom HH \<and> contained N NN \<and> 
                       (\<forall> \<sigma> I n h v H Nx N0 \<Sigma>0 \<Pi>0 N1 . 
                                       unisat \<sigma> \<Sigma>0 N0 I \<longrightarrow>
                                       SD_sum \<Sigma> H \<Sigma>0 \<longrightarrow> SD_sum ([c],emp,HH) H \<Pi>0 \<longrightarrow>
                                       AL_sum N Nx N0 \<longrightarrow> AL_dom NN \<inter> AL_dom Nx = {} \<longrightarrow>
                                       AL_sum NN Nx N1 \<longrightarrow>
                                       H:AL \<longrightarrow> Nx:AL \<longrightarrow> N0:AL \<longrightarrow> (snd(snd \<Sigma>0)):AL \<longrightarrow> (snd(snd \<Pi>0)):AL \<longrightarrow> N1 :AL \<longrightarrow>
                                       (M,l,\<sigma>, n, h, v) : Exec \<longrightarrow> 
                                       (\<exists> I1 . unisat ([v],emp,h) \<Pi>0 N1 I1 \<and>
                                               (\<forall> d . d : AL_dom N0 \<longrightarrow> 
                                                       Invariant d \<Pi>0 ([v],emp,h) I1 N0 \<Sigma>0 \<sigma> I)))"

lemma UniSS_UniSecN_subN:
  "\<lbrakk>UniSS_UniSecN k \<Sigma> N \<Pi> NN M l L; n \<le> k\<rbrakk> \<Longrightarrow> UniSS_UniSecN n \<Sigma> N \<Pi> NN M l L"
(*<*)
apply (unfold UniSS_UniSecN_def) 
apply (erule conjE)+
apply (rule, assumption)
apply (rule, assumption)
apply (rule, rule) 
apply (erule_tac x=na in allE, erule mp) apply clarsimp
done
(*>*)

lemma UniSS_UniSecN_UniSS_UniSec:
  "(\<forall> n . UniSS_UniSecN n \<Sigma> N \<Pi> NN M l L) \<Longrightarrow> UniSS_UniSec \<Sigma> N \<Pi> NN M l L"
(*<*)
apply (unfold UniSS_UniSec_def UniSS_UniSecN_def)
apply (rule, clarsimp)
apply (rule, clarsimp)
apply (rule allI)+
apply (erule_tac x=n in allE, (erule conjE)+)
apply (erule_tac x=n in allE, erule impE) apply simp
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE)
apply (erule_tac x=l1 in allE, erule_tac x=\<sigma>1 in allE)
apply (erule_tac x=H in allE, erule_tac x=Nx in allE)
apply (erule_tac x=N0 in allE, erule_tac x=\<Sigma>0 in allE)
apply (erule_tac x=\<Pi>0 in allE, erule_tac x=N1 in allE)
apply assumption
done
(*>*)

lemma UniSS_UniSec_UniSS_UniSecN:"UniSS_UniSec \<Sigma> N \<Pi> NN M l L \<Longrightarrow> UniSS_UniSecN n \<Sigma> N \<Pi> NN M l L"
(*<*)
apply (unfold UniSS_UniSec_def UniSS_UniSecN_def)
apply (erule conjE)+
apply (rule, assumption)
apply (rule, assumption)
apply (rule, rule)
apply (rule allI)+
apply (erule_tac x=\<sigma> in allE, erule_tac x=I in allE)
apply (erule_tac x=na in allE)
apply (erule_tac x=l1 in allE, erule_tac x=\<sigma>1 in allE)
apply (erule_tac x=H in allE, erule_tac x=Nx in allE)
apply (erule_tac x=N0 in allE, erule_tac x=\<Sigma>0 in allE)
apply (erule_tac x=\<Pi>0 in allE, erule_tac x=N1 in allE)
apply assumption
done
(*>*)

lemma UniBS_UniSecN_UniBS_UniSec:
  "(\<forall> n . UniBS_UniSecN n \<Sigma> N HH c NN M l) \<Longrightarrow> UniBS_UniSec \<Sigma> N HH c NN M l"
(*<*)
apply (simp add: UniBS_UniSec_def UniBS_UniSecN_def, clarify)
apply (erule_tac x=n in allE, erule_tac x=n in allE, clarsimp)
done
(*>*)

lemma UniBS_UniSec_UniBS_UniSecN:"UniBS_UniSec \<Sigma> N HH c NN M l \<Longrightarrow> UniBS_UniSecN n \<Sigma> N HH c NN M l"
(*<*)
apply (simp add: UniBS_UniSec_def UniBS_UniSecN_def)
done
(*>*)

types "UniCtxt" = "((Mbody \<times> Label) \<times> (STATE \<times> MP \<times> HP \<times> Colour \<times> MP)) set"

text{*Context validity and relatived context validity are defined as follows.*}

constdefs UniCtxtUniValid::"UniCtxt \<Rightarrow> bool"
"UniCtxtUniValid U \<equiv>
   (\<forall> M l S \<Gamma> H N H' c N'. 
      ((M,l),((S,\<Gamma>,H),N,H',c,N')) \<in> U \<longrightarrow>
      (AL_dom H \<subseteq> AL_dom H' \<and> contained N N' \<and> UniBS_UniSec (S,\<Gamma>,H) N H' c N' M l))"

constdefs UniCtxtUniValidN::"nat \<Rightarrow> UniCtxt \<Rightarrow> bool"
"UniCtxtUniValidN n U \<equiv>
   (\<forall> M l S \<Gamma> H N H' c N'. 
      ((M,l),((S,\<Gamma>,H),N,H',c,N')) \<in> U \<longrightarrow>
      (AL_dom H \<subseteq> AL_dom H' \<and> contained N N' \<and> UniBS_UniSecN n (S,\<Gamma>,H) N H' c N' M l))"

lemma UniCtxtUniValidN_sub:"UniCtxtUniValidN (Suc n) U \<Longrightarrow> UniCtxtUniValidN n U"
apply (simp add: UniCtxtUniValidN_def)
apply clarsimp
apply (rule UniBS_UniSecN_subN) apply fast
apply simp
done

lemma UniCtxtUniValidN_UniCtxtUniValid:
  "(\<forall> n . UniCtxtUniValidN n U) \<Longrightarrow> UniCtxtUniValid U"
apply (simp add: UniCtxtUniValid_def UniCtxtUniValidN_def)
apply clarsimp
  apply (rule UniBS_UniSecN_UniBS_UniSec) apply (rule, erule_tac x=n in allE, simp)
done

lemma UniCtxtUniValid_UniCtxtUniValidN:"UniCtxtUniValid U \<Longrightarrow> UniCtxtUniValidN n U"
(*<*)
apply (simp add: UniCtxtUniValid_def UniCtxtUniValidN_def)
apply clarsimp
  apply (rule UniBS_UniSec_UniBS_UniSecN) apply fast
done
(*>*)

end
