theory UniTyping = INSTR_GET + INSTR_PUT + INSTR_NEW + RuleUniInvS + RuleUniInvV + Rules_UniBasic + Ren:
      
(*This definition is in UniSatSec
types "UniCtxt" = "(Mbody \<times> Label,STATE \<times> MP \<times> HP \<times> Colour \<times> MP) AssList"
*)

consts UniSS:: "(UniCtxt \<times> STATE \<times> MP \<times> Mbody \<times> Label \<times> STATE \<times> MP \<times> (Label set)) set"
       UniBS:: "(UniCtxt \<times> STATE \<times> MP \<times> Mbody \<times> Label \<times> bool \<times> HP \<times> Colour \<times> MP) set"

inductive UniSS UniBS intros

UniBS_StaticGarbageHP: "\<lbrakk> (U, \<Sigma>,N, M,l,b,HH ,c,NN) : UniBS; d \<notin> DOM([c],emp,delete HH d); 
       AL_dom (snd(snd \<Sigma>)) \<subseteq> AL_dom (delete HH d); contained N NN; d \<notin> DOM \<Sigma>; d \<notin> AL_dom N; K=(delete HH d)
       \<rbrakk> \<Longrightarrow> (U, \<Sigma> ,N, M,l,b,K,c,NN) : UniBS"

UniBS_StaticGarbageColour: 
  "\<lbrakk> (U, \<Sigma>, N, M,l, b, HH ,c, NN) : UniBS; d \<notin> DOM([c],emp,HH);
      contained N (delete NN d); d \<notin> DOM \<Sigma>; NNN= delete NN d\<rbrakk>
   \<Longrightarrow> (U, \<Sigma> ,N, M,l,b,HH,c,NNN) : UniBS"

UniSSPost_extensional: 
   "\<lbrakk> (U, \<Sigma>, N, M, l, (S,\<Gamma>,H), NN, L) : UniSS;
      \<forall> c d . (H\<down>c = Some d) =  (K\<down>c = Some d); K:AL;
      \<forall> c d . (NN\<down>c = Some d) =  (MM\<down>c = Some d); MM:AL\<rbrakk> 
     \<Longrightarrow> (U, \<Sigma>, N, M, l, (S,\<Gamma>,K), MM, L) : UniSS"

UniBSPost_extensional:
  "\<lbrakk> (U, \<Sigma>,N, M,l,b,H,c,N') : UniBS;
     \<forall> c d . (H\<down>c = Some d) =  (K\<down>c = Some d); K:AL;
     \<forall> c d . (N'\<down>c = Some d) =  (MM\<down>c = Some d); MM:AL\<rbrakk>
  \<Longrightarrow> (U, \<Sigma>,N, M,l,b,K,c,MM) : UniBS"

UniGoto:"\<lbrakk> get_ins M l = Some (goto pc); L= {pc}; \<Pi> = \<Sigma>; NN=N\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L):UniSS"

UniRen:
  "\<lbrakk> renUniState (\<Sigma>,N) f (f\<Sigma>,fN); renUniState (\<Pi>,N') g (g\<Pi>,gN');
     \<forall>c fc. f c = Some fc \<longrightarrow> g c = Some fc;
     inj_on g (dom g - dom f); Img g (dom g - dom f) \<inter> Img g (dom f) = {};
     (U, \<Sigma>, N, M, l, \<Pi>, N', L) : UniSS\<rbrakk>
     \<Longrightarrow> (U, f\<Sigma>, fN, M, l, g\<Pi>, gN', L):UniSS"

UniSSFrame:
  "\<lbrakk> (U, \<Sigma>, NNN, M, l, \<Pi>, NN,L) : UniSS; SD_sum \<Sigma> H \<Sigma>1; SD_sum \<Pi> H \<Pi>1;
     AL_sum NNN N NNN1; AL_sum NN N NN1; AL_dom NN \<inter> AL_dom N = {}
   \<rbrakk> \<Longrightarrow> (U, \<Sigma>1, NNN1, M, l, \<Pi>1, NN1, L) : UniSS"

UniBSFrame:
  "\<lbrakk> (U, \<Sigma>, NNN, M, l, b, HH, c, NN) : UniBS; SD_sum \<Sigma> H \<Sigma>1; SD_sum ([],emp,HH) H ([],emp,HHH);
     AL_sum NNN N NNN1; AL_sum NN N NN1; AL_dom NN \<inter> AL_dom N = {}
   \<rbrakk> \<Longrightarrow> (U, \<Sigma>1,NNN1, M,l,b,HHH,c,NN1) : UniBS"

UniConst: "\<lbrakk> get_ins M l = Some (const (IVal i));
             \<Sigma> = (S,\<Gamma>,H); c \<notin> AL_dom N; L= {l+1}; 
             \<Pi>=(c#S,\<Gamma>,H); NN=N[c\<mapsto>intTP] \<rbrakk>
         \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

UniPop: "\<lbrakk> get_ins M l = Some pop; 
             \<Sigma> = (c#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

UniDup: "\<lbrakk> get_ins M l = Some dup; 
             \<Sigma> = (c#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(c#c#S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

UniSwap: "\<lbrakk> get_ins M l = Some swap; 
             \<Sigma> = (c#d#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(d#c#S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

UniLoad: "\<lbrakk> get_ins M l = Some (load x); 
             \<Sigma> = (S,\<Gamma>,H); \<Gamma>\<down>x = Some c; L= {l+1}; 
             \<Pi>=(c#S,\<Gamma>,H); NN=N \<rbrakk>
         \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

UniStore: "\<lbrakk> get_ins M l = Some (store x); 
             \<Sigma> = (c#S,\<Gamma>,H); L= {l+1}; 
             \<Pi>=(S,\<Gamma>[x\<mapsto>c],H); NN=N \<rbrakk>
         \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

UniUnop: "\<lbrakk>get_ins M l = Some (unop f); \<Sigma> = (c # S,\<Gamma>,H);
              N\<down>c = Some tpp; d \<notin> AL_dom N;  
              \<Pi> = (d#S,\<Gamma>,H); NN=N[d\<mapsto>intTP]; L={l+1};
            \<forall> v . typecorrect v tpp \<longrightarrow> typecorrect (f v) intTP\<rbrakk>
              \<Longrightarrow> (U,\<Sigma>,N,M,l,\<Pi>,NN,L):UniSS"

UniBinop:
   "\<lbrakk> get_ins M l = Some (binop f); \<Sigma> = (c1 # c2 # S,\<Gamma>,H);
      N\<down>c1 = Some tp1; N\<down>c2 = Some tp2; c \<notin> AL_dom N;
      \<Pi> = (c#S,\<Gamma>,H); NN=N[c\<mapsto>intTP]; L={l+1}; 
      \<forall> v w . typecorrect v tp1 \<longrightarrow> typecorrect w tp2 \<longrightarrow> typecorrect (f v w) intTP\<rbrakk>
   \<Longrightarrow> (U,\<Sigma>,N,M,l,\<Pi>,NN,L):UniSS"

(*UniBinopNEW:
   "\<lbrakk> get_ins M l = Some (binop f); \<Sigma> = (c1 # c2 # S,\<Gamma>,H);
      N\<down>c1 = Some tp1; N\<down>c2 = Some tp2; c \<notin> AL_dom N;
      \<Pi> = (c#S,\<Gamma>,H); NN=N[c\<mapsto>intTP]; L={l+1}; 
      \<forall> v w . typecorrect v tp1 \<longrightarrow> typecorrect w tp2 \<longrightarrow> typecorrect (f v w) intTP\<rbrakk>
   \<Longrightarrow> (U,\<Sigma>,N,M,l,\<Pi>,NN,L):UniSS"
*)

(*not needed any more: subclass_of C D*)
UniPut: "\<lbrakk> get_ins M l = Some (putfield C f); \<Sigma> = (c1#c2#S,\<Gamma>,H);
           H\<down>c2 = Some(D,F); L= {l+1}; 
           \<Pi>=(S,\<Gamma>,H[c2 \<mapsto> (D,F[f \<mapsto> c1])]); NN=N \<rbrakk>
         \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

(*not needed any more: subclass_of C D;*)
UniGet:"\<lbrakk> get_ins M l = Some (getfield C f); \<Sigma> = (c1#S,\<Gamma>,H);
          H\<down>c1 = Some(D,F); F\<down>f = Some c2; 
          \<Pi>=(c2#S,\<Gamma>,H); NN=N; L={l+1}\<rbrakk>
        \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L) : UniSS"

UniNew:"\<lbrakk> get_ins M l = Some (new C); \<Sigma> = (S,\<Gamma>,H);
          cl \<notin> AL_dom N; L= {l+1}; subclass_of C D;
          \<Pi> = (cl#S,\<Gamma>,H[cl \<mapsto> (C,emp)]); NN = N[cl \<mapsto> (classTP D)]\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L):UniSS"

UniInvS:"\<lbrakk> get_ins M l = Some (invokeS C m);  mbody_is C m (P1, code, l0); 
            \<Sigma> = (S1, \<Gamma>, H); (S1, P1,\<Gamma>1,S):absFrame; 
            \<Pi> = (c # S, \<Gamma>, HH); L = {l+1}; NN:AL;
           (U, ([], \<Gamma>1, H), N, (P1, code, l0), l0, True, HH, c, NN) : UniBS\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L): UniSS"

(*the rules InvV, InvV2 are sound, but we havent adapted the proofs in ruluniInvV to UniSec yet
UniInvV:"\<lbrakk> get_ins M l = Some (invokeV C m);  mbody_is C m (P1, code, l0); 
            \<Sigma> = (S1, \<Gamma>, H); (S1, P1,\<Gamma>1,d#S):absFrame; H\<down>d = Some(D,F); subclass_of D C;
            \<Pi> = (c # S, \<Gamma>, HH); L = {l+1}; NN:AL;
           \<forall> D code1 l1. subclass_of D C \<longrightarrow> mbody_is D m (P1,code1,l1) \<longrightarrow>
                         (U, ([], upd \<Gamma>1 this d, H), N, (P1, code1, l1), l1, True, HH, c, NN) : UniBS\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L): UniSS"

UniInvV2:"\<lbrakk> get_ins M l = Some (invokeV C m);  mbody_is C m (P1, code, l0); 
            \<Sigma> = (S1, \<Gamma>, H); (S1, P1,\<Gamma>1,d#S):absFrame; H\<down>d = Some(D,F); subclass_of D C;
            \<Pi> = (c # S, \<Gamma>, HH); L = {l+1}; NN:AL;
           \<forall> E . subclass_of E D \<longrightarrow> (\<exists> code1 l1 . mbody_is E m (P1,code1,l1) \<and>
                         (U, ([], upd \<Gamma>1 this d, H), N, (P1, code1, l1), l1, True, HH, c, NN) : UniBS)\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L): UniSS"
*)

UniInvV3:"\<lbrakk> get_ins M l = Some (invokeV C m);  mbody_is C m (P1, code, l0); 
            \<Sigma> = (S1, \<Gamma>, H); (S1, P1,\<Gamma>1,d#S):absFrame; H\<down>d = Some(D,F); 
            \<Pi> = (c # S, \<Gamma>, HH); L = {l+1}; NN:AL;
           \<forall> E . subclass_of E D \<longrightarrow> (\<exists> code1 l1 . mbody_is E m (P1,code1,l1) \<and>
                         (U, ([], upd \<Gamma>1 this d, H), N, (P1, code1, l1), l1, True, HH, c, NN) : UniBS)\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L): UniSS"

UniIf:"\<lbrakk> get_ins M l = Some (iftrue pc); \<Sigma> = (c#S,\<Gamma>,H);
         L= {l+1,pc}; \<Pi> = (S,\<Gamma>,H); NN=N\<rbrakk>
          \<Longrightarrow> (U, \<Sigma>, N, M, l, \<Pi>, NN, L):UniSS"

UniVret: "\<lbrakk>get_ins M l = Some vreturn; \<Sigma>=(c # S,\<Gamma>,H);NN=N\<rbrakk>
         \<Longrightarrow> (U, \<Sigma>,N, M,l, False, H, c, NN) : UniBS"

UniRun:  "\<lbrakk>(U, \<Sigma>, N, M,l, \<Sigma>', N', L):UniSS; 
            \<forall> l'. l' : L \<longrightarrow> (U, \<Sigma>', N', M,l',True,H, c, N''):UniBS \<rbrakk>
       \<Longrightarrow> (U, \<Sigma>,N, M,l,False,H,c,N'') : UniBS"
(*
UniRun:  "\<lbrakk>(U, \<Sigma>, N, M,l, \<Sigma>', N', L):UniSS; \<exists> l' . l' : L;
            \<forall> l'. l' : L \<longrightarrow> (U, \<Sigma>', N', M,l',True,H, c, N''):UniBS \<rbrakk>
       \<Longrightarrow> (U, \<Sigma>,N, M,l,False,H,c,N'') : UniBS"
*)
UniInj: "(U, \<Sigma>,N, M,l,False,H,c,N'') : UniBS \<Longrightarrow> (U, \<Sigma>,N, M,l,True,H,c,N'') : UniBS"

UniAx: "((M,l),(\<Sigma>,N,H,c,N')) \<in> U \<Longrightarrow> (U,\<Sigma>,N, M,l,True,H,c,N') : UniBS"

(*<*)
lemma UniRunSingle:  "\<lbrakk>(U, \<Sigma>, N, M,l, \<Sigma>', N', {l'}):UniSS; (U, \<Sigma>', N', M,l',True,H, c, N''):UniBS \<rbrakk>
       \<Longrightarrow> (U, \<Sigma>,N, M,l,False,H,c,N'') : UniBS"
apply (erule UniRun) apply fast done

lemma UniSS_L_notEmpty_Aux[rule_format]:
  "((U, \<Sigma>, N, M, l, \<Pi>, NN, L) \<in> UniSS \<longrightarrow> (\<exists> l . l:L)) \<and> ((U, \<Sigma> ,N, M,l,b,HH,c,NN) : UniBS \<longrightarrow> True)"
apply (rule UniSS_UniBS.induct)
apply (simp_all) apply fast
done
(*>*)

lemma UniSS_L_notEmpty: "(U, \<Sigma>, N, M, l, \<Pi>, NN, L) \<in> UniSS \<Longrightarrow> \<exists> l . l:L"
(*<*)
apply (simp add: UniSS_L_notEmpty_Aux)
done
(*>*)

text{*The syntactic counterpart to context validity , the formal
justification of a proof context, is the \emph{derivability} all
entries.*}

constdefs UniCtxtVerified::"UniCtxt \<Rightarrow> bool"
"UniCtxtVerified U \<equiv> 
 (\<forall> M l S \<Gamma> H N H' c N'. ((M,l),((S,\<Gamma>,H),N,H',c,N')) \<in> U \<longrightarrow>
                         AL_dom H \<subseteq> AL_dom H' \<and> contained N N' \<and> 
                         (U, (S,\<Gamma>,H), N, M,l,False,H',c,N') : UniBS)"

lemma UniCtxtVerified_emp: "UniCtxtVerified {}"
by (simp add: UniCtxtVerified_def AL_emp1)

end