theory ValuesRep = AbstrState:

types "AddrMapping" = "Colour ~=> Addr"

constdefs ValuesRepresented::"Colour \<Rightarrow> STATE \<Rightarrow> State \<Rightarrow> AddrMapping \<Rightarrow> (Val set)"
"ValuesRepresented c \<Sigma> \<sigma> I \<equiv>
   (case \<Sigma> of (S,\<Gamma>,H) \<Rightarrow> 
     (case \<sigma> of (ops,s,h) \<Rightarrow> { v . (\<exists> n < length S. (S!n) = c \<and> (ops!n) = v) \<or>
                                   (\<exists> x . \<Gamma>\<down>x = Some c \<and> s\<down>x = Some v) \<or>
                                   (\<exists> a . I c = Some a \<and> v = RVal (Loc a) \<and> c:AL_dom H) \<or>
                                   (\<exists> d D F f C G a. H\<down>d = Some(D,F) \<and> F\<down>f = Some c \<and> I d = Some a \<and>
                                                 h\<down>a = Some(C,G) \<and> G\<down>f = Some v)}))"

constdefs OpsValues_Represented::"Colour \<Rightarrow> (Colour list) \<Rightarrow> OpStack \<Rightarrow> (Val set)"
"OpsValues_Represented c S ops \<equiv> { v . (\<exists> n < length S. (S!n) = c \<and> (ops!n) = v)}"

constdefs StoreValues_Represented::"Colour \<Rightarrow> VarContext \<Rightarrow> Store \<Rightarrow> (Val set)"
"StoreValues_Represented c \<Gamma> s \<equiv> { v .\<exists> x . \<Gamma>\<down>x = Some c \<and> s\<down>x = Some v}"

constdefs AddrValues_Represented::"Colour \<Rightarrow> HP \<Rightarrow> AddrMapping \<Rightarrow> (Val set)"
"AddrValues_Represented c H I \<equiv> { v . \<exists> a . I c = Some a \<and> v = RVal (Loc a) \<and> c:AL_dom H}"

constdefs FieldValues_Represented::"Colour \<Rightarrow> HP \<Rightarrow> AddrMapping \<Rightarrow> Heap \<Rightarrow> (Val set)"
"FieldValues_Represented c H I h \<equiv> 
   {v . \<exists> d D F f C G a. H\<down>d = Some(D,F) \<and> F\<down>f = Some c \<and> I d = Some a \<and>
                       h\<down>a = Some(C,G) \<and> G\<down>f = Some v}"

constdefs Values_Represented::"Colour \<Rightarrow> STATE \<Rightarrow> State \<Rightarrow> AddrMapping \<Rightarrow> (Val set)"
"Values_Represented c \<Sigma> \<sigma> I \<equiv>
   (case \<Sigma> of (S,\<Gamma>,H) \<Rightarrow> 
     (case \<sigma> of (ops,s,h) \<Rightarrow> OpsValues_Represented c S ops \<union> StoreValues_Represented c \<Gamma> s \<union>
                             AddrValues_Represented c H I \<union> FieldValues_Represented c H I h))"

lemma ValRepEQ: "Values_Represented c \<Sigma> \<sigma> I = ValuesRepresented c \<Sigma> \<sigma> I"
apply (simp add: Values_Represented_def ValuesRepresented_def)
apply (case_tac \<Sigma>, clarsimp)
apply (case_tac \<sigma>, clarsimp)
apply (simp add: OpsValues_Represented_def StoreValues_Represented_def AddrValues_Represented_def
       FieldValues_Represented_def) apply fast
done

lemma ValuesRepresented_HD: "ValuesRepresented ca ([c], \<Gamma>, H) ([v], s, h) I \<subseteq> ValuesRepresented ca (c # S, \<Gamma>, H) (v # ops, s, h) I"
apply (simp add: ValuesRepresented_def, clarsimp)
apply (erule_tac x=0 in allE, clarsimp)
done

lemma ValuesRepresented1:
  "c \<noteq> d \<Longrightarrow>
   ValuesRepresented c (d # S, \<Gamma>, H) (v # ops, aa, b) I = ValuesRepresented c (S, \<Gamma>, H) (ops, aa, b) I"
apply (simp add: ValuesRepresented_def)
apply (rule, clarsimp) 
  apply (case_tac n, clarsimp) apply clarsimp
  apply (erule_tac x=nat in allE, clarsimp)
apply clarsimp
  apply (erule_tac x="Suc n" in allE, clarsimp)
done

lemma ValuesRepresented2:
  "v : (ValuesRepresented c (c # S, \<Gamma>, H) (v # ops, s, h) I)"
apply (simp add: ValuesRepresented_def)
apply clarsimp
  apply (erule_tac x=0 in allE, clarsimp)
done

lemma  ValuesRepresented3: "\<lbrakk>c \<in> AL_dom H; I c = Some a\<rbrakk> \<Longrightarrow> (RVal (Loc a)) : (ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I)"
by (simp add: ValuesRepresented_def)

lemma  ValuesRepresented4:
  "\<lbrakk> h\<down>a = Some (C, Flds); Flds\<down>f = Some v; H\<down>c = Some (D, F); F\<down>f = Some d; I c = Some a; subclass_of C D\<rbrakk>
   \<Longrightarrow> ValuesRepresented d (S, \<Gamma>, H) (ops, s, h) I = ValuesRepresented d (d # S, \<Gamma>, H) (v # ops, s, h) I"
apply (simp add: ValuesRepresented_def)
apply (rule, clarsimp)
  apply (erule_tac x="Suc n" in allE, clarsimp)
apply clarsimp
  apply (case_tac n, clarsimp) 
  apply clarsimp apply (erule_tac x=nat in allE, clarsimp)
done

lemma  ValuesRepresented5:
  "\<lbrakk> h\<down>a = Some (C, Flds); Flds\<down>f = Some v; H\<down>c = Some (D, F); 
     F\<down>f = Some d; subclass_of C D; I c = Some a\<rbrakk>
   \<Longrightarrow> v \<in> ValuesRepresented d (c # S, \<Gamma>, H) (RVal (Loc a) # ops, s, h) I"
by (simp add: ValuesRepresented_def, clarsimp)

lemma ValuesRepresented6:
  "\<lbrakk> H\<down>c = Some (C, F); I c = Some a\<rbrakk>
    \<Longrightarrow> ValuesRepresented c (c # S, \<Gamma>, H) (RVal (Loc a) # ops, aa, b) I = ValuesRepresented c (S, \<Gamma>, H) (ops, aa, b) I"
apply (simp add: ValuesRepresented_def)
apply (rule, clarsimp)
  apply (case_tac n, clarsimp) apply (simp add: AL_dom_def)
  apply clarsimp apply (erule_tac x=nat in allE, clarsimp)
apply clarsimp apply (erule_tac x="Suc n" in allE, clarsimp)
done

lemma ValuesRepresented7: "v \<in> ValuesRepresented d (c # d # S, \<Gamma>, H) (w # v # ops, s, h) I" 
apply (simp add: ValuesRepresented_def) 
apply clarsimp 
apply (erule_tac x=1 in allE, clarsimp)
done


lemma ValuesRepresented9: "ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I \<subseteq> ValuesRepresented c (d # S, \<Gamma>, H) (v # ops, s, h) I"
apply (simp add: ValuesRepresented_def, clarsimp)
by (erule_tac x="Suc n" in allE, clarsimp)

lemma ValuesRepresented10:
  "\<lbrakk>ValuesRepresented (\<alpha> c) (T1, \<Delta>1, K1) (ops, s1, h1) J = {}; 
        \<forall>x c. \<Delta>\<down>x = Some c \<longrightarrow> \<Delta>1\<down>x = Some (\<alpha> c);
        \<forall>c C F. K\<down>c = Some (C, F) \<longrightarrow> (\<exists>F1. K1\<down>(\<alpha> c) = Some (C, F1) \<and> (\<forall>f d. F\<down>f = Some d \<longrightarrow> F1\<down>f = Some (\<alpha> d)));
        length T1 = length T; \<forall>n<length T1. \<alpha> (T ! n) = T1 ! n\<rbrakk>
       \<Longrightarrow> ValuesRepresented c (T, \<Delta>, K) (ops, s1, h1) (\<lambda>c. J (\<alpha> c)) = {}"
apply (rule, simp add: ValuesRepresented_def, clarsimp)
      apply (rule, clarsimp) apply (erule_tac x="ops!n" in allE, clarsimp)
                             apply (rotate_tac -4, erule_tac x=n in allE, clarsimp)
      apply (rule, clarsimp) apply (erule_tac x="RVal (Loc a)" in allE, clarsimp) 
                             apply (subgoal_tac "\<exists> D F . K1\<down>(\<alpha> c) = Some(D,F)", simp add: AL_dom_def)
                             apply (subgoal_tac "\<exists> DD FF . K\<down>c = Some(DD,FF)", (erule exE)+) 
                               apply (erule_tac x=c in allE, erule_tac x=DD in allE, erule_tac x=FF in allE, erule impE, assumption)
                               apply clarsimp
                             apply ( simp add: AL_dom_def)
      apply clarsimp apply (erule_tac x=x in allE, clarsimp)
                     apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, erule impE, assumption)
                     apply clarsimp
    apply fast
done

lemma ValuesRepresented11:
  "\<lbrakk>x \<in> ValuesRepresented c (T, \<Delta>, K) (ops, s1, h1) (\<lambda>c. J (\<alpha> c)); 
        \<forall>x c. \<Delta>\<down>x = Some c \<longrightarrow> \<Delta>1\<down>x = Some (\<alpha> c);
        \<forall>c C F. K\<down>c = Some (C, F) \<longrightarrow> (\<exists>F1. K1\<down>(\<alpha> c) = Some (C, F1) \<and> (\<forall>f d. F\<down>f = Some d \<longrightarrow> F1\<down>f = Some (\<alpha> d)));
        length T1 = length T; \<forall>n<length T1. \<alpha> (T ! n) = T1 ! n
   \<rbrakk> \<Longrightarrow> x \<in> ValuesRepresented (\<alpha> c) (T1, \<Delta>1, K1) (ops, s1, h1) J"
    apply (simp add: ValuesRepresented_def, clarsimp)
      apply (erule disjE, clarsimp) 
        apply (rotate_tac -4, erule_tac x=n in allE, clarsimp)
      apply (erule disjE, clarsimp)
      apply (erule disjE, clarsimp) 
                             apply (subgoal_tac "\<exists> D F . K1\<down>(\<alpha> c) = Some(D,F)", simp add: AL_dom_def)
                             apply (subgoal_tac "\<exists> DD FF . K\<down>c = Some(DD,FF)", (erule exE)+) 
                               apply (erule_tac x=c in allE, erule_tac x=DD in allE, erule_tac x=FF in allE, erule impE, assumption)
                               apply clarsimp
                             apply ( simp add: AL_dom_def)
      apply clarsimp apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, erule impE, assumption)
                     apply clarsimp
done

lemma ValuesRepresented12: "ValuesRepresented c ([], \<Gamma>, H) ([], s, h) J \<subseteq> ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) J"
  apply (simp add: ValuesRepresented_def)
  apply (rule, clarsimp)
done

lemma ValuesRepresented13: "ValuesRepresented c (S, emp, H) (ops, emp, h) J \<subseteq> ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) J"
  apply (simp add: ValuesRepresented_def)
  apply (rule, clarsimp)
  apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
  apply clarsimp
done

lemma ValuesRepresented14:
   "ValuesRepresented ca (c1 # S, \<Gamma>, x) (va # opsb, aa, hh) I1 = ValuesRepresented ca ([c1], emp, x) ([va], emp, hh) I1 \<union>
                                                                 ValuesRepresented ca (S, \<Gamma>, x) (opsb, aa, hh) I1"
apply (simp add: ValuesRepresented_def)
apply rule
  apply clarsimp
    apply (case_tac n, clarsimp)
    apply clarsimp apply (erule_tac x=nat in allE, clarsimp)
  apply clarsimp
  apply rule
    apply clarsimp 
    apply (erule disjE, clarsimp) apply (erule_tac x=0 in allE, clarsimp)
    apply (erule disjE, clarsimp) apply (simp add: AL_emp1)
    apply clarsimp
  apply clarsimp apply (erule_tac x="Suc n" in allE, clarsimp)
done

lemma ValuesRepresented15:"ValuesRepresented ca ([], emp, hh) ([], emp, h) I \<subseteq> ValuesRepresented ca (ops, s, hh) (S, \<Gamma>, h) I"
apply (simp add: ValuesRepresented_def)
apply clarsimp
apply (simp add: AL_emp1)
done

lemma ValuesRepresented_notin_DOM: "c \<notin> DOM \<Sigma> \<Longrightarrow> ValuesRepresented c \<Sigma> \<tau> J = {}"
apply (simp add: ValuesRepresented_def DOM_def)
apply (case_tac \<Sigma>, clarsimp)
apply (case_tac \<tau>, clarsimp)
apply (erule disjE) apply clarsimp
apply (erule disjE) apply clarsimp apply (drule AL_codI) apply simp
apply clarsimp apply (simp add: AbsFields_expand) 
done

lemma Values_Represented_CONS: "Values_Represented ca (S, \<Gamma>, H) (ops, s, h) I \<subseteq> Values_Represented ca (c # S, \<Gamma>, H) (v # ops, s, h) I"
apply (simp add: Values_Represented_def OpsValues_Represented_def)
apply (rule, clarsimp) apply (rule_tac x="Suc n" in exI, simp)
apply (rule, clarsimp)
apply (rule, clarsimp)
apply  clarsimp
done

lemma ValuesRepresented_AddrMappingEQ:
  "\<lbrakk>J c = I c; \<forall> d . d:AL_dom H \<longrightarrow> J d = I d\<rbrakk>
    \<Longrightarrow> ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I = ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) J"
apply (simp add: ValuesRepresented_def)
apply (rule, clarsimp)
  apply (erule_tac x=d in allE, erule impE, erule AL_domI)
  apply (erule_tac x=d in allE, clarsimp)
apply clarsimp
  apply (erule_tac x=d in allE, erule impE, erule AL_domI)
  apply (erule_tac x=d in allE, clarsimp)
done
lemma ValuesRepresented_HPextensional:
  "\<lbrakk>\<forall> x c. (H\<down>x = Some c) = (HH\<down>x = Some c)\<rbrakk> 
  \<Longrightarrow> ValuesRepresented c (S, \<Gamma>, H) \<sigma> I = ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I"
apply (subgoal_tac " AL_dom HH = AL_dom H")
prefer 2 apply (simp add: AL_dom_def)
apply (simp add: ValuesRepresented_def)
apply (case_tac \<sigma>, clarsimp)
done

lemma VR_Addr_sum:
  "\<lbrakk> I d = Some y; AL_sum H Ha HHa; d \<in> AL_dom Ha\<rbrakk>
   \<Longrightarrow> RVal (Loc y) \<in> Values_Represented d (S, \<Gamma>, HHa) (ops, s, h) I"
apply (rule_tac X="AddrValues_Represented d HHa I" in SetTriv)
apply (simp add: AddrValues_Represented_def) apply (erule AL_sum4a, assumption)
apply (simp add: Values_Represented_def) apply fast 
done

lemma ValuesRepresented_AL_sum: "AL_sum H H1 HH \<Longrightarrow> ValuesRepresented c (S, \<Gamma>, H) \<sigma> I \<subseteq> ValuesRepresented c (S, \<Gamma>, HH) \<sigma> I"
apply (simp add: ValuesRepresented_def)
apply (case_tac \<sigma>, clarsimp)
apply (erule disjE, clarsimp) apply (erule AL_sum_member) apply assumption
apply clarsimp apply (drule AL_sum_entry) apply assumption
  apply clarsimp
done

lemma State_welldef_notinMP_ValuesRepresented_Empty:
  "\<lbrakk>State_welldef (S, \<Gamma>, H) N; c\<notin>AL_dom N\<rbrakk> \<Longrightarrow> ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I = {}"
apply (simp add: ValuesRepresented_def, clarsimp)
apply (rule, clarsimp) 
  apply (drule State_welldef_OPS_lookup_dom) apply assumption apply simp
apply (rule, clarsimp)
  apply (drule State_welldef_Store_lookup_dom) apply assumption apply simp
apply (rule, clarsimp)
  apply (drule AL_domD, clarsimp)
  apply (drule State_welldef_Heap_lookup_dom) apply assumption apply simp
apply clarsimp
  apply (drule State_welldef_Field_lookup_dom) apply assumption apply assumption apply simp
done

lemma ValuesRepresented_EQonObjIDs:
  "\<lbrakk> State_welldef (S, \<Gamma>, H) N;  \<forall>c. c \<in> ObjIDs N \<longrightarrow> I c = J c; c:AL_dom N\<rbrakk>
   \<Longrightarrow> ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) J = ValuesRepresented c (S, \<Gamma>, H) (ops, s, h) I"
apply (simp add: ValuesRepresented_def)
apply (rule, clarsimp)
  apply (erule disjE, clarsimp)
    apply (drule_tac X="AL_dom H" in SetTriv) apply (erule State_welldef_D_Heap_ObjIDs) apply (erule_tac x=c in allE, clarsimp)
  apply clarsimp apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, clarsimp)
                 apply (erule_tac x=f in allE, clarsimp)
                 apply (erule_tac x=C in allE, erule_tac x=G in allE, erule_tac x=a in allE, clarsimp)
                 apply (erule_tac x=d in allE, erule impE)
                      apply (rule SetTriv)  apply (erule AL_domI) apply (erule State_welldef_D_Heap_ObjIDs)
                 apply clarsimp
apply clarsimp 
  apply (erule disjE, clarsimp)
    apply (drule_tac X="AL_dom H" in SetTriv) apply (erule State_welldef_D_Heap_ObjIDs) apply (erule_tac x=c in allE, clarsimp)
  apply clarsimp apply (erule_tac x=d in allE, erule_tac x=D in allE, erule_tac x=F in allE, clarsimp)
                 apply (erule_tac x=f in allE, clarsimp)
                 apply (erule_tac x=C in allE, erule_tac x=G in allE, erule_tac x=a in allE, clarsimp)
                 apply (erule_tac x=d in allE, erule impE)
                      apply (rule SetTriv)  apply (erule AL_domI) apply (erule State_welldef_D_Heap_ObjIDs)
                 apply clarsimp
done

end
